      SUBROUTINE TARBLOCKS(A1,A2,DX,NBLOCKS,BLKSIZ,XYZB,IPRINAX,IOSHP,
     &                     CDESCR,MXNAT,NAT,IXYZ,ICOMP)
      IMPLICIT NONE

C Arguments:

      INTEGER BLKSIZ,IPRINAX,NBLOCKS,IOSHP,MXNAT,NAT
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      INTEGER XYZB(3,100)
      REAL A1(3),A2(3),DX(3)
      CHARACTER CDESCR*67

C Local variables:

      INTEGER JB,JD,JJX,JJY,JJZ,JOFF,JOFFX,JOFFY,JOFFZ,JX,JY,JZ
      REAL EIGVAL(3)

C***********************************************************************
C
C Subroutine to construct a target out of "cubic" blocks.
C Blocks are only cubic for case of a cubic lattice DX=(1.,1.,1.)
C In case of a noncubic lattice, "blocks" are rectangular, with an equal
C number (=BLKSIZ) of dipole spacings in each direction.
C
C Given:
C DX(1-3)     =(dx/d,dy/d,dz/d) where dx,dy,dz = x,y,z lattice spacing,
C              and d = (dx*dy*dz)**(1/3) = effective lattice spacing
C NBLOCKS     =number of cubic blocks in target
C BLKSIZ      =(integer) ratio of block width/dipole spacing
C              (there will be BLKSIZ**3 dipoles per block)
C XYZB(1-3,J) =x,y,z coordinates of block a, in units of block width
C IPRINAX     =0. to return A1=(1,0,0), A2=(0,1,0)
C             =1. to return A1,A2=principal axes with largest, 2nd largest
C              moment of inertia
C IOSHP       =device number for output file "target.out"
C             =-1 to suppress generation of file "target.out"
C MXNAT       =limit on largest allowed value of NAT=number of dipoles
C
C Returns:
C NAT         =number of dipoles in target
C IXYZ(J,1-3) =x,y,z location of dipole J on lattice
C ICOMP(J,1-3)=composition for dipole J; x,y,z directions
C A1(1-3)     =principal axis A1 in target frame (normalized)
C A2(1-3)     =principal axis A2 in target frame (normalized)
C CDESCR      =string describing target
C
C where A1 = principal axis with largest moment of inertia
C       A2 = principal axis with second-largest moment of inertia
C
C B.T. Draine, Princeton Univ. Observatory, 95.12.11
C History:
C 96.01.02 (BTD) modified to compute eigenvalues and eigenvectors of
C                moment of inertia tensor, and to define vectors A1 and 
C                A2 to be along eigenvectors with largest and second
C                largest eigenvalues, respectively.
C 96.01.26 (BTD) Replaced IX,IY,IZ by IXYZ
C                Removed principal axis calculation to separate
C                subroutine PRINAXIS
C 96.01.29 (BTD) Added variable IPRINAX to allow control over definition
C                of axes A1,A2
C 96.02.23 (BTD) Remove computation of principal axes and eigenvalues
C                as this is now carried out by routine PRINAXIS.
C 97.12.26 (BTD) Add DX(3) to argument list to support nonuniform
C                lattice spacing.
C                Add DX to argument list of PRINAXIS.
C 98.03.07 (BTD) Add DX to file target.out for compatibility with
C                new version of REASHP
C 03.11.06 (BTD) Modified to use new version of PRINAXIS with eigenvalues
C                in argument list
C 04.03.19 (BTD) Revert to previous version of PRINAXIS
C 04.05.23 (BTD) Added EIGVAL to argument list of PRINAXIS to conform
C                to change in PRINAXIS
C End history.
C Copyright (C) 1996,1997,1998,2003,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

C For the moment, let us assume that blocks do not overlap.

      JOFF=1-((BLKSIZ+1)/2)
      JD=0
      DO JB=1,NBLOCKS
         JOFFX=JOFF+BLKSIZ*XYZB(1,JB)
         JOFFY=JOFF+BLKSIZ*XYZB(2,JB)
         JOFFZ=JOFF+BLKSIZ*XYZB(3,JB)
         DO JX=1,BLKSIZ
            JJX=JX+JOFFX
            DO JY=1,BLKSIZ
               JJY=JY+JOFFY
               DO JZ=1,BLKSIZ
                  JJZ=JZ+JOFFZ
                  JD=JD+1
                  IXYZ(JD,1)=JJX
                  IXYZ(JD,2)=JJY
                  IXYZ(JD,3)=JJZ

C Homogeneous target:

                  ICOMP(JD,1)=1
                  ICOMP(JD,2)=1
                  ICOMP(JD,3)=1
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      NAT=JD

      IF(IPRINAX.NE.0)THEN

C Call PRINAXIS to compute principal axes

         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,EIGVAL)
      ELSE

C Do not compute principal axes: simply set 
C a1=(1,0,0) and a2=(0,1,0) in target frame.

         A1(1)=1.
         A1(2)=0.
         A1(3)=0.
         A2(1)=0.
         A2(2)=1.
         A2(3)=0.

      ENDIF

C***********************************************************************
C Write target description into string CDESCR
C Note: this will replace whatever CDESCR was read in from the
C 'blocks.par' file. If you want to retain that description,
C then comment out the following statement:
C      WRITE(CDESCR,FMT='(A,I7,A,I3,A)')'Target containing',
C     &      NAT,' dipoles arranged in ',NBLOCKS,' cubic blocks'
C***********************************************************************

      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)NAT,A1,A2,DX
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3),
     &                           ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF   
      RETURN
 9020 FORMAT(' >TARBLOCKS: cubic building blocks',/,
     &I7,' = NAT',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,
     &'     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE CXC3DFFT(CZ,I1,I2,I3,I4,I5,I6,I7)
      IMPLICIT NONE
      COMPLEX CZ(1)
      INTEGER I1,I2,I3,I4,I5,I6,I7
C***********************************************************************
C    Note: This module should NOT be linked into DDSCAT when
C    running on a Convex with the vector library -- in that case
C    link with the -lveclib flag and use the native Convex C3DFFT
C    routine.
C    On other systems, however, you need to link in this routine
C    to avoid an error message from the compiler.
C
C History:
C 93.xx.xx (BTD) created to substitute for convex C3DFFT library routine
C 00.07.05 (BTD) renamed for greater Makefile consistency
C end history
C Copyright (C) 1993,2000 
C               B.T. Draine and P.J. Flatau
C
C This code is covered by the GNU General Public License.
C***********************************************************************
      CALL ERRMSG('FATAL','C3DFFT',' CONVEX option but dummy routine!')
      RETURN
      END

      SUBROUTINE PETR(X,B,WRK,LDA,IPAR,SPAR,MATVEC,CMATVEC)
      IMPLICIT NONE
C solves Ax=b
C
C Input:
C B(LOCLEN) - RHS (doesn't change on output)
C WRK(LDA, LOCLEN) - scratch array 
C IPAR - defines integer paramteres (see documentation of PIM)
C SPAR - define real parameters
C LDA - leading dimension of arrays 
C MATVEC -- name of procedure for computing y=Ax
C CMATVEC -- name of procedure for computing y= conj(A') x
C
C Output:
C X(LOCLEN)
C 
C Reference:
C    Petravic,M and Kuo-Petravic,G. 1979, JCP, 32,263
C History: 
C    Late 80'  (Coded by Draine)
C    Changes to include "cprod" (PJF+BTD)
C    95.06.01 (PJF) re-written to conform to PIM
C    95.08.11 (BTD) minor editing (comments, etc.)
C
C Parameters:
      INTEGER IACE,IAXI,IGI,IPI,IQI,IR
      PARAMETER (IACE=1,IGI=2,IPI=3,IQI=4,IAXI=5,IR=6)
C Arguments:
      INTEGER LDA
      INTEGER IPAR(*)
      REAL SPAR(*)
      COMPLEX B(*), WRK(LDA,*), X(*)
      EXTERNAL CMATVEC,MATVEC
C
C Local variables
      COMPLEX CDUMMY
      INTEGER IDUMMY,ITNO,L,LOCLEN,MAXIT,STATUS
      REAL
     &   ALPHAI,BETAI1,BNORM,DUMMY,EPSILON,EXITNORM,
     &   GIGI,GI1GI1,QIQI,RHSSTOP
      REAL SCSETRHSSTOP
      EXTERNAL PSCNRM2
C
C***********************************************************************
      LOCLEN = IPAR(4)
      MAXIT = IPAR(10)
      EPSILON=SPAR(1)
C
C Compute RHSSTOP = EPSILON*|B|
C
      RHSSTOP = SCSETRHSSTOP(B,CDUMMY,EPSILON,IPAR,CDUMMY,PSCNRM2)
C
C Compute conjg(A')*B
C
      CALL CMATVEC(B,WRK(1,IACE),IDUMMY)
      BNORM = 0.
      DO 170 L = 1,LOCLEN
         BNORM = BNORM + REAL(B(L)*CONJG(B(L)))
         WRK(L,IGI) = WRK(L,IACE)
         WRK(L,IPI) = WRK(L,IGI)
  170 CONTINUE
C
C Compute |QI>=A|PI>
C
      CALL MATVEC(WRK(1,IPI), WRK(1,IQI), IDUMMY)
      QIQI = 0.
      GIGI = 0.
      DO 190 L = 1,LOCLEN
         GIGI = GIGI + REAL(CONJG(WRK(L,IGI))*WRK(l,IGI))
         QIQI = QIQI + REAL(CONJG(WRK(L,IQI))*WRK(L,IQI))
  190 CONTINUE
      ALPHAI = GIGI/QIQI
      DO 200 L = 1,LOCLEN
         X(L) = X(L) + ALPHAI*WRK(L,IPI)
  200 CONTINUE
C
C compute |AX1>:
C
      CALL MATVEC(X,WRK(1,IAXI),IDUMMY)
C
      DO 340 ITNO = 2,MAXIT
         IPAR(11) = ITNO
C
C Transfer <GI|GI> -> <GI-1|GI-1>:
C
         GI1GI1 = GIGI
C
C compute |GI>=AC|E>-AC|AXI>:
C
         CALL CMATVEC(WRK(1,IAXI), WRK(1,IGI), IDUMMY)
C
C Compute GIGI=<GI|GI>:
         GIGI = 0.
         DO 230 L = 1,LOCLEN
            WRK(L,IGI) = WRK(L,IACE) - WRK(L,IGI)
  230    CONTINUE
         DO 235 L = 1,LOCLEN
            GIGI = GIGI + REAL(CONJG(WRK(L,IGI))*WRK(L,IGI))
  235    CONTINUE
C
C Compute BETAI-1=<GI|GI>/<GI-1|GI-1>:
C
         BETAI1 = GIGI/GI1GI1
C
C Compute |PI>=|GI>+BETAI-1|PI-1>:
C
         DO 240 L = 1,LOCLEN
            WRK(L,IPI) = WRK(L,IGI) + BETAI1*WRK(L,IPI)
  240    CONTINUE
C
C Compute |QI>=A|PI>:
C
         CALL MATVEC(WRK(1,IPI), WRK(1,IQI), IDUMMY)
C
C Compute <QI|QI>:
C
         QIQI = 0.
         DO 250 L = 1,LOCLEN
            QIQI = QIQI + REAL(CONJG(WRK(L,IQI))*WRK(L,IQI))
  250    CONTINUE
C
C Compute ALPHAI = <GI|GI>/<QI|QI>:
C
         ALPHAI = GIGI/QIQI
C
C Compute |XI+1>=|XI>+ALPHAI*|PI>:
C
         DO 260 L = 1,LOCLEN
            X(L) = X(L) + ALPHAI*WRK(L,IPI)
  260    CONTINUE
C
C Except every 10TH iteration, compute |AXI+1>=|AXI>+ALPHAI*|QI>
C Draine: warning this part perhaps not checked 
C
         IF (ITNO.NE.10* (ITNO/10)) THEN
         DO 270 L = 1,LOCLEN
            WRK(L,IAXI) = WRK(L,IAXI) + ALPHAI*WRK(L,IQI)
  270    CONTINUE
         ELSE 
            CALL MATVEC(X,WRK(1,IAXI),IDUMMY)
         ENDIF
C
C Compute residual vector |RI>=A|XI>-|B>
C
         DO 300 L=1, LOCLEN
            WRK(L,IR) = WRK(L,IAXI)-B(L)
 300     CONTINUE
C
C Call STOPCRIT to check whether to terminate iteration.
C Criterion: terminate if <RI|RI> < TOL**2 * <B|B>
C Return with STATUS=0 if this condition is satisfied.
C
         CALL STOPCRIT(B,WRK(1,IR),CDUMMY,CDUMMY,CDUMMY,WRK,
     +                 RHSSTOP,IDUMMY,EXITNORM,
     +                 STATUS,IPAR,DUMMY,DUMMY,DUMMY,DUMMY,PSCNRM2)
C
C Call PROGRESS to report "error" = sqrt(<RI|RI>)/sqrt(<B|B>)
C
         CALL PROGRESS(LOCLEN,ITNO,EXITNORM,CDUMMY,CDUMMY,CDUMMY)
C      
      IF(STATUS.EQ.0)GOTO 500
 340  CONTINUE
 500  CONTINUE
      IPAR(12) = 0
      RETURN
      END

      SUBROUTINE REAPAR(CBINFLAG,CNETFLAG,AEFFA,
     &                  BETAMI,BETAMX,
     &                  CALPHA,CDIEL,CFLEPS,CFLPAR,CFLSHP,CMDSOL,CMDFFT,
     &                  CSHAPE,CMDTRQ,CXE01,CXE02,
     &                  DEGRAD,ETASCA,
     &                  IDVERR,IDVOUT,INIT,IOPAR,IORTH,IWRKSC,
     &                  MXBETA,MXCOMP,MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &                  NBETA,NCOMP,NPHI,NRAD,NSCA,NTHETA,NWAV,
     &                  IWAV0,IRAD0,IORI0,NSMELTS,
     &                  PHIMIN,PHIMAX,PHIN,
     &                  THETAN,THETMI,THETMX,TOL,
     &                  WAVEA,SHPAR,SMIND1,SMIND2,DX)
      IMPLICIT NONE

C Arguments:

      CHARACTER
     &   CALPHA*(*),CBINFLAG*(*),CDIEL*(*),CFLPAR*(*),CFLSHP*80,
     &   CMDSOL*(*),CMDFFT*(*),CMDTRQ*(*),CNETFLAG*(*),CSHAPE*(*)
      INTEGER
     &   IDVERR,IDVOUT,INIT,IOPAR,IORI0,IORTH,IRAD0,IWAV0,
     &   IWRKSC,
     &   MXBETA,MXCOMP,MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &   NBETA,NCOMP,NPHI,NRAD,NSCA,NSMELTS,NWAV,NTHETA
      INTEGER SMIND1(9),SMIND2(9)
      CHARACTER*60 CFLEPS(MXCOMP)
      REAL
     &   BETAMI,BETAMX,DEGRAD,ETASCA,PHIMIN,PHIMAX,THETMI,THETMX,TOL
      REAL
     &   AEFFA(MXRAD),DX(3),PHIN(MXSCA),SHPAR(6),THETAN(MXSCA),
     &   WAVEA(MXWAV)
      COMPLEX CXE01(3),CXE02(3)

C Local variables:

      CHARACTER CDIVID*3,CLINE*70,CMSGNM*70,CWHERE*70
      INTEGER J,NSCA0
      REAL
     &   AEFEND,AEFINI,DELTA,DTHETA,E1,PHI1,THETA1,THETA2,
     &   WAVEND,WAVINI

C External routines:

      EXTERNAL DIVIDE,ERRMSG,WRIMSG

C***********************************************************************
C Subroutine REAPAR handles the reading of input parameters from the
C "ddscat.par" file, as well as elementary processing with those input
C parameters to generate arrays.
C Original version created by P.J.Flatau, Colorado State Univ.
C Modified by B.T.Draine, Princeton Univ. Obs.
C History:
C 90.11.09 (BTD): Modified so as to remove sensitivity to errors
C                 in sign of entered value of DTHETA.
C 90.11.30 (BTD): Added test to compare CMDFFT and MXMEM
C 90.12.14 (BTD): Changed option MKRECT to RCTNGL
C 91.01.03 (BTD): Added MXBETA,MXPHI,MXTHET to argument list
C                 and added checking of NBETA,NPHI,NTHETA
C 91.05.08 (BTD): Added CALPHA to allow choice of prescription
C                 for polarizabilities
C 91.05.08 (BTD): Some rewriting done.
C 91.05.14 (BTD): Added separate options LDRXYZ and LDRAVG
C 91.05.15 (BTD): Added new option LDR000
C 91.05.23 (BTD): Added variable IWRKSC to argument list and
C                 added code to read IWRKSC
C 91.05.30 (BTD): Changed LDRXYZ->LDR100
C                 Added option LDR111
C 91.11.13 (BTD): Now three options: DRAI88, GOBR88, LATTDR
C                 (subroutine ALPHA now allows for directional
C                 dependence for LATTDR option)
C 92.05.14 (BTD): Allow for experimental option LDRISO
C 92.09.21 (BTD): Allow for option ANIELL (ellipsoid of anisotropic
C                 material); change option GRPHIT -> UNICYL (cylinder
C                 of uniaxial material)
C 93.01.07 (BTD): Allow for options TWOELL and TWOAEL (two touching
C                 ellipsoids, each either isotropic or anisotropic)
C 93.03.11 (BTD): Deleted all code associated with variable CMACHN
C                 which previously was used to identify machine/OS
C                 This information was not used or needed.
C 93.12.15 (BTD): Added code to check for compatibility of NCOMP
C                 when CSHAPE=TWOELL,THRELL,TWOAEL,or THRAEL
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6)
C                 Added CONELL (two concentric ellipsoids) as target
C                 option.
C 94.06.20 (PJF): Added code to handle NEWTMP
C 94.12.02 (BTD): Added options 
C                    LB1991 (Dungey-Bohren 1991 polarizability)
C                    LR1994 (Lumme-Rahola 1994 polarizability)
C 95.05.26 (BTD): Corrected construction of orthogonal polarization
C                 state for case where E01 is complex (e.g.,
C                 circular polarization)
C 95.06.14 (BTD): Added code to check that user is not requesting
C                 f_ml when illuminating target with other then
C                 linearly polarized light
C 95.06.19 (BTD): Added argument CMDSOL to allow selection of
C                 different CCG methods
C                 Added argument CMDTRQ to allow torque calculations
C                 to be skipped.
C 96.01.05 (BTD): Added shape options BLOCKS and DW1996
C 96.01.25 (BTD): Added shape option TWOSPH
C 96.01.25 (BTD): Disable code added 95.06.14 so that user can
C                 calculate f_ml even when illuminating target with
C                 elliptically polarized light.
C 96.10.18 (BTD): Changed option NEWTMP to GPFAFT (Generalized Prime
C                 Factor Algorithm for Fourier Transform).
C 96.11.06 (BTD): Added provision to 
C                 (1) produce fatal error if CXE01(1).NE.(0.,0.)
C                 (2) normalize CXE01 if necessary
C 96.11.14 (PJF): cbinflag for binary file
C 96.11.15 (PJF): netCDF netflag
C 96.11.21 (BTD): modified handling of CBINFLAG and CNETFLAG to
C                 be consistent with other option flags
C 97.11.01 (BTD): add DX to argument list
C                 read DX from ddscat.par
C                 renormalize DX (input DX not required to be
C                 normalized with DX(1)*DX(2)*DX(3)=1.)
C 98.12.06 (BTD): modified to read NSMELTS,SMELTS from ddscat.par
C                 and pass NSMELTS,SMIND1,SMIND2 as arguments to calling
C                 program DDSCAT
C 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
C                 CHARACTER*60 to allow longer file names
C                 (also changed in DDSCAT.f and dielec.f)
C 98.12.29 (BTD): modified to support new option LYRSLB
C 99.01.26 (BTD): modified to allow first IWAV,IRAD,IORI to be
C                 specified in ddscat.par (useful for restarting
C                 jobs which did not complete)
C 99.06.29 (BTD): corrected input of SHPAR for option TWOSPH
C                 previously had input only SHPAR(1-5),
C                 now input SHPAR(1-6)
C 00.06.12 (BTD): modified to support NSPHER option
C 00.06.23 (BTD): modified to support FFTWFJ option
C                 remove MXMEM from argument list
C                 since no longer supporting TMPRTN FFT option which
C                 required additional memory
C 00.07.05 (BTD): modified to print more information about CMDFFT
C                 option
C 02.02.12 (BTD): modified to support PRISM3 option
C 03.01.29 (BTD): modified to force DX(1-3)=1.
C 03.05.21 (BTD): modified to support SPHARM option
C 03.05.22 (BTD): bug fix re SPHARM option
C 03.07.13 (BTD): changed FFTWFJ to FFTW21 in anticipation of future
C                 option FFTW3x (FFTW 2.1.x and FFTW 3.0.1 have 
C                 different interfaces, so they must be distinguished).
C 03.10.23 (BTD): removed ICTHM and IPHIM from argument list,
C                 removed code to read these values from ddscat.par
C 03.10.24 (BTD): Add parameter ETASCA to allow user to control
C                 angular resolution used for scattering calculations.
c                 Add checks against invalid input
c 04.02.26 (BTD): Modify to accept polarizability option 'GKDLDR'
c                 for Gutkowicz-Krusin & Draine (2004) lattice
c                 dispersion relation.
c 04.04.01 (BTD): Modify to support option NPSPBC (multi-sphere cluster
c                 with periodic boundary conditions)
C 04.04.05 (BTD): Remove SPHARM option: GSPHER is sufficient
C 04.04.29 (BTD): Added ANIREC option for homogeneous anisotropic 
c                 rectangular target
c 04.05.23 (BTD): Added CWHERE string to provide error information
c                 in case of malformed ddscat.par file.
c 05.03.19 (BTD): Added 2 lines to set CLFEPS(1) in case using options
c                 H2OLIQ or H2OICE (previously were left undefined,
c                 which cause problems with output statement)
c 05.10.18 (BTD): Added check to ensure that NBETA*NTHETA*NPHI < 1001
c                 if IWRKSC=1 (since current version of NAMER is limited
c                 to maximum of 1000 directions)
C end history
C Copyright (C) 1993,1994,1995,1996,1997,1998,1999,2000,2002,2003,2004,
C               2005
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.

C***********************************************************************
C
      OPEN (UNIT=IOPAR,FILE=CFLPAR,STATUS='OLD')
C
      CWHERE='error reading line 1 of ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG('REAPAR',CLINE)
      CWHERE='error reading line 2 of ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)

C    Specify whether torques are to be calculated:
C
C    CMDTRQ*6 = 'DOTORQ' -  calculate torque on grain
C             = 'NOTORQ' -  do not calculate torque on grain

      CWHERE='error reading CMDTRQ from ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CMDTRQ
      IF(CMDTRQ.EQ.'dotorq')CMDTRQ='DOTORQ'
      IF(CMDTRQ.EQ.'notorq')CMDTRQ='NOTORQ'
      IF(CMDTRQ.EQ.'DOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDTRQ.EQ.'NOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - do not compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDTRQ')
      ENDIF

C    Define method used for iterative solution of complex linear equations
C
C    CMDSOL*6 = 'PETRKP' -  Petravic & Kuo-Petravic method
C             = 'PBCGST' -  PIM BiConjugate Gradient with Stabilization

      CWHERE='error reading CMDSOL from ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CMDSOL
      IF(CMDSOL.EQ.'petrkp')CMDSOL='PETRKP'
      IF(CMDSOL.EQ.'pbcgst')CMDSOL='PBCGST'
      IF(CMDSOL.EQ.'PETRKP'.OR.
     &   CMDSOL.EQ.'PBCGST')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDSOL,' - CCG Method  '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDSOL')
      ENDIF

C    Define FFT method:

C    CMDFFT*6 = 'BRENNR' -  Use Brenner's FOURX FFT routine [no longer used]
C             = 'TMPRTN' -  Use Temperton's FFT routine [no longer used]
C             = 'GPFAFT' -  GPFA code of Temperton
C             = 'FFTW21' -  FFTW 2.1.x code of Frigo & Johnson
C             = 'CONVEX' -  Use native Convex veclib routine C3DFFT.

      CWHERE='error reading CMDFFT from ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CMDFFT
      IF(CMDFFT.EQ.'CONVEX')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using native Convex ',
     &                    '3d FFT'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDFFT.EQ.'FFTW21')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using FFTW 2.1.x ',
     &                    'package from Frigo & Johnson'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDFFT.EQ.'GPFAFT')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using GPFA package ',
     &                    'from Clive Temperton'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         WRITE(CMSGNM,FMT='(A,A)')'DDSCAT6.1 only supports FFT options',
     &      ' FFTW21, GPFAFT, and CONVEX'
         CALL WRIMSG('REAPAR',CMSGNM)
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDFFT')
      ENDIF

C***********************************************************************

C    Define prescription for computing polarizabilities:

c    CALPHA*6 = 'LATTDR' - Lattice Dispersion Relation of
c                          Draine & Goodman (1993)
c               'GKDLDR' - Lattice Dispersion Relation of
c                          Gutkowicz-Krusin & Draine (2004)

      CWHERE='error reading CALPHA from ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CALPHA
      IF(CALPHA.EQ.'LATTDR')THEN
         CALL WRIMSG('REAPAR',
     &      'LATTDR - Draine & Goodman (1993) LDR for alpha')
      ELSEIF(CALPHA.EQ.'GKDLDR')THEN
         CALL WRIMSG('REAPAR',
     &      'GKDLDR - Gutkowicz-Krusin & Draine (2004) LDR for  alpha')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CALPHA')
      ENDIF

C binary file flag

      CWHERE='error reading CBINFLAG from ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CBINFLAG
      IF(CBINFLAG.EQ.'allbin')CBINFLAG='ALLBIN'
      IF(CBINFLAG.EQ.'oribin')CBINFLAG='ORIBIN'
      IF(CBINFLAG.EQ.'notbin')CBINFLAG='NOTBIN'
      IF(CBINFLAG.EQ.'ALLBIN'
     &   .OR.CBINFLAG.EQ.'ORIBIN'
     &   .OR.CBINFLAG.EQ.'NOTBIN')THEN
         WRITE(CMSGNM,FMT='(A,A)')CBINFLAG,
     &                            ' - Unformatted binary dump option'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong definition of CBINFLAG')
      ENDIF

C NETCDF file flag

      CWHERE='error reading CNETFLAG from ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CNETFLAG
      IF(CNETFLAG.EQ.'allcdf')CNETFLAG='ALLCDF'
      IF(CNETFLAG.EQ.'oricdf')CNETFLAG='ORICDF'
      IF(CNETFLAG.EQ.'notcdf')CNETFLAG='NOTCDF'
      IF(CNETFLAG.EQ.'ALLCDF'  
     &   .OR.CNETFLAG.EQ.'ORICDF' 
     &   .OR.CNETFLAG.EQ.'NOTCDF')THEN
         WRITE(CMSGNM,FMT='(A,A)')CNETFLAG,
     &                            ' - netCDF file option'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong definition of CNETFLAG')
      ENDIF

C***********************************************************************

C    Define shape:
C
C    CSHAPE*6 = 'FRMFIL'     read shape data from file
C             = 'RCTNGL'     make rectangular solid
C             = 'ELLIPS'     make ellipsoidal solid
C             = 'CYLNDR'     make cylindrical solid
c             = 'CYLCAP'     make cylinder with hemispherical end-caps
C             = 'HEXGON'     make hexagonal prism
C             = 'TETRAH'     make regular tetrahedron
C             = 'UNICYL'     make cylinder of unixaxial material
C             = 'ANIELL'     make ellipsoid of anisotropic material
C             = 'TWOELL'     make two touching ellipsoids of materials 1,2
C             = 'TWOAEL'     make two touching anisotropic ellipsoids of
C                            materials 1-6
C             = 'THRELL'     make three touching isotropic ellipsoids of
C                            materials 1,2,3
C             = 'THRAEL'     make three touching anisotropic ellipsoids of
C                            materials 1-9
C             = 'CONELL'     make two concentric ellipsoids of
C                            materials 1,2
C             = 'BLOCKS'     make target out of cubic blocks defined by
C                            data in file 'blocks.par'
C             = 'DW1996'     make 13-cube target used by Draine &
C                            Weingartner 1996
C             = 'TWOSPH'     make two touching spheroids with symmetry axes at
C                            specified angle
C             = 'LYRSLB'     make layered slab target, with up to 4 separate
C                            layers
C             = 'NSPHER'     make multisphere target = union of volumes of
C                            N spheres
C             = 'PRISM3'     make triangular prism target
C             = 'GSPHER'     make gaussian sphere target
C             = 'NSPPBC'     make multisphere target with periodic
C                            boundary conditions
C             = 'ANIREC'     make homogeneous anisotropic rectangular 
C                            target

      CWHERE='error reading CSHAPE from ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CSHAPE
      IF(    CSHAPE.EQ.'FRMFIL'.OR.CSHAPE.EQ.'RCTNGL'
     &   .OR.CSHAPE.EQ.'ELLIPS'.OR.CSHAPE.EQ.'CYLNDR'
     &   .OR.CSHAPE.EQ.'HEXGON'.OR.CSHAPE.EQ.'TETRAH'
     &   .OR.CSHAPE.EQ.'UNICYL'.OR.CSHAPE.EQ.'ANIELL'
     &   .OR.CSHAPE.EQ.'TWOELL'.OR.CSHAPE.EQ.'TWOAEL'
     &   .OR.CSHAPE.EQ.'THRELL'.OR.CSHAPE.EQ.'THRAEL'
     &   .OR.CSHAPE.EQ.'CONELL'.OR.CSHAPE.EQ.'BLOCKS'
     &   .OR.CSHAPE.EQ.'DW1996'.OR.CSHAPE.EQ.'LYRSLB'
     &   .OR.CSHAPE.EQ.'TWOSPH'.OR.CSHAPE.EQ.'NSPHER'
     &   .OR.CSHAPE.EQ.'PRISM3'.OR.CSHAPE.EQ.'GSPHER'
     &   .OR.CSHAPE.EQ.'NSPPBC'.OR.CSHAPE.EQ.'ANIREC'
     &   .OR.CSHAPE.EQ.'CYLCAP')THEN

         WRITE(CMSGNM,FMT='(A,A)')CSHAPE,' - Shape definition '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong shape directive ')
      ENDIF

C Read shape parameters
C Need 3 shape parameters for all options except 
C      FRMFIL (0 shape parameters: 
C                here skip a line, later read target from file)
C      TETRAH, DW1996 (1 shape parameter)
C      CYLNDR, CYLCAP, HEXGON, UNICYL (2 shape parameters)
C      TWOSPH (6 shape parameters)
C      CONELL (6 shape parameters)
C      LYRSLB (6 shape parameters)
C      NSPHER (2 shape parameters + 1 filename)
C      PRISM3 (4 shape parameters)
c      GSPHER (6 shape parameters)

      IF(CSHAPE.EQ.'FRMFIL')THEN
         READ(IOPAR,FMT=*,ERR=40)

c targets needing 1 shape parameter:

      ELSEIF(
     &   CSHAPE.EQ.'TETRAH'.OR.
     &   CSHAPE.EQ.'DW1996')THEN
         CWHERE='error reading 1 shape parameter in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1)

c targets needing 2 shape parameters:

      ELSEIF(
     &   CSHAPE.EQ.'CYLNDR'.OR.
     &   CSHAPE.EQ.'CYLCAP'.OR.
     &   CSHAPE.EQ.'HEXGON'.OR.
     &   CSHAPE.EQ.'UNICYL')THEN
         CWHERE='error reading 2 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2)

c targets needing 4 shape parameters

      ELSEIF(CSHAPE.EQ.'PRISM3')THEN
         CWHERE='error reading 4 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4)

c targets needing 6 shape parameters:

      ELSEIF(
     &   CSHAPE.EQ.'TWOSPH'.OR.
     &   CSHAPE.EQ.'CONELL'.OR.
     &   CSHAPE.EQ.'LYRSLB'.OR.
     &   CSHAPE.EQ.'GSPHER')THEN
         CWHERE='error reading 6 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),SHPAR(3),
     &                           SHPAR(4),SHPAR(5),SHPAR(6)

c targets needing 2 shape parameters and file name:

      ELSEIF(CSHAPE.EQ.'NSPHER')THEN
         CWHERE=
     &   'error reading 2 shape parameters and filename in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),CFLSHP

c targets needing 3 shape parameters and file name:

      ELSEIF(CSHAPE.EQ.'NSPPBC')THEN
         CWHERE=
     &   'error reading 3 shape parameters and filename in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),SHPAR(3),CFLSHP

c targets needing 3 shape parameters:

      ELSE
         CWHERE='error reading 3 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),SHPAR(3)
      ENDIF

C***********************************************************************
C following code disabled 03.01.29
C (retain for use in future noncubic version)
C
C   Obtain lattice anisotropy parameters DX(1-3)
C   For cubic lattice, DX(1)=DX(2)=DX(3)
C   Note that we do not require here that DX(1)*DX(2)*DX(3)=1 upon
C   input; DX is renormalized here before being returned to DDSCAT
C

C      READ(IOPAR,FMT=*,ERR=40)DX(1),DX(2),DX(3)
C      WRITE(CMSGNM,FMT='(F8.3,F8.3,F8.3,A)')DX,
C     &   ' = relative lattice spacings dx,dy,dz'
C      CALL WRIMSG('REAPAR',CMSGNM)

C      DELTA=(DX(1)*DX(2)*DX(3))**(1./3.)
C      DX(1)=DX(1)/DELTA
C      DX(2)=DX(2)/DELTA
C      DX(3)=DX(3)/DELTA
C      WRITE(CMSGNM,FMT='(F8.3,F8.3,F8.3,A)')DX,
C     &   ' = normalized lattice spacings dx,dy,dz'
C      CALL WRIMSG('REAPAR',CMSGNM)

C and replaced by following:

      DX(1)=1.
      DX(2)=1.
      DX(3)=1.

C-----------------------------------------------------------------------
C***********************************************************************

C   Obtain names of file(s) containing dielectric function(s)
C   NCOMP = number of different dielectric functions
C   CFLEPS(1-NCOMP) = names of files containing dielectric functions
C
      CWHERE='error reading NCOMP in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)NCOMP

C Check that MXCOMP is large enough 

      IF(NCOMP.GT.MXCOMP)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP > MXCOMP: must increase MXCOMP in DDSCAT')

C*** Check that NCOMP=2 if CSHAPE=UNICYL *******************************
C                     3           ANIELL
C                     2           TWOELL
C                     3           THRELL
C                     6           TWOAEL
C                     9           THRAEL
C                     2           CONELL
C                     2           TWOSPH
C                     2-4         LYRSLB

      IF(CSHAPE.EQ.'UNICYL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option UNICYL')
      IF(CSHAPE.EQ.'ANIELL'.AND.NCOMP.NE.3)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 3 for option ANIELL')
      IF(CSHAPE.EQ.'TWOELL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option TWOELL')
      IF(CSHAPE.EQ.'THRELL'.AND.NCOMP.NE.3)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 3 for option THRELL')
      IF(CSHAPE.EQ.'TWOAEL'.AND.NCOMP.NE.6)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 6 for option TWOAEL')
      IF(CSHAPE.EQ.'THRAEL'.AND.NCOMP.NE.9)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 9 for option THRAEL')
      IF(CSHAPE.EQ.'CONELL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option CONELL')
      IF(CSHAPE.EQ.'TWOSPH'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option TWOSPH')
      IF(CSHAPE.EQ.'LYRSLB')THEN
         IF(SHPAR(5).LE.0.)THEN
            J=2
         ELSE
            IF(SHPAR(6).LE.0.)THEN
               J=3
            ELSE
               J=4
            ENDIF
         ENDIF
         IF(J.NE.NCOMP)
     &      CALL ERRMSG('FATAL','REAPAR',
     &      'option LYRSLB; NCOMP incompatible with SHPAR(4-6)')
      ENDIF

C***********************************************************************

      READ(IOPAR,FMT=*,ERR=40)CDIEL
      IF(CDIEL.EQ.'TABLES')THEN
         CWHERE='error reading filename(s) for diel.fn. in ddscat.par'
         DO J=1,NCOMP
             READ(IOPAR,FMT=*,ERR=40)CFLEPS(J)
         ENDDO
      ELSEIF(CDIEL.EQ.'H2OICE'.OR.CDIEL.EQ.'H2OLIQ')THEN
         IF(NCOMP.GT.1)CALL ERRMSG('FATAL','REAPAR',
     &                              'H2OICE/LIQ with NCOMP>1?')
         IF(CDIEL.EQ.'H2OICE')CFLEPS(1)=
     &      'Using option H2OICE: H2O ice at T=250K'
         IF(CDIEL.EQ.'H2OLIQ')CFLEPS(1)=
     &      'Using option H2OLIQ: liquid H2O at T=280K'
      ELSE
         CALL ERRMSG('FATAL','REAPAR','Unrecognized option for CDIEL')
      ENDIF

C***********************************************************************

C    Define INITIALIZATION:

C    INIT = 0 to start with |X0>=0
C           1 to obtain |X0> from 4th-order expansion in polarizability
C           2 to read |X0> from file solvp.in

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading INIT in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)INIT
      IF(INIT.EQ.0)THEN
         CALL WRIMSG('REAPAR',
     &               'INIT=0 to start with |X0>=0 (CCG method)')
      ELSEIF(INIT.EQ.1)THEN
         CALL WRIMSG('REAPAR',
     &         'INIT=1 to obtain |X0> from 4th-order expansion (CCG)')
      ELSEIF(INIT.EQ.2)THEN
         CALL WRIMSG('REAPAR',
     &        'INIT=2 to read |X0> from file solvp.in')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong value of INIT')
      ENDIF

C***********************************************************************

C    Define error tolerance:
C    TOL= maximum acceptable value of |Ax-E|/|E|

      CWHERE='error reading TOL in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)TOL
      IF(TOL.GT.1.E-15.AND.TOL.LT.1.E-1)THEN
         WRITE(CMSGNM,FMT='(1PE10.3,A)')TOL,
     &         ' = TOL = max. acceptable normalized residue |Ax-E|/|E|'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('WARNING','REAPAR',' Strange value of TOL ')
      ENDIF

C***********************************************************************

C    Define angular resolution used for calculating radiation force,
C    <cos>, <cos^2>, and radiation torque (if CMTORQ='DOTORQ')

c     ETASCA = parameter controlling number of scattering angles
c            = 1 is a good choice, but can reduce this if higher
c                accuracy is required for angular averages

c     number of scattering angles will be approximately
c            6*[(3+x)/ETASCA]^2

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading ETASCA in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)ETASCA
      IF(ETASCA.GT.1.E-3)THEN
         WRITE(CMSGNM,FMT='(F7.4,A)')ETASCA,
     &    ' = ETASCA (parameter controlling number of scattering angles'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         WRITE(CMSGNM,FMT='(1PE10.3,A)')ETASCA,
     &    ' is not an appropriate value for ETASCA: check ddscat.par'
         CALL ERRMSG('FATAL','REAPAR',CMSGNM)
      ENDIF

C***********************************************************************

C    Define WAVELENGTH :

C    WAVINI = first wavelength (physical units)
C    WAVEND = last wavelength (physical units)
C    NWAV   = number of wavelengths
C    CDIVID = 'LIN', 'LOG', or 'INV' for equal increments in
C             wavelength, log(wavelength), or frequency

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE=
     &   'error reading firstwave, lastwave, number, how in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)WAVINI,WAVEND,NWAV,CDIVID
      IF(CDIVID.NE.'LIN'.AND.
     &   CDIVID.NE.'LOG'.AND.
     &   CDIVID.NE.'INV')THEN
         CALL ERRMSG('FATAL','REAPAR',
     &               ' CDIVID for wavelengths must be LIN,LOG, or INV')
      ENDIF
      WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')
     &      NWAV,' wavelengths from ',WAVINI,' to ',WAVEND
      CALL WRIMSG('REAPAR',CMSGNM)
      CALL DIVIDE(CDIVID,WAVINI,WAVEND,NWAV,MXWAV,WAVEA)

C***********************************************************************

C    Define AEFF = radius of equal-volume sphere (physical units)

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE=
     &   'error reading firstaeff, lastaeff, number, how in ddscat.par'
      READ(IOPAR,FMT=*)AEFINI,AEFEND,NRAD,CDIVID
      IF(CDIVID.NE.'LIN'.AND.
     &   CDIVID.NE.'LOG'.AND.
     &   CDIVID.NE.'INV')THEN
         CALL ERRMSG('FATAL','REAPAR',
     &               ' CDIVID for radii must be LIN,LOG, or INV')
      ENDIF
      WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')
     &      NRAD,' eff. radii from ',AEFINI,' to ',AEFEND
      CALL WRIMSG('REAPAR',CMSGNM)
      CALL DIVIDE(CDIVID,AEFINI,AEFEND,NRAD,MXRAD,AEFFA)

C***********************************************************************

C    Define incident polarizations (in Lab Frame)
C    It is assumed that incident radiation is along x axis in Lab Frame

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)

C Read complex polarization vector CXE01=e01 (normalize if necessary).

      CWHERE='error reading CXE01 in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)CXE01
      E1=REAL(SQRT(CXE01(1)*CONJG(CXE01(1))))
      IF(E1.NE.0.)THEN
         CALL ERRMSG('FATAL','REAPAR',' CXE01(1) must be zero!')
      ENDIF
C
C Normalize:
C
      E1=SQRT(REAL(CXE01(2)*CONJG(CXE01(2))+CXE01(3)*CONJG(CXE01(3))))
      CXE01(2)=CXE01(2)/E1
      CXE01(3)=CXE01(3)/E1
C
C Construct orthogonal normalized polarization vector CXE02=e02
C using xhat cross e01* = e02
C
      CXE02(1)=(0.,0.)
      CXE02(2)=-CONJG(CXE01(3))
      CXE02(3)=CONJG(CXE01(2))
C
C IORTH=1 to calculate only for single polarization
C      =2 to also calculate for orthogonal polarization
C
      READ(IOPAR,FMT=*,ERR=40)IORTH
C
C***********************************************************************

C    Specify whether or not to write ".sca" files

C IWRKSC=0 to NOT write ".sca" file for each target orientation
C       =1 to write ".sca" file for each target orientation

      CWHERE='error reading IWRKSC in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)IWRKSC

C***********************************************************************

C    Read information determining target rotations

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading BETAMI,BETAMX,NBETA in ddscat.par'
      READ(IOPAR,FMT=*)BETAMI,BETAMX,NBETA
      CWHERE='error reading THETMI,THETMX,NTHETA in ddscat.par'
      READ(IOPAR,FMT=*)THETMI,THETMX,NTHETA
      CWHERE='error reading PHIMIN,PHIMAX,NPHI in ddscat.par'
      READ(IOPAR,FMT=*)PHIMIN,PHIMAX,NPHI

c check that user has not requested more than 1000 orientations and
c IWRKSC=1

      IF(IWRKSC.GT.0.AND.(NBETA*NTHETA*NPHI).GT.1000)THEN
         CALL ERRMSG('FATAL','REAPAR',
     &   'error: if IWRKSC=1, NBETA*NTHETA*NPHI must be .le. 1000')
      ENDIF

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading IWAV0,IRAD0,IORI0 in ddscat.par'
      READ(IOPAR,FMT=*)IWAV0,IRAD0,IORI0

C*** Check that values of NBETA,NTHETA,NPHI are OK:

      IF(NBETA.GT.MXBETA)
     &   CALL ERRMSG('FATAL','REAPAR',' NBETA>MXBETA: must recompile')
      IF(NPHI.GT.MXPHI)
     &   CALL ERRMSG('FATAL','REAPAR',' NPHI>MXPHI: must recompile')
      IF(NTHETA.GT.MXTHET)
     &   CALL ERRMSG('FATAL','REAPAR',' NTHETA>MXTHET: must recompile')

C***  Check that IWAV0,IRAD0,IORI0 are OK:

      IF(IWAV0+1.GT.NWAV)
     &   CALL ERRMSG('FATAL','REAPAR','IWAV0+1 > NWAV')
      IF(IRAD0+1.GT.NRAD)
     &   CALL ERRMSG('FATAL','REAPAR','IRAD0+1 > NRAD')
      IF(IORI0+1.GT.NBETA*NTHETA*NPHI)
     &   CALL ERRMSG('FATAL','REAPAR','IORI0+1 > NBETA*NTHETA*NPHI')

C If NPHI>1, then set IORTH=2 regardless of value input.

      IF(IORTH.EQ.1.AND.NPHI.GT.1)THEN
         IORTH=2
         CALL WRIMSG('REAPAR',
     &               'Set IORTH=2 since NPHI>1 ')
      ENDIF
C
      IF(IORTH.EQ.1)THEN
         CALL WRIMSG('REAPAR',
     &               'Calculate only for single polarization ')
      ELSEIF(IORTH.EQ.2)THEN
         CALL WRIMSG('REAPAR',
     &               'Do orthogonal polarization for each case ')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' WRONG VALUE OF IORTH ')
      ENDIF
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')BETAMI,BETAMX,
     &  ' Range of BETA values ; NBETA =',NBETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')THETMI,THETMX,
     &  ' Range of THETA values; NTHETA=',NTHETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')PHIMIN,PHIMAX,
     &  ' Range of PHI values ;   NPHI =',NPHI
      CALL WRIMSG('REAPAR',CMSGNM)

C Convert from degrees to radians

      BETAMI=BETAMI/DEGRAD
      BETAMX=BETAMX/DEGRAD
      THETMI=THETMI/DEGRAD
      THETMX=THETMX/DEGRAD
      PHIMIN=PHIMIN/DEGRAD
      PHIMAX=PHIMAX/DEGRAD

C***********************************************************************

C    Specify elements of scattering matrix to be printed out

      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading NSMELTS in ddscat.par'
      READ(IOPAR,FMT=*,ERR=40)NSMELTS

C NSMELTS = number of elements of scattering matrix element to be
C           printed out.  Must be no greater than 9
C           if NSMELTS is zero, then 6 "default" elements are output

      IF(NSMELTS.GT.9)THEN
         WRITE(IDVOUT,FMT='(A,I2,A)')'Error:',NSMELTS,
     &      ' > 9 is not permitted by output routines'
         CALL ERRMSG('FATAL','REAPAR',
     &               'NSMELTS > 9 is not allowed in ddscat.par')
      ENDIF
      IF(NSMELTS.LE.0)THEN
         SMIND1(1)=11
         SMIND1(2)=21
         SMIND1(3)=31
         SMIND1(4)=41
         SMIND1(5)=12
         SMIND1(6)=13
         NSMELTS=6
         READ(IOPAR,FMT=*)
      ELSE
         CWHERE=
     &      'error reading indices ij of S_ij elements in ddscat.par'
         READ(IOPAR,FMT=*,ERR=40)(SMIND1(J),J=1,NSMELTS)
      ENDIF
      DO J=1,NSMELTS
         SMIND2(J)=SMIND1(J)-10*(SMIND1(J)/10)
         SMIND1(J)=SMIND1(J)/10
      ENDDO
      
C***********************************************************************

C    Specify scattering directions to be calculated
C    THETAN,PHIN = Direction of n from n0 in calculation of the
C                  scattering matrix; cos(THETAN) is n0 \dot n
C                  and PHIN is azimuthal angle of n from Lab xy plane
C                  Note: THETA1, THETA2, and PHI for each scattering
C                  plane are entered in degrees, and immediately 
C                  converted to radians.  Arbitrary number
C                  of scattering planes may be considered.

      NSCA=0
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading scattering directions in ddscat.par'
 22   READ(IOPAR,FMT=*,ERR=40,END=25)PHI1,THETA1,THETA2,DTHETA
      WRITE(CMSGNM,FMT='(3F7.1,A)')PHI1,THETA1,THETA2,
     &  ' = phi, theta_min, theta_max for scattering plane'
      CALL WRIMSG('REAPAR',CMSGNM)
C
C Convert to radians:
C
      PHI1=PHI1/DEGRAD
      THETA1=THETA1/DEGRAD
      THETA2=THETA2/DEGRAD
      DTHETA=DTHETA/DEGRAD
C
C Allow for possibility that user did not enter correct sign for
C DTHETA (if I did it, others will too...)
C
      IF(THETA2.LT.THETA1)DTHETA=-ABS(DTHETA)
C
C compute theta values for this scattering plane
C
      NSCA0=1
      DELTA=THETA2-THETA1
      IF(DELTA.NE.0)NSCA0=1+INT(DELTA/DTHETA+0.5)
C
C Check that there is enough storage space:
C
      IF((NSCA+NSCA0).GT.MXSCA)THEN
         WRITE(IDVOUT,FMT='(I6,I6,A)')MXSCA,NSCA0,
     &         ' =MXSCA,NSCA0 (dirs in this scatt. plane)'
         CALL ERRMSG('FATAL','REAPAR',
     &               'MXSCA too small in DDSCAT')
      ENDIF
      THETAN(NSCA+1)=THETA1
      IF(NSCA0.GT.2)THEN
         DO J=2,NSCA0-1
            THETAN(NSCA+J)=THETA1+(J-1)*DTHETA
         ENDDO
      ENDIF
      THETAN(NSCA+NSCA0)=THETA2
      DO J=1,NSCA0
         PHIN(NSCA+J)=PHI1
      ENDDO
      NSCA=NSCA+NSCA0
      WRITE(CMSGNM,FMT='(I4,A)')NSCA0,
     &  ' = number of scattering angles in this scattering plane'
      CALL WRIMSG('REAPAR',CMSGNM)
      GOTO 22
 25   CONTINUE
C
C Check that if user has requested computation of f_ml, user has
C also requested linearly-polarized incident radiation.
C 96.01.25 (BTD) We have disabled this "protection".  So long as user
C is aware that when using elliptical incident polarization the
C f_ml are not the "usual" ones with index l referring to linearly
C polarized incident modes, there is not reason not to allow user
C to calculate f_ml for the the scattered radiation.
C
C      IF(NSCA.GT.0)THEN
C         DO 26 J=1,3
C            IF(AIMAG(CXE01(J)).NE.0.)CALL ERRMSG('FATAL','REAPAR',
C     &      'pol. vector E01 is complex: DDSCAT cannot compute f_ml, so 
C     &do not ask it to!')
C 26      CONTINUE
C      ENDIF
C
      CLOSE (IOPAR)
      RETURN
   40 CONTINUE
      CALL WRIMSG('REAPAR',CWHERE)
      CALL ERRMSG('FATAL','REAPAR',' Error reading ddscat.par file')
      RETURN
      END

      SUBROUTINE WRITENET(CNETFILE,IDNC,CNETFLAG,CSTAMP,CDESCR,CMDFFT,
     &                    CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,
     &                    MXBETA,MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,
     &                    NX,NY,NZ,NAT0,NAT,NAT3,NAVG,NSCAT,NCOMP,NORI,
     &                    NWAV,NRAD,NTHETA,NPHI,NBETA,NTIMERS,MXNX,MXNY,
     &                    MXNZ,MXCOMP,BETMID,BETMXD,THTMID,THTMXD,
     &                    PHIMID,PHIMXD,TOL,DX,WAVEA,AEFFA,
     &                    THETA,BETA,PHI,A1,A2,ICOMP,IXYZ0,IWAV,IRAD,
     &                    ITHETA,IBETA,IPHI,IORI,AEFF,WAVE,XX,AK1,BETAD,
     &                    THETAD,PHID,AKR,CXE01R,CXE02R,CXRFR,CXEPS,
     &                    QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,
     &                    QTRQSC,SM,SMORI,
     &                    QEXSUM,QABSUM,QSCSUM,QBKSUM,QPHSUM,QSCGSUM,
     &                    QTRQABSUM,QTRQSCSUM,
     &                    PHIN,THETAN,TIMERS)
C***********************************************************************
C Dummy version of subroutine WRITENET
C (genuine subroutine WRITENET writes NetCDF portable binary file
C to file cnetfile 'dd.cdf')
C
C This dummy version is provided in order that use of DDSCAT is
C possible even if NetCDF software is not installed on system.
C
C History:
C 96.11.15 (PJF): First version of NetCDF  (Wolff's request)
C                 5a6 ---> 5a7 Converted to subroutine.
C 96.11.20 (BTD): dummy version created from real WRITENET
C 98.01.11 (BTD): added DX(3) to argument list for compatibility with
C                 new version of WRITENET
c 04.04.04 (BTD): Added additional variables to argument for
c                 compatibility with new version of WRITENET
C end history
C Copyright (C) 1996,1998,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C     .. Scalar Arguments ..
      REAL AEFF,AK1,BETAD,BETMID,BETMXD,PHID,PHIMID,PHIMXD,THETAD,
     &     THTMID,THTMXD,TOL,WAVE,XX
      INTEGER IBETA,IDNC,IORI,IORTH,IPHI,IRAD,ITHETA,IWAV,
     &        MXBETA,MXCOMP,MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPHI,MXRAD,MXSCA,
     &        MXTHET,MXTIMERS,MXWAV,NAT,NAT0,NAT3,NAVG,NBETA,NCOMP,NORI,
     &        NPHI,NRAD,NSCAT,NTHETA,NTIMERS,NWAV,NX,NY,NZ
      CHARACTER CALPHA*6,CMDFFT*6,CMDTRQ*6,CNETFLAG*6,CSHAPE*6,
     &          CNETFILE*14,CSTAMP*22,CDESCR*67
C     .. Array Arguments ..
      COMPLEX CXE01R(3),CXE02R(3),CXEPS(MXCOMP),CXRFR(MXCOMP)
      REAL A1(3),A2(3),AEFFA(MXRAD),AKR(3),BETA(MXBETA),DX(3),G(2),
     &     PHI(MXPHI),PHIN(MXSCA),
     &     QABS(2),QABSUM(2),QAV(17),QBKSCA(2),QBKSUM(2),QEXSUM(2),
     &     QEXT(2),QPHA(2),QPHSUM(2),QSCAT(2),QSCGSUM(3,2),QSCSUM(2),
     &     QTRQAB(3,2),QTRQSC(3,2),QTRQABSUM(3,2),QTRQSCSUM(3,2),
     &     SM(MXSCA,4,4),SMORI(MXSCA,4,4),
     &     THETA(MXTHET),THETAN(MXSCA),TIMERS(MXTIMERS),WAVEA(MXWAV)
      INTEGER*2 ICOMP(MXN3),IXYZ0(MXNAT,3)
C
C This subroutine should never be called, so if it is, bail out...
C
      CALL ERRMSG('FATAL','DUMMYWRITENET',
     &   ' NetCDF is not installed. Change to NOTCDF in ddscat.par!')
      RETURN
      END

      SUBROUTINE TARNSP(A1,A2,DIAMX,PRINAX,DX,CFLSHP,CDESCR,
     &                  IDVSHP,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      IMPLICIT NONE

C** Arguments:

      CHARACTER CDESCR*67,CFLSHP*80
      INTEGER IDVSHP,IOSHP,MXNAT,NAT
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL DIAMX,PRINAX
      REAL A1(3),A2(3),DX(3)

C** Local variables:

      INTEGER NSPHMX
      PARAMETER(NSPHMX=100)
      CHARACTER CMSGNM*70
      LOGICAL OCC
      INTEGER JA,JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,NSPH
      REAL R2,SCALE,X,XMAX,XMIN,Y,YMAX,YMIN,Z,ZMAX,ZMIN
      REAL ALPHA(3),AS(NSPHMX),XS(NSPHMX),YS(NSPHMX),ZS(NSPHMX)

C***********************************************************************
C Routine to construct multisphere target
C
C Input:
C        DIAMX =max extent in X direction/d
C        PRINAX=0 to set A1=(1,0,0), A2=(0,1,0)
C              =1 to use principal axes for vectors A1 and A2
C        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
C                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
C                spacing
C        CFLSHP= name of file containing locations and radii of spheres
C        IOSHP =device number for "target.out" file
C              =-1 to suppress printing of "target.out"
C        MXNAT =dimensioning information (max number of atoms)
C
C and, from input file CFLSHP:
C
C        NSPH              = number of spheres
C        one descriptive line which will be ignored (may be blank)
C        XS(1) YS(1) ZS(1) AS(1)
C        XS(2) YS(2) ZS(2) AS(2)
C        ...
C        XS(NSPH) YS(NSPH) ZS(NSPH) AS(NSPH)
C
C where XS(J),YS(J),ZS(J) = x,y,z coordinates in target frame, in
C                                 arbitrary units, of center of sphere J
C        AS(J)            = radius of sphere J (same arbitrary units)
C
C units used for XS,YS,ZS, and AS are really arbitrary: actual size of 
C overall target, in units of lattice spacing d, is controlled by
C parameter SHPAR(1) in ddscat.par
C
C Output:
C        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
C        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        ICOMP(1-NAT,1-3)=composition identifier (currently 1 1 1)
C        CDESCR=description of target (up to 67 characters)
C
C B.T.Draine, Princeton Univ. Obs., 2000.06.12
C
C History:
C 00.06.12 (BTD) adapted to version 6.0 (introduce DX)
C 00.11.02 (BTD) write ICOMP to target.out
C 01.01.13 (BTD) corrected comments
C 01.04.21 (BTD) corrected comments
C 01.04.21 (BTD) corrected typo: changed
C                      YMAX=YS(1)+YS(1)
C                to    YMAX=YS(1)+AS(1)
C                Thanks to Ivan O. Sosa Perez (UNAM) for discovering
C                this error.
C 03.06.06 (BTD) corrected error in setting LMX1,...,LMZ2
C 03.11.06 (BTD) modified to use new version of PRINAXIS with eigenvalues
C                in argument list
C 04.03.19 (BTD) revert to previous version of PRINAXIS
C                change CFLSHP*13 to CFLSHP*80 to accomodate long file
c                names
c 04.05.23 (BTD) modified to obtain eigenvalues ALPHA from PRINAXIS
c                modified arg list of PRINAXIS to conform to change
C end history
C
C Copyright (C) 2000,2001,2003,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

C Read parameters of spheres:

      OPEN(UNIT=IDVSHP,FILE=CFLSHP)
      READ(IDVSHP,*)NSPH
      READ(IDVSHP,*)
      DO JX=1,NSPH
         READ(IDVSHP,*)XS(JX),YS(JX),ZS(JX),AS(JX)
      ENDDO

      CLOSE(IDVSHP)

C Dipoles are located at sites
C (x,y,z)=(I,J,K), I,J,K=integers

C Determine max extent in X direction:

      XMIN=XS(1)-AS(1)
      XMAX=XS(1)+AS(1)
      YMIN=YS(1)-AS(1)
      YMAX=YS(1)+AS(1)
      ZMIN=ZS(1)-AS(1)
      ZMAX=ZS(1)+AS(1)
      IF(NSPH.GT.1)THEN
         DO JX=2,NSPH
            IF(XS(JX)-AS(JX).LT.XMIN)XMIN=XS(JX)-AS(JX)
            IF(XS(JX)+AS(JX).GT.XMAX)XMAX=XS(JX)+AS(JX)
            IF(YS(JX)-AS(JX).LT.YMIN)YMIN=YS(JX)-AS(JX)
            IF(YS(JX)+AS(JX).GT.YMAX)YMAX=YS(JX)+AS(JX)
            IF(ZS(JX)-AS(JX).LT.ZMIN)ZMIN=ZS(JX)-AS(JX)
            IF(ZS(JX)+AS(JX).GT.ZMAX)ZMAX=ZS(JX)+AS(JX)
         ENDDO
      ENDIF
      SCALE=DIAMX/(XMAX-XMIN)

C Now determine min,max values of I,J,K:

      LMX1=NINT(SCALE*XMIN/DX(1)-0.01)
      LMX2=NINT(SCALE*XMAX/DX(1)+0.01)
      LMY1=NINT(SCALE*YMIN/DX(2)-0.01)
      LMY2=NINT(SCALE*YMAX/DX(2)+0.01)
      LMZ1=NINT(SCALE*ZMIN/DX(3)-0.01)
      LMZ2=NINT(SCALE*ZMAX/DX(3)+0.01)

C Convert AS to squared radius:

      DO JX=1,NSPH
         AS(JX)=(SCALE*AS(JX))**2
         XS(JX)=SCALE*XS(JX)
         YS(JX)=SCALE*YS(JX)
         ZS(JX)=SCALE*ZS(JX)
      ENDDO

C Determine list of occupied sites

      NAT=0
      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ)*DX(3)
         DO JY=LMY1,LMY2
            Y=REAL(JY)*DX(2)
            DO JX=LMX1,LMX2
               X=REAL(JX)*DX(1)
               OCC=.FALSE.
               DO JA=1,NSPH
                  R2=(X-XS(JA))**2+(Y-YS(JA))**2+(Z-ZS(JA))**2
                  IF(R2.LT.AS(JA))OCC=.TRUE.
               ENDDO
               IF(OCC)THEN

C Site is occupied:

                  NAT=NAT+1
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
            ENDDO
         ENDDO
      ENDDO

      IF(NAT.GT.MXNAT)THEN
         CALL ERRMSG('FATAL','TARNSP',' NAT.GT.MXNAT ')
      ENDIF

C Homogeneous target:

      DO JA=1,NAT
         DO JX=1,3
            ICOMP(JA,JX)=1
         ENDDO
      ENDDO

c*** diagnostic
c      write(0,*)'in tarsnp: made target with NAT=',NAT,' dipoles'
c***

c Specify target axes A1 and A2
c If PRINAX=0, then
c     A1=(1,0,0) in target frame
c     A2=(0,1,0) in target frame
c If PRINAX=1., then
c     A1,A2 are principal axes of largest, second largest moment of
c     inertia

      IF(PRINAX.LE.0.)THEN
         DO JX=1,3
            A1(JX)=0.
            A2(JX)=0.
         ENDDO
         A1(1)=1.
         A2(2)=1.
      ELSE
         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,ALPHA)
      ENDIF

C***********************************************************************
C Write target description into string CDESCR

      WRITE(CDESCR,FMT='(A,I7,A)')' Multisphere cluster containing',
     &   NAT,' dipoles'

C***********************************************************************

      CMSGNM=CDESCR
      CALL WRIMSG('TARNSP',CMSGNM)
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)NSPH,DIAMX,NAT,ALPHA,A1,A2
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3),
     &                           ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
 9020 FORMAT(' >TARNSP multisphere target composed of ',I3,' spheres, ',
     &   'DIAMX=',F8.4,/,
     &   I7,3F8.4,' = NAT, alpha_1-3',/,
     &   3F9.5,' = A_1 vector',/,
     &   3F9.5,' = A_2 vector',/,
     &   ' 1.00 1.00 1.00 = lattice spacings (d_x,d_y,d_z)/d',/,
     &'     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
C
C     timeit_titan
C
C This version of TIMEIT is for Titan computers.
C
c history
C 94.06.20 (PJF) add dtime to the formal parameters
C 04.04.05 (BTD) changed IF(CMSGTM(1:7).NE.. to IF(CMSGTM.NE..
c end history
C Copyright (C) 1993,1994,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C     .. Scalar Arguments ..
      CHARACTER CMSGTM* (*)
C     ..
C     .. Local Scalars ..
      REAL DTIME, OLDTIM, TIME
      INTEGER IAD
      CHARACTER CSTA*3, CMSGNM*70
C     ..
C     .. External Subroutines ..
      EXTERNAL WRIMSG
C     ..
C     .. External Functions ..
      REAL CPUTIM
      EXTERNAL CPUTIM
C     ..
C     .. Data statements ..
      DATA CSTA/'ONE'/
C     .. 
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         OLDTIM=CPUTIM(0.)
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         TIME=CPUTIM(0.)
         IF(CMSGTM.NE.'NOPRINT'.AND.CMSGTM.NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            WRITE(CMSGNM,FMT='(G15.6, A)')DTIME,' CPU time (in secs) '
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
      IMPLICIT NONE
C
C     timeit_null
C
C This version of timeit is a dummy which does not provide any
C timing information.
c history:
C 94.06.20 (PJF) add dtime to the formal parameters
C 99.05.12 (BTD) explicitly declare DTIME
C 04.04.05 (BTD) changed IF(CMSGTM(1:7).NE.. to IF(CMSGTM.NE..
C end history
C
C Copyright (C) 1993,1999,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      CHARACTER CMSGTM*(*)
      REAL DTIME
C Local variables:
      CHARACTER CSTA*3,CMSGNM*70
C***********************************************************************
      DATA CSTA/'ONE'/
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         WRITE(CMSGNM,FMT='(A,A)')'Timing results for: ',CMSGTM
         CALL WRIMSG('TIMEIT',CMSGNM)
         IF(CMSGTM.NE.'NOPRINT'.AND.CMSGTM.NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A)')
     &         'Dummy timing routine: no timings available'
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      DTIME=0.
      RETURN
      END

      SUBROUTINE NAMID(MYID,CFLLOG)
      IMPLICIT NONE
C***********************************************************************
C Purpose: to generate unique file names for log file written
C          each MPI process
C
C Present version allows up to 1000 MPI processes (000-999)
C
C Given:
C         MYID=integer (0-999) MPI ID number

C Returns:
C          CFLLOG=name for output file containing running output
C                 from DDSCAT
C                 = ddscat.log_nnn
C                   where nnn = MYID
C
C B.T.Draine, Princeton Univ. Observatory, 2003.04.12
C History:
C 03.04.12 (BTD): Created using NAMER as an example
C end history
C
C Copyright (C) 2003, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:

      INTEGER MYID
      CHARACTER CFLLOG*14

C Local variables:

      CHARACTER A1*11,ZLOG*14
      CHARACTER N(0:9)*1,V(1:3)*1,W(1:14)*1

C Equivalences:
      EQUIVALENCE (A1,W(1)),(V,W(12))
      EQUIVALENCE (W,ZLOG)

C DATA statements:

      DATA N/'0','1','2','3','4','5','6','7','8','9'/
C***********************************************************************
C*** Filename CFLLOG will be of the form ddscat.log_NNN
C     where NNN = MYID
C
      A1='ddscat.log_'

      V(1)=N(MYID/100)
      V(2)=N((MYID-100*(MYID/100))/10)
      V(3)=N(MYID-10*(MYID/10))

      CFLLOG=ZLOG

      RETURN
C
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
      IMPLICIT NONE
C
C     timeit_convex
C
C This version of timeit uses the system call "etime" available under
C Convex unix and other bsd-like Unix systems.
C history:
C 94.06.20 (PJF) add dtime to the formal parameters
C 95.06.19 (PJF) modified to suppress printing if CMSGTM='noprint'
C 04.04.05 (BTD) changed IF(CMSGTM(1:7).NE.. to IF(CMSGTM.NE..
C end history
C Copyright (C) 1993,1995,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      CHARACTER CMSGTM* (*)
C Local variables:
      REAL DTIME,OLDTIM
      CHARACTER CSTA*3,CMSGNM*70
      REAL TARRAY(2)
C External Subroutines:
      EXTERNAL WRIMSG
C External Functions:
      REAL ETIME
      EXTERNAL ETIME
C***********************************************************************
      DATA CSTA/'ONE'/
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         OLDTIM=ETIME(TARRAY)
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         DTIME=ETIME(TARRAY)-OLDTIM
         IF(CMSGTM.NE.'NOPRINT'.AND.CMSGTM.NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            WRITE(CMSGNM,FMT='(G15.6, A)')DTIME,' CPU time (in secs) '
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE SCAVEC(MXSCA,NSCAT,THETAN,PHIN,CXE01,ENSC,EM1,EM2)
      IMPLICIT NONE
C***********************************************************************
C Given:
C      MXSCA=dimension information for ENSC,PHIN,THETAN
C      NSCAT=number of scattering directions
C      THETAN(1-NSCAT)=scattering angles theta
C      PHIN(1-NSCAT)=scattering angles phi
C      CXE01(1-3)=complex polarization vector 1 (phi=0 direction
C                 is defined by x,y plane (Lab Frame), where incident
C                 radiation propagates along the x axis.
C Returns:
C      ENSC(1-3,1-NSCAT)=scattering vectors in Lab Frame
C      EM1(1-3,1-NSCAT)=scattered pol vectors parallel to scat. plane
C                       in Lab Frame
C      EM2(1-3,1-NSCAT)=scattered pol vectors perp. to scat. plane
C                       in Lab Frame
C It is assumed that incident propagation vector is in x-direction
C in Lab Frame
C
C History:
C 96.11.06 (BTD): Changed definition of scattering angle phi
C                 Previously, phi was measured from plane containing
C                 incident k vector (i.e., Lab x-axis) and Re(CXE01)
C                 Henceforth, phi is measured from Lab x,y plane.
C
C Copyright (C) 1993,1996, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C Arguments:
      INTEGER MXSCA,NSCAT
      COMPLEX CXE01(3)
      REAL EM1(3,MXSCA), EM2(3,MXSCA), ENSC(3,MXSCA), PHIN(MXSCA),
     &     THETAN(MXSCA)
C
C Local variables:
      INTEGER I
      REAL COSPHI,COSTHE,SINPHI,SINTHE
C
C***********************************************************************
      DO 1000 I=1,NSCAT
         COSPHI=COS(PHIN(I))
         SINPHI=SIN(PHIN(I))
         COSTHE=COS(THETAN(I))
         SINTHE=SIN(THETAN(I))
         ENSC(1,I)=COSTHE
         ENSC(2,I)=SINTHE*COSPHI
         ENSC(3,I)=SINTHE*SINPHI
         EM1(1,I)=-SINTHE
         EM1(2,I)=COSTHE*COSPHI
         EM1(3,I)=COSTHE*SINPHI
         EM2(1,I)=0.
         EM2(2,I)=-SINPHI
         EM2(3,I)=COSPHI
 1000 CONTINUE
      RETURN
      END

      SUBROUTINE TARGSPHER(AEFF,PRINAX,BETA,RLMAX,S2,RSEED,
     &                     A1,A2,DX,CFLSHP,CDESCR,
     &                     IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      IMPLICIT NONE

C Arguments:

      CHARACTER CDESCR*67,CFLSHP*(*)
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL AEFF,BETA,PRINAX,RLMAX,RSEED,S2,S2LMAX
      REAL A1(3),A2(3),DX(3)

c local variables

      CHARACTER CMSGNM*70

c=======================================================================
c Fake version of subroutine TARGSPHER
c
c This routine acts as a placeholder for subroutine TARGSPHER
c which will generate "gaussian sphere" targets.
c to be released at a later date.

c B.T. Draine, Princeton University Observatory.
c
c=======================================================================
      WRITE(CMSGNM,FMT='(A)')
     &   'Fatal error: target option GSPHER not valid:'
      CALL WRIMSG('TARGSPHER',CMSGNM)
      WRITE(CMSGNM,FMT='(A)')
     &   ' subroutine TARGSPHER is not available in DDSCAT 6.1'
      CALL WRIMSG('TARGSPHER',CMSGNM)
      STOP
      END

      SUBROUTINE DIAGL(U,V,IPAR)
      IMPLICIT NONE

C Arguments:
      COMPLEX U(*), V(*)
      INTEGER IPAR(*)

C Common variables:

      CHARACTER*6 CMETHD
      INTEGER
     &   IDVOUT,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &   NAT,NAT0,NAT3,NPY,NPZ,NX,NY,NZ

      COMPLEX CXADIA(1)
C-----------------------------------------------------------------------
      COMMON/M2/CXADIA
      COMMON/M6/MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3,NAT0,NX,NY,NZ,
     &          MXN3F,IDVOUT,NPY,NPZ,CMETHD
C-----------------------------------------------------------------------


C cg package
C Left preconditioning subroutine - division by diagonal
C History:
C Originally written by P.J. Flatau, 1993
C 00.06.26 (BTD) Removed MXMEMF from COMMON/M6/
C 04.03.04 (BTD) Added NPY,NPZ to COMMON/M6/ to support periodic
C                boundary conditions
C end history
C Copyright (C) 1993,2000,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License
c-----------------------------------------------------------------------

      CALL CDIV(U,V,CXADIA,NAT3)
      RETURN
      END

      SUBROUTINE CDIV(U,V,CXA,N)
      IMPLICIT NONE

C Arguments:

      INTEGER N
      COMPLEX U(*), V(*), CXA(*)
C
C Local variables:
      INTEGER I

c-----------------------------------------------------------------------
c Part of conjugate gradient package
c needed by left preconditioning subroutine
c Copyright (C) 2003 B.T. Draine and P.J. Flatau
c This code is covered by the GNU General Public License
c-----------------------------------------------------------------------
      DO I=1,N
         V(I)=U(I)/CXA(I)
      ENDDO
      RETURN
      END

      SUBROUTINE MATVEC(CXX,CXY,IPAR)
      IMPLICIT NONE
C Arguments:
      COMPLEX CXX(*), CXY(*), IPAR(*)
C Common:
      INTEGER*2 IOCC(1)
      INTEGER
     &   IDVOUT,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &   NAT,NAT0,NAT3,NPY,NPZ,NX,NY,NZ
      CHARACTER*6 CMETHD
      REAL AK(3),DX(3)
      COMPLEX CXADIA(1),CXAOFF(1),CXZC(1),CXZW(1)
C-----------------------------------------------------------------------
      COMMON/M1/AK,DX
      COMMON/M2/CXADIA
      COMMON/M3/CXZC
      COMMON/M4/CXZW
      COMMON/M5/IOCC
      COMMON/M6/MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3,NAT0,NX,NY,NZ, 
     &          MXN3F,IDVOUT,NPY,NPZ,CMETHD
      COMMON/M7/CXAOFF

C-----------------------------------------------------------------------
C Subroutine MATVEC

C matvec  --> cxy = A cxx          'N'
C tmatvec --> cxy = A' cxx         'T'
C cmatvec --> cxy = conjg(A') cxx  'C'
C
C 
C Notice that DDSCAT has cases 'N' and 'C' implemented in CPROD
C Notice, however, that in DDSCAT 'T'='N'.
C Some CG methods use cases N, C (like Petravic).
C Some CG methods use cases N, T (like PIM)
C Some CG use all three products N, C, T  (parts of CCGPAK)
C
C Information about matrix A is transfered via commons /M1/-/M7/ with
C the main program. Arrays cxadia, cxzc, cxzwm,  iocc are properly
C dimensioned inside "cprod". You may get warning during the compilation
C about "misaligned common". Ignore these. Also notice mxnatf,
C mxn3f,mxnxf, mxnyf, mxnzf. These are defined by "parameter
C statement" in main code and this is the reason why they have "f" suffix.
C
C ipar - information array, not used, defined for compatibility
C
C History:
C 97.11.01 (BTD): modified to allow for noncubic lattice, introduced
C                 new vector DX(1-3) via COMMON/M1/
C                 added DX to argument list of CPROD
C 97.12.25 (BTD): added COMMON/M7/CXAOFF to communicate off-diagonal
C                 elements of inverse polarizability tensors.
C                 Added CXAOFF to argument list of CPROD
C 00.06.13 (BTD): Explicit declaration of all variables.
C 00.06.25 (BTD): Removed MXMEMF from COMMON/M6/
C 04.03.04 (BTD): Added NPY,NPZ to COMMON/M6/ to support periodic
C                 boundary conditions
C                 Added NPY,NPZ to argument list of CPROD
C end history
C Copyright (C) 1993,1997,2000,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

      CALL CPROD(AK,DX,CMETHD,'N',CXADIA,CXAOFF,
     &           CXX,CXY,CXZC,CXZW,
     &           IDVOUT,IOCC,MXN3f,MXNATf,MXNXf,MXNYf,MXNZf,
     &           NAT,NAT0,NAT3,NX,NY,NZ,NPY,NPZ)
      RETURN
      END

      SUBROUTINE CMATVEC(CXX,CXY,IPAR)
      IMPLICIT NONE

C Arguments:

      COMPLEX CXX(*),CXY(*),IPAR(*)

C Common:

      INTEGER*2 IOCC(1)
      INTEGER
     &   IDVOUT,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &   NAT,NAT0,NAT3,NPY,NPZ,NX,NY,NZ
      CHARACTER*6 CMETHD
      REAL AK(3),DX(3)
      COMPLEX CXADIA(1),CXAOFF(1),CXZC(1), CXZW(1)
C-----------------------------------------------------------------------
      COMMON/M1/AK,DX
      COMMON/M2/CXADIA
      COMMON/M3/CXZC
      COMMON/M4/CXZW
      COMMON/M5/IOCC
      COMMON/M6/MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3,NAT0,NX,NY,NZ,
     &          MXN3F,IDVOUT,NPY,NPZ,CMETHD
      COMMON/M7/CXAOFF
C-----------------------------------------------------------------------
c Subroutine CMATVEC
c
C matvec  --> cxy = A cxx   
C tmatvec --> cxy = A' cxx   
C cmatvec --> cxy = conjg(A') cxx   
C History:
C 97.11.01 (BTD): modified to allow for noncubic lattice, introduced
C                 new vector DX(1-3) via COMMON/M1/
C                 added DX to argument list of CPROD
C 97.12.25 (BTD): added COMMON/M7/CXAOFF to communicate off-diagonal
C                 elements of inverse polarizability tensors.
C                 Added CXAOFF to argument list of CPROD
C 00.06.13 (BTD): Explicit declaration of all variables.
C 00.06.26 (BTD): Removed MXMEMF from COMMON/M6/
C 04.03.04 (BTD): Added NPY,NPZ to COMMON/M6/ to support periodic
C                 boundary conditions
C                 Added NPY,NPZ to argument list of CPROD
C end history
C Copyright (C) 1993,1997,2000,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

      CALL CPROD(AK,DX,CMETHD,'C',CXADIA,CXAOFF,
     &           CXX,CXY,CXZC,CXZW,
     &           IDVOUT,IOCC,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &           NAT,NAT0,NAT3,NX,NY,NZ,NPY,NPZ)
      RETURN
      END

      SUBROUTINE CPROD(AK,DX,CMETHD,CWHAT,CXADIA,CXAOFF,
     &                 CXX,CXY,CXZC,CXZW,
     &                 IDVOUT,IOCC,MXN3,MXNAT,MXNX,MXNY,MXNZ,
     &                 NAT,NAT0,NAT3,NX,NY,NZ,NPY,NPZ)
      IMPLICIT NONE

c Arguments:

      INTEGER IDVOUT,MXN3,MXNAT,MXNX,MXNY,MXNZ,
     &        NAT,NAT0,NAT3,NPY,NPZ,NX,NY,NZ
      CHARACTER CMETHD*6,CWHAT*1
      INTEGER*2 IOCC(MXNAT)
      REAL AK(3),DX(3)
      COMPLEX CXADIA(MXN3),CXAOFF(MXN3),
     &        CXX(MXN3),CXY(MXN3),CXZC(NX+1,NY+1,NZ+1,6),
     &        CXZW(MXNX*MXNY*MXNZ,*)

c Local variables:

      INTEGER J1,J2,J3
      REAL AKD

C Intrinsic functions:

      INTRINSIC CONJG

C***********************************************************************
c Subroutine CPROD

C Given:
C   AK(1-3)= k(1-3)*d , where k=k vector in vacuo
C                       d=effective lattice spacing=(dx*dy*dz)**(1/3)
C   DX(1-3)=(dx/d, dy/d, dz/d) 
C                 where dx,dy,dz=lattice spacing in x,y,z directions.
C                 By definition of effective lattice spacing d, must 
C                 have DX(1)*DX(2)*DX(3)=1
C   CMETHD = character variable specifying method used for FFT evaluation
C            (see ESELF)
C   CWHAT  = 'N' or 'C' determines what is to be done (see below)
C   CXADIA(1-NAT3) = diagonal elements of A(j,k)
C   CXAOFF(1-NAT3) = off-diagonal elements of 3x3 diagonal blocks of 
C                 A(j,k): CXAOFF(J,1-3)=a_{23},a_{31},a_{12} from 3x3
C                 matrix a_{ij} for dipole J.
C                 Recall that a_{ij} is inverse of 3x3 polarizability
C                 tensor alpha_{ij} for dipole J.
C   CXX(1-NAT3) = complex vector
C   CXZC        = (NX+1)*(NY+1)*(NZ+1)*6 array of Green function 
C                 coefficients used internally by ESELF, and generated
C                 by ESELF each time called with new k vector
C                 *****Not to be overwritten between calls to ESELF*****
C   CXZW        = complex workspace required by ESELF
C   IDVOUT      = device number for output
C   IOCC(1-NAT) = 0 or 1 if site is unoccupied or occupied
C   MXN3,MXNX,MXNY,MXNZ = dimensioning information (see DDSCAT)
C   NAT         = number of sites in extended target
C   NAT0        = number of occupied sites in extended target
C   NAT3        = 3*NAT
C   NX,NY,NZ    = extended target size is (NX*DX(1)) by (NY*DX(2)) by
C                 (NZ*DX(3))
C   NPY         = 0 to do isolated target
C               = periodicity/d(2) in y direction for periodic b.c.
C   NPZ         = 0 to do isolated target
C               = periodicity/d(3) in z direction for periodic b.c.
C
C If CWHAT = 'N', this returns CXY(j)=A(j,k)*CXX(k) (sum over k)
C          = 'C', this returns CXY(j)=conjg(A(k,j))*CXX(k) (sum over k)
C
C It is assumed that matrix A(j,k) is symmetric
C Diagonal elements of A(j,k) are in vector CXADIA(j)
C Off-diagonal terms coupling dipole component x with direction y, etc
C are stored in vector CXAOFF(j), CXAOFF(j+NAT), CXAOFF(j+2*NAT)
C Other off-diagonal elements of A(j,k) are produced internally by
C   subroutine ESELF, which uses 3d-FFT to accomplish convolution
C   of CXX with A-matrix terms coupling dipole j with other dipoles
C   (i.e., E field at j due to other dipoles)
C
C Original version of CPROD created by P.J.Flatau, Colorado State Univ.
C Subsequently modified by B.T.Draine, Princeton Univ. Obs.
C History:
C 90.11.04 (BTD): Major modification to incorporate FFT method (FFT
C                 computations are handled by ESELF).
C 90.11.08 (BTD): Remove DO...ENDDO structures; renumber DO...CONTINUEs
C 90.11.21 (BTD): Remove "CCGMVM" option: only FFT stuff retained.
C 90.12.03 (BTD): No longer necessary to change ordering of CXX and CXY
C 90.12.05 (BTD): Changed call to ESELF to eliminate MXNX,MXNY,MXNZ
C 97.11.01 (BTD): Added comments and modified to accomodate noncubic
C                 lattice. Added DX to argument list for CPROD and to
C                 argument list in call to ESELF
C 97.12.25 (BTD): Added CXAOFF to argument list.
C 97.12.28 (BTD): Modified to use CXAOFF in calculation of CXY
C 98.01.01 (BTD): Modified coding to use indices J1,J2,J3 in loops
C                 computing with CXAOFF
C 00.06.13 (BTD): Explicit declaration of all variables.
C 04.03.05 (BTD): Added NPY,NPZ to argument list to support periodic
C                 boundary conditions
C end history
C Copyright (C) 1993,1997,1998,2000,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
c-----------------------------------------------------------------------

      AKD=SQRT(AK(1)*AK(1)+AK(2)*AK(2)+AK(3)*AK(3))

C We assume that input vector CXX has zeroes for elements corresponding
C to vacuum sites.

      IF(CWHAT.EQ.'N')THEN
C***********************************************************************
C
         CALL ESELF(CMETHD,CXX,NX,NY,NZ,NPY,NPZ,AKD,DX,CXZC,CXZW,CXY)
C
C***********************************************************************
C ESELF omitted contribution from diagonal terms: add these.
C Also remember that ESELF computes -A_jk*x_k
         DO J1=1,NAT3
            CXY(J1)=CXADIA(J1)*CXX(J1)-CXY(J1)
         ENDDO

C Add contribution from off-diagonal elements of 3x3 diagonal blocks
C Version below assumes that off-diagonal elements a_ij are stored as
C CXAOFF(J,1-3)=(a_23,a_31,a_12) for dipole J.
C 97.12.28 (BTD):

         DO J1=1,NAT
            J2=J1+NAT
            J3=J2+NAT
            CXY(J1)=CXY(J1)+CXAOFF(J2)*CXX(J3)+CXAOFF(J3)*CXX(J2)
            CXY(J2)=CXY(J2)+CXAOFF(J3)*CXX(J1)+CXAOFF(J1)*CXX(J3)
            CXY(J3)=CXY(J3)+CXAOFF(J1)*CXX(J2)+CXAOFF(J2)*CXX(J1)
         ENDDO

      ELSEIF(CWHAT.EQ.'C')THEN

C Need to temporarily replace CXX by conjg(CXX)

         DO J1=1,NAT3
            CXX(J1)=CONJG(CXX(J1))
         ENDDO

C**********************************************************************
C
         CALL ESELF(CMETHD,CXX,NX,NY,NZ,NPY,NPZ,AKD,DX,CXZC,CXZW,CXY)
C
C************************************************************************
C
C ESELF omitted contribution from diagonal terms: add these.
C Also remember that ESELF computed -A_jk*conjg(x_k), while
C we seek to compute conjg(A_kj)* x_k.  Since A_kj=A_jk, we have
C conjg(A_kj)*x_k=conjg(A_jk*conjg(x_k))
C
         DO J1=1,NAT3
            CXY(J1)=CXADIA(J1)*CXX(J1)-CXY(J1)
         ENDDO
C
C Add contribution from off-diagonal elements of 3x3 diagonal blocks
C It is assumed that we have stored off-diagonal elements a_ij as
C CXAOFF(J,1-3)=(a_23,a_31,a_12) for element J
C Note that we could *probably* speed up the code by
C (1) "reducing" product vector CXY immediately after calling ESELF
C (2) restricting CXADIA to occupied sites
C (3) restricting CXAOFF to occupied sites
C but this would require modifications outside this routine, and
C therefore requires further study...
C 97.12.28 (BTD)

         DO J1=1,NAT
            J2=J1+NAT
            J3=J2+NAT
            CXY(J1)=CXY(J1)+CXAOFF(J2)*CXX(J3)+CXAOFF(J3)*CXX(J2)
            CXY(J2)=CXY(J2)+CXAOFF(J3)*CXX(J1)+CXAOFF(J1)*CXX(J3)
            CXY(J3)=CXY(J3)+CXAOFF(J1)*CXX(J2)+CXAOFF(J2)*CXX(J1)
         ENDDO

C Now compute conjugate of CXY, and restore CXX:

         DO J1=1,NAT3
            CXY(J1)=CONJG(CXY(J1))
            CXX(J1)=CONJG(CXX(J1))
         ENDDO
      ELSE
         WRITE(IDVOUT,FMT=*)' Error in CPROD: CWHAT= ',CWHAT
      ENDIF

C*** Now must "clean" product vector CXY:
C    (zero out elements corresponding to vacuum sites)

      IF(NAT0.LT.NAT)CALL NULLER(CXY,IOCC,MXNAT,MXN3,NAT)
      RETURN
      END

      SUBROUTINE NULLER(CXVEC,IOCC,MXNAT,MXN3,NAT)
      IMPLICIT NONE
C Arguments:
      INTEGER MXNAT,MXN3,NAT
      INTEGER*2 IOCC(MXNAT)
      COMPLEX*8 CXVEC(NAT,3)
C Local variables:
      INTEGER J,L
C***********************************************************************
C This routine takes as input a complex vector with NAT3 elements
C and sets to zero those elements corresponding to "vacuum" sites.
C This is accomplished by multiplying by vector IOCC(J), whose
C elements are either 1 or 0 depending on whether site is occupied
C or "vacuum".
C Note: CXVEC should be given dimension CXVEC(NAT,3) here
C       so that first 3*NAT elements of CXVEC are employed.
C
C B.T.Draine, Princeton Univ. Obs., 90/11/1
C History:
C 90/12/15 (BTD): Corrected error in dimensioning of CXVEC.
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DO 110 L=1,3
         DO 100 J=1,NAT
            IF(IOCC(J).EQ.0)THEN
               CXVEC(J,L)=IOCC(J)*CXVEC(J,L)
            ENDIF
  100    CONTINUE
  110 CONTINUE
      RETURN
      END

      PROGRAM DDSCAT
      IMPLICIT NONE

c-----------------------------------------------------------------------

c           Instructions for Enabling or Disabling MPI
c           ==========================================

c To enable MPI use (this requires that you have installed the "full"
c version of DDSCAT):  
c                      uncomment INCLUDE statement
c                      comment out INTEGER MPI_COMM_WORLD statement
c                      compile mpi_subs.f

c For non-MPI version (either the "plain" version of DDSCAT, or the
c "full" version with MPI support disabled):

c                      comment out INCLUDE statement
c                      uncomment INTEGER MPI_COMM_WORLD statement
c                      compile mpi_fake.f

c      INCLUDE 'mpif.h'
      INTEGER MPI_COMM_WORLD

c-----------------------------------------------------------------------

C**********************************************************************

C                          DDSCAT.6.1

C    DDSCAT is a program to use the Discrete Dipole Approximation (DDA)
C    to calculate the absorption and scattering properties of targets
C    of arbitrary geometry and dielectric properties.  The only
C    approximation is that the target may be approximated by an array
C    of point dipoles on a cubic lattice.
C    DDA theory and validity criteria are discussed in
C    Draine, B.T. 1988, 
C       "The Discrete-Dipole Approximation and its Application to 
C       Interstellar Graphite Grains",
C       Astrophys. J., 333, pp. 848-872
C    Draine, B.T., & Flatau, P.J. 1994, 
C       "Discrete dipole approximation for scattering calculations",
C       J. Opt. Soc. Am. A, 11, 1491-1499

C    The original version of DDSCAT was developed by B. T. Draine,
C    Princeton University Observatory.
C
C    Subsequent versions  of DDSCAT were jointly developed by
C    B. T. Draine (Princeton University Observatory) and
C    P. J. Flatau (University of California, San Diego, Scripps Inst.
C                  of Oceanography, La Jolla)
C
C    DDSCAT.6.1 includes the following features:
C    1. Optional generation of target arrays for to approximate several
C       standard target shapes, including
C       a. ellipsoid (sphere is special case) ("ELLIPS")
C       b. cylindrical prism ("CYLNDR")
C       c. rectangular prism ("RCTNGL")
C       d. hexagonal prism ("HEXGON")
C       e. regular tetrahedron ("TETRAH")
C       f. cylindrical prism with anisotropic diel. tensor ("UNICYL")
C          (uniaxial material with crystal axis = cylinder axis)
C       g. ellipsoid with anisotropic diel. tensor ("ANIELL")
C       h. two touching ellipsoids with either isotropic or aniostropic
C          dielectric tensors ("TWOELL" or "TWOAEL")
C       i. three thouching ellipsoids with either isotropic or aniostropic
C          dielectric constants ("THRELL" or "THRAEL")
C       j. two concentric ellipsoids ("CONELL")
C       k. target consisting of cubic blocks ("BLOCKS")
C       l. target consisting of union of N spheres ("NSPHER")
C       m. triangular prism ("PRISM3")
C       n. layered slab ("LYRSLB")
C    2. Alternatively, program may read in target array properties from
C       ascii file ("FRMFIL")
C    3. User may easily specify target orientation with respect to
C       incident plane wave.
C    4. Solution is found iteratively using Complex Conjugate Gradient
C       methods.
C    5. User may select FFT implementation:
C       a. GPFA code of Temperton (recommended for general use).
C       b. FFTW code of Frigo and Johnson
C       c. Convex vector library implementation (if on Convex);
C    6. User may select prescription for determining dipole
C       polarizabilities:
C       a. Lattice Dispersion Relation ("LATTDR") is only option supported
C          in DDSCAT.6.1
C    7. Automatic computation of cross sections for:
C       a. absorption;
C       b. extinction;
C       c. scattering;
C       d. vector radiation pressure;
C       e. vector torque.
C    8. User may easily specify scattering directions for which
C       scattering matrixs is to be computed.
C    9. Automatic computation of orientational averages, with
C       orientation weights provided by simple subroutine.
C   10. Multicomponent targets are allowed.
C   11. Anisotropic dielectric tensors are allowed, although with
C       the restriction that the principal axes must be aligned with
C       the xyz directions in the "target frame".
C   12. Wavelength-dependent dielectric functions are read from user-
C       provided files, with automatic interpolation if necessary.
C   13. Automatic looping over radii and wavelengths if desired.
C   14. User may select up to nine Mueller matrix elements for
C       computation.
C   15. DDSCAT.6.0 introduces support for MPI (Message Passing Interface)
C       for parallel computations of different scattering orientations.
C   16. New with DDSCAT.6.1: 
C       Automatic selection of scattering directions for computation
C       of angular averages: radiation pressure force, <cos>, <cos^2>,
C       and radiation torque.  User sets a single parameter ETASCA
C       which controls angular resolution.  Reducing ETASCA will lead
C       to greater accuracy in calculation of angular averages.
C       ETASCA=1 should provide accuracy of better than 1% for angular
C       averages.

C History:
C Note: Overall history of significant changes to the DDSCAT package may
C       be found in the comments in subroutine version.f .
C Here we limit comments to changes to this program module, DDSCAT.f:
C 90.11.30 (BTD): Removed LSC3 portion of CXSC complex scratch space.
C 90.12.03 (BTD): Reordered vectors.
C                 Removed LSC2 and LSC1 portions of CXSC scratch space.
C 90.12.21 (BTD): Added code to create output files
C                 'qtable' (summary of Q values)
C                 'mtable' (summary of diel. func. for material 1)
C 91.01.03 (BTD): Added MXBETA,MXPHI,MXTHET to argument list for REAPAR
C 91.01.05 (BTD): Changed I4 -> I7 in format statements 9010,9011.
C                 Set IOSHP=-1 to suppress printing of target.out file.
C 91.05.08 (BTD): Added CALPHA to argument lists for REAPAR and ALPHA
C                 and added CALPHA to various WRITE statements.
C 91.05.23 (BTD): Added IWRKSC to arg. list for REAPAR and use it to
C                 control creation of wAArBBkCCC.sca files
C                 Move lines calculating G.
C                 Move code writing to qtable and mtable.
C                 Added IDVOUT to argument list for TARGET
C 91.08.14 (BTD): Add QBKSCA to arg. list for GETFML
C                 Modify code to print out Q_bk
C 91.08.15 (BTD): Provide different headings for qtable depending on
C                 whether IORTH=1 or 2 (add statement 9043).
C 91.09.17 (BTD): Remove calls to ALPHA and EVALA (needed to move these
C                 to subroutine GETFML since alpha from Lattice
C                 Dispersion Relation depends on propagation direction
C                 and polarization state)
C                 Add CALPHA,CXEPS,ICOMP,MXCOMP to argument list for
C                 GETFML (information required by ALPHA)
C 91.11.12 (BTD): Added variable IDVSHP to argument list for TARGET
C                 (device number for REASHP to use in reading shape file)
C 93.01.15 (BTD): Divided output file qtable into 2 files:
C                 qtable (containing Q_ext,Q_abs,Q_sca,g,Q_bk) and
C                 qtable2 (containing Q_pha, Q_pol, Q_cpol)
C 93.01.16 (BTD): Modify so that qtable, qtable2, and mtable are closed
C                 after writing, and reopened for each new write
C 93.01.20 (BTD): Add MXNX, MXNY, MXNZ to argument list for subroutine
C                 EXTEND to permit checking of target size against
C                 maximum allowed dimensions
C 93.03.11 (BTD): Deleted all code associated with unused variable
C                 CMACHN (originally included to identify machine/OS)
C 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
C                 Moved WRITE(IDVOUT,9010) to subr. TARGET
C 93.06.02 (BTD): Corrected error in FORMAT statement 9045
C 93.06.03 (BTD): Corrected error in computation of angle-averaged
C                 backscattering cross section QBKSUM(JO) (had neglected
C                 to reset sum to zero for each new target).
C 93.09.28 (BTD): Add "fix" to work around Sun compiler/OS bug (see
C                 description below.
C 93.12.15 (BTD): Corrected calculation of PPOL.  Added comments on
C                 correspondence between our notation and elements
C                 of 2x2 amplitude scattering matrix and 4x4 Mueller
C                 scattering matrix.
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
C                 allow up to 6 shape parameters
C 94.06.20 (PJF): Comment about NEWTMP FFT and corresponding changes
C                 in reapar, eself, extend.  Add FFT timing code
C                 TSTFFT to distribution and changes to cxfft3 and 
C                 timeit routines.
C 94.12.20 (BTD): Introduce subroutine VERSION to set value of
C                 variable CSTAMP.  version.f will now serve as
C                 location to maintain log of significant code
C                 changes.
C 95.06.15 (BTD): Changed CSTAMP from character*11 to character*22
C                 to include a date.
C 95.06.14 (BTD): Create version 5x.1 for internal use.
C                 Version 5x.1 computes vector force and torque
C                 on grain due to incident radiation.
C                 Changed QSCATG(2) to QSCAG(3,2) to allow for
C                 asymmetric scattering by target.
C                 Added variable QTRQSC(1-3,1-2) and added to
C                 argument list of GETFML
C                 Replaced variable GSUM(1-2) to QSCGSUM(1-3,1-2)
C                 Added variables QTRQAB(1-3,1-2) and 
C                 QTRQABSUM(1-3,1-2)
C 95.06.20 (PJF+: Introduce changes into DDSCAT in order to support
C           BTD): use of modular iterative solvers (e.g., CCG).
C               : add CMDSOL to argument list to specify method
C                 of solution
C               : add CMDTRQ to argument list of REAPAR and GETFML
C 95.07.10 (BTD): deleted redundant declarations of NAT,NAT0,NAT3,
C                 NX,NY,NZ (already declared in COMMON/M6/
C 95.07.20 (BTD): added new scratch array SCRRS2(MXNAT) for use in
C                 torque calculations in SCAT
C 95.07.27 (BTD): Added new scratch variable CXSCR1 for GETFML to
C                 use for storing first polarization solution while
C                 solving for second.
C 96.01.26 (BTD): Replaced IX0,IY0,IZ0 by IXYZ0
C                 (with simultaneous change in TARGET)
C 96.02.23 (BTD): Modified format statements to get additional digits
C                 for a_1, a_2, k vector, and pol. vectors.
C 96.11.05 (BTD): Modified to remove various computations to
C                 subroutines GETMUELLER and WRITESCA
C 96.11.14 (PJF): Add TIMERS, MXTIMERS, NTIMERS 
C                 Add cbinflag, cbinfile, IOBIN (binary file)
C                 Add cbinflag to formal parameters of REAPAR routine
C                 Remove GETSET routine calls
C 96.11.15 (PJF): Add cnetflag, cnetfile to reapar call. Add netCDF close
C 96.11.21 (BTD): Declared IDNC,NTIMERS,etc.
C                 Removed call to NCCLOS
C                 Added call to WRITESCA in order to call WRITENET in
C                 order to call NCCLOS in order to close netCDF file
C 96.12.02 (BTD): initialized smori to zero before looping over
C                 orientations
C                 eliminated variables S1212,S222,CX1112,CX1122,
C                 CX1221,CX1222,CX2122
C 97.07.24 (BTD): Changed argument list for GETMUELLER, replacing
C                 PHI by PHIN, in order to correct error in computation
C                 of Mueller matrix elements and amplitude scattering
C                 matrix elements (see GETMUELLER).
C 97.11.01 (BTD): Modified to allow noncubic rectangular lattice.
C                 Information on lattice anisotropy is contained
C                 in variable DX(1-3)=(dx/d,dy/d,dz/d) where
C                 dx,dy,dz=lattice spacings in x,y,z directions
C                 d=(dx*dy*dz)**(1/3)
C                 Note that by definition, DX(1)*DX(2)*DX(3)=1
C                 Pass DX through COMMON/M1/ for use by subroutines
C                 MATVEC and CMATVEC
C 97.12.25 (BTD): Added CXAOFF to COMMON/M7/
C 98.01.13 (BTD): Added DX to argument list in last 2 calls to WRITESCA
C 98.05.01 (BTD): Removed DATA/IDVOUT/0 since IDVOUT is in COMMON
C                 Reduced number of continuation lines in CALL WRITESCA
C                 statements
C 98.08.09 (BTD): Slight change to FORMAT statement 9020
C 98.12.12 (BTD): Add NSMELTS,SMIND1,SMIND2 to argument lists of REAPAR
C                 and WRITESCA, to allow selection of Muller matrix
C                 elements
C 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
C                 CHARACTER*60 to allow longer file names
C                 (also changed in reapar.f and dielec.f)
C 99.01.26 (BTD): modify so we can restart calculation for specified
C                 IWAV0,IRAD0,IORI0
C                 now need to input IWAV0,IRAD0,IORI0 through ddscat.par
C 00.06.12 (BTD): added CFLSHP to argument list of REAPAR to support
C                 option NSPHER (need to pass CFLSPH from REAPAR to
C                 TARGET)
C 03.02.13 (BTD): added 1 more digit of precision to qtable and qtable2
C                 outputs; modified header line in stmnts 9044,9046
C 03.04.13 (BTD): added character variable CFLLOG to contain name of
C                 running output file
C                 added call to NAMID to generate a unique name for output
C                 file, to support MPI use.
C                 Unfortunately, when this is done, output to device 0
C                 is no longer unbuffered.
C                 If it is necessary to reenable unbuffered output for
C                 debugging purposes, 
C                 OPEN(UNIT=IDVOUT,FILE=CFLLOG)
C                 should be commented out
C                 Added variables ITNUM(2) and MXITER to argument lists
C                 for GETFML and WRITESCA
C 03.07.13 (BTD): Added new variable ITNUMMX(2) to store maximum number
C                 of iterations taken for any of the orientations for
C                 each size and wavelength, for output in orientational
C                 average files waarbbkccc.sca
C Develop version 6.1
C 03.10.23 (BTD): Removed ICTHM and IPHIM from argument lists of
C                 REAPAR, GETFML, SHARE1, and WRITESCA -- these 
C                 variables are no longer used, since SCAT now 
C                 determines scattering directions automatically
C                 Add ETASCA to argument list of REAPAR, SHARE1,
C                    GETFML, WRITESCA
C                 Added NAVG to argument list of GETFML and WRITESCA
c                 Add IWRKSC to argument list of SHARE1
c 04.02.22 (BTD): Add IWRKSC to argument list of WRITESCA and SHARE1
c 04.02.25 (BTD): Added final call to WRIMSG reporting normal 
c                 termination
c 04.04.01 (BTD): Added NPY,NPZ to COMMON/M6/ to support periodic
c                 boundary condition option
c 04.04.04 (BTD): Added NPY,NPZ to argument list of TARGET to be
c                 compatible with new version of TARGET
c 04.05.21 (BTD): One of the calls to WRITESCA had QSCGSUM and
c                 QSCG2SUM in incorrect order. Fixed.
c 04.05.22 (BTD): Added IF(CBINFLAG.NE.'NOTBIN') conditional
c                 before closing dd.bin (file never opened otherwise)
c 05.10.11 (BTD): Modified to support up to 1000 wavelengths:
c                 changed MXWAV from 100 to 1000
c                 changed CFLAVG*13 to CFLAVG*14
c                 changed CFLSCA*14 to CFLSCA*15
c                 (also changes in NAMER and WRITESCA)
c 05.10.18 (BTD): Modified to allow use of more than 1000 orientations
c                 if IWRKSC=0 (previously would exceed array limits
c                 in subroutine NAMER with IORI>1000).
C end history
C Copyright (C) 1993,1994,1995,1996,1997,1998,1999,2000,2003,2004,2005
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C    Adjustable Parameters:
C
C    MXNX   = max. extent of target in x direction
C    MXNY   =                          y
C    MXNZ   =                          z
C    MXCOMP = max. number of different dielectric functions
C    MXTHET = max. number of target  rotation angles THETA
C    MXBETA = max. number of target rotation angles BETA
C    MXPHI  = max. number of target rotation angles PHI
C    MXSCA  = max. number of scattered directions
C    MXRAD  = max. number of radii
C    MXWAV  = max. number of wavelengths
C    MXWAVT = max. number of wavelengths in dielectric tables
C
C*** Set parameters MXNX,MXNY,MXNZ *************************************
      INTEGER MXNX,MXNY,MXNZ
C      PARAMETER(MXNX=8,MXNY=8,MXNZ=8)
C      PARAMETER(MXNX=12,MXNY=12,MXNZ=12)
C      PARAMETER(MXNX=16,MXNY=16,MXNZ=16)
C      PARAMETER(MXNX=12,MXNY=18,MXNZ=18)
C      PARAMETER(MXNX=16,MXNY=24,MXNZ=24)
C      PARAMETER(MXNX=20,MXNY=20,MXNZ=20)
C      PARAMETER(MXNX=24,MXNY=24,MXNZ=24)
C      PARAMETER(MXNX=25,MXNY=25,MXNZ=25)
C      PARAMETER(MXNX=30,MXNY=30,MXNZ=30)
C      PARAMETER(MXNX=32,MXNY=32,MXNZ=32)
C      PARAMETER(MXNX=36,MXNY=36,MXNZ=36)
C      PARAMETER(MXNX=24,MXNY=48,MXNZ=42)
C      PARAMETER(MXNX=40,MXNY=40,MXNZ=40)
C      PARAMETER(MXNX=48,MXNY=16,MXNZ=16)
C      PARAMETER(MXNX=48,MXNY=48,MXNZ=48)
      PARAMETER(MXNX=50,MXNY=50,MXNZ=50)
C      PARAMETER(MXNX=60,MXNY=60,MXNZ=60)
C      PARAMETER(MXNX=64,MXNY=64,MXNZ=64)
C      PARAMETER(MXNX=72,MXNY=48,MXNZ=32)
C      PARAMETER(MXNX=72,MXNY=72,MXNZ=72)
C      PARAMETER(MXNX=80,MXNY=80,MXNZ=80)
C      PARAMETER(MXNX=81,MXNY=54,MXNZ=36)
C      PARAMETER(MXNX=90,MXNY=60,MXNZ=40)
C      PARAMETER(MXNX=96,MXNY=48,MXNZ=24)
C      PARAMETER(MXNX=72,MXNY=72,MXNZ=72)
C      PARAMETER(MXNX=96,MXNY=32,MXNZ=32)
C      PARAMETER(MXNX=100,MXNY=100,MXNZ=100)
C Experiment for maximum possible size on Intel-32 Linux
C      PARAMETER(MXNX=135,MXNY=135,MXNZ=135)
C      PARAMETER(MXNX=144,MXNY=144,MXNZ=144)
C 150x150x150 is too large for 32-bit Redhat Linux and pgf77
C      PARAMETER(MXNX=150,MXNY=150,MXNZ=150)
C
C
C*** Set parameters MXCOMP,MXTHET,MXBETA,MXPHI,MXRAD,MXWAV,MXWAVT,MXSCA
      INTEGER MXCOMP
C      PARAMETER(MXCOMP=1)
      PARAMETER(MXCOMP=9)
      INTEGER MXTHET,MXBETA,MXPHI 
      PARAMETER(MXTHET=100,MXBETA=100,MXPHI=100)
      INTEGER MXRAD,MXWAV,MXWAVT
      PARAMETER(MXRAD=100,MXWAV=1000,MXWAVT=1500)
      INTEGER MXSCA
      PARAMETER(MXSCA=1000)
      INTEGER MXTIMERS,NTIMERS
      PARAMETER(MXTIMERS=20,NTIMERS=12)

C*** Derived Parameters: **********************************************

      INTEGER MXNAT,MXN3
      PARAMETER(MXNAT=MXNX*MXNY*MXNZ,MXN3=3*MXNAT)
      INTEGER MXCXSC

C MXCXSC specifies required complex scratch array CXSC
C increase from 7*MXN3 required by PETR 
C           to 10*MXN3 required by PIMCBICGSTAB method 
C                 (PIM Complex BiConjugate Gradient with Stabilization)
      PARAMETER(MXCXSC=10*MXN3)
C
C Common variables (required for communication with the
C conjugate gradient package):
C
      CHARACTER CMDFFT*6
      INTEGER IDVOUT,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &        NAT,NAT3,NAT0,NPY,NPZ,NX,NY,NZ
      INTEGER*2 IOCC(MXNAT)
      REAL AKR(3),DX(3)
      COMPLEX
     &   CXADIA(MXNAT,3,3),
     &   CXAOFF(MXNAT,3),
     &   CXZC(MXNX+1,MXNY+1,MXNZ+1,6),
     &   CXZW(2*MXNX,2*MXNY,2*MXNZ,3)
C-----------------------------------------------------------------------
      COMMON/M1/AKR,DX
      COMMON/M2/CXADIA
      COMMON/M3/CXZC
      COMMON/M4/CXZW
      COMMON/M5/IOCC
      COMMON/M6/MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3,NAT0,NX,NY,NZ,
     &          MXN3F,IDVOUT,NPY,NPZ,CMDFFT
      COMMON/M7/CXAOFF
C-----------------------------------------------------------------------

C Local variables:

      CHARACTER CMDSOL*6,CMDTRQ*6,CMSGNM*70

      COMPLEX CXEN

      INTEGER NAVG

      REAL
     &   AEFF,AK1,AK3,BETAD,BETAMI,BETAMX,BETMID,BETMXD,
     &   DEGRAD,ETASCA,FREQ,
     &   PHID,PHIMAX,PHIMID,PHIMIN,PHIMXD,PI,PIA2,
     &   THETAD,THETMI,THETMX,THTMID,THTMXD,TOL,
     &   WAVE,XX

C Target Properties:
C AEFF=aeff=effective radius of target (physical units)
C PIA2=pi*(aeff/d)**2=pi*(3*NAT/4*pi)**(2/3)

C Incident Wave Properties:
C AK1=(k*d), where k=2*pi/wave=propagation vector and d=dipole spacing
C AK3=(k*d)**3
C AKE2=(k*d \dot E0), where E0 is incident polarization vector
C WAVE=wavelength (in vacuo) in physical units
C XX=k*aeff=2*pi*aeff/wave
C
C Scattering Properties:
C G=<cos(theta)> for scattered radiation
C QSCGSUM(1-3,1-2)=running (weighted) sum of g(1-3)*Q_sca
C           over target orientations, for incident polarizations 1-2,
C           where
C           g(1)=<cos(theta)> for scattered radiation
C           g(2)=<sin(theta)cos(phi)> for scattered radiation
C           g(3)=<sin(theta)sin(phi)> for scattered radiation
C           theta is measured relative to incident direction
C           phi is measured relative to x,y plane (Lab Frame)
C QPHA(1-2)=(phaseshift cross section)/(pi*aeff**2)
C QEXSUM(1-2)=running sum of QEXT over target orientations
C QABSUM(1-2)=running sum of QABS over target orientations
C QBKSUM(1-2)=running sum of QBKSCA over target orientations
C QSCSUM(1-2)=running sum of QSCA over target orientations
C QSCG2SUM(1-2)=running sum of cos^2*Q_sca
C QTRQSCSUM(1-3,1-2)=running sum of QTRQSC(1-3,1-2) over target orientations
C THETND=scattering angle theta in degrees
C PHIND=scattering angle phi in degrees
C SINPHI=sin(phi)
C DEPOLR=depolarization ratio for scattered of initially polarized
C        light into direction theta,phi
C PPOL=percentage polarization for scattering of initially unpolarized
C      light into direction theta,phi
C
      INTEGER
     &   IBETA,IBETA1,IBETH,IBETH1,IDIR,IDNC,IDVERR,IDVSHP,IERR,
     &   INIT,ILIN10,ILIN12,
     &   IOBIN,IOPAR,IORI,IORI0,IORI1,IORTH,IOSHP,IPHI,IPHI1,IRAD,
     &   IRAD0,IRAD1,ITASK,ITHETA,ITHETA1,IWAV,IWAV0,IWAV1,
     &   IWRKSC,
     &   J,JO,LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0,MYID,
     &   NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT,NSMELTS,NTHETA,
     &   NUMPROCS,NWAV

      INTEGER MXITER
      INTEGER ITNUM(2),ITNUMMX(2)


      INTEGER SMIND1(9),SMIND2(9)
C
C MYID     = MPI process identifier that runs from 0-(NUMPROCS-1). 0 is the
C            master process.
C NUMPROCS = number of MPI parallel processes (including the master)
C IERR     = MPI error code, which we ignore
C NAT=number of dipoles in target
C NAT3=3*NAT
C NBETA=number of different beta values for target orientation
C NBETH=NBETA*NTHETA=number of target orientations for outer orientation loop
C NTHETA=number of different theta values for target orientation
C NPHI=number of different phi values for target orientation
C NORI=NBETA*NTHETA*NPHI=total number of target orientations
C NSCAT=number of different scattering directions for each orientation
C NWAV=number of different wavelengths
C NRAD=number of different target radii
C NSMELTS=number of scattering matrix elements to print out
C INIT=0,1,2 for choice of initial vector |x0> in complex conjugate gradient
C      method
C IORTH=1 or 2 to do 1 or 2 incident polarizations
C IWRKSC=0 or 1 to suppress or generate "wAArBBkCCC.sca" files for each
C        target orientation
C NX=x-length of extended target
C NY=y-length of extended target
C NZ=z-length of extended target
C
C SMIND1(1-NSMELTS) = index 1 of scattering matrix elements to
C                     be printed out (e.g., 1 for element S_{13})
C SMIND2(1-NSMELTS) = index 2 of scattering matrix elements to
C                     be printed out (e.g., 3 for element S_{13})
      CHARACTER
     &   CALPHA*6,CDIEL*6,CSHAPE*6,CSTAMP*22,
     &   CFLAVG*14,CFLPAR*13,CFLSCA*15,CFLSHP*80,CDESCR*67,
     &   CBINFLAG*6, CBINFILE*14, CNETFLAG*6, CNETFILE*14
      CHARACTER CFLLOG*14
      CHARACTER*60 CFLEPS(MXCOMP)
C     ..
C     .. Local Arrays ..
      COMPLEX
     &   CX1121(MXSCA),
     &   CXALOF(MXN3),CXALOS(MXN3),
     &   CXALPH(MXN3),CXALDS(MXN3),
     &   CXE(MXN3),CXE01(3),CXE02(3),
     &   CXE01R(3),CXE02R(3),CXEPS(MXCOMP),
     &   CXF11(MXSCA),CXF12(MXSCA),CXF21(MXSCA),CXF22(MXSCA),
     &   CXRLOC(MXCOMP+1,3,3),
     &   CXRFR(MXCOMP),CXS1(MXSCA),CXS2(MXSCA),CXS3(MXSCA),CXS4(MXSCA),
     &   CXSC(MXCXSC),CXSCR1(MXN3),CXXI(MXN3)
C
C Arrays describing target properties:
C CXADIA(1-3*NAT)=diagonal elements of A matrix
C CXEPS(1-MXCOMP)=dielectric const. for each of MXCOMP materials
C CXREFR(1-3)=complex refractive index at current wavelength
C CXALPH(1-3*NAT)=diagonal elements of dipole polarizability tensor alpha
C CXALOF(1-3*NAT)=off-diagonal elements of dipole polarizability tensor alpha
C CXALDS(1-3*NAT)=diagonal elements of dipole polarizability tensor alpha
C                 calculated (for CALPHA.EQ.'SCLDR') by Rahmani et al. (2002)
C                 method, and stored to save computation time and memory
C CXALOS(1-3*NAT)=off-diagonal elements of dipole polarizability tensor 
C                 corresponding to CXALDS
C
C Arrays describing incident radiation:
C CXE01(1-3)=incident polarization vector e01 prior to target rotation
C CXE02(1-3)=incident polarization vector e02 prior to target rotation
C CXE01R(1-3)=rotated incident polarization vector e01 in Target Frame
C CXE02R(1-3)=rotated incident polarization vector e02 in Target Frame
C CXE0R(1-3)=incident polarization vector (=CXE01R or CXE02R) being used
C CXE(1-3*NAT)=incident electric field vector in Target Frame
C
C Array describing polarization of target for one incident wave:
C CXXI(1-3*NAT)=polarization vector at each dipole
C
C Arrays describing scattering properties of target:
C CXFF11(1-NSCAT)=scattering matrix element f11 for each of NSCAT directions
C CXFF12(1-NSCAT)=                          f12
C CXFF21(1-NSCAT)=                          f21
C CXFF22(1-NSCAT)=                          f22
C CX1121(1-NSCAT)=sum of f11* \times f21 over orientations
C
C Scratch arrays:
C CXSC(1-MXCXSC)=scratch array used by DDACCG
C
      INTEGER*2 ICOMP(MXN3),ISCR1(MXN3),IXYZ0(MXNAT,3)
C
C IXYZ0(1-NAT0,1-3)=x/d,y/d,z/d for dipoles 1-NAT0 in real target
C
C Scratch arrays:
C ISCR1,ISCR2,ISCR3,ISCR4 (used by EXTEND)
C
C
      REAL
     &   A1(3),A2(3),AEFFA(MXRAD),AKSR(3,MXSCA),
     &   BETA(MXBETA),
     &   E1A(MXWAVT),E2A(MXWAVT),EM1(3,MXSCA),EM1R(3,MXSCA),
     &   EM2(3,MXSCA),EM2R(3,MXSCA),EN0R(3),ENSC(3,MXSCA),
     &   PHI(MXPHI),PHIN(MXSCA),
     &   QABS(2),QABSUM(2),QBKSCA(2),QBKSUM(2),QEXT(2),
     &   QEXSUM(2),QPHA(2),QPHSUM(2),QSCAT(2),QSCAG(3,2),QSCAG2(2),
     &   QSCG2SUM(2),QSCGSUM(3,2),QSCSUM(2),QTRQAB(3,2),QTRQSC(3,2),
     &   QTRQABSUM(3,2),QTRQSCSUM(3,2),
     &   S1111(MXSCA),S2121(MXSCA),
     &   SCRRS1(MXN3),SCRRS2(MXNAT),SHPAR(6),SM(MXSCA,4,4),
     &   SMORI(MXSCA,4,4),THETA(MXTHET),THETAN(MXSCA),
     &   WAVEA(MXWAV),WGTA(MXTHET,MXPHI),WGTB(MXBETA),WVA(MXWAVT),
     &   TIMERS(MXTIMERS)
C
C Arrays describing target properties:
C A1(1-3)=initial direction of target axis a1 in Lab Frame
C A2(1-3)=initial direction of target axis a2 in Lab Frame
C AEFFA(1-NRAD)=values of effective radius of target (physical units)
C SHPAR(1-6)=up to 6 parameters for defining target geometry
C
C Arrays describing target rotation:
C THETA(1-NTHETA)=desired values of target rotation angle theta
C BETA(1-NBETA)=desired values of target rotation angle beta
C PHI(1-NPHI)=desired values of target rotation angle phi
C WGTA(1-NTHETA,1-NPHI)=weight factor for each orientation of target
C                       axis a1 in Lab Frame
C WGTB(1-NBETA)=weight factor for rotation of target around a1
C Arrays describing incident wave:
C WAVEA(1-NWAV)=values of wavelength (physical units)
C EN0R(3)=unit vector in direction of incidence in (rotated) Target
C         Frame
C AKR(3)=k*d vector in (rotated) Target Frame
C
C Arrays describing scattering properties:
C ENSC(1-3,1-NSCAT)=scattering vectors in Lab Frame
C AKSR(1-3,1-NSCAT)=scattering k-vectors in Target Frame
C EM1(1-3,1-NSCAT)=scattering polarization state 1 in Lab Frame
C EM2(1-3,1-NSCAT)=scattering polarization state 2 in Lab Frame
C EM1R(1-3,1-NSCAT)=scattering polarization state 1 in Target Frame
C EM1R(1-3,1-NSCAT)=scattering polarization state 2 in Target Frame
C THETAN(1-NSCAT)=values of theta for NSCAT scattering directions nhat
C                 at which scattering matrix fml is to be calculated
C PHIN(1-NSCAT)=values of phi for scattering NSCAT directions nhat at
C               which scattering matrix fml is to be calculated
C S1111(1-NSCAT)=sum of |f11|**2 over target orientations
C S2121(1-NSCAT)=       |f21|**2
C QABS(1-2)=(absorption cross section)/(pi*aeff**2) for 2 polarizations
C QBKSCA(1-2)=4*pi*(diff.scatt.cross section for theta=pi)/(pi*aeff**2)
C             for 2 polarizations
C QEXT(1-2)=(extinction cross section)/(pi*aeff**2)
C QSCA(1-2)=(scattering cross section)/(pi*aeff**2)=QEXT-QABS
C QSCAT(1-2)=(scattering cross section)/(pi*aeff**2) estimated by SCAT
C
C Scratch array:
C SCRRS1(1-3*NAT)=scratch array used by DDACCG and SCAT
C SCRRS2(1-NAT)=scratch array used by SCAT
C
C External subroutines:
      EXTERNAL DIELEC,EVALA,NAMER,REAPAR
C
C Intrinsic functions:
      INTRINSIC ATAN,SQRT,REAL
C
C VMS version:
C
C      DATA CFLPAR,CFLSHP/'DDSCAT.PAR','SHAPE.DAT'/
C
C Unix version:
C
      DATA CFLPAR/'ddscat.par'/
      DATA CFLSHP/'shape.dat'/
C
C Set device numbers:
C IDVERR = device number for error messages
C IOPAR = device number for reading ddscat.par file
C IOSHP = device number for writing target.out (IOSHP<0 to suppress)
C IDVSHP = device number for reading shape file
C
      DATA IDVERR/0/
      DATA IDVSHP/10/
      DATA IOPAR/1/
      DATA IOSHP/-1/
C
C IDVOUT = device number for running I/O
C          on Solaris IDVOUT=0 produces unbuffered output to standard
C                              output
C                     IDVOUT=6 produces buffered output to standard
C                              output
C Initialize IDVOUT (cannot be done in DATA statement because IDVOUT
C is in COMMON/M6/
C
      IDVOUT=0
C
C***********************************************************************
C MPI environment setup:

      CALL MPI_INIT(IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMPROCS,IERR)

C
C MPI_INIT is called by each process to initialize the MPI environment
C MPI_COMM_RANK is called by each process to determine its identifier 
C                which is stored in MYID
C MPI_COMM_SIZE is called by each process to determine the number of 
C                parallel processes, stored in NUMPROCS
C If not using MPI, these calls can be turned into dummies by including 
C subroutines in mpi_fake.f (also need to comment out INCLUDE 'mpif.h'
C and uncomment declaration of integer variable MPI_COMM_WORLD as noted 
C above)

C Call subroutine NAMID to obtain unique filename for output file
C written by this process.

      CALL NAMID(MYID,CFLLOG)

c=======================================================================

c When following statement is enabled, output is buffered.
c If using MPI, each MPI process will write to a unique file named
c ddscat.log_xxx , where xxx=000,001,002, etc.
c If it is necessary to have unbuffered output for debugging purposes,
c comment out the following OPEN statement, in which case running
c diagnostic information will be written to standard output.
c Note that in this case, if using MPI, all MPI processes will write
c to a single output stream.

      OPEN(UNIT=IDVOUT,FILE=CFLLOG)

c=======================================================================
      CALL VERSION(CSTAMP)

      IF(MYID.EQ.0)THEN
         WRITE(IDVOUT,FMT=9000)CSTAMP,MXNX,MXNY,MXNZ
      ENDIF

C Initialize various variables in common blocks which are derived
C from parameters:

      MXNATF=MXNAT
      MXNXF=MXNX
      MXNYF=MXNY
      MXNZF=MXNZ
      MXN3F=MXN3

C Pseudo names of scratch array  positions:

      LACE=1
      LAXI=1*MXN3+1
      LCLM=2*MXN3+1
      LGI=3*MXN3+1
      LPI=4*MXN3+1
      LQI=5*MXN3+1
      LSC0=6*MXN3+1

      PI=4.*ATAN(1.)
      DEGRAD=180./PI

C**** Read program control parameters
C CMDFFT=choice of solution methods
C CSHAPE=description of shape
C SHPAR(1-6)= up to 6 parameters for defining target geometry
C INIT=selection of |x0> in CCG method
C TOL=error tolerance in CCG method
C MXWAV=dimensioning information for array WAVEA
C NWAV=number of wavelengths to be used
C WAVEA(1-NWAV)=wavelengths (physical units)
C MXRAD=dimensioning information for array AEFFA
C NRAD=number of radii to be used
C AEFFA(1-NRAD)=effective radii (physical units)
C IORTH=1 or 2 for 1 or 2 incident polarization states to be used
C NBETA=number of beta values to be used for target orientation
C BETAMI=minimum value of beta (radians)
C BETAMX=maximum value of beta (radians)
C NTHETA=number of theta values to be used for target orientation
C THETMI=minimum value of theta (radians)
C THETMX=maximum value of theta (radians)
C NPHI=number of phi values to be used for target orientation
C PHIMIN=minimum value of phi (radians)
C PHIMAX=maximum value of phi (radians)
C DEGRAD=degrees/radian (conversion factor)
C MXSCA=dimensioning information for arrays PHIN, THETAN
C NSCAT=number of scattered directions for computation of fml
C THETAN(1-NSCAT)=theta values (radians) for scattered directions
C PHIN(1-NSCAT)=phi values (radians) for scattered directions
C

      IF(MYID.EQ.0)THEN

         CALL REAPAR(CBINFLAG,CNETFLAG,AEFFA,
     &            BETAMI,BETAMX,
     &            CALPHA,CDIEL,CFLEPS,CFLPAR,CFLSHP,CMDSOL,CMDFFT,
     &            CSHAPE,CMDTRQ,CXE01,CXE02,
     &            DEGRAD,ETASCA,
     &            IDVERR,IDVOUT,INIT,IOPAR,IORTH,IWRKSC,
     &            MXBETA,MXCOMP,MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &            NBETA,NCOMP,NPHI,NRAD,NSCAT,NTHETA,NWAV,
     &            IWAV0,IRAD0,IORI0,NSMELTS,
     &            PHIMIN,PHIMAX,PHIN,
     &            THETAN,THETMI,THETMX,TOL,
     &            WAVEA,SHPAR,SMIND1,SMIND2,DX)

         NORI=NTHETA*NBETA*NPHI
         NBETH=NTHETA*NBETA

C Compute angles in degrees for printout

         BETMID=DEGRAD*BETAMI
         BETMXD=DEGRAD*BETAMX
         THTMID=DEGRAD*THETMI
         THTMXD=DEGRAD*THETMX
         PHIMID=DEGRAD*PHIMIN
         PHIMXD=DEGRAD*PHIMAX

C Obtain scattering vectors and scattering pol. vectors in Lab Frame

         CALL SCAVEC(MXSCA,NSCAT,THETAN,PHIN,CXE01,ENSC,EM1,EM2)

C Specify target properties

C A1(1-3)=target axis 1 in Target Frame
C A2(1-3)=target axis 2 in Target Frame

         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &            SHPAR,DX,NAT0,IXYZ0,ICOMP,IDVOUT,MXN3,NAT3,NPY,NPZ)

C NAT0=number of dipoles in "real" target
C Extend target to rectangular volume suitable for FFT

         CALL EXTEND(CMDFFT,ICOMP,ISCR1,IDVERR,IDVOUT,IOCC,
     &            IXYZ0(1,1),IXYZ0(1,2),IXYZ0(1,3),
     &            MXNX,MXNY,MXNZ,MXNAT,MXN3,NAT,NAT0,NAT3,NX,NY,NZ)

C Note: IXYZ0(1-NAT0,1-3) contain coordinates of occupied lattice sites.

         WRITE(IDVOUT,FMT=9011)NAT,NX,NY,NZ

C Specify target orientations
C
C MXBETA=dimensioning information for array BETA of beta values
C MXTHET=dimensioning information for array THETA of theta values
C MXPHI=dimensioning information for array PHI of phi values
C BETAMI,BETAMX=minimum,maximum beta values (radians)
C THETMI,THETMX=minimum,maximum theta values (radians)
C PHIMIN,PHIMAX=minimum,maximum phi values (radians)
C BETA(1-NBETA)=beta values for target orientations (radians)
C THETA(1-NTHETA)=theta values for target orientations (radians)
C PHI(1-NPHI)=phi values for target orientations (radians)
C WGTA(1-NTHETA,1-NPHI)=weight for each orientation of axis a1 in LF
C WGTB(1-NBETA)=weight for each rotation of target around a1

         CALL ORIENT(BETAMI,BETAMX,THETMI,THETMX,PHIMIN,PHIMAX,
     &            MXBETA,MXTHET,MXPHI,NBETA,NTHETA,NPHI,
     &            BETA,THETA,PHI,WGTA,WGTB)

C Open file 'qtable' for summary of Q values and
C           'mtable' for summary of refractive indices

         OPEN(UNIT=10,FILE='qtable',STATUS='UNKNOWN')
         OPEN(UNIT=11,FILE='mtable',STATUS='UNKNOWN')
         OPEN(UNIT=12,FILE='qtable2',STATUS='UNKNOWN')

C why not use cbinfile ? and open it in writesca ?

         IF(CBINFLAG.EQ.'ALLBIN'.OR.CBINFLAG.EQ.'ORIBIN')THEN
            IOBIN=51
            OPEN(UNIT=IOBIN,file='dd.bin',form='unformatted')
         ENDIF

C Write out header for 'qtable', 'qtable2', and 'mtable' files

         WRITE(10,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,CDIEL
         ILIN10=7
         WRITE(10,FMT=9021)(CFLEPS(J),J=1,NCOMP)
         ILIN10=ILIN10+NCOMP
         WRITE(12,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,CDIEL
         ILIN12=7
         WRITE(12,FMT=9021)(CFLEPS(J),J=1,NCOMP)
         ILIN12=ILIN12+NCOMP
         IF(IORTH.EQ.1)THEN
            WRITE(10,FMT=9043)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                     PHIMID,PHIMXD,NPHI,ETASCA,NORI,IORTH
            ILIN10=ILIN10+7
            WRITE(12,FMT=9045)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                     PHIMID,PHIMXD,NPHI,NORI,IORTH
            ILIN12=ILIN12+6
         ELSE
            WRITE(10,FMT=9043)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                     PHIMID,PHIMXD,NPHI,ETASCA,NORI,IORTH
            ILIN10=ILIN10+7
            WRITE(12,FMT=9046)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                  PHIMID,PHIMXD,NPHI,NORI,IORTH
            ILIN12=ILIN12+6
         ENDIF
         CLOSE(10)
         CLOSE(12)
         WRITE(11,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,CDIEL
         WRITE(11,FMT=9021)(CFLEPS(J),J=1,NCOMP)
         WRITE(11,FMT=9048)
      ENDIF

C*** The master process needs to share information from the above section
C    with the slave processes. All processes call this subroutine, which 
C    does nothing if MPI is not being used.

      CALL SHARE1(A1,A2,AEFFA,BETA,
     &     BETMID,BETMXD,
     &     CALPHA,CBINFLAG,CDESCR,CDIEL,
     &     CFLEPS,CMDFFT,CMDSOL,CMDTRQ,
     &     CNETFLAG,CSHAPE,CXE01,CXE02,
     &     DX,ENSC,EM1,EM2,ETASCA,
     &     ICOMP,IDVERR,IDVOUT,ILIN10,
     &     ILIN12,INIT,IOBIN,IOCC,IORI0,IORTH,
     &     IRAD0,IWAV0,IWRKSC,IXYZ0,
     &     MXBETA,MXCOMP,MXN3,MXNAT,
     &     MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &     NAT,NAT0,NAT3,NBETA,NBETH,NCOMP,NORI,NPHI,
     &     NRAD,NSCAT,NSMELTS,NTHETA,NWAV,NX,NY,NZ,
     &     PHI,PHIMID,PHIMXD,PHIN,
     &     SHPAR,SMIND1,SMIND2,THETA,THETAN,
     &     THTMID,THTMXD,TOL,
     &     WAVEA,WGTA,WGTB)

C*** Loop over wavelengths:

      IWAV1=IWAV0+1
      IRAD1=IRAD0+1
      IORI1=IORI0+1
      ITHETA1=1+IORI0/(NBETA*NPHI)
      IBETA1=1+IORI0/NPHI-(ITHETA1-1)*NBETA
      IBETH1=1+IORI0/NPHI
      IPHI1=IORI1-(ITHETA1-1)*NBETA*NPHI-(IBETA1-1)*NPHI
      DO IWAV=IWAV1,NWAV
         WAVE=WAVEA(IWAV)

C*** Determine dielectric properties of target

         IF(MYID.EQ.0)THEN
            CALL DIELEC(CDIEL,WAVE,IDVOUT,CFLEPS,CXEPS,
     &               MXCOMP,MXWAVT,NCOMP,E1A,E2A,WVA)
         ENDIF

C*** Again the master process needs to share information with the slaves.

         CALL SHARE2(MXCOMP,MXWAVT,
     &               CXEPS,E1A,E2A,WVA)

C*** Obtain complex polarizabilities

         DO J=1,NCOMP
            CXRFR(J)=SQRT(CXEPS(J))
            IF(MYID.EQ.0)THEN
               WRITE(IDVOUT,FMT=9031)CXRFR(J),CXEPS(J),J
            ENDIF
         ENDDO

C**** Loop over grain sizes:

         DO IRAD=IRAD1,NRAD
            AEFF=AEFFA(IRAD)
            XX=2.*PI*AEFF/WAVE
            IF(MYID.EQ.0)THEN
               WRITE(IDVOUT,FMT=9032)AEFF,WAVE,XX
            ENDIF

C Compute AK1=length of k vector in "natural" units=k*d
C (natural unit of length = d = lattice spacing)
C Remember that NAT = number of dipoles including "vacuum" sites in
C                     extended target
C               NAT0= number of dipoles in "real" target

            AK1=XX*(4.*PI/(3.*REAL(NAT0)))**(1./3.)
            AK3=AK1**3

C PIA2=pi*(aeff/d)**2

            PIA2=PI*(.75*NAT0/PI)**(2./3.)

C Initialize various sums over target orientation.

            DO JO=1,IORTH
               QSCSUM(JO)=0.
               QABSUM(JO)=0.
               QEXSUM(JO)=0.
               QBKSUM(JO)=0.
               QPHSUM(JO)=0.
               QSCG2SUM(JO)=0.
               DO J=1,3
                  QSCGSUM(J,JO)=0.
                  QTRQABSUM(J,JO)=0.
                  QTRQSCSUM(J,JO)=0.
               ENDDO
            ENDDO
            DO IDIR=1,NSCAT
               S1111(IDIR)=0.
               S2121(IDIR)=0.
               CX1121(IDIR)=(0.,0.)
            ENDDO
            DO J=1,4
               DO JO=1,4
                  DO IDIR=1,NSCAT
                     SMORI(IDIR,JO,J)=0.
                  ENDDO
               ENDDO
            ENDDO

C Loop over target orientations (target rotations in Lab Frame)
C (actually, loop over lab rotations in Target Frame)

C**** The outer orientation loop over IBETH=1,NBETH is divided up among
C     the parallel processes.

            IORI=IORI0

c ITNUMMX will store the maximum number of iterations used for any of
c the orientations for current size and wavelength, so that this can
c be written to the waarbbkccc.sca output file

            DO J=1,2
               ITNUMMX(J)=0
            ENDDO

            DO IBETH=MYID+IBETH1,NBETH,NUMPROCS
               ITHETA=INT((IBETH-1)/NBETA)+1
               THETAD=THETA(ITHETA)*DEGRAD
               IBETA=MOD(IBETH-1,NBETA)+1
               BETAD=BETA(IBETA)*DEGRAD

C*** collinge: for testing

               IF(MYID.EQ.0.AND.IORI.EQ.IORI0)THEN
                  IF(ITHETA.NE.ITHETA1)THEN
                     WRITE(CMSGNM,FMT='(A,A)')'Got wrong ',
     &                    'value for ITHETA1'
                     CALL ERRMSG('FATAL','DDSCAT',CMSGNM)
                  ENDIF
                  IF(IBETA.NE.IBETA1)THEN
                     WRITE(CMSGNM,FMT='(A,A)')'Got wrong ',
     &                    'value for IBETA1'
                     CALL ERRMSG('FATAL','DDSCAT',CMSGNM)
                  ENDIF                  
               ENDIF
c***
               DO IPHI=IPHI1,NPHI

                  PHID=PHI(IPHI)*DEGRAD
                  IORI=(ITHETA-1)*NBETA*NPHI+(IBETA-1)*NPHI+IPHI

C**** Obtain propagation vectors, polarization vectors, and scattering
C     vectors in Target Frame for desired target rotation in Lab Frame

                  CALL ROTATE(A1,A2,AK1,CXE01,CXE02,BETA(IBETA),
     &                        THETA(ITHETA),PHI(IPHI),EN0R,
     &                        CXE01R,CXE02R,
     &                        MXSCA,NSCAT,ENSC,EM1,EM2,
     &                        AKSR,EM1R,EM2R)
C

                  DO J=1,3
                     AKR(J)=AK1*EN0R(J)
                  ENDDO

c note: if called with IORI > 999, NAMER will have trouble when
c       generating CFLSCA.  If IWRKSC=0, this is immaterial, because
c       CFLSCA will not be used.
c       We will check in REAPAR to halt if user requests IWRKSC=1 and
c       more than 1000 orientations.

                  IF(IWRKSC.EQ.1)THEN
                     CALL NAMER(IWAV,IRAD,IORI,CFLSCA,CFLAVG)
                  ELSE
                     CALL NAMER(IWAV,IRAD,0,CFLSCA,CFLAVG)
                  ENDIF
                  
                  CALL GETFML(AKR,AK3,AKSR,DX,
     &                        CALPHA,CMDSOL,CMDFFT,CMDTRQ,CSHAPE,
     &                        CXADIA,CXAOFF,CXALPH,CXALOF,
     &                        CXALDS,CXALOS,
     &                        CXE,CXE01R,CXE02R,CXEPS,
     &                        CXF11,CXF12,CXF21,CXF22,CXRLOC,
     &                        CXXI,CXSC,CXSCR1,CXZC,CXZW,
     &                        EM1R,EM2R,ETASCA,
     &                        IBETH,IBETH1,ICOMP,IDVOUT,INIT,
     &                        IOCC,IORTH,IPHI,IPHI1,ITASK,IXYZ0,
     &                        ITNUM,MXITER,
     &                        LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0,
     &                        MXCOMP,MXCXSC,MXN3,MXNAT,
     &                        MXNX,MXNY,MXNZ,MXPHI,MXSCA,MYID,
     &                        NAT,NAT0,NAT3,NAVG,NCOMP,NSCAT,NX,NY,NZ,
     &                        PHI,PHIN,PIA2,
     &                        QABS,QBKSCA,QEXT,QPHA,QSCAT,QSCAG,QSCAG2,
     &                        QTRQAB,QTRQSC,
     &                        SCRRS1,SCRRS2,SHPAR,THETAN,TOL,TIMERS,
     &                        MXTIMERS,NTIMERS)

                  DO J=1,2
                     IF(ITNUM(J).GT.ITNUMMX(J))ITNUMMX(J)=ITNUM(J)
                  ENDDO

C Compute Mueller scattering matrix

                  CALL GETMUELLER(IBETA,IORTH,IPHI,ITHETA,MXBETA,
     &                            MXSCA,MXPHI,MXTHET,NSCAT,
     &                            CMDTRQ,PHIN,SM,SMORI,
     &                            S1111,S2121,
     &                            CX1121,CXE01,CXE02,
     &                            CXF11,CXF12,CXF21,CXF22,
     &                            CXS1,CXS2,CXS3,CXS4,
     &                            QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,
     &                            QEXT,QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,
     &                            QSCG2SUM,QSCGSUM,QSCSUM,QTRQAB,
     &                            QTRQABSUM,QTRQSC,QTRQSCSUM,WGTA,WGTB)

C----------------------------------------------------------------------
C**** Choose whether or not to write out scattering properties for
C     current orientation; conditional may be replaced if desired.
C
C**** If IWRKSC=1, write scattering properties of current orientation:

                  IF(IWRKSC.EQ.1)THEN

                     CALL WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,DX,ICOMP,
     &                     IXYZ0,MXNAT,MXN3,NAT,NAT3,WAVEA,MXWAV,NWAV,
     &                     AEFFA,MXRAD,NRAD,ITHETA,IBETA,IPHI,THETA,
     &                     MXTHET,NTHETA,BETA,MXBETA,NBETA,PHI,MXPHI,
     &                     NPHI,NSMELTS,TIMERS,MXTIMERS,NTIMERS,
     &                     CBINFILE,IOBIN,CBINFLAG,CNETFILE,IDNC,
     &                     CNETFLAG,ILIN10,ILIN12,IORI,IWRKSC,IORTH,
     &                     IRAD,IWAV,MXCOMP,MXSCA,NAT0,NAVG,ITNUM,
     &                     MXITER,NCOMP,NORI,NSCAT,CALPHA,CDESCR,CFLAVG,
     &                     CFLSCA,CMDFFT,CMDTRQ,CSHAPE,CSTAMP,AEFF,AK1,
     &                     AKR,BETAD,BETMID,BETMXD,ETASCA,PHID,PHIMID,
     &                     PHIMXD,THETAD,THTMID,THTMXD,TOL,WAVE,XX,A1,
     &                     A2,PHIN,QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,
     &                     QEXT,QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,QSCGSUM,
     &                     QSCG2SUM,QSCSUM,QTRQAB,QTRQABSUM,QTRQSC,
     &                     QTRQSCSUM,S1111,S2121,SM,SMIND1,SMIND2,SMORI,
     &                     THETAN,CX1121,CXE01,CXE01R,CXE02,CXE02R,
     &                     CXEPS,CXRFR,CXF11,CXF21,CXF12,CXF22)
                  ENDIF
               ENDDO

               IPHI1=1

C*** Have completed loop over target orientation IPHI

            ENDDO

            IBETH1=1

C*** Have completed loop over target orientation IBETH (BETA and THETA)
C*** Have completed all loops over target orientations

C*** Collect the partial sums over target orientation 
C     from the parallel processes. This routine is a dummy 
C     if MPI is not being used.

            CALL COLSUM(IORTH,MYID,MXSCA,NSCAT,
     &                  QSCSUM,QABSUM,QEXSUM,QBKSUM,QPHSUM,
     &                  QSCG2SUM,QSCGSUM,QTRQABSUM,QTRQSCSUM,
     &                  S1111,S2121,CX1121,SMORI)

C*** Write dielectric information to 'mtable'

            FREQ=1.E4/WAVE
            CXEN=SQRT(CXEPS(1))
            IF(MYID.EQ.0)THEN
               WRITE(11,FMT=9058)WAVE,FREQ,CXEN,CXEPS(1)
            ENDIF

C Set IORI=0 prior to calling WRITESCA in order to print orientational
C averages

            IORI=0

C******** Now calculate and print out orientational averages **********

            IF(MYID.EQ.0)THEN

               CALL WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,DX,ICOMP,
     &                    IXYZ0,MXNAT,MXN3,NAT,NAT3,WAVEA,MXWAV,NWAV,
     &                    AEFFA,MXRAD,NRAD,ITHETA,IBETA,IPHI,THETA,
     &                    MXTHET,NTHETA,BETA,MXBETA,NBETA,PHI,MXPHI,
     &                    NPHI,NSMELTS,TIMERS,MXTIMERS,NTIMERS,
     &                    CBINFILE,IOBIN,CBINFLAG,CNETFILE,IDNC,
     &                    CNETFLAG,ILIN10,ILIN12,IORI,IWRKSC,IORTH,
     &                    IRAD,IWAV,MXCOMP,MXSCA,NAT0,NAVG,ITNUMMX,
     &                    MXITER,NCOMP,NORI,NSCAT,CALPHA,CDESCR,CFLAVG,
     &                    CFLSCA,CMDFFT,CMDTRQ,CSHAPE,CSTAMP,AEFF,AK1,
     &                    AKR,BETAD,BETMID,BETMXD,ETASCA,PHID,PHIMID,
     &                    PHIMXD,THETAD,THTMID,THTMXD,TOL,WAVE,XX,A1,
     &                    A2,PHIN,QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,
     &                    QEXT,QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,QSCGSUM,
     &                    QSCG2SUM,QSCSUM,QTRQAB,QTRQABSUM,QTRQSC,
     &                    QTRQSCSUM,S1111,S2121,SM,SMIND1,SMIND2,SMORI,
     &                    THETAN,CX1121,CXE01,CXE01R,CXE02,CXE02R,
     &                    CXEPS,CXRFR,CXF11,CXF21,CXF12,CXF22)
            ENDIF

         ENDDO
         IRAD1=1

C*** Have completed loop over target size

      ENDDO

C*** Have completed loop over wavelengths

C close binary file (this perhaps should be moved to writesca)

      IF(MYID.EQ.0)THEN
         IF(CBINFLAG.NE.'NOTBIN')THEN
            CALL WRIMSG('DDSCAT',' close dd.bin')
            CLOSE(IOBIN)
         ENDIF
         IF(CNETFLAG.NE.'NOTCDF')THEN
            CALL WRIMSG('DDSCAT',' close NetCDF')
            CNETFLAG='NCCLOS'
            CALL WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,DX,ICOMP,
     &                    IXYZ0,MXNAT,MXN3,NAT,NAT3,WAVEA,MXWAV,NWAV,
     &                    AEFFA,MXRAD,NRAD,ITHETA,IBETA,IPHI,THETA,
     &                    MXTHET,NTHETA,BETA,MXBETA,NBETA,PHI,MXPHI,
     &                    NPHI,NSMELTS,TIMERS,MXTIMERS,NTIMERS,
     &                    CBINFILE,IOBIN,CBINFLAG,CNETFILE,IDNC,
     &                    CNETFLAG,ILIN10,ILIN12,IORI,IWRKSC,IORTH,
     &                    IRAD,IWAV,MXCOMP,MXSCA,NAT0,NAVG,ITNUMMX,
     &                    MXITER,NCOMP,NORI,NSCAT,CALPHA,CDESCR,CFLAVG,
     &                    CFLSCA,CMDFFT,CMDTRQ,CSHAPE,CSTAMP,AEFF,AK1,
     &                    AKR,BETAD,BETMID,BETMXD,ETASCA,PHID,PHIMID,
     &                    PHIMXD,THETAD,THTMID,THTMXD,TOL,WAVE,XX,A1,
     &                    A2,PHIN,QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,
     &                    QEXT,QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,QSCGSUM,
     &                    QSCG2SUM,QSCSUM,QTRQAB,QTRQABSUM,QTRQSC,
     &                    QTRQSCSUM,S1111,S2121,SM,SMIND1,SMIND2,SMORI,
     &                    THETAN,CX1121,CXE01,CXE01R,CXE02,CXE02R,
     &                    CXEPS,CXRFR,CXF11,CXF21,CXF12,CXF22)
         ENDIF
      ENDIF

      CALL WRIMSG('DDSCAT',' terminates normally')

C MPI environment shutdown:

      CALL MPI_FINALIZE(IERR)

      STOP

 9000 FORMAT(' >DDSCAT --- ',A,/,
     &       '             compiled with MXNX=',I3,' MXNY=',I3,
     &       ' MXNZ=',I3)
 9011 FORMAT(7X,I7,' = NAT  = number of dipoles in extended target',/,
     &       7X,3I4,' = x,y,z length of extended target (Targ. Frame)')
 9020 FORMAT(' DDSCAT --- ',A,/,' TARGET ---',A,/,
     &       ' ',A,' --- method of solution ',/,
     &       ' ',A,' --- prescription for polarizabilities',/,
     &       ' ',A,' --- shape ',/,
     &       I7,' = NAT0 = number of dipoles',/,
     &       ' ',A,' --- source of dielectric function')
 9021 FORMAT(' ',A)
 9031 FORMAT(' n= (',F7.4,' , ',F7.4,'),  epsilon= (',F8.4,' , ',F7.4,
     &       ')  for material',I2)
 9032 FORMAT('  AEFF=',F10.5,' =',' effective radius (physical units)',
     &       /,'  WAVE=',F10.5,' = wavelength (physical units)',/,
     &       '   K*A=',F10.5,' = 2*pi*aeff/lambda')
 9043 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,
     &       2F8.3,' = theta_min, theta_max; NTHETA=',I2,/,
     &       2F8.3,' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       F7.4,' = ETASCA (param. controlling # of ',
     &            'scatt. dirs used to calculate <cos> etc.',/,
     &       ' Results averaged over ',I4,' target orientations',/,
     &       '                   and ',I2,' incident polarizations',/,
     &       3X,'aeff',7X,'wave',7X,'Q_ext',5X,'Q_abs',6X,'Q_sca',5X,
     &       'g(1)=<cos>',2X,'<cos^2>',4X,'Q_bk',7X,'Nsca')
 9045 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,
     &       2F8.3,' = theta_min, theta_max; NTHETA=',I2,/,
     &       2F8.3,' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       ' Results averaged over ',I4,' target orientations',/,
     &       '                   and ',I2,' incident polarizations',/,
     &       '   aeff       wave      Q_pha')
 9046 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,
     &       2F8.3,' = theta_min, theta_max; NTHETA=',I2,/,
     &       2F8.3,' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       ' Results averaged over ',I4,' target orientations',/,
     &       '                   and ',I2,' incident polarizations',/,
     &       '   aeff',7X,'wave',7X,'Q_pha',7X,'Q_pol',7X,'Q_cpol')
 9048 FORMAT(' wave(um)   f(cm-1)     Re(m)     Im(m)    Re(eps)   ',
     &       'Im(eps)')
 9058 FORMAT(1PE10.4,E11.4,4E10.3)
C
      END

      SUBROUTINE TARELL(A1,A2,AX,AY,AZ,DX,CDESCR,IOSHP,MXNAT,NAT,IXYZ,
     &                  ICOMP)
      IMPLICIT NONE
C** Arguments:
      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL AX,AY,AZ
      REAL A1(3),A2(3),DX(3)
C** Local variables:
      INTEGER JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2
      REAL AX2,AY2,AZ2,R,RYZ2,RZ2,X,XOFF,Y,YOFF,Z,ZOFF
C***********************************************************************
C Routine to construct ellipsoid from "atoms"
C Input:
C        AX=(x-length)/d    (d=lattice spacing)
C        AY=(y-length)/d
C        AZ=(z-length)/d
C        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
C                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
C                spacing
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
C        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        CDESCR=description of target (up to 67 characters)
C        ICOMP(1-NAT,1-3)=1 (composition identifier)

C B.T.Draine, Princeton Univ. Obs.
C History:
C 91.01.05 (BTD): Changed I4 -> I7 when printing NAT
C 91.04.22 (BTD): Added AX,AY,AZ and A1,A2 to WRITE(IOSHP,FMT=9020)
C 91.05.01 (BTD): TEMPORARY hack to be able to reproduce all arrays
C                 used by Draine 88 (in which XOFF=YOFF=ZOFF=0.5 always).
C 92.10.26 (BTD): Added code to set string CDESCR
C                 Added one call to WRIMSG
C 93.01.01 (BTD): Changed method for determining target axes A1, A2
C                 [previous criteria -- A1 = longest dimension,
C                 A2 = intermediate dimension -- created confusion]
C                 new rule: A1=(1,0,0), A2=(0,1,0)
C 93.03.12 (BTD): Changed CDESCR*(*) -> CDESCR*67
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 97.11.02 (BTD): Added DX to argument list, and modified to allow use
C                 of noncubic lattice
C 98.02.11 (BTD): Modified to write DX to file "target.out"
C 00.10.19 (BTD): Corrected to reduce length of string written to
C                 CDESCR for ellipsoidal grain
C 00.11.02 (BTD): Add ICOMP to argument list, return ICOMP=1
C                 Write ICOMP to target.out
C end history
C
C Copyright (C) 1993,1996,1997,1998,2000 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

C Routine to construct pseudo-ellipsoidal target aray.
C With occupied array sites contained within ellipsoidal surface
C defined by (X/AX*d)**2+(Y/AY*d)**2+(Z/AZ*d)**2=0.25
C Ideal volume V=(pi/6)*AX*AY*AZ*d**3
C where d = effective lattice spacing

C Dipoles are located on lattice at sites
C (x,y,z)=(I+XOFF,J+YOFF,Z+KOFF), I,J,K=integers
C                                 XOFF,YOFF,ZOFF=constants

C For sphere: call with AX=AY=AZ
C For spheroid: call with AX=AY (or AY=AZ or AX=AZ)
C B.T.Draine, Princeton Univ. Obs., 88.08.12

C Criterion for choosing XOFF:
C If AX is close to an even integer, take XOFF=1/2
C If AX is close to an odd integer, take XOFF=0

      JX=INT(AX/DX(1)+.5)
      IF(2*(JX/2).EQ.JX)THEN
         XOFF=0.5
      ELSE
         XOFF=0.
      ENDIF
C Similar criterion for YOFF:
      JY=INT(AY/DX(2)+.5)
      IF(2*(JY/2).EQ.JY)THEN
         YOFF=0.5
      ELSE
         YOFF=0.
      ENDIF
C Similar criterion for ZOFF:
      JZ=INT(AZ/DX(3)+.5)
      IF(2*(JZ/2).EQ.JZ)THEN
         ZOFF=0.5
      ELSE
         ZOFF=0.
      ENDIF

      LMX1=-INT(.5*AX/DX(1)+.5)
      LMX2=INT(.5*AX/DX(1)-.25)
      LMY1=-INT(.5*AY/DX(2)+.5)
      LMY2=INT(.5*AY/DX(2)-.25)
      LMZ1=-INT(.5*AZ/DX(3)+.5)
      LMZ2=INT(.5*AZ/DX(3)-.25)
      AX2=AX*AX
      AY2=AY*AY
      AZ2=AZ*AZ
      NAT=0

C Specify target axes A1 and A2
C Convention: A1=(1,0,0) in target frame
C             A2=(0,1,0) in target frame

      DO JX=1,3
         A1(JX)=0.
         A2(JX)=0.
      ENDDO
      A1(1)=1.
      A2(2)=1.

C Determine list of occupied sites.

      DO JZ=LMZ1,LMZ2
         Z=(REAL(JZ)+ZOFF)*DX(3)
         RZ2=Z*Z/AZ2
         IF(RZ2.LT.0.25)THEN
            DO JY=LMY1,LMY2
               Y=(REAL(JY)+YOFF)*DX(2)
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2.LT.0.25)THEN
                  DO JX=LMX1,LMX2
                     X=(REAL(JX)+XOFF)*DX(1)
                     R=RYZ2+X*X/AX2
                     IF(R.LT.0.25)THEN
C Site is occupied:
                        NAT=NAT+1
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDDO

      IF(NAT.GT.MXNAT)THEN
         CALL ERRMSG('FATAL','TARELL',' NAT.GT.MXNAT ')
      ENDIF

C Set composition

      DO JX=1,3
         DO JZ=1,NAT
            ICOMP(JZ,JX)=1
         ENDDO
      ENDDO

C***********************************************************************
C Write target description into string CDESCR
      IF(AX.EQ.AY.AND.AX.EQ.AZ)THEN
         WRITE(CDESCR,FMT='(A,I7,A,F6.3,F6.3,F6.3,A)')
     &         ' Sphere,',NAT,' dipoles,',
     &         DX(1),DX(2),DX(3),'=x,y,z lattice spacing'
      ELSE
         WRITE(CDESCR,FMT='(A,I7,A,F6.3,F6.3,F6.3,A)')
     &         ' Ellipsoid,',NAT,' dipoles,',
     &         DX(1),DX(2),DX(3),'=x,y,z lattice spacing'
      ENDIF
C***********************************************************************
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)AX,AY,AZ,NAT,A1,A2,DX
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3),
     &                           ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 9020 FORMAT(' >TARELL  ellipsoidal grain; AX,AY,AZ=',3F8.4,/,
     &I7,' = NAT',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,
     &'     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE TARCYL(A1,A2,A,B,DX,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      IMPLICIT NONE
C Scalar arguments:
      CHARACTER CDESCR*67
      INTEGER MXNAT,NAT
      REAL A,B
C Array arguments:
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL A1(3),A2(3),DX(3)
C Local scalars:
      INTEGER IOSHP,JX,JY,JZ,
     &    NB,NFAC,NLAY,
     &    NX2,NY1,NY2,NZ1,NZ2
      REAL ASPR,PI,REFF2,Y2M,YCM,Z2,ZCM
C***********************************************************************
C Purpose: to construct cylindrical target from "atoms", with cylinder
C axis along x axis.
C Input:
C        A = cylinder length (in units of lattice spacing d)
C        B = cylinder diameter (in units of lattice spacing d)
C        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
C                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
C                spacing
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT = dimensioning information
C Returns:
C        A1(1-3) = unit vector along cylinder axis
C        A2(1-3) = unit vector perpendicular to cylinder axis
C        CDESCR = string describing target (up to 67 chars.)
C        NAT = number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms in target
C        ICOMP(1-NAT,1-3)=1 (composition identifier)
C
C B.T.Draine, Princeton Univ. Obs., 87.04.03
C History:
C 89.12.21 (BTD): Modified for use by ddscat 89.12.21
C 90.12.03 (BTD): Modified for conformity with other target routines
C 91.01.05 (BTD): Changed I4 -> I7 when printing NAT
C 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
C 93.03.12 (BTD): Changed CDESCR*(*) -> CDESCR*67
C 95.04.07 (BTD): Corrected error in code which affected target
C                 construction for 4.5<B<5.5, 6.5<B<7.5, ...
C                 In these cases code was construction target with
C                 diameter 4, 6, ... dipoles
C                 This error was discovered by Tao Du
C 96.01.25 (BTD): Modified for conformity with DDSCAT.5a
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 97.12.26 (BTD): Added DX(1-3) to argument list to support noncubic
C                 lattice.
C 98.02.11 (BTD): Make changes to generate target for noncubic lattice.
C                 Take opportunity to simplify and streamline.
C 98.04.27 (BTD): Delete unused variables IN,Y2,ROFF,X,Z,IAXIS
C                 Declare variabels Y2M
C                 Delete IAXIS from WRITE(IOSHP,FMT=9020) statement
C 00.11.02 (BTD): Add ICOMP to argument list, return with ICOMP=1
C                 for occupied sites.
C                 write ICOMP to target.out
c 06.09.13 (BTD): Corrected error: initialize NAT
C end history
C Copyright (C) 1993,1995,1996,1997,1998,2000,2006
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

      PI=4.*ATAN(1.)

      NAT=0

C Cylinder axis is along x axis in target frame.

      DO JX=1,3
         A1(JX)=0.
         A2(JX)=0.
      ENDDO
      A1(1)=1.
      A2(2)=1.

C A = cylinder length/d
C B = cylinder diameter/d

C Determine centroid XCM,YCM,ZCM

C If A/d_x is near an odd integer, XCM=0
C If A/d_x is near an even integer, XCM=0.5

C If B/d_y is near an odd or even integer, YCM=0 or 0.5
C If B/d_z is near an odd or even integer, ZCM=0 or 0.5

C Determine limits for testing x,y,z values
C In case of disk axis, run from I=1 to I=INT(A+0.5)
C In radial directions, place atoms as follows:
C     If B is close to even number
C          x = i + 0.5
C          with i running from -int((b+.5)/2) to int((b+.5)/2)-1
C     If B is close to odd number
C          x = i
C          with i running from -int((b+.5)/2) to int((b+.5)/2)

      NX2=INT(A/DX(1)+0.5)
      NB=INT(B/DX(2)+0.5)
      IF(2*(NB/2).LT.NB)THEN
         YCM=0.
         NY1=-NB/2
         NY2=NB/2
      ELSE
         YCM=0.5
         NY1=-NB/2+1
         NY2=NB/2
      ENDIF
      NB=INT(B/DX(3)+0.5)
      IF(2*(NB/2).LT.NB)THEN
         ZCM=0.
         NZ1=-NB/2
         NZ2=NB/2
      ELSE
         ZCM=0.5
         NZ1=-NB/2+1
         NZ2=NB/2
      ENDIF
      
      DO JZ=NZ1,NZ2
         Z2=((JZ-ZCM)*DX(3))**2
         Y2M=((0.5*B)**2-Z2)/DX(2)**2
         DO JY=NY1,NY2
            IF((JY-YCM)**2.LT.Y2M)THEN
               DO JX=1,NX2
                  NAT=NAT+1
                  IF(NAT.GT.MXNAT)THEN
                     CALL ERRMSG('FATAL','TARCYL',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDDO
            ENDIF
         ENDDO
      ENDDO

C Set composition

      DO JZ=1,3
         DO JX=1,NAT
            ICOMP(JX,JZ)=1
         ENDDO
      ENDDO

C NLAY = number of layers in cylinder
C NFAC = number of atoms in slice

      NLAY=NX2
      NFAC=NAT/NLAY

C REFF2=effective radius**2 of disk

      REFF2=REAL(NFAC)/PI

C ASPR=aspect ratio (length/diameter)

      ASPR=0.5*REAL(NLAY)/SQRT(REFF2)
      WRITE(CDESCR,FMT='(A,I7,A,I4,A,I4,A,F7.4)')
     &    ' Cyl.prism, NAT=',NAT,' NFAC=',NFAC,' NLAY=',NLAY,
     &    ' asp.ratio=',ASPR

      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)A,B,NAT,A1,A2,DX
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3),
     &                           ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 9020 FORMAT(' >TARELL  cylindrical target: Length=',F8.4,
     &' Diameter=',F8.4,/,
     &I7,' = NAT',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &3F9.6,' = (d_x,d_y,d_z)/d',/,
     &'     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE INTERP(X,Y,Z,XA,YA,ZA,IDVOUT,MXTAB,NTAB)
      IMPLICIT NONE
C Arguments:
      INTEGER IDVOUT,MXTAB,NTAB
      REAL X,Y,Z
      REAL XA(MXTAB),YA(MXTAB),ZA(MXTAB)
C Local variables:
      INTEGER I1,I2,I3,I4,INC
      REAL SGN,X1,X2,X3,X4,Y1,Y2,Y3,Y4
C***********************************************************************
C Given array of tabulated values XA(1-NTAB), YA(1-NTAB), ZA(1-NTAB),
C and given independent variable X, this routine interpolates for two
C dependent variables: Y and Z.
C Uses only parabolic interpolation for safety.
C When called with X outside range of tabulated values XA, returns
C extrapolated values Y and Z but issues warning statement.
C Note: XA values must be either monotonically increasing OR
C       monotonically decreasing.
C B.T.Draine, Princeton Univ. Observatory
C 89/12/19 (BTD): Revised.
C 91/05/02 (BTD): Added IDVOUT to argument list.
C                 Changed WRITE(0 -> WRITE(IDVOUT
C 92/03/24 (BTD): Added test IF(I2.GE.NTAB) in case INTERP is used for
C                 data sets with different lengths.
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DATA I2/1/
      IF(I2.GE.NTAB)I2=NTAB-1
      INC=0
      SGN=1.
C*** Check whether X is increasing or decreasing:
      IF(XA(1).GE.XA(NTAB))SGN=-1.
C*** Check whether outside table limits
      IF((SGN*(X-XA(1))).LT.0.)THEN
         I2=2
         WRITE(IDVOUT,6990)X
         GOTO 4600
      ENDIF
      IF(SGN*(X-XA(NTAB)).GT.0.)THEN
         I2=NTAB-1
         WRITE(IDVOUT,6990)X
         GOTO 4600
      ENDIF
C*** X is within table limits.  Find I2
 1000 IF(SGN*(XA(I2)-X))2000,3000,4000
 2000 IF(INC)2100,2200,2200
 2100 IF(I2+2-NTAB)4700,4700,2500
 2200 INC=1
      I2=I2+1
      IF(I2+1.LE.NTAB)GO TO 1000
 2500 I2=NTAB-1
      GO TO 4600
 3000 Y=YA(I2)
      Z=ZA(I2)
      RETURN
 4000 IF(INC)4200,4200,4100
 4100 I2=I2-1
      IF(I2-2)4500,4700,4700
 4200 INC=-1
      I2=I2-1
      IF(I2.GE.2)GOTO 1000
 4500 I2=2
 4600 I1=I2-1
      I3=I2+1
      X1=XA(I1)
      X2=XA(I2)
      X3=XA(I3)
      Y1=YA(I1)
      Y2=YA(I2)
      Y3=YA(I3)
      CALL PARAB3(X,Y,X1,X2,X3,Y1,Y2,Y3)
      Y1=ZA(I1)
      Y2=ZA(I2)
      Y3=ZA(I3)
      CALL PARAB3(X,Z,X1,X2,X3,Y1,Y2,Y3)
      RETURN
 4700 I1=I2-1
      I3=I2+1
      I4=I2+2
      X1=XA(I1)
      X2=XA(I2)
      X3=XA(I3)
      X4=XA(I4)
      Y1=YA(I1)
      Y2=YA(I2)
      Y3=YA(I3)
      Y4=YA(I4)
      CALL PARAB4(X,Y,X1,X2,X3,X4,Y1,Y2,Y3,Y4)
      Y1=ZA(I1)
      Y2=ZA(I2)
      Y3=ZA(I3)
      Y4=ZA(I4)
      CALL PARAB4(X,Z,X1,X2,X3,X4,Y1,Y2,Y3,Y4)
      RETURN
 6990 FORMAT('Warning from INTERP: outside table limits for X=',1PE12.5)
      END

      SUBROUTINE PARAB3(X,Y,X1,X2,X3,Y1,Y2,Y3)
      REAL A,B,X,X1,X2,X3,Y,Y1,Y2,Y3
C***********************************************************************
C Subroutine PARAB3 does parabolic interpolation, with parabola
C constrained to fit (x1,y1),(x2,y2),(x3,y3) exactly.
C B.T.Draine, Institute for Advanced Study, March 1980.
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      A=(Y3-Y2-(X3-X2)*(Y1-Y2)/(X1-X2))/((X3-X2)*(X3-X1))
      B=(Y1-Y2)/(X1-X2)-A*(X1-X2)
      Y=(A*(X-X2)+B)*(X-X2)+Y2
      RETURN
      END

      SUBROUTINE PARAB4(X,Y,X1,X2,X3,X4,Y1,Y2,Y3,Y4)
      REAL A,B,X,X1,X2,X3,X4,Y,Y1,Y2,Y3,Y4
C***********************************************************************
C Subroutine PARAB4 is designed to do parabolic interpolation, with
C parabola constrained to match (x2,y2) and (x3,y3) exactly, and to
C minimize sum of squared deviations from (x1,y1) and (x4,y4).
C It is assumed that x1.lt.x2.le.x.lt.x3.lt.x4
C Fit parabola Y=A*(X-X2)**2+B*(X-X2)+Y2
C B.T.Draine, Institute for Advanced Study, March 1980.
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
***********************************************************************
      A=((X1-X2)*(Y3-Y2)/(X3-X2)+Y2-Y1)*(X1-X2)*(X1-X3)
     &  +((X4-X2)*(Y3-Y2)/(X3-X2)+Y2-Y4)*(X4-X2)*(X4-X3)
      A=-A/(((X1-X2)*(X1-X3))**2+((X4-X2)*(X4-X3))**2)
      B=(Y3-Y2)/(X3-X2)-A*(X3-X2)
      Y=(A*(X-X2)+B)*(X-X2)+Y2
      RETURN
      END

      SUBROUTINE TARANIREC(A1,A2,XV,YV,ZV,DX,CDESCR,IOSHP,MXNAT,NAT,
     &                     IXYZ,ICOMP)
      IMPLICIT NONE

C Arguments:

      REAL XV,YV,ZV
      INTEGER IOSHP,MXNAT,NAT
      CHARACTER CDESCR*67
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL A1(3),A2(3),DX(3)

C Local variables:

      INTEGER JA,JX,JY,JZ,NX,NY,NZ
      CHARACTER CMSGNM*70

C External subroutines:

      EXTERNAL ERRMSG

C Intrinsic functions:
c intrinsic function: do not need to explicitly type:      INTEGER IFIX
      INTRINSIC IFIX
C***********************************************************************
C Subroutine TARANIREC
C Purpose: to construct rectangular target with anisotropic dielectric
C          tensor.
C          Dielectric tensor is assumed to be diagonalized in target
C          frame, with 
C          material 1 for x-direction
C          material 2 for y-direction
C          material 3 for z-direction
C          Note: Must specify NCOMP=3 in ddscat.par, and provide
C                file names for three materials
C Input:
C        XV=(x-length)/d    (d=lattice spacing)
C        YV=(y-length)/d
C        ZV=(z-length)/d
C        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
C                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
C                spacing
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Frame
C        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C
C B.T.Draine, Princeton Univ. Obs.
C History:
C 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
C 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
C 93.03.12 (BTD): Specified CDESCR*67, and now use it.
C 95.07.12 (BTD): Changed definition of axes A1,A2.  They used to be
C                 longest,next longest dimention.  They are now
C                 fixed to always be (1,0,0) and (0,1,0).
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 97.12.26 (BTD): Added DX(1-3) to argument list to support nonuniform
C                 lattice spacing.
C 98.02.11 (BTD): Modify to generate target on noncubic lattice.
C 00.11.02 (BTD): Add ICOMP to argument list, set ICOMP=1,
C                 write ICOMP to target.out
C 04.04.29 (BTD): Created from TARREC with only minor modifications 
C end history
C
C Copyright (C) 1993,1995,1996,1997,1998,2000,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C***********************************************************************
      NX=IFIX(XV/DX(1)+0.5)
      NY=IFIX(YV/DX(2)+0.5)
      NZ=IFIX(ZV/DX(3)+0.5)
      WRITE(CMSGNM,FMT='(A,3I4)')
     &      ' Anisotropic rectangular prism; NX,NY,NZ=',NX,NY,NZ
      WRITE(CDESCR,FMT='(A,3I4)')
     &      ' Anisotropic rectangular prism; NX,NY,NZ=',NX,NY,NZ

C Specify target axes A1 and A2
C Convention: A1 will be (1,0,0) in target frame
C             A2 will be (0,1,0) in target frame

      DO JA=1,3
         A1(JA)=0.
         A2(JA)=0.
      ENDDO
      A1(1)=1.
      A2(2)=1.
C               
C Now populate lattice:
      NAT=0
      DO JZ=1,NZ
         DO JY=1,NY
            DO JX=1,NX
               NAT=NAT+1
               IF(NAT.GT.MXNAT)THEN
                  CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT')
               ENDIF
               IXYZ(NAT,1)=JX
               IXYZ(NAT,2)=JY
               IXYZ(NAT,3)=JZ
            ENDDO
         ENDDO
      ENDDO
      IF(NAT.GT.MXNAT)THEN
         CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT ')
      ENDIF

C homogeneous, anisotropic composition:

      DO JX=1,3
         DO JA=1,NAT
            ICOMP(JA,JX)=JX
         ENDDO
      ENDDO

      WRITE(CMSGNM,FMT='(A, I7, A)')
     &      '  Anisotropic rectangular prism of NAT=',NAT,' dipoles'
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)XV,YV,ZV,NAT,A1,A2,DX
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3),
     &                           ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE (UNIT=IOSHP)
      ENDIF
      RETURN
 9020 FORMAT (' >TARREC anisotropic rectangular prism; AX,AY,AZ=',3F8.4,
     &/,I7,' = NAT',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,
     &'     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE ALPHA(AKR,CALPHA,CXALDS,CXALPH,CXALOF,CXALOS,
     &     CXE0R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH,IBETH1,
     &     ICOMP,IOCC,IPHI,IPHI1,IXYZ0,JORTH,MYID,MXCOMP,MXNAT,MXN3,
     &     NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,CXRLOC,CSHAPE,SHPAR)
      IMPLICIT NONE

C*** Arguments:

      CHARACTER*6 CALPHA,CSHAPE
      INTEGER 
     &   IBETH,IBETH1,IPHI,IPHI1,JORTH,MXCOMP,MXNAT,MXN3,
     &   MYID,NAT,NAT0,NAT3,NCOMP,NX,NY,NZ
      COMPLEX 
     &   CXALOF(NAT,3),
     &   CXALPH(NAT,3),
     &   CXE0R(3),
     &   CXEPS(MXCOMP),
     &   CXALDS(NAT,3),
     &   CXALOS(NAT,3),
     &   CXSC(NAT,3,3),
     &   CXSCR1(NAT,3),
     &   CXZC(NX+1,NY+1,NZ+1,6),
     &   CXZW(2*NX,2*NY,2*NZ,3),
     &   CXRLOC(MXCOMP+1,3,3)
      INTEGER*2 
     &   ICOMP(NAT,3),
     &   IOCC(NAT),
     &   IXYZ0(MXNAT,3)
      REAL 
     &   AKR(3),
     &   DX(3),
     &   SHPAR(6)

C*** Local Variables:

      LOGICAL INIT
      CHARACTER CMSGNM*70
      INTEGER
     &   IA,IC,L
      REAL 
     &   AK1,AK2,B1,B2,B3,B3L,EMKD,PI,SUM
      COMPLEX 
     &   CXI,CXRR,CXTERM

C*** Common:

      CHARACTER*6 CMETHD
      INTEGER DUM1,DUM2,DUM3,DUM4,DUM5,DUM6,DUM7,DUM8,DUM9,
     &     DUM10,DUM11,DUM12,DUM13,DUM14
C-----------------------------------------------------------------------
      COMMON/M6/DUM1,DUM2,DUM3,DUM4,DUM5,DUM6,DUM7,DUM8,DUM9,DUM10,
     &          DUM11,DUM12,DUM13,DUM14,CMETHD
C-----------------------------------------------------------------------

      SAVE INIT,CXI,PI
      DATA CXI/(0.,1.)/
      DATA INIT/.TRUE./

C***********************************************************************
C Given:
C       AKR(1-3)=(kx,ky,kz)*d, where d=effective lattice spacing
C       CALPHA = 'LATTDR' or 'SCLDR' = polarizability prescription
C       CMETHD = determines 3-d FFT routine used by ESELF
C       CSHAPE = descriptor of target shape
C       CXE0R(1-3) = polarization vector in lattice coordinates
C                    (assumed to be normalized)
C       CXEPS(1-NCOMP)=distinct values of dielectric constant
C       CXSC(1-NAT,1-3,1-3) = complex scratch space for SCLDR calculation
C       CXSCR1(1-NAT,1-3)   = complex scratch space for SCLDR calculation
C       CXZC = complex scratch space needed by ESELF
C       CXZW = complex scratch space needed by ESELF
C       DX(1-3)=(dx/d,dy/d,dz/d), where dx,dy,dz=lattice spacings in
C               x,y,z directions, and d=(dx*dy*dz)**(1/3)
C       IBETH= MYID+IBETH1 if first time through combined BETA/THETA 
C              orientation loop
C       IBETH1=starting value of IBETH (see above)
C       ICOMP(1-NAT3)=composition identifier for each lattice site and
C                     direction (ICOMP=0 if lattice site is unoccupied)
C                storage scheme: 
C                1x,2x,...,NATx,1y,2y,...,NATy,1z,2z,...,NATz
C       IOCC(1-NAT) == 0 if site unoccupied
C                   == 1 if site occupied
C       IPHI = IPHI1 if first time through PHI orientation loop
C       IPHI1= starting value of IPHI (see above)
C       JORTH= 1 if first incident polarization state
C       MXCOMP = dimensioning information
C       MXN3 = dimensioning information
C       MYID = parallel process identifier (=0 if only 1 process)
C       NAT  = number of sites in extended target (incl. vacuum sites)
C       NAT3 = 3*number of sites in extended target (incl. vacuum sites)
C       NCOMP= number of different dielectric tensor elements in target
C       NX   = x-dimension of extended target
C       NY   = y-dimension of extended target
C       NZ   = z-dimension of extended target
C       SHPAR(1-6)=target shape parameters
C
C Returns:
C       CXALPH(J,1-3)=(alpha_11,alpha_22,alpha_33)/d^3 for dipole J=1-NAT
C                     where alpha_ij=complex polarizability tensor.
C       CXALOF(J,1-3)=(alpha_23,alpha_31,alpha_12)/d^3 for dipole J=1-NAT
C
C***
C If CALPHA = LATTDR:
C    Compute dipole polarizability using "Lattice Dispersion Relation"
C    of Draine & Goodman (1993,ApJ,March 10).  It is required that
C    polarizability be such that an infinite lattice of such dipoles
C    reproduce the continuum dispersion relation for radiation
C    propagating with direction and polarization of radiation incident
C    on the DDA target.  This is the recommended option.
C
C***
C    Note: CXALPH = polarizability/d^3
C    In the event that ICOMP=0, then we set CXALPH=1.
C***********************************************************************
C B.T.Draine, Princeton Univ. Obs.
C History:
C 90.09.13 (BTD): Corrected error in DO loop limit.
C 90.11.01 (BTD): Special treatment for "vacuum" sites in order
C                 to allow FFT treatment.
C 90.11.02 (BTD): Set CXALPH=(1.,0.) at vacuum sites.
C 91.04.30 (BTD): Modified to include both O[(kd)^2] correction term
C                 from Goedecke & Obrien (1988) in addition to
C                 radiative reaction correction.
C 91.05.07 (BTD): Modified to allow easy choice among three methods
C                 for computing polarizability.
C 91.05.07 (BTD): Added call to WRIMSG to record which method in use
C 91.05.08 (BTD): Added CALPHA to argument list.
C 91.05.09 (BTD): Added printing of kd and magnitude of correction
C                 terms.
C 91.05.13 (BTD): Experiment with use of approximate directional
C                 average for coefficient of CXEPS in Lattice
C                 Disperision Relation theory
C 91.05.13 (BTD): Corrected error in radiative reaction correction
C                 (error presumably introduced during last week)
C 91.05.14 (BTD): Added separate options LDRXYZ and LDRAVG
C 91.05.15 (BTD): Added option LDR000 to omit CXEPS-dependent
C                 correction term
C 91.05.30 (BTD): Changed LDRXYZ -> LDR100
C                 Added option LDR111
C 91.09.12 (BTD): Corrected error in numerical coefficient for
C                 LDRAVG case
C 91.09.17 (BTD): Eliminate options LDR000,LDRXYZ,LDRAVG
C                 Introduce option LATTDR (LATTice Dispersion Relation)
C                 which includes explicit dependence
C                 on direction and polarization state
C                 remove AK1 from argument list
C                 add AKR, CXE0R to argument list
C 92.05.14 (BTD): Introduce option LDRISO to experiment with
C                 using average directional correction term
C                 rather than using correction for incident direction
C                 and polarization
C 92.05.16 (BTD): Correct error in LDRISO option: average SUM should be
C                 3/15 rather than 4/15
C 97.11.02 (BTD): Add DX to argument list to allow use with noncubic
C                 lattices (additional modifications still required!!)
C 97.12.26 (BTD): Add CXALOF to argument list to allow use with noncubic
C                 lattices (additional modifications still required).
C 97.12.30 (BTD): Add code to evaluate alpha for noncubic case,
C                 using subroutine NONCUBIC to evaluate the lattice
C                 sums R0,R1,R2,R3
C 98.01.14 (BTD): Change sign of radiative reaction correction term.
C 98.01.19 (BTD): Change treatment of R_1,C3, and C4
C                 and output value of C4
C                 temporary modification to allow value of C4 to be
C                 read in from file 'alpha.par'
C 98.01.22 (BTD): Minor change in computation of radiative reaction
C                 correction.
C 98.03.10 (BTD): set C4=-C3, disable reading C4 from 'alpha.par'
C 98.04.27 (BTD): declared IC1,IC2,IC3 as integers.
C 99.02.09 (BTD): experiment with change in expression used to calculate
C                 off-diagonal elements of polarizability tensor
C                 experiment with C4=-C3-R1 to "cancel" the contribution
C                 of R1 to the off-diagonal terms
C 03.01.29 (BTD): remove code to calculate alpha for noncubic lattice
C                 (hold for release in future version)
c 04.02.26 (BTD): add new option 'GKDLDR' to use Gutkowicz-Krusin
c                 and Draine (2004) lattice dispersion relation
c 04.03.31 (BTD): replace WRITE(0,... with CALL WRIMSG(...
c 04.04.01 (BTD): added DUM13,DUM14 to COMMON/M6/ to accomodate use of
c                 COMMON/M6/ in communicating NPY,NPZ to subroutineS
c                 MATVEC and CMATVEC
c 04.05.21 (BTD): cleanup -- eliminated a number of unused local
c                 variables
C end history
C Copyright (C) 1993,1996,1997,1998,1999,2003,2004
c               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      PI=4.*ATAN(1.)
      AK2=AKR(1)*AKR(1)+AKR(2)*AKR(2)+AKR(3)*AKR(3)
      AK1=SQRT(AK2)
      CXRR=-(AK1*AK2/1.5)*CXI

C*** EMKD = |m|*k_0*d , where |m|=refractive index
C                             k_0 = wave vector in vacuo
C                             d = lattice spacing

      EMKD=SQRT(CABS(CXEPS(1)))*AK1

C***********************************************************************

C*** Lattice dispersion relation (Draine & Goodman 1993)

      IF(CALPHA.EQ.'LATTDR')THEN
         WRITE(CMSGNM,FMT='(A,F6.4)')
     &         'Lattice dispersion relation for |m|k_0d=',EMKD
         CALL WRIMSG('ALPHA ',CMSGNM)

C*** Compute sum (a_j*e_j)^2 , where a_j=unit propagation vector
C                                    e_j=unit polarization vector

         SUM=0.0
         DO L=1,3
            SUM=SUM+(AKR(L)*CABS(CXE0R(L)))**2
         ENDDO
         SUM=SUM/AK2
         B1=-1.8915316*AK2
         B2=(0.1648469-1.7700004*SUM)*AK2
         DO L=1,3
            DO IA=1,NAT
               IC=ICOMP(IA,L)
               IF(IC.GT.0)THEN

C*** First compute Clausius-Mossotti polarizability:

                  CXTERM=(.75/PI)*(CXEPS(IC)-1.)/(CXEPS(IC)+2.)

C*** Determine polarizability by requiring that infinite lattice of
C    dipoles have dipersion relation of continuum.

                  CXTERM=CXTERM/(1.+CXTERM*(B1+CXEPS(IC)*B2))

C*** Radiative-reaction correction:

                  CXALPH(IA,L)=CXTERM/(1.+CXTERM*CXRR)

c set off-diagonal terms to zero

                  CXALOF(IA,L)=0.

               ELSEIF(IC.EQ.0)THEN

C To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.

                  CXALPH(IA,L)=1.
                  CXALOF(IA,L)=0.
               ENDIF
            ENDDO
         ENDDO
         RETURN

c*** Lattice dispersion relation: modified 
c    (Gutkowicz-Krusin & Draine 2004)

      ELSEIF(CALPHA.EQ.'GKDLDR')THEN
         WRITE(CMSGNM,FMT='(A,F6.4)')
     &         'GKDLDR Lattice dispersion relation for |m|k_0d=',EMKD
         CALL WRIMSG('ALPHA ',CMSGNM)

C B1 = (c_1/pi)*ak2 = (-5.9424219/pi)*ak2 = -1.8915316*ak2
C B2 = (c_2/pi)*ak2 = (0.5178819/pi)*ak2 = 0.1648469*ak2
C B3 = -[(3c_2+c_3)/pi]*ak2 = -[(3*0.5178819+4.0069747)/pi]*ak2
C                           = -1.7700004*ak2
C B3L = B3*A(I)**2 where a_i = unit vector in direction of propagation

         B1=-1.8915316*AK2
         B2=0.1648469*AK2
         B3=-1.7700004*AK2
         DO L=1,3
            B3L=B3*AKR(L)*AKR(L)/AK2
            DO IA=1,NAT
               IC=ICOMP(IA,L)
               IF(IC.GT.0)THEN

C*** First compute Clausius-Mossotti polarizability:

                  CXTERM=(.75/PI)*(CXEPS(IC)-1.)/(CXEPS(IC)+2.)

C*** Determine polarizability by requiring that infinite lattice of
C    dipoles have dipersion relation of continuum.


                  CXTERM=CXTERM/(1.+CXTERM*(B1+CXEPS(IC)*(B2+B3L)))

C*** Radiative-reaction correction:

                  CXALPH(IA,L)=CXTERM/(1.+CXTERM*CXRR)

c set off-diagonal terms to zero

                  CXALOF(IA,L)=0.

               ELSEIF(IC.EQ.0)THEN

C To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.

                  CXALPH(IA,L)=1.
                  CXALOF(IA,L)=0.
               ENDIF
            ENDDO
         ENDDO
         RETURN
      ELSE
         WRITE(CMSGNM,FMT='(A)')
     &      'Error: invalid option for subroutine ALPHA'
         CALL WRIMSG('ALPHA ',CMSGNM)
         STOP
      ENDIF
      END

      SUBROUTINE WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,DX,ICOMP,
     &                    IXYZ0,MXNAT,MXN3,NAT,NAT3,WAVEA,MXWAV,NWAV,
     &                    AEFFA,MXRAD,NRAD,ITHETA,IBETA,IPHI,THETA,
     &                    MXTHET,NTHETA,BETA,MXBETA,NBETA,PHI,MXPHI,
     &                    NPHI,NSMELTS,TIMERS,MXTIMERS,NTIMERS,
     &                    CBINFILE,IOBIN,CBINFLAG,CNETFILE,IDNC,
     &                    CNETFLAG,ILIN10,ILIN12,IORI,IWRKSC,IORTH,
     &                    IRAD,IWAV,MXCOMP,MXSCA,NAT0,NAVG,ITNUM,
     &                    MXITER,NCOMP,NORI,NSCAT,CALPHA,CDESCR,CFLAVG,
     &                    CFLSCA,CMDFFT,CMDTRQ,CSHAPE,CSTAMP,AEFF,AK1,
     &                    AKR,BETAD,BETMID,BETMXD,ETASCA,PHID,PHIMID,
     &                    PHIMXD,THETAD,THTMID,THTMXD,TOL,WAVE,XX,A1,
     &                    A2,PHIN,QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,
     &                    QEXT,QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,QSCGSUM,
     &                    QSCG2SUM,QSCSUM,QTRQAB,QTRQABSUM,QTRQSC,
     &                    QTRQSCSUM,S1111,S2121,SM,SMIND1,SMIND2,SMORI,
     &                    THETAN,CX1121,CXE01,CXE01R,CXE02,CXE02R,
     &                    CXEPS,CXRFR,CXF11,CXF21,CXF12,CXF22)
C
      IMPLICIT NONE
C
C Scalar Arguments ..
C
      REAL AEFF,AK1,BETAD,BETMID,BETMXD,ETASCA,PHID,PHIMID,PHIMXD,
     &     THETAD,THTMID,THTMXD,TOL,WAVE,XX
      INTEGER IBETA,IDNC,ILIN10,ILIN12,IOBIN,IORI,IORTH,IPHI,
     &        IRAD,ITHETA,IWAV,IWRKSC,MXBETA,MXCOMP,MXITER,MXN3,MXNAT,
     &        MXNX,MXNY,MXNZ,MXPHI,MXRAD,MXSCA,MXTHET,MXTIMERS,MXWAV,
     &        NAT,NAT0,NAT3,NAVG,NBETA,NCOMP,NORI,NPHI,NRAD,NSCAT,
     &        NSMELTS,NTHETA,NTIMERS,NWAV,NX,NY,NZ
      
      INTEGER ITNUM(2)
      CHARACTER CALPHA*6,CBINFLAG*6,CMDFFT*6,CMDTRQ*6,CNETFLAG*6,
     &          CSHAPE*6,CFLAVG*14,CBINFILE*14,CFLSCA*15,CNETFILE*14,
     &          CSTAMP*22,CDESCR*67
C
C Array Arguments ..
C
      COMPLEX CX1121(MXSCA),CXE01(3),CXE01R(3),CXE02(3),CXE02R(3),
     &        CXEPS(MXCOMP),CXF11(MXSCA),CXF12(MXSCA),CXF21(MXSCA),
     &        CXF22(MXSCA),CXRFR(MXCOMP)
      REAL A1(3),A2(3),AEFFA(MXRAD),AKR(3),BETA(MXBETA),DX(3),
     &     PHI(MXPHI),PHIN(MXSCA),QABS(2),
     &     QABSUM(2),QBKSCA(2),QBKSUM(2),QEXSUM(2),QEXT(2),QPHA(2),
     &     QPHSUM(2),QSCAG(3,2),QSCAG2(2),QSCAT(2),QSCG2SUM(2),
     &     QSCGSUM(3,2),QSCSUM(2),QTRQAB(3,2),QTRQABSUM(3,2),
     &     QTRQSC(3,2),QTRQSCSUM(3,2),
     &     S1111(MXSCA),S2121(MXSCA),SM(MXSCA,4,4),SMORI(MXSCA,4,4),
     &     THETA(MXTHET),THETAN(MXSCA),TIMERS(MXTIMERS),WAVEA(MXWAV)
      INTEGER*2 ICOMP(MXN3),IXYZ0(MXNAT,3)
      INTEGER SMIND1(9),SMIND2(9)

C Local variables:

      COMPLEX CXVAR1
      REAL DEGRAD,MKD,PHIND,PI,PPOL,RVAR1,RVAR2,RVAR3,THETND
      INTEGER I,J,ND
      REAL G(2),G2(2),QAV(18)

C External Subroutines:

      EXTERNAL NAMER,WRITEBIN,WRITENET

C Intrinsic Functions:

      INTRINSIC CONJG,SQRT

C Save statement:

      SAVE DEGRAD

C Data statements ..

      DATA DEGRAD/57.29578/
C***********************************************************************
C
C Purpose of this module is to collect a lot of the output code into
C a single module.
C
C If IORI = 0, then print orientational average
C If IORI > 0, print output for specific orientation
C
C History:
C 96.11.14 (PJF) added binary write options (see also info in
C                "versions.f" about IDL postprocessing)
C                possible "checkpointing" could be done here "close(iobin)"
C                open(iobin,file=cbinfile,form='unformatted',access='append')
C                (which is non-standard Fortran 77 (but standard in F90)
C                open(iobin,file=cbinfile,form='unformatted',status='old')
C 96.11.21 (BTD) added call to WRITENET if called with CNETFLAG='NCCLOS'
C                in order to get call to NCCLOS out of DDSCAT.f
C 98.01.11 (BTD) added DX(3) to argument list to pass information on
C                nonuniform lattice spacing [development of DDSCAT.6.0]
C 98.11.16 (BTD) corrected CX01R -> CXE01R in argument list of WRITEBIN
C 98.12.12 (BTD) Introduce NSMELTS,SMIND1,SMIND2 to argument list to
C                allow selection of Muller matrix elements to be
C                printed out.  Add code to allow from 1 to 9 matrix
C                elements to be printed.
C 98.12.13 (BTD) Modify to print out validity criterion |m|kd
C                for each composition
C 03.01.30 (BTD) disabled output line to print out dx,dy,dz
C 03.02.13 (BTD) added one more digit of precision to output Q values
C                with appropriate modifications to format statements
C 03.04.14 (BTD) added ITNUM(2) and MXITER to argument list
C                added ITNUM(2) = number of iterations
C                and MXITER = max number of iterations allowed
C                to output statements 9150 and 9155
C 03.09.01 (BTD) cosmetic change to output statement: g -> g(1)
C 03.10.23 (BTD) removed ICTHM and IPHIM from argument list
c                removed ICTHM and IPHIM from argument list of
c                WRITENET and WRITEBIN
c                removed ICTHM and IPHIM from WRITE(..,9033)
c                added NAVG to argument list
c                added NAVG to WRITE(..,9033)
c                added NAVG to argument list of WRITENET and WRITEBIN
c                write NAVG to qtable,wxxrxxkxxx.sca, wxxrxxori.avg
C 04.02.22 (BTD) added IWRKSC to argument list of WRITESCA and use to
c                control writing to ascii output files
c 04.05.21 (BTD) reordered QSCGSUM and QSCG2SUM in argument list
c 04.12.29 (BTD) corrected error in writing Mueller matrix for the
c                "sca" files when IWRKSC=1
c 05.10.11 (BTD) changed CFLAVG*13 to CFLAVG*14
c                changed CFLSCA*14 to CFLSCA*15
c 06.11.28 (BTD) corrected error in calculation of PPOL = degree of
c                linear polarization of scattered light
C end history
C
C Copyright (C) 1996,1998,2003,2004,2005,2006
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

C If CNETFLAG = 'NCCLOS' then call WRITENET to close netCDF files

      IF(CNETFLAG.EQ.'NCCLOS')THEN

         CALL WRITENET(CNETFILE,IDNC,CNETFLAG,CSTAMP,CDESCR,CMDFFT,
     &                 CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,
     &                 MXBETA,MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,
     &                 NX,NY,NZ,NAT0,NAT,NAT3,NAVG,NSCAT,NCOMP,NORI,
     &                 NWAV,NRAD,NTHETA,NPHI,NBETA,NTIMERS,MXNX,MXNY,
     &                 MXNZ,MXCOMP,BETMID,BETMXD,THTMID,THTMXD,
     &                 PHIMID,PHIMXD,TOL,DX,WAVEA,AEFFA,
     &                 THETA,BETA,PHI,A1,A2,ICOMP,IXYZ0,IWAV,IRAD,
     &                 ITHETA,IBETA,IPHI,IORI,AEFF,WAVE,XX,AK1,BETAD,
     &                 THETAD,PHID,AKR,CXE01R,CXE02R,CXRFR,CXEPS,
     &                 QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,
     &                 QTRQSC,SM,SMORI,
c btd 04.02.22 add next two lines
     &                 QEXSUM,QABSUM,QSCSUM,QBKSUM,QPHSUM,QSCGSUM,
     &                 QTRQABSUM,QTRQSCSUM,
c ---------------
     &                 PHIN,THETAN,TIMERS)
         RETURN
      ENDIF

C If IORI > 0, then write out scattering properties for this specific
C target orientation.

      PI=4.*ATAN(1.)
      IF(IORI.GT.0)THEN

C*** Compute G=<cos(theta)> and G2=<cos^2(theta)>

         DO J=1,IORTH
            G(J)=QSCAG(1,J)/QSCAT(J)
            G2(J)=QSCAG2(J)/QSCAT(J)
         ENDDO

         IF(IWRKSC.EQ.1)THEN

            CALL NAMER(IWAV,IRAD,IORI,CFLSCA,CFLAVG)
            OPEN(UNIT=8,FILE=CFLSCA,STATUS='UNKNOWN')
            WRITE(8,FMT=9030)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0

C following code to be enabled for noncubic treatment:
C     &         ,DX

            WRITE(8,FMT=9032)AEFF,WAVE,XX
            DO J=1,NCOMP
               MKD=(4.*PI/(3.*NAT0))**(1./3.)*
     &             SQRT(REAL(CXRFR(J)*CONJG(CXRFR(J))))*XX
               WRITE(8,FMT=9031)CXRFR(J),CXEPS(J),MKD,J
            ENDDO
            WRITE(8,FMT=9033)TOL,NAVG,A1,A2
            WRITE(8,FMT=9035)AKR,CXE01R,CXE02R
            WRITE(8,FMT=9040)BETAD,THETAD,PHID,ETASCA
            WRITE(8,FMT=9050)QEXT(1),QABS(1),QSCAT(1),G(1),G2(1),
     &                       QBKSCA(1),QPHA(1)
         ENDIF

         IF(IORTH.EQ.1)THEN

C Assign "missing value" value if there is only one polarization

            DO I=1,18
               QAV(I)=-999.
            ENDDO
            QEXT(2)=-999.
            QABS(2)=-999.
            QSCAT(2)=-999.
            QBKSCA(2)=-999.
            QPHA(2)=-999.
            G(2)=-999.
            G2(2)=-999.
            DO J=1,3
               QSCAG(J,2)=-999.
            ENDDO
            QSCAG2(2)=-999.
         ENDIF

         IF(IORTH.EQ.2)THEN
            QAV(1)=.5*(QEXT(1)+QEXT(2))
            QAV(2)=.5*(QABS(1)+QABS(2))
            QAV(3)=.5*(QSCAT(1)+QSCAT(2))
            QAV(4)=.5*(QSCAG(1,1)+QSCAG(1,2))/QAV(3)
            QAV(5)=.5*(QSCAG2(1)+QSCAG2(2))/QAV(3)
            QAV(6)=.5*(QBKSCA(1)+QBKSCA(2))
            QAV(7)=.5*(QPHA(1)+QPHA(2))
            QAV(8)=QEXT(1)-QEXT(2)
            QAV(9)=QPHA(1)-QPHA(2)
            DO J=1,3
               QAV(9+J)=.5*(QSCAG(J,1)+QSCAG(J,2))
            ENDDO
            IF(CMDTRQ.EQ.'DOTORQ')THEN
               DO J=1,3
                  QAV(12+J)=.5*(QTRQAB(J,1)+QTRQAB(J,2))
                  QAV(15+J)=.5*(QTRQSC(J,1)+QTRQSC(J,2))
               ENDDO
            ENDIF
            IF(IWRKSC.EQ.1)WRITE(8,FMT=9055)QEXT(2),QABS(2),QSCAT(2),
     &                     G(2),G2(2),QBKSCA(2),QPHA(2),(QAV(J),J=1,9)
         ENDIF

         IF(IWRKSC.EQ.1)THEN
            WRITE(8,FMT=9150)(QSCAG(J,1),J=1,3),ITNUM(1),MXITER,NAVG
            IF(IORTH.EQ.2)THEN
               WRITE(8,FMT=9155)(QSCAG(J,2),J=1,3),ITNUM(2),MXITER,NAVG,
     &                          (QAV(J),J=10,12)
            ENDIF
         ENDIF

         IF(CMDTRQ.EQ.'DOTORQ')THEN
            IF(IWRKSC.EQ.1)THEN
               WRITE(8,FMT=9250)(QTRQAB(J,1),J=1,3),(QTRQSC(J,1),J=1,3)
               IF(IORTH.EQ.2)WRITE(8,FMT=9255)(QTRQAB(J,2),J=1,3),
     &                       (QTRQSC(J,2),J=1,3),(QAV(J),J=13,18)
            ENDIF
         ELSE

C add missing value code (set to -999.)

            DO I=1,3
               DO J=1,2
                  QTRQAB(I,J)=-999.
                  QTRQSC(I,J)=-999.
               ENDDO
            ENDDO

         ENDIF

         IF(IORTH.EQ.1)THEN

            IF(IWRKSC.EQ.1)WRITE(8,FMT=9060)
            DO ND=1,NSCAT

C convert scattering angles to degrees

               PHIND=DEGRAD*PHIN(ND)
               THETND=DEGRAD*THETAN(ND)
               RVAR1=REAL(CONJG(CXF11(ND))*CXF11(ND))
               RVAR2=REAL(CONJG(CXF21(ND))*CXF21(ND))
               CXVAR1=CONJG(CXF11(ND))*CXF21(ND)
               IF(IWRKSC.EQ.1)
     &            WRITE(8,FMT=9070)ND,THETND,PHIND,RVAR1,RVAR2,CXVAR1
            ENDDO

         ELSEIF(IORTH.EQ.2)THEN
            IF(IWRKSC.EQ.1)THEN
               WRITE(8,FMT=9080)
               IF(NSMELTS.EQ.1)THEN
                  WRITE(8,FMT=9081)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.2)THEN
                  WRITE(8,FMT=9082)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.3)THEN
                  WRITE(8,FMT=9083)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.4)THEN
                  WRITE(8,FMT=9084)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.5)THEN
                  WRITE(8,FMT=9085)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.6)THEN
                  WRITE(8,FMT=9086)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.7)THEN
                  WRITE(8,FMT=9087)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.8)THEN
                  WRITE(8,FMT=9088)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ELSEIF(NSMELTS.EQ.9)THEN
                  WRITE(8,FMT=9089)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
               ENDIF

               DO ND=1,NSCAT

C convert scattering angles to degrees

                  PHIND=DEGRAD*PHIN(ND)
                  THETND=DEGRAD*THETAN(ND)

C Compute PPOL = degree of linear polarization of scattered light
C for incident unpolarized light
c---
c 061128 (BTD) correct error in calculation of PPOL
c                  PPOL=SQRT(SM(ND,2,1)**2+SM(ND,3,1)**2)/SM(ND,1,1)
                  PPOL=-SM(ND,1,2)/SM(ND,1,1)
c---
                  WRITE(8,FMT=9090)THETND,PHIND,PPOL,
c*** 
c 04.12.29 (BTD) correction
c    &                 (SMORI(ND,SMIND1(J),SMIND2(J)),J=1,NSMELTS)
     &                 (SM(ND,SMIND1(J),SMIND2(J)),J=1,NSMELTS)
c***
               ENDDO
            ENDIF
         ENDIF

         IF(IWRKSC.EQ.1)CLOSE(8)

      ELSE

C This module writes out results from orientational averaging.
C (arrive here when called with IORI=0)

         OPEN(UNIT=8,FILE=CFLAVG,STATUS='UNKNOWN')
         WRITE(8,FMT=9030)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0

C following code to be enabled for noncubic treatment:
C         WRITE(8,FMT=9030)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,DX

         WRITE(8,FMT=9032)AEFF,WAVE,XX
         DO J=1,NCOMP
             MKD=(4.*PI/(3.*NAT0))**(1./3.)*
     &           SQRT(REAL(CXRFR(J)*CONJG(CXRFR(J))))*XX
            WRITE(8,FMT=9031)CXRFR(J),CXEPS(J),MKD,J
         ENDDO
         WRITE(8,FMT=9033)TOL,NAVG,A1,A2
         RVAR1=AK1
         RVAR2=0.
         RVAR3=0.
         WRITE(8,FMT=9037)RVAR1,RVAR2,RVAR3,CXE01,CXE02
         WRITE(8,FMT=9042)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                    PHIMID,PHIMXD,NPHI,ETASCA,NORI,IORTH

         RVAR1=QSCGSUM(1,1)/QSCSUM(1)
         RVAR2=QSCG2SUM(1)/QSCSUM(1)
         WRITE(8,FMT=9050)QEXSUM(1),QABSUM(1),QSCSUM(1),RVAR1,RVAR2,
     &                    QBKSUM(1),QPHSUM(1)
         IF(IORTH.EQ.1)THEN
            WRITE(8,FMT=9150)(QSCGSUM(J,1),J=1,3)
            IF(CMDTRQ.EQ.'DOTORQ')WRITE(8,FMT=9250)
     &              (QTRQABSUM(J,1),J=1,3),(QTRQSCSUM(J,1),J=1,3)
            WRITE(8,FMT=9060)
            DO ND=1,NSCAT

C Convert scattering angles to degrees

               PHIND=DEGRAD*PHIN(ND)
               THETND=DEGRAD*THETAN(ND)
               WRITE(8,FMT=9070)ND,THETND,PHIND,S1111(ND),S2121(ND),
     &                          CX1121(ND)
            ENDDO

C Write orientationally-averaged Q values (except Qpha) to 'qtable':

            OPEN(UNIT=10,FILE='qtable',STATUS='OLD')
            DO ND=1,ILIN10
               READ(10,FMT=*)
            ENDDO
            RVAR1=QSCGSUM(1,1)/QSCSUM(1)
            RVAR2=QSCG2SUM(1)/QSCSUM(1)
            WRITE(10,FMT=9056)AEFF,WAVE,QEXSUM(1),QABSUM(1),QSCSUM(1),
     &                        RVAR1,RVAR2,QBKSUM(1),NAVG
            ILIN10=ILIN10+1
            CLOSE(10)
            OPEN(UNIT=12,FILE='qtable2',STATUS='OLD')
            DO ND=1,ILIN12
               READ(12,FMT=*)
            ENDDO
            WRITE(12,FMT=9057)AEFF,WAVE,QPHSUM(1)
            ILIN12=ILIN12+1
            CLOSE(12)

         ELSEIF(IORTH.EQ.2)THEN
            RVAR1=QSCGSUM(1,2)/QSCSUM(2)
            RVAR2=QSCG2SUM(2)/QSCSUM(2)
            QAV(1)=.5*(QEXSUM(1)+QEXSUM(2))
            QAV(2)=.5*(QABSUM(1)+QABSUM(2))
            QAV(3)=.5*(QSCSUM(1)+QSCSUM(2))
            QAV(4)=.5*(QSCGSUM(1,1)+QSCGSUM(1,2))/QAV(3)
            QAV(5)=.5*(QSCG2SUM(1)+QSCG2SUM(2))/QAV(3)
            QAV(6)=.5*(QBKSUM(1)+QBKSUM(2))
            QAV(7)=.5*(QPHSUM(1)+QPHSUM(2))
            QAV(8)=QEXSUM(1)-QEXSUM(2)
            QAV(9)=QPHSUM(1)-QPHSUM(2)
            DO J=1,3
               QAV(9+J)=.5*(QSCGSUM(J,1)+QSCGSUM(J,2))
            ENDDO
            IF(CMDTRQ.EQ.'DOTORQ')THEN
               DO J=1,3
                  QAV(12+J)=.5*(QTRQABSUM(J,1)+QTRQABSUM(J,2))
                  QAV(15+J)=.5*(QTRQSCSUM(J,1)+QTRQSCSUM(J,2))
               ENDDO
            ENDIF
            RVAR2=.5*(QSCG2SUM(1)+QSCG2SUM(2))/QAV(3)
            WRITE(8,FMT=9055)QEXSUM(2),QABSUM(2),QSCSUM(2),RVAR1,RVAR2,
     &                       QBKSUM(2),QPHSUM(2),(QAV(J),J=1,9)
            WRITE(8,FMT=9150)(QSCGSUM(J,1),J=1,3),ITNUM(1),MXITER,NAVG
            WRITE(8,FMT=9155)(QSCGSUM(J,2),J=1,3),ITNUM(2),MXITER,NAVG,
     &                       (QAV(J),J=10,12)
            IF(CMDTRQ.EQ.'DOTORQ')THEN
               WRITE(8,FMT=9250)(QTRQABSUM(J,1),J=1,3),
     &                          (QTRQSCSUM(J,1),J=1,3)
               WRITE(8,FMT=9255)(QTRQABSUM(J,2),J=1,3),
     &                          (QTRQSCSUM(J,2),J=1,3),(QAV(J),J=13,18)
            ENDIF

C Write orientationally-averaged Q values (except Qpha) to 'qtable':

            OPEN(UNIT=10,FILE='qtable',STATUS='OLD')
            DO ND=1,ILIN10
               READ(10,FMT=*)
            ENDDO
            WRITE(10,FMT=9056)AEFF,WAVE,QAV(1),QAV(2),QAV(3),QAV(4),
     &                        QAV(5),QAV(6),NAVG
            ILIN10=ILIN10+1
            CLOSE(10)
            OPEN(UNIT=12,FILE='qtable2',STATUS='OLD')
            DO ND=1,ILIN12
               READ(12,FMT=*)
            ENDDO
            WRITE(12,FMT=9057)AEFF,WAVE,QAV(7),QAV(8),QAV(9)
            ILIN12=ILIN12+1
            CLOSE(12)
C
            WRITE(8,FMT=9080)
            IF(NSMELTS.EQ.1)THEN
               WRITE(8,FMT=9081)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.2)THEN
               WRITE(8,FMT=9082)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.3)THEN
               WRITE(8,FMT=9083)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.4)THEN
               WRITE(8,FMT=9084)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.5)THEN
               WRITE(8,FMT=9085)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.6)THEN
               WRITE(8,FMT=9086)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.7)THEN
               WRITE(8,FMT=9087)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.8)THEN
               WRITE(8,FMT=9088)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS.EQ.9)THEN
               WRITE(8,FMT=9089)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ENDIF
            DO ND=1,NSCAT

C Convert scattering angles to degrees

               PHIND=DEGRAD*PHIN(ND)
               THETND=DEGRAD*THETAN(ND)

C Compute PPOL = degree of linear polarization of scattered light
C for incident unpolarized light (Bohren & Huffman p. 382)
c---
c 061128 (BTD) correct error in calculation of PPOL
c               PPOL=SQRT(SMORI(ND,2,1)**2+SMORI(ND,3,1)**2)/
c     &                   SMORI(ND,1,1)
               PPOL=-SMORI(ND,1,2)/SMORI(ND,1,1)
c---
               WRITE(8,FMT=9090)THETND,PHIND,PPOL,
     &              (SMORI(ND,SMIND1(J),SMIND2(J)),J=1,NSMELTS)
            ENDDO

         ENDIF

         CLOSE(8)
      ENDIF

C write FORTRAN unformatted file

      IF(CBINFLAG.NE.'NOTBIN')THEN

         CALL WRITEBIN(CBINFLAG,CBINFILE,IOBIN,CSTAMP,CDESCR,CMDFFT,
     &                 CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,
     &                 MXBETA,MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,
     &                 NX,NY,NZ,NAT0,NAT,NAT3,NAVG,NSCAT,NCOMP,NORI,
     &                 NWAV,NRAD,NTHETA,NPHI,NBETA,NTIMERS,MXNX,MXNY,
     &                 MXNZ,MXCOMP,BETMID,BETMXD,THTMID,THTMXD,
     &                 PHIMID,PHIMXD,TOL,DX,WAVEA,AEFFA,
     &                 THETA,BETA,PHI,A1,A2,ICOMP,IXYZ0,IWAV,IRAD,
     &                 IORI,AEFF,WAVE,XX,AK1,BETAD,THETAD,PHID,AKR,
     &                 CXE01R,CXE02R,CXRFR,CXEPS,QEXT,QABS,QSCAT,G,
     &                 QBKSCA,QPHA,QAV,QTRQAB,QTRQSC,SM,PHIN,THETAN,
     &                 TIMERS)

      ENDIF

c btd 04.02.22 change
c add following to WRITENET argument list:
c QEXSUM
c QABSUM
c QSCSUM
c QBKSUM
c QPHSUM
c QSCGSUM
c QTRQABSUM
c QTRQSCSUM

      IF(CNETFLAG.NE.'NOTCDF')THEN
         CALL WRITENET(CNETFILE,IDNC,CNETFLAG,CSTAMP,CDESCR,CMDFFT,
     &                 CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,
     &                 MXBETA,MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,
     &                 NX,NY,NZ,NAT0,NAT,NAT3,NAVG,NSCAT,NCOMP,NORI,
     &                 NWAV,NRAD,NTHETA,NPHI,NBETA,NTIMERS,MXNX,MXNY,
     &                 MXNZ,MXCOMP,BETMID,BETMXD,THTMID,THTMXD,
     &                 PHIMID,PHIMXD,TOL,DX,WAVEA,AEFFA,
     &                 THETA,BETA,PHI,A1,A2,ICOMP,IXYZ0,IWAV,IRAD,
     &                 ITHETA,IBETA,IPHI,IORI,AEFF,WAVE,XX,AK1,BETAD,
     &                 THETAD,PHID,AKR,CXE01R,CXE02R,CXRFR,CXEPS,
     &                 QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,
     &                 QTRQSC,SM,SMORI,
c btd 04.02.22 add next two lines
     &                 QEXSUM,QABSUM,QSCSUM,QBKSUM,QPHSUM,QSCGSUM,
     &                 QTRQABSUM,QTRQSCSUM,
c--------------------------------
     &                 PHIN,THETAN,TIMERS)
      ENDIF

      RETURN

 9030 FORMAT(' DDSCAT --- ',A,/,' TARGET ---',A,/,' ',A,
     &       ' --- method of solution ',/,' ',A,
     &       ' --- prescription for polarizabilies',/,' ',A,
     &       ' --- shape ',/,I7,' = NAT0 = number of dipoles')
c following code to be enabled for noncubic treatment
c 9030 FORMAT(' DDSCAT --- ',A,/,' TARGET ---',A,/,' ',A,
c     &       ' --- method of solution ',/,' ',A,
c     &       ' --- prescription for polarizabilies',/,' ',A,
c     &       ' --- shape ',/,I7,' = NAT0 = number of dipoles',
C     &       3F8.5,' = normalized lattice spacings dx,dy,dz')
 9031 FORMAT('n= (',F7.4,' , ',F7.4,'),  eps.= (',F8.4,' , ',F7.4,
     &       ')  |m|kd=',0PF8.4,' for subs.',I2)
 9032 FORMAT('  AEFF=',F10.5,' =',' effective radius (physical units)',
     &       /,'  WAVE=',F10.5,' = wavelength (physical units)',/,
     &       'K*AEFF=',F10.5,' = 2*pi*aeff/lambda')
 9033 FORMAT('   TOL=',1P,E10.3,' = error tolerance for CCG method',/,
     &       '  NAVG=',I6,
     &       ' = (theta,phi) values used in comp. of Qsca,g',/,
     &       0P,'(',F8.5,2F9.5,') = target axis A1 in Target Frame',/,
     &       1X,'(',F8.5,2F9.5,') = target axis A2 in Target Frame')
 9035 FORMAT(1X,'(',F8.5,2F9.5,') = k vector (latt. units) in TF',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in TF',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in TF')
 9037 FORMAT(1X,'(',F8.5,2F9.5,
     &       ') = k vector (latt. units) in Lab Frame',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in LF',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in LF')
 9040 FORMAT(' BETA =',F7.3,' = rotation of target around A1',/,
     &       ' THETA=',F7.3,' = angle between A1 and k',/,'  PHI =',
     &       F7.3,' = rotation of A1 around k',/,
     &       F7.4,' = ETASCA = param. controlling # of ',
     &       'scatt. dirs used to calculate <cos> etc.')
 9042 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,2F8.3,
     &       ' = theta_min, theta_max; NTHETA=',I2,/,2F8.3,
     &       ' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       F7.4,' = ETASCA = param. controlling # of ',
     &       'scatt. dirs used to calculate <cos> etc.',/,
     &       ' Results averaged over ',I4,' target orientations',/,
     &       '                   and ',I2,' incident polarizations')
 9050 FORMAT(10X,'Qext',7X,'Qabs',7X,'Qsca',6X,'g(1)=<cos>',2X,
     &       '<cos^2>',5X,'Qbk',7X,
     &       'Qpha',/,1X,'JO=1: ',1P,3E11.4,E12.4,2E11.4,E12.4)
 9055 FORMAT(1X,'JO=2: ',1P,3E11.4,E12.4,2E11.4,E12.4,/,1X,'mean: ',
     &       3E11.4,E12.4,2E11.4,E12.4,/,1X,'Qpol= ',E11.4,50X,'dQpha=',
     &       E12.4)
 9056 FORMAT(1P,E10.4,4E11.4,E12.4,E11.4,E11.4,I6)
 9057 FORMAT(1P,E10.4,E11.4,3E12.4)
 9060 FORMAT('**** Selected scattering directions ',
     &       ' [note: incident pol state 1 is FIXED!]',/,
     &       ' ND THETA   PHI <|f11|^2> <|f21|^2> Re<f11*f21>',
     &       ' Im<f11*f21>')
 9070 FORMAT(I3,2F6.1,1P,2E10.3,2E11.3)
C 9080 FORMAT(' ***************** Selected scattering directions *****',
C     &       '************',/,
C     &       ' ND THETA   PHI <|f11|^2> <|f21|^2> <|f12|^2> ',
C     &       '<|f22|^2>  DEPOLR    PPOL')
 9080 FORMAT(12X,'** Mueller matrix elements for selected scattering ',
     &       'directions **')
 9081 FORMAT('theta   phi    Pol.    S_',I1,I1)
 9082 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1)
 9083 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1)
 9084 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1)
 9085 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
 9086 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
 9087 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1)
 9088 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1)
 9089 FORMAT('theta   phi    Pol.    S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,
     &       'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
 9090 FORMAT(F5.1,F6.1,F9.5,1P,9E11.3)
 9150 FORMAT(9X,'Qsca*g(1)   Qsca*g(2)   Qsca*g(3)   iter  mxiter',
     &       2X,'Nsca'/,
     &       1X,'JO=1:',1P,3E12.4,3I7)
 9155 FORMAT(1X,'JO=2:',1P,3E12.4,3I7,/,1X,'mean:',1P,3E12.4)
 9250 FORMAT(8X,'Qtrqab(1)  Qtrqab(2)  Qtrqab(3)  ',
     &       'Qtrqsc(1)  Qtrqsc(2)  Qtrqsc(3)',/,1X,'JO=1:',1P,6E11.3)
 9255 FORMAT(1X,'JO=2:',1P,6E11.3,/,1X,'mean:',1P,6E11.3)

      END

      SUBROUTINE TARCEL(A1,A2,AX,AY,AZ,BX,BY,BZ,DX,
     &                  CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      IMPLICIT NONE
C** Arguments:
      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      REAL AX,AY,AZ,BX,BY,BZ
      REAL A1(3),A2(3),DX(3)
C** Local variables:
      INTEGER JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,NIN
      REAL AX2,AY2,AZ2,BX2,BY2,BZ2,R,RR,RYZ2,RZ2,X,XOFF,Y,YOFF,Z,ZOFF
C***********************************************************************
C
C Routine to construct target consisting of two materials, with outer
C surface an allipsoid of dimensions AX,AY,AZ,
C and core/mantle interface a concentric ellipsoid of dimensions BX,BY,BZ
C Input:
C        AX=(x-length)/d of outer ellipsoid  (d=lattice spacing)
C        AY=(y-length)/d "   "     "
C        AZ=(z-length)/d "   "     "
C        BX=(x-length)/d of inner ellipsoid
C        BY=(y-length)/d "   "     "
C        BZ=(z-length)/d "   "     "
C        DX(1-3)=lattice spacing (dx/d,dy/d,dz/d), d=(dx*dy*dz)**(1/3)
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
C        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        ICOMP(1-NAT,1-3)=1 for sites within inner ellipsoid,
C                        =2 for sites between inner and outer ellipsoids
C        CDESCR=description of target (up to 67 characters)
C
C B.T.Draine, Princeton Univ. Obs.
C History:
C 94.01.26 (AP) : Adapted from TARELL by Antonio Peimbert, Princeton U.
C 94.01.27 (BTD): Modified for compatibility with TARGET, using
C                 AX,AY,AZ,BX,BY,BZ to transfer shape parameters read by
C                 subroutine REAPAR
C 94.03.21 (BTD): Corrected format statement
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 97.12.26 (BTD): Added DX(3) to argument list to support nonuniform
C                 lattice spacing.
C                 *** Note: additional code modifications required
C                     to support noncubic lattice!
C 98.03.06 (BTD): If called with noncubic lattice (not yet supported)
C                 call ERRMSG and halt with fatal error.
C 98.03.07 (BTD): Modify to write DX to file "target.out" for
C                 compatibility with REASHP
C 00.11.02 (BTD): Remove XOFF,YOFF,ZOFF from target.out
C                 cosmetic changes
C end history
C
C Copyright (C) 1994,1996,1997,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C Current version of TARCEL is restricted to cubic lattices
C
      IF(DX(1).NE.1..OR.DX(2).NE.1.)THEN
         CALL ERRMSG('FATAL','TARCEL',
     &               ' tarcel does not support noncubic lattice')
      ENDIF
C
C Inner ellipsoid is defined by
C      (X/AX)**2+(Y/AY)**2+(Z/AZ)**2 = 0.25
C Outer ellipsoid is defined by
C      (X/BX)**2+(Y/BY)**2+(Z/BZ)**2 = 0.25
C Material within inner ellipsoid is of composition 1
C Material between inner and outer ellipsoids is of composition 2
C
C Ideal volume V=(pi/6)*BX*BY*BZ
C
C Dipoles are located at sites
C (x,y,z)=(I+XOFF,J+YOFF,Z+KOFF), I,J,K=integers
C                                 XOFF,YOFF,ZOFF=constants
C
C For concentric spheres: call with AX=AY=AZ, BX=BY=BZ
C For spheroids: call with AX=AY (or AY=AZ or AX=AZ) and BX=BY (or BY=BZ
C   or BX=BZ)
C
C***********************************************************************
C
C Check that input parameters have "inner" ellipsoid smaller than
C "outer" ellipsoid:
      IF(AX.LT.BX)CALL ERRMSG('FATAL','TARCEL',' AX < BX ')
      IF(AY.LT.BY)CALL ERRMSG('FATAL','TARCEL',' AY < BY ')
      IF(AZ.LT.BZ)CALL ERRMSG('FATAL','TARCEL',' AZ < BZ ')
C Criterion for choosing XOFF: try to optimize outer ellipsoid surface
C If AX is close to an even integer, take XOFF=1/2
C If AX is close to an odd integer, take XOFF=0
      JX=INT(AX+.5)
      IF(2*(JX/2).EQ.JX)THEN
         XOFF=0.5
      ELSE
         XOFF=0.
      ENDIF
C Similar criterion for YOFF:
      JY=INT(AY+.5)
      IF(2*(JY/2).EQ.JY)THEN
         YOFF=0.5
      ELSE
         YOFF=0.
      ENDIF
C Similar criterion for ZOFF:
      JZ=INT(AZ+.5)
      IF(2*(JZ/2).EQ.JZ)THEN
         ZOFF=0.5
      ELSE
         ZOFF=0.
      ENDIF

      LMX1=-INT(.5*AX+.5)
      LMX2=INT(.5*AX-.25)
      LMY1=-INT(.5*AY+.5)
      LMY2=INT(.5*AY-.25)
      LMZ1=-INT(.5*AZ+.5)
      LMZ2=INT(.5*AZ-.25)

      AX2=AX*AX
      AY2=AY*AY
      AZ2=AZ*AZ
      BX2=BX*BX
      BY2=BY*BY
      BZ2=BZ*BZ

      NAT=0
      NIN=0

C Specify target axes A1 and A2
C   A1=(1,0,0) in target frame
C   A2=(0,1,0) in target frame

      DO JX=1,3
         A1(JX)=0.
         A2(JX)=0.
      ENDDO
      A1(1)=1.
      A2(2)=1.

C Determine list of occupied sites.

      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ)+ZOFF
         RZ2=Z*Z/AZ2
         IF(RZ2.LT.0.25)THEN
            DO JY=LMY1,LMY2
               Y=REAL(JY)+YOFF
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2.LT.0.25)THEN
                  DO JX=LMX1,LMX2
                     X=REAL(JX)+XOFF
                     R=RYZ2+X*X/AX2
                     IF(R.LT.0.25)THEN
C Site is occupied:
                        NAT=NAT+1
                        RR=Z*Z/BZ2+Y*Y/BY2+X*X/BX2
                        IF(RR.LT.0.25)THEN
C within inner ellipsoid:
                           ICOMP(NAT,1)=1
                           ICOMP(NAT,2)=1
                           ICOMP(NAT,3)=1
                           NIN=NIN+1
                        ELSE
C between inner and outer ellipsoids:
                           ICOMP(NAT,1)=2
                           ICOMP(NAT,2)=2
                           ICOMP(NAT,3)=2
                        ENDIF
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDDO

      IF(NAT.GT.MXNAT)THEN
         CALL ERRMSG('FATAL','TARELL',' NAT.GT.MXNAT ')
      ENDIF

C***********************************************************************
C Write target description into string CDESCR

      IF(AX.EQ.AY.AND.AX.EQ.AZ)THEN
         WRITE(CDESCR,FMT='(A,I7,A)')' Spherical target containing',
     &      NAT,' dipoles'
      ELSE
         WRITE(CDESCR,FMT='(A,I6,A,I7,A)')' Concentric ellipsoids with',
     &      NIN,' inner ',NAT,' total dipoles'
      ENDIF

C***********************************************************************

      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)AX,AY,AZ,BX,BY,BZ,NAT,NIN,
     &      A1,A2,DX
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3),
     &         ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 9020 FORMAT(' >TARCEL: concentric ellipsoids; AX,AY,AZ=',3F8.4,
     &       ' BX,BY,BZ=',3F8.4,/,
     &       I7,I7,' = NAT,NIN',/,
     &       3F9.4,' = A_1 vector',/,
     &       3F9.4,' = A_2 vector',/,
     &       3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,
     &       '     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE VERSION(CSTAMP)
      IMPLICIT NONE
C Arguments:
      CHARACTER CSTAMP*22
      CSTAMP='DDSCAT 6.1 [08.06.23]'
C*******************************************************************************
C History of major changes to DDSCAT package:
C 90.12.21 (BTD): Added code to DDSCAT to create output files
C                 'qtable' (summary of Q values)
C                 'mtable' (summary of diel. func. for material 1)
C 91.08.14 (BTD): Add QBKSCA to arg. list for GETFML
C                 Modify code to print out Q_bk
C 91.08.15 (BTD): Provide different headings for qtable depending on
C                 whether IORTH=1 or 2 (add statement 9043 to DDSCAT).
C 91.09.17 (BTD): Remove calls to ALPHA and EVALA in DDSCAT (needed to 
C                 move these to subroutine GETFML since alpha from Lattice
C                 Dispersion Relation depends on propagation direction
C                 and polarization state)
C                 Add CALPHA,CXEPS,ICOMP,MXCOMP to argument list for
C                 GETFML (information required by ALPHA)
C 91.11.12 (BTD): Added variable IDVSHP to argument list for TARGET
C                 (device number for REASHP to use in reading shape file)
C 93.01.15 (BTD): Modified DDSCAT to divided output file qtable into 2 files:
C                 qtable (containing Q_ext,Q_abs,Q_sca,g,Q_bk) and
C                 qtable2 (containing Q_pha, Q_pol, Q_cpol)
C 93.01.16 (BTD): Modify DDSCAT so that qtable, qtable2, and mtable are closed
C                 after writing, and reopened for each new write
C 93.01.20 (BTD): Add MXNX, MXNY, MXNZ to argument list for subroutine
C                 EXTEND to permit checking of target size against
C                 maximum allowed dimensions
C 93.03.11 (BTD): Deleted all code associated with unused variable
C                 CMACHN (originally included to identify machine/OS)
C 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
C                 Moved WRITE(IDVOUT,9010) to subr. TARGET
C 93.06.02 (BTD): Corrected error in FORMAT statement 9045 in DDSCAT
C 93.06.03 (BTD): Corrected error in computation of angle-averaged
C                 backscattering cross section QBKSUM(JO) in DDSCAT (had
C                 neglected to reset sum to zero for each new target).
C 93.09.28 (BTD): Add "fix" in DDSCAT.f to work around Sun compiler/OS 
C                 bug (see description below.
C 93.12.15 (BTD): Corrected calculation of PPOL in DDSCAT.f  Added 
C                 comments on correspondence between our notation and
C                 elements of 2x2 amplitude scattering matrix and 4x4 
C                 Mueller scattering matrix.
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
C                 allow up to 6 shape parameters in DDSCAT, REAPAR, 
C                 TARGET.
C 94.06.20 (PJF): Version 4c.1:
C                 Modifications to various routines to support use of
C                 GPFA FFT code of Temperton by specifying option
C                 NEWTMP in ddscat.par.  Changes made in
C                 cxfft3, eself, extend, reapar
C                 Add FFT timing code TSTFFT to distribution.
C                 Change made to timeit_xxx routines for compatibility
C                 with TSTFFT
C 94.12.20 (BTD): Add subroutine VERSION to consolidate log of
C                 significant changes to DDSCAT package.
C 95.04.07 (BTD): REASHP: Changed CDESCR*60->CDESCR*67 for compatibility
C                         with calling routine TARGET
C                 TARCYL: corrected error in code
C 95.05.15 (BTD): REASHP: Corrected READ statement
C                         added module for inhomogeneous/anisotropic
C                         targets.
C 95.05.26 (BTD): REAPAR: corrected construction of orthogonal
C                         polarization when E01 is complex (e.g.,
C                         circular polarization).
C 95.06.14 (BTD): REAPAR: added code to check that user is not requesting
C                         computation of f_ml when using other than
C                         linearly polarized E01
C 95.06.14 (BTD): Version 5a.1: first development
C                 Differs from version 4d in computing:
C                 full radiation pressure force (transverse components,
C                 in additional to longitudinal component computed
C                 previously);
C                 Torque due to scattering and absorption of radiation
C                 as measured by "vector torque cross section".
C                 Changes made in:
C                 DDSCAT
C                 GETFML (including argument list)
C                 SCAT (including argument list)
C                 VERSION (CSTAMP is now CHARACTER*22, so that a date
C                    can be attached to version number)
C 95.06.15 (BTD): Added CXE to argument list of SCAT
C                 Added new control parameters
C                 CMDSOL (to choose solution method)
C                 CMDTRQ (to choose whether or not to compute torques)
C 95.06.20 (PJF+: Major modification of DDSCAT and GETFML to support
C           BTD): use of modular iterative solvers (e.g., CCGPACK and
C                 PIM routines).
C               : add CMDSOL to argument list to specify method
C                 of solution, with "supported" options
C                 PETRKP = Petravic&Kuo-Petravic CCG routine (from 
C                          CCGPACK, coded by P.J. Flatau based on 
C                          earlier code by B.T. Draine)
C                 PBCGST = Preconditioned Biconjugate Gradient with 
C                          Stabilization (from PIM package, coded by
C                          R. Dias da Cunha and T. Hopkins)
C               : add CMDTRQ to argument list of REAPAR and GETFML
C 95.07.21 (BTD): Major revision to subroutine SCAT
C                 Added additional scratch arrays to DDSCAT,GETFML,SCAT
C 95.07.24 (BTD): Corrected errors in SCAT
C 95.08.14 (BTD): Modified GETFML and PROGRESS to include
C                 COMMON/NORMRES/ERRSCAL to allow renormalization of
C                 error |Ax-b| relative to |b|.
C 96.01.05 (BTD): Version 5a.2:
C                 Differs from version 5a.1 in including
C                 shape options BLOCKS and DW1996, including
C                 automatic calculation of principal axes A1 and A2
C                 with largest and second-largest moment of inertia
C                 eigenvalue and eigenvector problem is solved using
C                 routines BALANC, BALBAK, EIGV, ELMHS0, ELTRN0, HQR2,
C                 IPMPAR, and SPMPAR taken from the Naval Surface 
C                 Warfare Center Library of Mathematics Subroutines.
C 96.01.25 (BTD): Added shape option TWOSPH (routine TAR2SP, and
C                 modifications to TARGET,REAPAR).
C 96.02.23 (BTD): Subroutine PRINAXIS now carries out calculation of
C                 principal axes and eigenvalues of moment of inertia
C                 for arbitary grain shape (if invoked by appropriate
C                 "target generation" subroutine), and prints out
C                 3 principal axes and eigenvalues
C 96.10.17 (BTD): Version 5a.3: 
C                 Added NAT0 to argument list for routine ALPHA.
C                 This required modification of ALPHA and GETFML.
C 96.10.18 (BTD): Changed NEWTMP to GPFAFT (for Generalized Prime
C                 Factor Algorithm for Fourier Transform).
C 96.11.06 (BTD): Version 5a.4:
C                 Removed code from DDSCAT and moved to subroutines
C                 GETMUELLER and WRITESCA
C                 Changed definition of scattering angle phi.
C                 Previously, phi was measured from plane containing
C                 incident k vector and Re(CXE01)
C                 Henceforth, phi is measured from Lab x,y plane
C                 (incident radiation is along x axis).
C                 This involved changes to SCAVEC
C                 Modified GETMUELLER so that for IORTH=2 it
C                 automatically computes the complete Mueller scattering
C                 matrix for each target orientation, and for the
C                 orientational average.
C                 Modified WRITESCA so that it writes out selected
C                 elements of the Mueller matrix.
C 96.11.14 (PJF): Add timers(mxtimers), ntimers to DDSCAT and getfml
C                 timers contains information about CPU times of 
C                 various parts of the code and informations needed
C                 for timming (e.g. number of iterations)
C                 Further changes of "WRITESCA" to include binary
C                 file option. This should be of use, for example, 
C                 for users of IDL.
C                 Added "cbinflag" to DDSCA, reapar. Added
C                 "cbinfile", "iobin" and "open" unformatted file in DDSCAT
C                 "close(iobin) in DDSCAT.
C                 Removed "getset" routine. Hardwired "ioerr" in
C                 "errmsg", and "ioout" in "wrimsg". 
C                 Combined all "rotation" code in rot.2
C                 Added dd.pro package for DDSCAT output postprocessing.
C                 The package includes IDL reading code of binary
C                 DDSCAT file and Bohren and Huffman Mie routine coded in IDL.
C                 Added 10,000 lines of LAPACK code to solve 3x3
C                 eigenvalue problem. Removed NSWC l(eispack)
C                 driver because (a) it contains ald r1mach
C                 tedious to support code (b) because LAPACK is
C                 more modern. 
C                 Add several *.ps files to doc and BibTeX
C                 bibliography of recent DDA references.
C 96.11.15 (PJF): Added NetCDF binary option to "writesca.f"
C                 One needs "include" in writesca.f which is non-standard
C                 in FORTRAN77 but will probably work on all architectures.
C                 Also -lnetcdf flag is needed during the loading step
C                 if NetCDF is being used. Otherwise  "empty" NetCDF routines
C                 should be substittuted to satisfy loader (c.f. dummynetcdf.f)
C                 "ncclose" is executed from DDSCAT.f instead of writesca.f
C                 NetCDF is available from http://www.unidata.ucar.edu/
C                 for most popular computers. 
C                 Added "writebin.f" and "writecdf.f" for 5a7
C 96.11.21 (BTD): moved NCCLOS to WRITENET so that all dependence on
C                 netCDF is through subroutine WRITENET
C                 This required changes to DDSCAT,WRITESCA, and
C                 WRITENET, and adding additional call to WRITESCA
C                 from DDSCAT, and additional call to WRITENET from
C                 WRITESCA
C                 added variable IDVOUT2 to COMMON/NORMERR to permit
C                 device number for standard output to be passed to
C                 subroutine PROGRESS
C 96.12.02 (BTD): Corrected error in DDSCAT.f : SMORI was not
C                 initialized, and hence was incorrect except (possibly)
C                 for first wavelength and radius.
C                 Also eliminated some superfluous variables from
C                 DDSCAT.f
C 97.04.28 (BTD): Corrected bug in TARHEX: NAT was not initialized to 0
C 97.06.04 (BTD): Corrected bug in TARGET, affecting only target option
C                 "UNICYL" (target composition was not being set
C                 correctly).
C 97.07.24 (BTD): Corrected bug in GETMUELLER: was using PHI rather
C                 than PHIN in computation of amplitude scattering
C                 matrix and Mueller matrix from f_ml computed by
C                 GETFML.  Required change in GETMUELLER argument,
C                 list, with corresponding change required in DDSCAT.f
C                 Also corrected bugs in GETMUELLER pertaining to
C                 computation of Mueller matrix elements S_14 and
C                 S_31.  Note that because S_31 was incorrect, PPOL
C                 (evaluated in WRITESCA) was numerically incorrect.

C --------------- begin creation of version 6.0 -----------------------
C                 continuing to support "public" version 5a7 while
C                 carrying on private development of version 6.0
C ---------------------------------------------------------------------
C 98.01.01 (BTD): Version 6.0, with capability of using noncubic
C                 rectangular lattices.  Extensive changes required,
C                 because polarizability tensor will now be nondiagonal
C                 even when dielectric tensor is isotropic.
C                 Changes include following modules:
C                    DDSCAT
C                    ALPHA
C                    CMATVEC (in cprod.f)
C                    CPROD
C                    ESELF
C                    EVALA
C                    EVALE
C                    EVALQ
C                    GETFML
C                    MATVEC (in cprod.f)
C                    PRINAXIS
C                    REASHP
C                    SCAT
C                    TARELL
C                    TARGET
C                    TARBLOCKS
C                    TARCEL
C                    TARCYL
C                    TARHEX
C                    TARREC
C                    TARTET
C                    TAR2EL
C                    TAR3EL
C                    TAR2SP
C                 and additional module
C                    NONCUBIC (called by subroutine ALPHA)
C 98.01.20 (BTD): Modified subroutine ALPHA to use (and print out)
C                 constant C4 in evaluation of first-order corrections
C                 to alpha.
C 98.03.10 (BTD): Changes to:
C                    ERRMSG
C                    REAPAR
C                    TAR2EL
C                    TAR2SP
C                    TAR3EL
C                    TARBLOCKS
C                    TARCEL
C                    TARELL
C                    TARHEX
C                    TARTET
C 98.04.27 (BTD): Minor changes made in
C                    ALPHA
C                    CGCOMMON
C                    EVALQ
C                    GETFML
C                    NONCUBIC
C                    PRINAXIS
C                    RESTORE
C                    TARCYL
C                    TARGET
C 98.10.07 (BTD) Rewrote cgcommon.f, function SCNRM2,
C                because g77 optimization generates bad code
C                complicated code replaced with simple code
C -------------- [separate creation of version 5a9 at this time] ----
C 98.10.08 (BTD) modified cgcommon.f, subroutine PROGRESS,
C                to keep track of minimum error, and to
C                note when new error minimum is attained.  This is
C                to observe convergence behavior of PBCGST.
C 98.10.26 (BTD) modified subroutine PROGRESS in cgcommon.f
C                to also print information on
C                rate of convergence (variable RATE).
C 98.10.27 (BTD) modified subroutine SMACHCONS in cgcommon.f
C                because Solaris compiler complained about value of
C                OVERFLOW parameter.  Reduced by factor 2
C 98.11.16 (BTD) Corrected error in value of CXE01R passed to WRITEBIN
C                for binary write option.
C 98.12.07 (BTD) Found and corrected bug reported by Timo Nousiainen 
C                (tpnousia@lumi.meteo.helsinki.fi) which caused Mueller
C                matrix elements S_12 and S_13 to be computed 
C                due to inconsistency in definition of f_ml.  Removed
C                code in GETFML which had been inserted to change
C                f_ml to refer to "usual" incident pol states l=1,2
C                whereas GETFML assumed that incident pol states
C                l=1,2 were those specified by the user in ddscat.par
C                Stick with this latter convention.
C                Modified GETMUELLER so that Mueller matrix elements
C                are computed correctly even when user-specified
C                incident polarization state CXE01 is not linearly
C                polarized.
C 98.12.07 (BTD) Edited UserGuide to give more detailed (and now correct)
C                discussion of computation of Mueller matrix elements
C                from the f_ml.
C 98.12.07 (BTD) Inserted (commented out) code into getfml to allow
C                verification of final error in approximate solution
C                to confirm reliability of error reported by iteration
C                machinery.  After confirming that these errors appear
C                to be reasonable, code was commented out, but can be
C                reactivated at future date if repetition of such tests
C                is desired.
C 98.12.16 (BTD) In getfml.f, increase upper limit on iterations from
C                300 to 10000
C 99.01.26 (BTD) Modified DDSCAT.f and reapar.f to allow user to specify
C                first IWAV,IRAD,IORI (normally 0 0 0).  This allows
C                one to restart calculational runs which abort after
C                doing only some of the desired wavelengths, radii,
C                and orientations.  Note: structure of ddscat.par is
C                changed as a result!
C 99.03.01 (BTD) rewrote subroutine orient.f to make it handle odd
C                NTHETA as described in the UserGuide
C 99.03.05 (BTD) corrected errors in new orient.f
C 99.04.30 (BTD) corrected new errors in orient.f (introduced in
C                99.03.05 revision)
C 99.06.30 (BTD) modifications to reapar (was not reading correct 
C                number of SHPAR values for case TWOSPH) and tar2sp 
C                in order to deal correctly with two spheroid case.
C                (Although have not yet implemented changes necessary
C                to do TWOSPH with noncubic lattice.)
C------------------------------------------------------------------------
C 00.06.12 (BTD) [Separate release of version 5a10 at this time]
C------------------------------------------------------------------------
C 00.06.12 (BTD) New target option NSPHER supported by routine TARNSP
C                Replaced old LAPACK source code with latest version
C                of routines from www.netlib.org
C                New LAPACK routines required by PRINAXIS are now
C                collected in two files, lapackblas.f and lapacksubs.f
C                with new LAPACK routines, PRINAXIS now executes properly
C                when compiled with g77
C                To support TARNSP, it was necessary to modify argument
C                lists for REAPAR and TARGET to include character
C                variable CFLSHP to pass name of file containing
C                description of multisphere target
C                Minor "tidying" of a number of files to make
C                all data type conversion explicit.
C                All variables in CXFFT3 now declared explicitly.
C 01.04.21 (BTD) copied over changes made to REASHP in version 5a10
C                modified all target routines so that in all cases
C                the target.out file created when using CALLTARGET
C                will contain composition information, so that there
C                is now a standard format for shape.dat input files
C                Modified as-delivered REASHP to read ICOMP.
C 01.04.21 (BTD) copied over changes made to TARNSP to correct bug
C                in version 5a10
C 02.02.12 (BTD) added support for target option PRISM3, with
C                new routine TARPRSM and concomitant changes to
C                TARGET and REAPAR
C 02.11.15 (BTD) working with Matthew Collinge to add MPI capability to
C                code.
C                DDSCAT.f now calls
C                       MPI_INIT
C                       MPI_COMM_RANK
C                       MPI_COMM_SIZE
C                       MPI_FINALIZE
C                created new module mpi_subs.f with following routines:
C                    SUBROUTINE COLSUM, which calls MPI_REDUCE
C                    SUBROUTINE SHARE1, which calls MPI_BCAST
C                    SUBROUTINE SHARE2, which calls MPI_BCAST
C                for use on systems where MPI is not installed,
C                created new module mpi_fake.f with dummy routines
C                    SUBROUTINE MPI_INIT
C                    SUBROUTINE MPI_COMM_RANK
C                    SUBROUTINE MPI_COMM_SIZE
C                    SUBROUTINE MPI_BCAST
C                    SUBROUTINE MPI_REDUCE
C                    SUBROUTINE MPI_FINALIZE
C                so that calls to these subroutines can remain in
C                the code.
C 03.02.13 (BTD) added 1 more digit of precision to qtable and qtable2
C                outputs
C 03.04.13 (BTD) working with Matthew Collinge to add MPI capability to
C                added character variable CFFLOG to contain name of
C                running output file
C                added routine NAMID to generate a unique name for output
C                file printed by each MPI-spawned process.
C                output to logfile is no longer unbuffered (if required
C                for debugging purposes, this can be reactivated -- see
C                comments in DDSCAT.f
C                added variables ITNUM(2) and MXITER to argument lists
C                for GETFLM and WRITESCA
C 03.07.13 (BTD) added new variable ITNUMMX(2) to DDSCAT so that
C                waarbbori.avg file will contain *maximum* number of
C                iterations required by any of the orientations being
C                averaged over
C 03.08.01 (BTD) version 6.0 released
C 03.10.24 (BTD) Modifications for version 6.1:
C                Changed method used for choosing scattering 
C                directions for calculation of radiation force and 
c                torque.
c                * Eliminate use of ICTHM and IPHIM -- these are
c                  removed from many argument lists, and are no longer 
c                  read from file ddscat.par
c                * Add variable ETASCA to control angular resolution
c                  used for angular averaging.  ETASCA is now input
c                  from file ddscat.par, and passed to subroutines
c                  GETFML, SCAT, and WRITESCA
c                * Add variable NAVG to record number of scattering 
c                  directions used.  Pass NAVG from SCAT to GETFML to
c                  DDSCAT to WRITESCA to WRITENET and WRITEBIN
c                * Add code to calculate <cos^2> in SCAT, and pass
c                  variable CSCAG2(2) from SCAT to DDSCAT to WRITESCA
c                * Modify output format of qtable, wxxrxxkxxx.sca,
c                  and wxxrxxori.avg to report NAVG
c 03.10.30 (BTD) corrected typo in WRITENET
c 04.02 22 (BTD):Modifications to writenet:
c                 * add QEXSUM,QABSUM,QSCSUM,QBKSUM,QPHSUM,QSCGSUM,
c                       QTRQABSUM,QTRQSCSUM
c                   to argument list
c                 * add various quantities (e.g. Qext) averaged over
c                   polarization to netcdf output when IORI>0
c                 * add various quantities (e.g. Qext) averaged over
c                   orientation (and polarization)
c                   to netcdf output when IORI=0
c                 * reorganize netCDF output following experimental
c                   version ver6.01
c 04.02.22 (BTD) added IWRKSC to argument list of WRITESCA and use to
c                control writing to ascii output files
C 04.02.25 (BTD) corrected typo in TARPRSM
c 04.03.04 (BTD) modified ESELF (eself.f) so that when called with target
c                option NSPPBC, will create A matrix using truncated
c                summation over a periodic lattice of targets.
c                Added new parameter NPMX to control how many periods to
c                include in summation
c                added NPMX to COMMON/M6/ in
c                * ALPHA in alpha.f (dummy)
c                * DIAGL, MATVEC, and CMATVEC in cprod.f
c                * DDSCAT in DDSCAT.f
c                added DUM13,DUM14 to COMMON/M6/ in alpha.f
c 04.03.31 (BTD) modified LAPACK routine SLAMC1 so that it behaves
c                as intended even after optimization by pgf77.  Note
c                that fix presumes that arithmetic is base 2.
c 04.04.01 (BTD) * added calls to TARGSPHER in subroutine TARGET
c                * added DX to argument list of TARGSPHER
c                * added arguments NPY,NPZ to support periodic b.c.
c                  option (at present time, used only for target option
c                  NSPPBC)
c                * added code to REAPAR to support option NSPPBC
c 04.04.04 (BTD) * added NPY,NPZ to argument list of TARGET
c                   and in call to TARGET from DDSCAT
c                * added variables to argument list of fake version of
c                  WRITENET in dummywritenet.f
c                * reorganize file mpi_subs.f so that mpi_subs includes
c                   SUBROUTINE COLSUM
c                   SUBROUTINE SHARE1
c                   SUBROUTINE SHARE2
c                  and mpi_fake.f includes dummy versions of
c                   SUBROUTINE COLSUM
c                   SUBROUTINE SHARE1
c                   SUBROUTINE SHARE2
c                   SUBROUTINE MPI_INIT
c                   SUBROUTINE MPI_COMM_RANK
c                   SUBROUTINE MPI_COMM_SIZE
c                   SUBROUTINE MPI_FINALIZE
c                  Subroutine mpi_subs is no longer used in "plain"
c                  version -- all the ersatz MPI calls used by DDSCAT
c                  are supplied in mpi_fake.f
c 04.04.29 (BTD) Added target option ANIREC (homogeneous anisotropic
c                rectangular target
c                To accomplish this, modified subroutines
c                  REAPAR
c                  TARGET
c                and added new routine
c                  TARANIREC
c 04.05.21 (BTD) Fixed bug in DDSCAT.f: one of the calls to WRITESCA
c                had QSCGSUM and QSCG2SUM in incorrect order.
c 04.05.22 (BTD) Fixed bug in computation of true error in getfml.f
c 04.05.23 (BTD) Added CWHERE string in reapar.f to provide helpful 
c                information to user in event of malformed ddscat.par
c                file
c 04.12.29 (BTD) Corrected error in WRITESCA: when IWRKSC=1, had not 
c                been writing out correct values of Mueller matrix to 
c                wxxrxxkxxx.sca files. (Output error only: wrong 
c                variable in WRITE statement. No computational error 
c                involved.)
c 05.03.19 (BTD) REAPAR modified:
c                Added 2 lines to set CLFEPS(1) in case using options
c                H2OLIQ or H2OICE (previously were left undefined,
c                which cause problems with output statement)
c 05.03.29 (BTD) ROTATE modified:
c                Added code to guard against roundoff errors leading to
c                argument of ACOS with abs(arg)>1
c 05.10.11 (BTD) Modified NAMER, DDSCAT, WRITESCA to change filenames
c                to allow up to 1000 wavelengths instead of 100
c                filenames are now longer by one character, and of form
c                w000r00k000.sca and w000r00ori.avg
c 05.10.18 (BTD) Modified DDSCAT.f to allow use of more than 1000
c                orientations if IWRKSC=0 (previously would exceed array
c                limits in subroutine NAMER with IORI>1000).
c                Modified REAPAR to ensure that user does not request
c                more than 1000 orientations with IWRKSC=1
c 06.09.13 (BTD) Corrected error in TARCYL
c 06.09.13 (BTD) Added new target option CYLCAP:
c                new routine TARCYLCAP
c                modifications to REAPAR and TARGET
c 06.10.05 (BTD) fixed minor bugs in WRITENET
c 06.11.28 (BTD) Modified WRITESCA to correct error in calculation of
c                PPOL = degree of linear polarization of scattered
c                light
c 08.06.23 (BTD) corrected bug in routine TARCYLCAP
c end history
c
c Copyright (C) 1993,1994,1995,1996,1997,1998,1999,2000,2001,2002,2003,
c               2004,2005,2006,2008 B.T. Draine and P.J. Flatau
c This code is covered by the GNU General Public License.
c***********************************************************************
      RETURN
      END

C mpi_fake.f contains dummy subroutines that take the place 
C of 
C    SUBROUTINE COLSUM
C    SUBROUTINE SHARE1
C    SUBROUTINE SHARE2
C    SUBROUTINE MPI_INIT
C    SUBROUTINE MPI_COMM_RANK
C    SUBROUTINE MPI_COMM_SIZE
C    SUBROUTINE MPI_FINALIZE
C which are called when MPI is being used.
C These dummy routines do nothing when MPI is not being used.
C
      SUBROUTINE COLSUM(IORTH,MYID,MXSCA,NSCAT,
     &           QSCSUM,QABSUM,QEXSUM,QBKSUM,QPHSUM,
     &           QSCG2SUM,QSCGSUM,QTRQABSUM,QTRQSCSUM,
     &           S1111,S2121,CX1121,SMORI)
      IMPLICIT NONE
c arguments:
      INTEGER IORTH,MXSCA,NSCAT,MYID
      REAL
     &   QABSUM(IORTH),
     &   QBKSUM(IORTH),
     &   QEXSUM(IORTH),
     &   QPHSUM(IORTH),
     &   QSCG2SUM(IORTH),
     &   QSCGSUM(3,IORTH),
     &   QSCSUM(IORTH),
     &   QTRQABSUM(3,IORTH),
     &   QTRQSCSUM(3,IORTH),
     &   S1111(MXSCA),
     &   S2121(MXSCA),
     &   SMORI(MXSCA,4,4)
      COMPLEX CX1121(MXSCA)
c-----------------------------------------------------------------------
      RETURN
      END

      SUBROUTINE SHARE1(
     &     A1,A2,AEFFA,BETA,
     &     BETMID,BETMXD,
     &     CALPHA,CBINFLAG,CDESCR,CDIEL,
     &     CFLEPS,CMDFFT,CMDSOL,CMDTRQ,
     &     CNETFLAG,CSHAPE,CXE01,CXE02,
     &     DX,ENSC,EM1,EM2,ETASCA,
     &     ICOMP,IDVERR,IDVOUT,ILIN10,
     &     ILIN12,INIT,IOBIN,IOCC,IORI0,IORTH,
     &     IRAD0,IWAV0,IWRKSC,IXYZ0,
     &     MXBETA,MXCOMP,MXN3,MXNAT,
     &     MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &     NAT,NAT0,NAT3,NBETA,NBETH,NCOMP,NORI,NPHI,
     &     NRAD,NSCAT,NSMELTS,NTHETA,NWAV,NX,NY,NZ,
     &     PHI,PHIMID,PHIMXD,PHIN,
     &     SHPAR,SMIND1,SMIND2,THETA,THETAN,
     &     THTMID,THTMXD,TOL,
     &     WAVEA,WGTA,WGTB)
      IMPLICIT NONE
c arguments
      INTEGER MXNAT,MXN3,MXBETA,MXCOMP,
     &     MXPHI,MXRAD,MXSCA,MXTHET,MXWAV
      CHARACTER CBINFLAG*(*),CNETFLAG*(*),CALPHA*6,CDIEL*6,
     &     CMDSOL*6,CMDTRQ*6,CMDFFT*6,
     &     CSHAPE*6,CDESCR*67
      CHARACTER*60 CFLEPS(MXCOMP)
      INTEGER IDVERR,IDVOUT,ILIN10,ILIN12,INIT,IOBIN,IORTH,IORI0,
     &     IRAD0,IWAV0,IWRKSC,
     &     NAT,NAT0,NAT3,NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT,
     &     NSMELTS,NTHETA,NWAV,NX,NY,NZ
      INTEGER*2 
     &   ICOMP(MXN3),
     &   IXYZ0(MXNAT,3),
     &   IOCC(MXNAT)
      INTEGER
     &   SMIND1(9),
     &   SMIND2(9)
      REAL BETMID,BETMXD,ETASCA,PHIMID,PHIMXD,THTMID,THTMXD,TOL
      REAL 
     &   A1(3),
     &   A2(3),
     &   AEFFA(MXRAD),
     &   BETA(MXBETA),
     &   DX(3),
     &   EM1(3,MXSCA),
     &   EM2(3,MXSCA),
     &   ENSC(3,MXSCA),
     &   PHI(MXPHI),
     &   PHIN(MXSCA),
     &   SHPAR(6),
     &   THETA(MXTHET),
     &   THETAN(MXSCA),
     &   WAVEA(MXWAV),
     &   WGTA(MXTHET,MXPHI),
     &   WGTB(MXBETA)
      COMPLEX CXE01(3),CXE02(3)
c-----------------------------------------------------------------------
      RETURN
      END

c=======================================================================

      SUBROUTINE SHARE2(MXCOMP,MXWAVT,CXEPS,E1A,E2A,WVA)
      IMPLICIT NONE
c arguments:
      INTEGER MXCOMP,MXWAVT,IERR
      REAL 
     &   E1A(MXWAVT),
     &   E2A(MXWAVT),
     &   WVA(MXWAVT)
      COMPLEX
     &   CXEPS(MXCOMP)
c-----------------------------------------------------------------------
      RETURN
      END

c=======================================================================

      SUBROUTINE MPI_INIT(IERR)
      IMPLICIT NONE
      INTEGER IERR
c-----------------------------------------------------------------------
      IERR=0
      RETURN
      END

c=======================================================================

      SUBROUTINE MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)
      IMPLICIT NONE
      INTEGER IERR,MPI_COMM_WORLD,MYID
c-----------------------------------------------------------------------
      MYID=0
      RETURN
      END

c=======================================================================

      SUBROUTINE MPI_COMM_SIZE(MPI_COMM_WORLD,NUMPROCS,IERR)
      IMPLICIT NONE
      INTEGER IERR,MPI_COMM_WORLD,NUMPROCS
c-----------------------------------------------------------------------
      NUMPROCS=1
      RETURN
      END

c=======================================================================

      SUBROUTINE MPI_FINALIZE(IERR)
      IMPLICIT NONE
c arguments:
      INTEGER IERR
c-----------------------------------------------------------------------
      IERR=0
      RETURN
      END

      SUBROUTINE CXFFT3N(C,MX,MY,MZ,ISIGN)

C Parameters:

      INTEGER MXTRIG
      PARAMETER(MXTRIG=1000)

C Arguments:

      INTEGER ISIGN,MX,MY,MZ
      REAL C(*)

C Local scalars:

      INTEGER INC,IND,JUMP,K,LOT,MXOLD,MYOLD,MZOLD

C Local arrays:

      REAL TRIG1(MXTRIG),TRIG2(MXTRIG),TRIG3(MXTRIG)
      SAVE TRIG1,TRIG2,TRIG3,MXOLD,MYOLD,MZOLD
C***********************************************************************
C Subroutine CXFFT3N

c Interface routine for "Generalized Prime Factor Algorithm" FFT code
c of Temperton for computation of 3 dimensional FFTs

c Calling program should have call of form

c    CALL CXFFT3N(CX,MX,MY,MZ,ISIGN)

c where
c    CX(I,J,K,L)= complex array of 3-vectors at locations (I,J,K), with
c                  I = 1,...,MX
c                  J = 1,...,MY
c                  K = 1,...,MZ
c                  L = 1-3
c
c Upon return,
c    CX(I,J,K,L)= complex array of discrete fourier transform of original
c                 array CX, defined to be

c    CXout(I,J,K,L)=

c    Mx-1 My-1 Mz-1
c    sum  sum  sum CXin(u,v,w,L)*exp[ISIGN*2*pi*i*(u*I/Mx+v*J/My+w*K/Mz)]
c    u=0  v=0  w=0

c Note that here C is defined as a real array C(*) 
c C(1) = Re[CX(1,1,1,1)]
c C(2) = Im[CX(1,1,1,1)]
c C(3) = Re[CX(2,1,1,1)]
c C(4) = Re[CX(2,1,1,1)]
 
c or, in general:

c C(1+2*((I-1)+(J-1)*MY+(K-1)*MY*MZ+(L-1)*(MX+MY+MZ)) = Re[CX(I,J,K,L]
c C(2+2*((I-1)+(J-1)*MY+(K-1)*MY*MZ+(L-1)*(MX+MY+MZ)) = Im[CX(I,J,K,L]

c
C Interface written by P.J.Flatau
C
C History:
C
C***********************************************************************
      data mxold, myold, mzold/0,0,0/
      if(mx.ne.mxold .or. my.ne.myold .or. mz.ne.mzold) then
        mxold=mx
        myold=my
        mzold=mz
        CALL SETGPFA(trig1,mX)
        CALL SETGPFA(trig2,mY)
        CALL SETGPFA(trig3,mZ)
      endif
C --- first dimension
      INC=2
      JUMP=2*MX
      LOT=MY*MZ
      CALL GPFA(C(1),c(2),TRIG1,INC,JUMP,MX,LOT,ISIGN)
C --- second dimension
      INC=MX*2
      JUMP=2
      LOT=MX
C --- one plane at a time
      DO K=1,MZ
         IND=1+2*MX*MY*(K-1)
         CALL GPFA(C(IND),C(IND+1),TRIG2,INC,JUMP,
     &               MY,LOT,ISIGN)
      ENDDO
C --- third dimension
      INC=MX*MY*2
      JUMP=2
      LOT=MX*MY
      CALL GPFA(C(1),C(2),TRIG3,INC,JUMP,MZ,LOT,
     &          ISIGN)
      RETURN
      END

      SUBROUTINE TARPRSM(A1,A2,A,BA,CA,LA,DX,CDESCR,IOSHP,MXNAT,
     &                   NAT,IXYZ,ICOMP)
      IMPLICIT NONE

C Arguments:

      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL A,BA,CA,LA

C Array arguments:

      REAL A1(3),A2(3),DX(3)

C Local scalars:

      CHARACTER CMSGNM*70
      INTEGER JA,JX,JY,JZ,NFAC,NLAY,NX,NY,NZ

      REAL
     &   B,BETA,C,COTBETA,COTGAMMA,GAMMA,L,
     &   XMAX,XMIN,Y,YMAX,YMIN,Z,ZMAX,ZMIN

C***********************************************************************
C Routine to construct triangular prism from "atoms".
C triangle side lengths = a,b,c ; prism length = L
C prism axis is assumed to be in x direction
C normal to prism face of width a : (0,1,0)
C normal to prism face of width b : (0,-cos(gamma),sin(gamma))
C normal to prism face of width c : (0,-cos(beta),-sin(beta))
C angles alpha,beta,gamma are opposite sides a,b,c

C first layer of target array is at x=0 (target boundary at x=-0.5)
C layer along side a is at int(b*sin(gamma))
C      boundary is at ymax=int(b*sin(gamma))+0.5
C Input:
C        A      = a/d
C        BA     = b/a
C        CA     = c/a
C        LA     = L/a
C        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
C                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
C                spacing
C        IOSHP  =device number for "target.out" file
C               =-1 to suppress printing of "target.out"
C        MXNAT  =dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=unit vector (1,0,0) defining target axis 1 (prism axis)
C        A2(1-3)=unit vector (0,1,0) defining target axis 2 (normal to
C                rectangular faces with sides a,L
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        ICOMP(1-NAT,1-3)=dielectric function identifier for dipole
C                         locations and 3 directions in space
C        CDESCR=string describing target (up to 67 chars.)
C
C B.T.Draine, Princeton Univ. Obs., 2002.02.12
C
C History:
C 02.02.12 (BTD): adapted from tarprsm.f for ver5a10
C 04.02.25 (BTD): corrected typographical error found by In-Ho Lee
C 06.02.15 (BTD): modified write statement to elminate obvious error
C                 found by K. Lance Kelly
C end history
C
C Copyright (C) 2002,2004,2006 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C-----------------------------------------------------------------------

C Current version of TARPRSM is restricted to cubic lattices

      IF(DX(1).NE.1..OR.DX(2).NE.1.)THEN
         CALL ERRMSG('FATAL','TARPRSM',
     &               ' tarprsm does not support noncubic lattice')
      ENDIF

      DO JA=1,3
         A1(JA)=0.
         A2(JA)=0.
      ENDDO
      A1(1)=1.
      A2(2)=1.

C A = a/d
C B = b/d
C C = c/d
C L = L/d

      B=BA*A
      C=CA*A
      L=LA*A

c sanity check:

      IF((A.GE.B+C).OR.(B.GE.A+C).OR.(C.GE.A+B))
     &    CALL ERRMSG('FATAL','TARPRSM',
     &'prism sides a,b,c do not satisfy triangle inequality:check input'
     &)

      BETA=ACOS((A*A+C*C-B*B)/(2.*A*C))
      GAMMA=ACOS((A*A+B*B-C*C)/(2.*A*B))
      COTBETA=COS(BETA)/SIN(BETA)
      COTGAMMA=COS(GAMMA)/SIN(GAMMA)

c ideal prism extent:
c    x = xmin to x=xmax
c    triangle vertices at (0,ymax,zmin),(0,ymax,zmax),(0,ymin,za)
c    where xmin=-0.5
c          xmax=xmin+L
c          ymax=int[b*sin(gamma)]+0.5
c          ymin=ymax-b*sin(gamma)
c          zmax=a/2
c          zmin=-a/2
c          za=-a/2+c*cos(beta)

      XMIN=-0.5
      XMAX=XMIN+L
      YMAX=INT(B*SIN(GAMMA))+0.5
      YMIN=YMAX-B*SIN(GAMMA)
      ZMAX=0.5*A
      ZMIN=-ZMAX

C Now determine limits for testing x,y,z values
C Along axis (x), run from 0 to NX=INT(XMAX)
C Along y direction, run from 0 to NY=INT(YMAX)
C Along z direction, run from -NZ to NZ=INT(ZMAX)

      NX=INT(XMAX)
      NY=INT(YMAX)
      NZ=INT(ZMAX)

      NAT=0
      DO JZ=-NZ,NZ
         Z=REAL(JZ)
         DO JY=0,NY
            Y=REAL(JY)
            IF((Z.LE.ZMAX+(Y-YMAX)*COTGAMMA)
     &         .AND.
     &         (Z.GE.ZMIN-(Y-YMAX)*COTBETA))THEN
               DO JX=0,NX
                  NAT=NAT+1
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDDO
            ENDIF
         ENDDO
      ENDDO

      NLAY=NX+1
      NFAC=NAT/NLAY

      DO JX=1,3
         DO JA=1,NAT
            ICOMP(JA,JX)=1
         ENDDO
      ENDDO

C Note: string CDESCR will be printed by subr. TARGET

      WRITE(CDESCR,FMT='(A,I7,A)')' Triangular prism of NAT=',NAT,
     &                             ' dipoles'

C Here print any additional target info which is desired by using
C subroutine WRIMSG

      WRITE(CMSGNM,FMT='(A,3F7.4,A)')
     &    ' A1 = (',A1,') = prism axis direction'
      CALL WRIMSG('TARPRSM',CMSGNM)
      WRITE(CMSGNM,FMT='(A,3F7.4,A)')
     &    ' A2 = (',A2,') = normal to face of width a'
      CALL WRIMSG('TARPRSM',CMSGNM)
      WRITE(CMSGNM,FMT='(A,I7,A,I4,A,I4)')
     &    ' NAT=',NAT,' NFAC=',NFAC,' NLAY=',NLAY
      CALL WRIMSG('TARPRSM',CMSGNM)
      WRITE(CDESCR,FMT='(A,F7.4,A,F8.4,A,F7.4,A,F8.4)')
     &    ' tri.prism: a/d=',A,
     &    ' b/a=',BA,' c/a=',CA,' L/a=',LA

C Now store atom coordinates in file

      IF(IOSHP.GT.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')

C*** 3 lines of general description allowed:

         WRITE(IOSHP,9020)A,BA,CA,LA,NAT,A1,A2

C***

         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3),
     &                           ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 9020 FORMAT(
     &   ' Triangular Prism:  a/d=',F7.4,' b/a=',F7.4,' c/a=',F7.4,
     &   ' L/a=',F7.4,/,
     &   I7,'= NAT. Prism axis along x, rect. face a normal to y',/,
     &   3F9.4,' = A_1 vector',/,
     &   3F9.4,' = A_2 vector',/,
     &   '1.00 1.00 1.00 = lattice spacings (d_x,d_y,d_z)/d',/,
     &   '     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      PROGRAM CALLTARGET
      IMPLICIT NONE
C
C Program CALLTARGET is used to generate target arrays using target
C generation routines employed by DDSCAT.
C
C B.T.Draine, Princeton Univ. Obs., 91/1/1
C History:
C 91.05.24 (BTD): Modified to allow entry target names in lower case
C 91.07.16 (BTD): Replaced DO...ENDDO with DO #...# CONTINUE
C 92.12.16 (BTD): Added IDVSHP to argument list of TARGET
C 93.01.07 (BTD): Added options TWOELL and TWOAEL
C 94.05.15 (BTD): Added option CONELL
C 95.12.11 (BTD): Added option BLOCKS
C 96.01.04 (BTD): Added option DW1996
C 96.01.25 (BTD): Added option TWOSPH
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ here and in TARGET
C                 Added calls to SIZER
C 96.01.29 (BTD): Support selection of principal axis calculation
C                 in TAR2SP via SHPAR(6)
C 97.04.25 (BTD): Added option BLK_AN
C 97.04.30 (BTD): Removed code offering choice on target axis for
C                 HEXGON option (target axis now hardwired within
C                 TARHEX)
C 00.06.12 (BTD): Added option NSPHER
C 02.02.13 (BTD): Added option PRISM3
C 02.11.12 (BTD): Added option SPHARM
C 03.11.06 (BTD): Modified to input parameters to generate random
C                 SPHARM target
c                 Added DX(3) to argument list of TARGET
c 03.11.08 (BTD): Added option GSPHER
c 04.03.31 (BTD): Replaced all WRITE(0, with WRITE(IDVOUT,
C 04.04.01 (BTD): Added NPY,NPZ to argument list of TARGET,
c                 so we can use new version of TARGET that supports
C                 periodic boundary conditions
C end history
C
C Copyright (C) 1993,1994,1995,1996,1997,2000,2002,2003,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C Adjustable parameters:
C    MXNAT=max.number of dipoles in target
C
      INTEGER MXNAT
      PARAMETER(MXNAT=500000)
C
C Derived parameters:
C
      INTEGER MXN3
      PARAMETER(MXN3=3*MXNAT)
C
C Variables:
C
      CHARACTER CDESCR*67,CFLSHP*80,CSHAPE*6
      INTEGER IDVSHP,IDVOUT,IOSHP,J,JJ,NAT,NAT3,NPY,NPZ
      INTEGER LXYZ(3)
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      REAL ERR,F,PI,RGYR2,RXY,RXZ,RYX,RYZ,RZX,RZY,
     &     X,XCM,Y,YCM,Z,ZCM
      REAL A1(3),A2(3),DX(3),SHPAR(6)
      DOUBLE PRECISION DDX,DDY,DDZ,X2,Y2,Z2
C
C***********************************************************************
      DATA IDVOUT/0/,IOSHP/15/
      PI=4.*ATAN(1.)
C Define variables CFLSHP and IDVSHP to please flint:
      CFLSHP='none'
      IDVSHP=10
 1000 WRITE(IDVOUT,*)'What shape? (Enter choice in quotes) Choices:'
      WRITE(IDVOUT,*)'  BLK_AN = construct from anisotropic cubic ',
     &               'blocks, input from "blocks.par"'
      WRITE(IDVOUT,*)'  BLOCKS = construct from cubic blocks, input ',
     &               'from file "blocks.par"'
      WRITE(IDVOUT,*)'  CONELL = two concentric ellipsoids'
      WRITE(IDVOUT,*)'  CYLNDR = cylinder'
      WRITE(IDVOUT,*)'  DW1996 = 13 cube target used by Draine & ',
     &               'Weingartner (1996)'
      WRITE(IDVOUT,*)'  ELLIPS = ellipsoid'
      WRITE(IDVOUT,*)'  HEXGON = hexagonal prism'
      WRITE(IDVOUT,*)'  RCTNGL = rectangular solid'
      WRITE(IDVOUT,*)'  SPHERE = sphere'
      WRITE(IDVOUT,*)'  TETRAH = regular tetrahedron'
      WRITE(IDVOUT,*)'  THRAEL = three collinear touching anisotropic ',
     &               'ellipsoids'
      WRITE(IDVOUT,*)'  THRELL = three collinear touching ellipsoids'
      WRITE(IDVOUT,*)'  TWOAEL = two touching anisotropic ellipsoids'
      WRITE(IDVOUT,*)'  TWOELL = two touching isotropic ellipsoids'
      WRITE(IDVOUT,*)'  TWOSPH = two touching spheroids (with angle ',
     &               'phi between symm. axes'
      WRITE(IDVOUT,*)'  NSPHER = multisphere (union of spheres)'
      WRITE(IDVOUT,*)'  PRISM3 = triangular prism'
      WRITE(IDVOUT,*)'  SPHARM = spherical-harmonic-generated surface'
      WRITE(IDVOUT,*)'  GSPHER = gaussian sphere'

c at this time, restrict to cubic lattice:

      DX(1)=1.
      DX(2)=1.
      DX(3)=1.

      READ(*,*)CSHAPE
      IF(CSHAPE.EQ.'TETRAH'.OR.CSHAPE.EQ.'tetrah')THEN
         CSHAPE='TETRAH'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter tetrahedron side length ',
     &                     ' (0 to stop)'
            READ(*,*)SHPAR(1)
            SHPAR(2)=SHPAR(1)
            SHPAR(3)=SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(*,6000)SHPAR(1),NAT
         ENDDO
         STOP
      ELSEIF(CSHAPE.EQ.'SPHERE'.OR.CSHAPE.EQ.'sphere')THEN
         CSHAPE='SPHERE'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter sphere diameter (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)stop
            SHPAR(2)=SHPAR(1)
            SHPAR(3)=SHPAR(1)
            CSHAPE='ELLIPS'
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            RGYR2=0.
            XCM=0.
            YCM=0.
            ZCM=0.
            DO JJ=1,NAT
               X=IXYZ(JJ,1)
               Y=IXYZ(JJ,2)
               Z=IXYZ(JJ,3)
               XCM=XCM+X
               YCM=YCM+Y
               ZCM=ZCM+Z
               RGYR2=RGYR2+X*X+Y*Y+Z*Z+0.25
            ENDDO
            XCM=XCM/REAL(NAT)
            YCM=YCM/REAL(NAT)
            ZCM=ZCM/REAL(NAT)
            RGYR2=RGYR2/REAL(NAT)-XCM**2-YCM**2-ZCM**2
            F=(5./3.)*(4.*PI/REAL(3.*NAT))**(2./3.)*RGYR2
            WRITE(*,6100)SHPAR(1),SHPAR(2),SHPAR(3),NAT,F
         ENDDO
         STOP
      ELSEIF(CSHAPE.EQ.'ELLIPS'.OR.CSHAPE.EQ.'ellips')THEN
         CSHAPE='ELLIPS'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter ellipsoid diameters xv,yv,zv',
     &                     ' (0,0,0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)stop
            CSHAPE='ELLIPS'
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            XCM=0.
            YCM=0.
            ZCM=0.
            DO JJ=1,NAT
               X=IXYZ(JJ,1)
               Y=IXYZ(JJ,2)
               Z=IXYZ(JJ,3)
               XCM=XCM+X
               YCM=YCM+Y
               ZCM=ZCM+Z
            ENDDO
            XCM=XCM/REAL(NAT)
            YCM=YCM/REAL(NAT)
            ZCM=ZCM/REAL(NAT)
            X2=0.
            Y2=0.
            Z2=0.
            DO JJ=1,NAT
               DDX=IXYZ(JJ,1)-XCM
               DDY=IXYZ(JJ,2)-YCM
               DDZ=IXYZ(JJ,3)-ZCM
               X2=X2+DDX*DDX
               Y2=Y2+DDY*DDY
               Z2=Z2+DDZ*DDZ
            ENDDO
            X2=X2/NAT+1./12.
            Y2=Y2/NAT+1./12.
            Z2=Z2/NAT+1./12.
            ERR=20.*PI*SQRT(5.*REAL(X2*Y2*Z2))/(3.*REAL(NAT))-1.
            RXY=REAL(SQRT(X2/Y2))
            RYZ=REAL(SQRT(Y2/Z2))
            RZX=REAL(SQRT(Z2/X2))
            RYX=1./RXY
            RZY=1./RYZ
            RXZ=1./RZX
            X2=2.*SQRT(5.*X2)
            Y2=2.*SQRT(5.*Y2)
            Z2=2.*SQRT(5.*Z2)
            WRITE(*,6200)SHPAR(1),SHPAR(2),SHPAR(3),NAT,X2,Y2,Z2,ERR,
     &                   RYX,RZX,RYZ,RXY,RXZ,RZY
         ENDDO
         STOP
      ELSEIF(CSHAPE.EQ.'CYLNDR'.OR.CSHAPE.EQ.'cylndr')THEN
         CSHAPE='CYLNDR'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter cylinder length (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter cylinder diameter'
            READ(*,*)SHPAR(2)
            WRITE(IDVOUT,*)'Enter 1,2,3 for axis along x,y,z'
            READ(*,*)SHPAR(3)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
         ENDDO
         STOP
      ELSEIF(CSHAPE.EQ.'RCTNGL'.OR.CSHAPE.EQ.'rctngl')THEN
         CSHAPE='RCTNGL'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x-length (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter y-length'
            READ(*,*)SHPAR(2)
            WRITE(IDVOUT,*)'Enter z-length'
            READ(*,*)SHPAR(3)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
         ENDDO
      ELSEIF(CSHAPE.EQ.'HEXGON'.OR.CSHAPE.EQ.'hexgon')THEN
         CSHAPE='HEXGON'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length (along symmetry axis)',
     &                     ' (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter length of 1 hexagon side'
            READ(*,*)SHPAR(2)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
         ENDDO
      ELSEIF(CSHAPE.EQ.'TWOELL'.OR.CSHAPE.EQ.'twoell')THEN
         CSHAPE='TWOELL'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
         ENDDO
      ELSEIF(CSHAPE.EQ.'TWOAEL'.OR.CSHAPE.EQ.'twoael')THEN
         CSHAPE='TWOAEL'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
         ENDDO
      ELSEIF(CSHAPE.EQ.'THRELL'.OR.CSHAPE.EQ.'threll')THEN
         CSHAPE='THRELL'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
         ENDDO
      ELSEIF(CSHAPE.EQ.'THRAEL'.OR.CSHAPE.EQ.'thrael')THEN
         CSHAPE='THRAEL'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
         ENDDO
      ELSEIF(CSHAPE.EQ.'CONELL'.OR.CSHAPE.EQ.'conell')THEN
         CSHAPE='CONELL'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of outer ellipsoid (icomp=2) ',
     &                     'in x,y,z directions (lattice units) (0 0 0',
     &                     ' to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            WRITE(IDVOUT,*)'Enter length of inner ellipsoid (icomp=1) ',
     &                     'in x,y,z directions (lattice units)'
            READ(*,*)SHPAR(4),SHPAR(5),SHPAR(6)
            IF(SHPAR(4).LE.SHPAR(1).AND.
     &         SHPAR(5).LE.SHPAR(2).AND.
     &         SHPAR(6).LE.SHPAR(3))THEN
               CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,
     &              MXNAT,SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &              MXN3,NAT3,NPY,NPZ)
               CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            ELSE
               WRITE(IDVOUT,*)'Input error: inner ellipsoid is not ',
     &                        'contained within outer ellipsoid'
            ENDIF
         ENDDO
      ELSEIF(CSHAPE.EQ.'BLOCKS'.OR.CSHAPE.EQ.'blocks')THEN
         CSHAPE='BLOCKS'
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'BLK_AN'.OR.CSHAPE.EQ.'blk_an')THEN
         CSHAPE='BLK_AN'
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'DW1996'.OR.CSHAPE.EQ.'dw1996')THEN
         CSHAPE='DW1996'
         WRITE(IDVOUT,*)'Enter block size (lattice units)'
         READ(*,*)SHPAR(1)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'TWOSPH'.OR.CSHAPE.EQ.'twosph')THEN
         CSHAPE='TWOSPH'
         WRITE(IDVOUT,*)'Enter length a_1 and diameter b_1 of 1st ',
     &                  'spheroid'
         READ(*,*)SHPAR(1),SHPAR(2)
         WRITE(IDVOUT,*)'Enter length a_2 and diameter b_2 of 2nd ',
     &                  'spheroid'
         READ(*,*)SHPAR(3),SHPAR(4)
         WRITE(IDVOUT,*)'Enter angle phi (deg) between axes a_1 and ',
     &                  'a_2'
         READ(*,*)SHPAR(5)
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ',
     &                  'in TF'
         WRITE(IDVOUT,*)'            =1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(6)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'NSPHER'.OR.CSHAPE.EQ.'nspher')THEN
         CSHAPE='NSPHER'
         WRITE(IDVOUT,*)'Enter DIAMX = target extent in x-direction'
         READ(*,*)SHPAR(1)
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ',
     &                  'in TF'
         WRITE(IDVOUT,*)'            =1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(2)
         WRITE(IDVOUT,*)'Enter name of sphere parameter file (e.g., ',
     &             'tarnsp.par [in quotes])'
         READ(*,*)CFLSHP
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'PRISM3'.OR.CSHAPE.EQ.'prism3')THEN
         CSHAPE='PRISM3'
         WRITE(IDVOUT,*)'Enter a/d = first triangle side/d'
         READ(*,*)SHPAR(1)
         WRITE(IDVOUT,*)'Enter b/a , c/a, L/a'
         READ(*,*)SHPAR(2),SHPAR(3),SHPAR(4)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'SPHARM'.OR.CSHAPE.EQ.'spharm')THEN
         CSHAPE='SPHARM'
         WRITE(IDVOUT,*)'Enter a_eff/d'
         READ(*,*)SHPAR(1)
         WRITE(IDVOUT,*)'Enter name of file with coefficients a_lm'
         WRITE(IDVOUT,*)'      or 0 to use random number generator'
         READ(*,*)CFLSHP
         IF(CFLSHP.EQ.'0')THEN
            WRITE(IDVOUT,*)'Enter power law index beta > 1'
            READ(*,*)SHPAR(3)
            WRITE(IDVOUT,*)'Enter Lmax > 1 (e.g., 5)'
            READ(*,*)SHPAR(4)
            WRITE(IDVOUT,*)'Enter <|a_{l0}|^2>/|a_{00}|^2'
            READ(*,*)SHPAR(5)
            WRITE(IDVOUT,*)'Enter integer seed > 0'
            READ(*,*)SHPAR(6)
         ENDIF
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ',
     &                  'in TF'
         WRITE(IDVOUT,*)'             1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(2)
c*** diagnostic
         WRITE(IDVOUT,*)'about to call target with ioshp=',ioshp
c***
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'GSPHER'.OR.CSHAPE.EQ.'gspher')THEN
         CSHAPE='GSPHER'
         WRITE(IDVOUT,*)'Enter a_eff/d'
         READ(*,*)SHPAR(1)
         WRITE(IDVOUT,*)'Enter power law index beta > 1 (0 to input',
     &             ' a_lm from file targspher.alm)'
         READ(*,*)SHPAR(3)
         IF(SHPAR(3).EQ.0)THEN
            WRITE(IDVOUT,*)'OK -- will read input params from ',
     &                     'targspher.alm'
            CFLSHP='targspher.alm'
         ELSEIF(SHPAR(3).GT.1.)THEN
            WRITE(IDVOUT,*)'Enter Lmax > 0 (e.g., 5)'
            READ(*,*)SHPAR(4)
            WRITE(IDVOUT,*)'Enter <s^2> (e.g., 0.05) [this includes ',
     &                'all a_lm up to NMAX (=100)'
            READ(*,*)SHPAR(5)
            WRITE(IDVOUT,*)'Enter integer seed > 0'
            READ(*,*)SHPAR(6)
         ELSE
            WRITE(IDVOUT,*)'Invalid value for BETA'
         ENDIF
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ',
     &                  'in TF'
         WRITE(IDVOUT,*)'             1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(2)
c*** diagnostic
         WRITE(IDVOUT,*)'about to call target with ioshp=',ioshp
c***
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &               SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &               MXN3,NAT3,NPY,NPZ)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSE
         WRITE(IDVOUT,*)'Do not know how to make shape = ',CSHAPE
         GOTO 1000
      ENDIF
 6000 FORMAT(' AX=',F7.4,' NAT=',I7)
 6100 FORMAT(' AX=',F7.4,' AY=',F7.4,' AZ=',F7.4,' NAT=',I7,' F=',F10.6)
 6200 FORMAT('    XV =',F7.4,'    YV =',F7.4,'    ZV =',F7.4,
     &       ' NAT=',I8,/,
     &       ' 2a_eff=',F7.4,' 2b_eff=',F7.4,' 2c_eff=',F7.4,
     &       ' err=',F8.7,/,
     &       '   y:x =',F7.4,'   z:x =',F7.4,'   y:z =',F7.4,/,
     &       '   x:y =',F7.4,'   x:z =',F7.4,'   z:y =',F7.4)
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
C***********************************************************************
C This version of timeit uses the system call "etime" available under
C SunOS and some other bsd-like Unix systems (e.g., Convex unix).
C
C***********************************************************************
c begin history
C 94.06.20 (PJF) add dtime to the formal parameters
C 95.06.19 (PJF) modified to suppress printing in CMSGTM='noprint'
C 04.04.05 (BTD) changed IF(CMSGTM(1:7).NE.. to IF(CMSGTM.NE..
c end history
C Copyright (C) 1993,1995,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      CHARACTER CMSGTM*(*)
      REAL DTIME
C
C External system calls:
      REAL ETIME
      EXTERNAL ETIME
C
C Local variables:
      REAL OLDTIM
      CHARACTER CSTA*3,CMSGNM*70
      REAL TARRAY(2)
C
C External subroutines:
      EXTERNAL WRIMSG
C
C Local variables to be saved:
      SAVE CSTA,OLDTIM
C
C Data statements:
      DATA CSTA/'ONE'/
C
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         OLDTIM=ETIME(TARRAY)
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         DTIME=ETIME(TARRAY)-OLDTIM
         IF(CMSGTM.NE.'NOPRINT'.AND.CMSGTM.NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            IF(DTIME.GT.1.E4)THEN
               WRITE(CMSGNM,FMT='(F9.0, A)')DTIME,' CPU time (in secs)'
            ELSE
               WRITE(CMSGNM,FMT='(F9.3, A)')DTIME,' CPU time (in secs)'
            ENDIF
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE CXFFTW(CX,MX,MY,MZ,ISIGN)
      IMPLICIT NONE
C
C Arguments:
C
      INTEGER ISIGN,MX,MY,MZ
      COMPLEX CX(MX,MY,MZ)

c Local variables:

      CHARACTER CMSGNM*70

C***********************************************************************
C
C Purpose: This is a dummy routine to substitute for CXFFTW to allow
C          DDSCAT to be used on systems where the FFTW package has not
C          been installed.  If called, it will generate a fatal error
C          with an error message reporting DDSCAT has been compiled
C          with this dummy routine and option FFTW is unavailable.
C          
C History:
C 00.07.05 (BTD): created
C 03.07.13 (BTD): changed option FFTWFJ to option FFTW21
C 04.03.31 (BTD): replaced WRITE(0,  with CALL WRIMSG(...
C end history
C Copyright (C) 2000, 2003
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C
C***********************************************************************
C
      WRITE(CMSGNM,FMT='(A,A)')
     &   'FATAL ERROR: DDSCAT has been compiled with dummy version of',
     &   ' CXFFTW'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE(CMSGNM,FMT='(A)')
     &   ' *** option FFTW21 cannot be used with dummy routine'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE(CMSGNM,FMT='(A)')
     &   ' *** to enable option FFTW21 it is necessary to:'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE(CMSGNM,FMT='(A)')
     &   ' --- have fftw 2.1.x library installed on system'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE(CMSGNM,FMT='(A,A)')
     &   ' --- in Makefile, variable LIBFFTW should include ',
     &   'correct path to libsfftw.a'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE(CMSGNM,FMT='(A,A)')
     &   ' --- in Makefile, define cxfftw = cxfftw',
     &   ' (rather than dummycxfftw.f)'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE(CMSGNM,FMT='(A)')' --- then make ddscat'
      CALL WRIMSG('CXFFTW',CMSGNM)
      STOP
      END

      SUBROUTINE TAR2SP(A1,A2,A_1,B_1,A_2,B_2,PHI,PRINAX,DX,
     &                   CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      IMPLICIT NONE

C Arguments:

      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL A_1,A_2,B_1,B_2,PHI,PRINAX
      REAL A1(3),A2(3),DX(3)

C Local variables:

      CHARACTER CMSGNM*70
      INTEGER JA,JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,
     &   NAT1,NAT2
      REAL AX2,AY2,AZ2,COSPHI,SINPHI,U,V,
     &   R,RX2,RYZ2,RZ2,X,XC1,XC2,Y,YC1,YC2,Z,ZC1,ZC2
      REAL EIGVAL(3)

C***********************************************************************
C Routine to construct two touching spheroids from "atoms"
C    First spheroid has symmetry axis in y direction.
C    Second spheroid is displaced in x direction, with symmetry
C    axis in yz plane, in direction ey*cos(phi)+ez*sin(phi).
C    Separation between centroids=(B_1+B_2)/2
C   
C Input:
C        A_1=length/d of 1st spheroid along symm.axis  (d=lattice spacing)
C        A_2=length/d of 2nd spheroid along symm.axis
C        B_1=diameter/d of 1st spheroid
C        B_2=diameter/d of 2nd spheroid
C        PHI=angle (deg) specifying relative orientation of spheroids
C        PRINAX=0. to set A1=(1,0,0),A2=(0,1,0) in Target Framee
C              =1. to set A1,A2=principal axes of largest and second 
C                               largest moment of inertia 
C        DX(1-3)=(dx/d,dy/d,dz/d) where dx,dy,dz=lattice spacing in x,y,z
C            directions, and d=(dx*dy*dz)**(1/3)=effective lattice spacing
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
C        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        ICOMP(1-NAT,1-3)=1 for sites within first spheroid
C                        =2 for sites within second spheroid
C        CDESCR=description of target (up to 67 characters)
C
C B.T.Draine, Princeton Univ. Obs.
C History:
C 96.01.25 (BTD): First written.
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 96.01.29 (BTD): Modified to add PRINAX to argument list, and
C                 call to PRINAXIS to determine principal axes if
C                 PRINAX=1.
C 97.12.26 (BTD): Added DX(3) to argument list to support nonuniform
C                 lattice spacing.
C                 *** Note: additional code modifications required
C                     to support noncubic lattice!
C 98.03.06 (BTD): If called with noncubic lattice (not yet supported)
C                 call ERRMSG and halt with fatal error.
C 98.03.07 (BTD): Modified to write DX to file "target.out" for
C                 compatibility with REASHP.
C 99.06.30 (BTD): Revised procedure for constructing target.
C                 With new prescription,
C                 should obtain a symmetric structure when called
C                 with A_1,B_1 = A_2,B_2 and PHI=0 or 90
C                 Note that we have not yet made modifications 
C                 necessary to support noncubic lattice.
C 00.11.02 (BTD): Modified to write ICOMP to target.out
C 03.11.06 (BTD): Modified to use new PRINAXIS with eigenvalues in
C                 argument list.
C 04.03.19 (BTD): Revert to previous version of PRINAXIS
C 04.05.23 (BTD): Modify argument list of PRINAXIS to conform to
C                 change in PRINAXIS (eigenvalues added to arg list)
C end history
C
C Copyright (C) 1996,1997,1998,1999,2000,2003,2004
C                B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************

C Current version of TAR2SP is restricted to cubic lattices

      IF(DX(1).NE.1..OR.DX(2).NE.1.)THEN
         CALL ERRMSG('FATAL','TAR2SP',
     &               ' tar2sp does not yet support noncubic lattice')
      ENDIF

C Routine to construct target array representing two spheroids in
C contact.
C line connecting spheroid centers is parallel to x
C symmetry axis of first spheroid is parallel to y
C symmetry axis of second spheroid is in y-z plane, at angle PHI to y
C
C First spheroid:
C Array sites contained within spheroidal surface defined by
C    ((X-XC1)/B_1)**2+((Y-YC1)/A_1)**2+((Z-ZC1)/B_1)**2=0.25
C Ideal volume V=(pi/6)*A_1*B_1*B_1
C
C Second spheroid:
C    ((X-XC2)/B_2)**2+((U-UC1)/A_1)**2+((V-VC1)/B_1)**2=0.25
C where
C    U  =  Y*cos(PHI)  +  Z*sin(PHI)
C    V  = -Y*sin(PHI)  +  Z*cos(PHI)
C   UC1 = YC1*cos(PHI) + ZC1*sin(PHI)
C   VC1 =-YC1*sin(PHI) + ZC1*cos(PHI)
C    
C Dipoles are located at sites
C (x,y,z)=(I,J,K)*d, I,J,K=integers
C
C Criterion for choosing XC1:
C Point where spheroids contact each other should be midway between
C lattice points.  Thus take XC1+0.5*B_1 = 0.5
C or XC1 = 0.5(1.-B_1)
C
C Criterion for choosing YC1 and ZC1:
C If XC1 is close to an integer, take YC1=ZC1=0
C If XC1 is close to a half-integer, take YC1=ZC1=0.5
C
C Note that other criteria are obviously possible.  For example,
C could have chosen YC1 and ZC1 to maximize number of lattice
C sites falling within spheroidal surfaces.
C
      XC1=0.5*(1.-B_1)
      IF(XC1-INT(XC1).LT.0.25.OR.XC1-INT(XC1).GT.0.75)THEN
         YC1=0.
         ZC1=0.
      ELSE
         YC1=0.5
         ZC1=0.5
      ENDIF
C
      NAT=0
C             
C Determine list of occupied sites in first spheroid
C
      LMX1=INT(XC1-.5*B_1)
      LMX2=INT(XC1+.5*B_1)
      LMY1=INT(YC1-.5*A_1)
      LMY2=INT(YC1+.5*A_1)
      LMZ1=INT(ZC1-.5*B_1)
      LMZ2=INT(ZC1+.5*B_1)
      AX2=B_1*B_1
      AY2=A_1*A_1
      AZ2=B_1*B_1
      DO 0300 JZ=LMZ1,LMZ2
         Z=REAL(JZ)-ZC1
         RZ2=Z*Z/AZ2
         IF(RZ2.LT.0.25)THEN
            DO 0200 JY=LMY1,LMY2
               Y=REAL(JY)-YC1
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2.LT.0.25)THEN
                  DO 0100 JX=LMX1,LMX2
                     X=REAL(JX)-XC1
                     R=RYZ2+X*X/AX2
                     IF(R.LT.0.25)THEN
                        NAT=NAT+1
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
 0100             CONTINUE
               ENDIF
 0200       CONTINUE
         ENDIF
 0300 CONTINUE
      NAT1=NAT
C
C Determine occupied sites in second spheroid
C
      XC2=XC1+.5*(B_1+B_2)
      YC2=YC1
      ZC2=ZC1
      LMX1=INT(XC2-.5*B_2)
      LMX2=INT(XC2+.5*B_2)
C
C This is not time-consuming, so no need to optimize choices of 
C LMY1,LMY2,LMZ1,LMZ2
C
      LMY1=INT(YC1-.5*MAX(A_2,B_2))
      LMY2=INT(YC1+.5*MAX(A_2,B_2))
      LMZ1=INT(ZC1-.5*MAX(A_2,B_2))
      LMZ2=INT(ZC1+.5*MAX(A_2,B_2))
      SINPHI=SIN(3.1415927*PHI/180.)
      COSPHI=COS(3.1415927*PHI/180.)
C
C transform (y,z) -> (u,v) with u=y*cos(phi)-z*sin(phi)
C                               v=y*sin(phi)+z*cos(phi)
C
      DO 0600 JX=LMX1,LMX2
         X=REAL(JX)-XC2
         RX2=(X/B_2)**2
         IF(RX2.LT.0.25)THEN
            DO 0500 JY=LMY1,LMY2
               Y=REAL(JY)-YC2
               DO 0400 JZ=LMZ1,LMZ2
                  Z=REAL(JZ)-ZC2
                  U=(COSPHI*Y-SINPHI*Z)/A_2
                  V=(SINPHI*Y+COSPHI*Z)/B_2
                  R=RX2+U**2+V**2
                  IF(R.LT.0.25)THEN
C Site is occupied:
                     NAT=NAT+1
                     IXYZ(NAT,1)=JX
                     IXYZ(NAT,2)=JY
                     IXYZ(NAT,3)=JZ
                  ENDIF
 0400          CONTINUE
 0500       CONTINUE
         ENDIF
 0600 CONTINUE
      NAT2=NAT-NAT1
      IF(NAT.GT.MXNAT)THEN
          CALL ERRMSG('FATAL','TAR2SP',' NAT.GT.MXNAT ')
      ENDIF
C
      DO JX=1,3
         DO JA=1,NAT1
            ICOMP(JA,JX)=1
         ENDDO
         DO JA=NAT1+1,NAT
            ICOMP(JA,JX)=2
         ENDDO
      ENDDO

C Specify target axes A1 and A2
C If PRINAX=0. then
C    A1=(1,0,0) in target frame
C    A2=(0,1,0) in target frame
C If PRINAX=1. then
C    A1,A2 are principal axes of largest,second largest moment of
C    inertia

      IF(PRINAX.LE.0.)THEN
         DO JX=1,3
            A1(JX)=0.
            A2(JX)=0.
         ENDDO
         A1(1)=1.
         A2(2)=1.
      ELSE
         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,EIGVAL)
      ENDIF

C***********************************************************************
C Write target description into string CDESCR

      WRITE(CDESCR,FMT='(A,I7,A,I7,A,I7,A)')
     &      ' Spheroids with',NAT1,' +',NAT2,'=',NAT,' dipoles'

C***********************************************************************

      CMSGNM=CDESCR
      CALL WRIMSG('TAR2SP',CMSGNM)
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)A_1,B_1,A_2,B_2,PHI,NAT,NAT1,NAT2,A1,A2,DX
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3),
     &                           ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
 9020 FORMAT(' >TAR2SP: touching spheroids, A_1,B_2,A_2,B_2,PHI=',5F8.4,
     &/,3I7,' = NAT,NAT1,NAT2',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,
     &'     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE DIELEC(CDIEL,WAVE,IDVOUT,CFLEPS,CXEPS,
     &                  MXCOMP,MXWAVT,NCOMP,E1A,E2A,WVA)
      IMPLICIT NONE
C Arguments:
      INTEGER MXCOMP,MXWAVT
      CHARACTER*6 CDIEL
      CHARACTER*60 CFLEPS(MXCOMP)
      COMPLEX CXEPS(MXCOMP)
      INTEGER IDVOUT,NCOMP
      REAL WAVE
      REAL E1A(MXWAVT),E2A(MXWAVT),
     &     WVA(MXWAVT)
C Local Variables:
      LOGICAL INIT
      CHARACTER*80 CDESCR
      COMPLEX CXI
      INTEGER I,J,JJ,NWAVT,IWV,IREN,IIMN,IEPS1,IEPS2,ICOL
      REAL DUM1,DUM2,E1,E2,TEMP
      REAL XIN(10)
      EXTERNAL ERRMSG
      SAVE CXI,IEPS1,INIT,NWAVT
***********************************************************************
C Given:
C       CDIEL = 'TABLES' to read from input tables
C               'H2OICE' for H2O ice
C               'H2OLIQ' for H2O liquid
C       WAVE = wavelength (micron)
C       IDVOUT=output unit number
C       CFLEPS(1-NCOMP) = names of files containing dielectric data
C       MXCOMP,MXWAVT = dimensioning information
C       NCOMP = number of components
C       NWAV = number of wavelengths
C       E1A, E2A, WVA = scratch arrays
C Returns:
C       CXEPS(1-NCOMP) = dielectric constant for materials
C                        1-NCOMP
C NOTE:
C       If CDIEL='TABLES', then it is assumed that file(s) containing
C       the table(s) will have following format:
C line1 = description (CHARACTER*80)
C line2 = IWV, IREN, IIMN, IEPS1, IEPS2
C         where IWV = column in which wavelengths are tabulated
C               IREN = col. in which Re(N) is tabulated (0 if not)
C               IIMN = col. in which Im(N) is tabulated (0 if not)
C               IEPS1= col. in which Re(EPS) is tabulated (0 if not)
C               IEPS2= col. in which Im(EPS) is tabulated (0 if not)
C line3 = header line (will not be read)
C line4... = data, according to columns specified on line2
C wavelengths must be monotonic, either increasing or decreasing
C
C B.T.Draine, Princeton Univ. Obs.
C History:
C 90.12.04 (BTD): Rewritten to allow H2OICE and H2OLIQ options.
C 90.12.21 (BTD): Correct handling of 'TABLES' option when more than
C                 one wavelength is considered.
C 91.05.02 (BTD): Added IDVOUT to argument list for subr. INTERP
C 91.09.12 (BTD): Moved declaration of MXCOMP and MWAVT ahead of
C                 declaration of CFLEPS and CXEPS
C 93.12.06 (BTD): Added IEPS1,INIT, and NWAVT to SAVE statement
C                 (without this did not run properly on SGI Indigo)
C 96.12.16 (BTD): Corrected temperature to T=250K in output statement
C                 for H2OICE option
C 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
C                 CHARACTER*60 to allow longer file names
C                 (also changed in reapar.f and DDSCAT.f)
C Copyright (C) 1993,1996,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DATA CXI/(0.,1.)/,INIT/.TRUE./
      IF(CDIEL.EQ.'TABLES')THEN
         IF(INIT.OR.NCOMP.GT.1)THEN
            DO 1000 J=1,NCOMP
               OPEN(UNIT=3,FILE=CFLEPS(J),STATUS='OLD')
C Read header line:
               READ(3,9000)CDESCR
               WRITE(IDVOUT,9000)CDESCR
C Read line specifying columns for wavelength,Re(n),Im(n),Re(eps),Im(eps):
               READ(3,*)IWV,IREN,IIMN,IEPS1,IEPS2
               ICOL=IWV
               IF(IREN.GT.ICOL)ICOL=IREN
               IF(IIMN.GT.ICOL)ICOL=IIMN
               IF(IEPS1.GT.ICOL)ICOL=IEPS1
               IF(IEPS2.GT.ICOL)ICOL=IEPS2
C Skip header line:
               READ(3,*)
               DO 0500 I=1,MXWAVT
                  READ(3,*,END=0600)(XIN(JJ),JJ=1,ICOL)
                  WVA(I)=XIN(IWV)
                  IF(IEPS1.GT.0)THEN
                     E1A(I)=XIN(IEPS1)
                     E2A(I)=XIN(IEPS2)
                  ELSE
                     E1A(I)=XIN(IREN)
                     E2A(I)=XIN(IIMN)
                  ENDIF
                  NWAVT=I
 0500          CONTINUE
C Check whether there is unread data remaining in file
               READ(3,*,END=0600)(XIN(JJ),JJ=1,ICOL)
C If this point is reached, apparently unread data remains, so
C issue warning:
               CALL ERRMSG('WARNING','DIELEC',
     &    'parameter MXWAVT not large enough to read full dielec file')
 0600          CLOSE(3)
C
C*** Have completed reading in table for this composition.
C    Now interpolate
               CALL INTERP(WAVE,E1,E2,WVA,E1A,E2A,
     &                     IDVOUT,MXWAVT,NWAVT)
               IF(IEPS1.GT.0)THEN
                  CXEPS(J)=E1+CXI*E2
               ELSE
                  CXEPS(J)=(E1**2-E2**2)+2.*CXI*E1*E2
               ENDIF
 1000       CONTINUE
            INIT=.FALSE.
         ELSE
C*** Perform this only if NCOMP=1 and previously initialized:
            CALL INTERP(WAVE,E1,E2,WVA,E1A,E2A,IDVOUT,MXWAVT,NWAVT)
            IF(IEPS1.GT.0)THEN
               CXEPS(1)=E1+CXI*E2
            ELSE
               CXEPS(1)=(E1**2-E2**2)+2.*CXI*E1*E2
            ENDIF
         ENDIF
      ELSEIF(CDIEL.EQ.'H2OICE')THEN
         IF(NCOMP.GT.1)CALL ERRMSG('FATAL','DIELE',
     &                 'H2OICE with NCOMP>1??')
C For the moment set T=250K
         TEMP=250.
         WRITE(CDESCR,FMT='(A)')' H2O ice at T=250K'
         WRITE(IDVOUT,9000)CDESCR
         CALL REFICE(0,WAVE,TEMP,E1,E2,DUM1,DUM2)
         CXEPS(1)=E1**2-E2**2+2.*CXI*E1*E2
         RETURN
      ELSEIF(CDIEL.EQ.'H2OLIQ')THEN
         WRITE(CDESCR,FMT='(A)')' H2O liquid at T=280K'
         WRITE(IDVOUT,9000)CDESCR
         IF(NCOMP.GT.1)CALL ERRMSG('FATAL','DIELE',
     &                 'H2OLIQ with NCOMP>1??')
C For the moment set T=280K
         TEMP=280.
         CALL REFWAT(0,WAVE,TEMP,E1,E2,DUM1,DUM2)
         CXEPS(1)=E1**2-E2**2+2.*CXI*E1*E2
         RETURN
      ELSE
         CALL ERRMSG('FATAL','DIELE','unrecognized value of CDIEL')
      ENDIF
      RETURN
 9000 FORMAT(A80)
      END

      SUBROUTINE TARSLB(A1,A2,XV,YV,ZV,F1,F2,F3,
     &                  DX,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      IMPLICIT NONE
C***********************************************************************
C Routine to construct rectangular prism from "atoms"
C with layered structure
C slab has dimensions a,b,c in x,y,z dimensions
C current version allows for up to 4 layers
C slab is layered in x direction
C   0  < x < f1*a is composition 1
C f1*a < x < f2*a is composition 2
C f2*a < x < f3*a is composition 3
C f3*a < x <  a   is composition 4
C
C for fewer than 4 layers, let x2=x3=0 (for two layers)
C                           or x3=0    (for three layers)
C
C Input:
C        XV=(x-length)/d    (d=lattice spacing)
C        YV=(y-length)/d
C        ZV=(z-length)/d
C        F1,F2,F3 = interface locators (see above)
C        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
C                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
C                spacing
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Frame
C        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        ICOMP(1-NAT,1-3)=composition
C
C B.T.Draine, Princeton Univ. Obs.
C History:
C 98.12.29 (BTD): Created using TARREC as starting material.
C 00.11.02 (BTD): Write ICOMP to target.out
C end history
C
C Copyright (C) 1998,2000 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      REAL F1,F2,F3,XV,YV,ZV
      INTEGER IOSHP,MXNAT,NAT
      CHARACTER CDESCR*67
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL A1(3),A2(3),DX(3)
C
C Local variables:
      INTEGER JA,JX,JY,JZ,NCOMP,NX,NX1,NX2,NX3,NY,NZ
      CHARACTER CMSGNM*70
C
C External subroutines:
      EXTERNAL ERRMSG
C
C Intrinsic functions:
      INTEGER IFIX
      INTRINSIC IFIX
C***********************************************************************

      IF(F2.LE.0.)THEN
         NCOMP=2
      ELSE
         IF(F3.LE.0.)THEN
            NCOMP=3
         ELSE
            NCOMP=4
         ENDIF
      ENDIF
      NX=IFIX(XV/DX(1)+0.5)
      NY=IFIX(YV/DX(2)+0.5)
      NZ=IFIX(ZV/DX(3)+0.5)
      WRITE(CMSGNM,FMT='(A,3I4)')
     &      ' Layered slab; NX,NY,NZ=',NX,NY,NZ
      WRITE(CDESCR,FMT='(A,3I4)')
     &      ' Layered slab; NX,NY,NZ=',NX,NY,NZ
C
      NX1=IFIX(F1*NX+0.5)
      NX2=NX
      NX3=NX
      IF(NCOMP.GE.3)NX2=IFIX(F2*NX+0.5)
      IF(NCOMP.EQ.4)NX3=IFIX(F3*NX+0.5)
C
C Specify target axes A1 and A2
C Convention: A1 will be (1,0,0) in target frame
C             A2 will be (0,1,0) in target frame
C
      DO 0100 JA=1,3
         A1(JA)=0.
         A2(JA)=0.
 0100 CONTINUE
      A1(1)=1.
      A2(2)=1.
C               
C Now populate lattice:
      NAT=0
      DO JZ=1,NZ
         DO JY=1,NY
            DO JX=1,NX1
               NAT=NAT+1
               IF(NAT.GT.MXNAT)THEN
                  CALL ERRMSG('FATAL','TARSLB',' NAT.GT.MXNAT')
               ENDIF
               IXYZ(NAT,1)=JX
               IXYZ(NAT,2)=JY
               IXYZ(NAT,3)=JZ
               ICOMP(NAT,1)=1
               ICOMP(NAT,2)=1
               ICOMP(NAT,3)=1
            ENDDO
            DO JX=NX1+1,NX2
               NAT=NAT+1
               IF(NAT.GT.MXNAT)THEN
                  CALL ERRMSG('FATAL','TARSLB',' NAT.GT.MXNAT')
               ENDIF
               IXYZ(NAT,1)=JX
               IXYZ(NAT,2)=JY
               IXYZ(NAT,3)=JZ
               ICOMP(NAT,1)=2
               ICOMP(NAT,2)=2
               ICOMP(NAT,3)=2
            ENDDO
         ENDDO
      ENDDO
      IF(NCOMP.GE.3)THEN
         DO JZ=1,NZ
            DO JY=1,NY
               DO JX=NX2+1,NX3
                  NAT=NAT+1
                  IF(NAT.GT.MXNAT)THEN
                     CALL ERRMSG('FATAL','TARSLB',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
                  ICOMP(NAT,1)=3
                  ICOMP(NAT,2)=3
                  ICOMP(NAT,3)=3
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF(NCOMP.EQ.4)THEN
         DO JZ=1,NZ
            DO JY=1,NY
               DO JX=NX3+1,NX
                  NAT=NAT+1
                  IF(NAT.GT.MXNAT)THEN
                     CALL ERRMSG('FATAL','TARSLB',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
                  ICOMP(NAT,1)=4
                  ICOMP(NAT,2)=4
                  ICOMP(NAT,3)=4
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF(NAT.GT.MXNAT)THEN
         CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT ')
      ENDIF
      WRITE(CMSGNM,FMT='(A, I7, A)')
     &      '  Rectangular prism of NAT=',NAT,' dipoles'
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)XV,YV,ZV,NAT,A1,A2,DX
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3),
     &                           ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
 9020 FORMAT (' >TARREC   rectangular prism; AX,AY,AZ=',3F8.4,/,
     &I7,' = NAT',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,
     &'     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,3I2)
      END

      SUBROUTINE TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3,NPY,NPZ)
      IMPLICIT NONE
C
C Arguments:
C
      CHARACTER CDESCR*67,CFLSHP*80,CSHAPE*6
      INTEGER IDVOUT,IDVSHP,IOSHP,MXNAT,NAT,MXN3,NAT3,NPY,NPZ
      REAL A1(3),A2(3),DX(3),SHPAR(6)
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      EXTERNAL ERRMSG,REASHP,TARCYL,TARELL,TARHEX,TARREC,TARTET
C
C Local variables:
C
      INTEGER BLKSIZ,IPRINAX,J,J1,NBLOCKS
      INTEGER XYZB(3,100)
C
C***********************************************************************
C Given:
C    CSHAPE = string describing target geometry; will determine which
C             "shape" routine is invoked.  Current options are:
C             RCTNGL, ELLIPS, CYLNDR, HEXGON, TETRAH, UNICYL, ANIELL,
C             TWOELL, TWOAEL, FRMFIL, THRELL, THRAEL, CONELL, BLOCKS,
C             DW1996, TWOSPH, LYRSLB, NSPHER, PRISM3, ANIREC
C    IOSHP = device number for "target.out" file
C          = -1 to suppress printing of "target.out"
C    SHPAR(1-6) = up to 6 parameters defining target geometry
C    DX(1-3)= d_x/d, d_y/d, d_z/d for lattice, where d=(d_x*d_y*d_z)**(1/3)
C             is the effective lattice spacing, and d_x,d_y,d_z are lattice
C             spacings in x,y,z directions
C    MXNAT = limit on largest allowed value of NAT
C    MXN3  = 3*MXNAT
C    IDVOUT = 1 to print out information on target shape
C            -1 to suppress printing information on target shape
C    CFLSHP = name of target shape file if CSHAPE='FRMFIL'
C    IDVSHP = device number to use to read target shape if
C             CSHAPE='FRMFIL'
C Returns:
C    A1,A2 = two 3-vectors defining initial target orientation
C    CDESCR = string describing target
C    NAT = number of dipoles in target
C    NAT3 = 3*NAT
C    IXYZ(1-NAT,1-3)=integers fixing x,y,z coordinates of
C         occupied sites in target
C    ICOMP(1-NAT,1-3)=composition for E in x,y,z direction at each site
C    NPY = 0 if isolated target
C        = (periodicity in target frame y direction)/DX(2) if periodic
C           boundary conditions are to be used
C    NPZ = 0 if isolated target
C        = (periodicity in target frame z direction)/DX(3) if periodic
C           boundary conditions are to be used
C
C P.J.Flatau, Colorado State University
C B.T.Draine, Princeton Univ. Observatory
C History:
C 90.11.08 (BTD): Changed DO...ENDDO to DO #...# CONTINUE
C 90.12.02 (BTD): Changed ordering of data in ICOMP
C 90.12.14 (BTD): Changed option MKRECT -> RCTNGL
C 91.05.02 (BTD): Added IDVOUT to argument list
C                 Added IDVOUT to argument list for subr. REASHP
C 91.05.23 (BTD): Added A1,A2 to arg. list for subr. REASHP
C 91.11.12 (BTD): Added IDVSHP to arg. list for TARGET and REASHP
C 92.09.21 (BTD): Added option UNIELL (uniaxial ellipsoid)
C 93.01.07 (BTD): Added option TWOELL (two touching ellipsoids,
C                 consisting of materials 1 and 2)
C 92.01.07 (BTD): Added option TWOAEL (two touching anisotropic
C                 ellipsoids, 1st with diel.fnc.1,2,3 along x,y,z
C                 2nd with diel.fnc.4,5,6 along x,y,z
C 92.01.19 (BTD): Added option THRELL (three touching anisotropic
C                 ellipsoids, 1st with diel.fnc.1,2,3 along x,y,z
C                 2nd with diel.fnc.4,5,6 along x,y,z
C                 3rd with diel.fnc.7,8,9 along x,y,z
C 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
C                 Moved WRITE(IDVOUT,9010) from DDSCAT to TARGET
C 93.12.14 (BTD): Corrected handling of THRELL (had assigned
C                 ICOMP=1 to 50% of sites, ICOMP=2 to other 50%)
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
C                 allow up to 6 shape parameters
C                 Added call to TARCEL to generate two concentric
C                 ellipsoids
C 94.03.21 (BTD): Changed "CONCEL" to "CONELL" for consistency with
C                 REAPAR
C 95.12.11 (BTD): Modified to handle "BLOCKS" as target option, using
C                 subroutine TARBLOCKS
C 96.01.04 (BTD): Modified to handle "DW1996" as target option
C 96.01.25 (BTD): Modified to handle "TWOSPH" as target option
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 96.01.29 (BTD): Added variable IPRINAX to control choice of axes A1,A2
C                 in option BLOCKS
C 97.06.04 (BTD): Corrected bug in handling of option "UNICYL" -- was
C                 not setting composition correctly after changing REAPAR
C                 so that no longer had choice of cylinder axis.
C                 Cylinder axis is always in x direction in target frame.
C                 Thanks for Mike Wolff for calling attention to the
C                 bug.
C 97.11.01 (BTD): add DX to argument list to allow use of noncubic lattice
C                 add DX to argument list of TARELL
C 97.12.26 (BTD): add DX to argument list of TARREC, TARCYL, TARHEX,
C                 TARTET, TAR2EL, TAR3EL, TARCEL, TAR2SP 
C 98.04.27 (BTD): restored missing comma in argument list of TAR2EL
C 98.12.29 (BTD): added new option 'LYRSLB' for layered slab
C 00.06.12 (BTD): modified to support option TARNSP for multisphere
C                 target, including variable lattice spacing DX
C                 all data type conversions now explicit
C 00.07.18 (BTD): corrected bug in calls to tarblocks
C 00.11.02 (BTD): added ICOMP to arg. list for TAR2EL,TAR3EL,TARCYL,
C                 TARELL,TARHEX,TARREC,RCTNGL,TARTET
C 02.02.12 (BTD): added option PRISM3 and call to routine TARPRSM
C 03.05.21 (BTD): added option SPHARM = irregular target
C                 generated using spherical harmonics
C                 target generated by TARSPHARM
C 03.05.22 (BTD): bug fix: define CFLSHP='spharm.par' when calling
C                 TARSPHARM
C 03.11.06 (BTD): modify to use new version of TARSPHARM
C 04.03.19 (BTD): change CFLSHP*13 to CFLSHP*80 to accomodate long file
C                 names
C 04.04.01 (BTD): added arguments NPY,NPZ to support periodic b.c.
C                 option (at present time, used only for target option
c                 NSPPBC)
c 04.04.01 (BTD): Add DX to argument list of TARGSPHER
c                 Remove call to TARSPHARM -- this is superseded by
c                 TARGSPHER
c 04.04.29 (BTD): Add option ANIREC for anisotropic rectangular target
c 06.09.13 (BTD): Add new target option CYLCAP
C end history
C
C Copyright (C) 1993,1994,1995,1996,1997,1998,2000,2002,2003,2004,2006
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
c Most targets are isolated, so set NPY=NPZ=0 as the default, to be
c changed only in case of targets with periodic b.c.

      NPY=0
      NPZ=0

C-----------------------------------------------------------------------
C RCTNGL -> homogeneous, isotropic, rectangular target

      IF(CSHAPE.EQ.'RCTNGL')THEN
         CALL TARREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C ANIREC -> homogeneous, anisotropic, rectangular target

      ELSEIF(CSHAPE.EQ.'ANIREC')THEN
         CALL TARANIREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,
     &                  IOSHP,MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C ELLIPS -> homogeneous, isotropic, ellipsoidal target

      ELSEIF(CSHAPE.EQ.'ELLIPS')THEN
         CALL TARELL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C CYLNDR -> homogeneous, isotropic cylinder

      ELSEIF(CSHAPE.EQ.'CYLNDR')THEN
         CALL TARCYL(A1,A2,SHPAR(1),SHPAR(2),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C CYLCAP -> homogeneous, isotropic cylinder with hemispherical caps

      ELSEIF(CSHAPE.EQ.'CYLCAP')THEN
         CALL TARCYLCAP(A1,A2,SHPAR(1),SHPAR(2),DX,CDESCR,IOSHP,
     &                  MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C HEXGON -> homogeneous, isotropic hexagonal prism

      ELSEIF(CSHAPE.EQ.'HEXGON')THEN
         CALL TARHEX(A1,A2,SHPAR(1),SHPAR(2),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C TETRAH -> homogeneous, isotropic tetrahedron

      ELSEIF(CSHAPE.EQ.'TETRAH')THEN
         CALL TARTET(A1,A2,SHPAR(1),DX,CDESCR,IOSHP,MXNAT,NAT,IXYZ,
     &               ICOMP)

C-----------------------------------------------------------------------
C UNICYL -> uniaxial cylinder
C Cylinder axis is in x direction in Target Frame.
C Assume c axis to be parallel to cylinder axis
C Assume component 1 to be dielectric const. for E par. c axis
C Assume component 2 to be dielectric const. for E perp. c axis

      ELSEIF(CSHAPE.EQ.'UNICYL')THEN
         CALL TARCYL(A1,A2,SHPAR(1),SHPAR(2),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C Set composition

         DO J=1,NAT
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=2
         ENDDO

C-----------------------------------------------------------------------
C ANIELL -> anisotropic ellipsoid

      ELSEIF(CSHAPE.EQ.'ANIELL')THEN
         CALL TARELL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C Dielectric constants 1,2,3 for E along directions x,y,z in Target Frame

         DO J=1,NAT
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
         ENDDO

C-----------------------------------------------------------------------
C TWOELL -> two touching identical ellipsoids, of materials 1 and 2
C           second ellipsoid is displaced from first in x-direction

      ELSEIF(CSHAPE.EQ.'TWOELL')THEN
         CALL TAR2EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C TWOAEL -> two touching identical ellipsoids with anisotropic
C           functions.
C           second ellipsoid is displaced from first in x-direction
C           1st ellipsoid has dielectric fcns 1,2,3 in x,y,z dirs.
C           2nd ellipsoid has dielectric fcns 4,5,6 in x,y,z dirs.

      ELSEIF(CSHAPE.EQ.'TWOAEL')THEN
         CALL TAR2EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)
         J1=NAT/2
         DO J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
         ENDDO
         DO J=J1+1,NAT
            ICOMP(J,1)=4
            ICOMP(J,2)=5
            ICOMP(J,3)=6
         ENDDO

C-----------------------------------------------------------------------
C THRELL -> three touching identical ellipsoids, of materials 1,2,3
C           second ellipsoid is displaced from first in +x-direction
C           third ellipsoid is displaced from second in +x-direction
C           1st,2nd,3rd ellipsoid has ICOMP=1,2,3 (set in TAR3EL)

      ELSEIF(CSHAPE.EQ.'THRELL')THEN
         CALL TAR3EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C THRAEL -> three touching identical ellipsoids with anisotropic
C           functions.  Need to override TAR3EL.
C           second ellipsoid is displaced from first in x-direction
C           1st ellipsoid has dielectric fcns 1,2,3 in x,y,z dirs.
C           2nd ellipsoid has dielectric fcns 4,5,6 in x,y,z dirs.
C           3rd ellipsoid has dielectric fcns 7,8.9 in x,y,z dirs.

      ELSEIF(CSHAPE.EQ.'THRAEL')THEN
         CALL TAR3EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ,ICOMP)
         J1=NAT/3
         DO J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
         ENDDO
         DO J=J1+1,2*J1
            ICOMP(J,1)=4
            ICOMP(J,2)=5
            ICOMP(J,3)=6
         ENDDO
         DO J=2*J1+1,NAT
            ICOMP(J,1)=7
            ICOMP(J,2)=8
            ICOMP(J,3)=9
         ENDDO

C-----------------------------------------------------------------------
C CONELL -> two concentric ellipsoids with isotropic dielectric functions
C           1 (inner) and 2 (outer)

      ELSEIF(CSHAPE.EQ.'CONELL')THEN
         CALL TARCEL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),
     &               SHPAR(6),DX,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C TAR2SP -> two touching spheroids

      ELSEIF(CSHAPE.EQ.'TWOSPH')THEN
         CALL TAR2SP(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),
     &               SHPAR(6),DX,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C BLOCKS -> target is constructed from identical cubic blocks
C           locations of blocks, and size of blocks (lattice units)
C           is specified in file 'blocks.par'
C           file structure:
C              target description
C              IPRINAX = 0 (a1=100,a2=010) or 1 (a1,a2=principal axes)
C              N = number of blocks
C              SIZE = width of one block, in lattice units
C              X Y Z = location of block 1 (in units of block width)
C              ...
C              X Y Z =    "     "    "   N  "   "    "    "     "
C
      ELSEIF(CSHAPE.EQ.'BLOCKS')THEN
         OPEN(UNIT=IDVSHP,FILE='blocks.par',STATUS='OLD',
     &        FORM='FORMATTED')
         READ(IDVSHP,FMT='(A67)')CDESCR
         READ(IDVSHP,*)IPRINAX
         READ(IDVSHP,*)NBLOCKS
         READ(IDVSHP,*)BLKSIZ
         DO J=1,NBLOCKS
            READ(IDVSHP,*)XYZB(1,J),XYZB(2,J),XYZB(3,J)
         ENDDO
         CLOSE(IDVSHP)
         CALL TARBLOCKS(A1,A2,DX,NBLOCKS,BLKSIZ,XYZB,IPRINAX,IOSHP,
     &                  CDESCR,MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C DW1996 -> the 13-cube target studied by Draine & Weingartner 1996
C           SHPAR(1)=width per block in lattice units

      ELSEIF(CSHAPE.EQ.'DW1996')THEN
         IPRINAX=1
         NBLOCKS=13
         BLKSIZ=NINT(SHPAR(1))
         XYZB(1,1)=0
         XYZB(2,1)=1
         XYZB(3,1)=0
         XYZB(1,2)=1
         XYZB(2,2)=1
         XYZB(3,2)=0
         XYZB(1,3)=0
         XYZB(2,3)=2
         XYZB(3,3)=0
         XYZB(1,4)=1
         XYZB(2,4)=2
         XYZB(3,4)=0
         XYZB(1,5)=0
         XYZB(2,5)=1
         XYZB(3,5)=1
         XYZB(1,6)=1
         XYZB(2,6)=1
         XYZB(3,6)=1
         XYZB(1,7)=0
         XYZB(2,7)=2
         XYZB(3,7)=1
         XYZB(1,8)=1
         XYZB(2,8)=2
         XYZB(3,8)=1
         XYZB(1,9)=2
         XYZB(2,9)=1
         XYZB(3,9)=0
         XYZB(1,10)=2
         XYZB(2,10)=2
         XYZB(3,10)=0
         XYZB(1,11)=0
         XYZB(2,11)=0
         XYZB(3,11)=1
         XYZB(1,12)=0
         XYZB(2,12)=0
         XYZB(3,12)=2
         XYZB(1,13)=0
         XYZB(2,13)=1
         XYZB(3,13)=2
         CALL TARBLOCKS(A1,A2,DX,NBLOCKS,BLKSIZ,XYZB,IPRINAX,IOSHP,
     &                  CDESCR,MXNAT,NAT,IXYZ,ICOMP)
         CDESCR='13-cube target used by Draine & Weingartner 1996'

C-----------------------------------------------------------------------
C TARSLB -> Layered slab:

      ELSEIF(CSHAPE.EQ.'LYRSLB')THEN
         CALL TARSLB(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),
     &               SHPAR(6),DX,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
C
C slab has dimensions a,b,c in x,y,z dimensions
C current version allows for up to 4 layers
C slab is layered in x direction
C  0 < x < x1 is composition 1
C x1 < x < x2 is composition 2
C x2 < x < x3 is composition 3
C x3 < x < a  is composition 4

C for fewer than 4 layers, let x2 or x3=0

C SHPAR(1-3)= a/d , b/d , c/d  where d=(dx*dy*dz)**{1/3}
C SHPAR(4)  = x1/a
C SHPAR(5)  = x2/a
C SHPAR(6)  = x3/a

C-----------------------------------------------------------------------
C NSPHER -> Multisphere target:

      ELSEIF(CSHAPE.EQ.'NSPHER')THEN

         CALL TARNSP(A1,A2,SHPAR(1),SHPAR(2),DX,CFLSHP,CDESCR,
     &               IDVSHP,IOSHP,MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C PRISM3 -> triangular prism:

      ELSEIF(CSHAPE.EQ.'PRISM3')THEN
         CALL TARPRSM(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),DX,
     &                CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)

c-----------------------------------------------------------------------
c GSPHER -> gaussian sphere target
C SHPAR(1)= a_eff/d
C SHPAR(2)= 0. to use A1=(1,0,0),A2=(0,1,0) in TF
C           1. to use A1,A2 = principal axes with largest,2nd largest
C              moment of inertia
C SHPAR(3)= BETA : for L>1, contribution of different L values to
C                  <s^2> varies as L^{-BETA}
C SHPAR(4)= LMAX : maximum value of L to use
C SHPAR(5)= <s^2>
C SHPAR(6)= RSEED

      ELSEIF(CSHAPE.EQ.'GSPHER')THEN
c*** diagnostic
         write(0,*)'about to call targspher with shpar(1)=',shpar(1)
c***
         CALL TARGSPHER(SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),
     &                  SHPAR(6),A1,A2,DX,CFLSHP,
     &                  CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)

C-----------------------------------------------------------------------
C NSPPBC -> cluster of N spheres with periodic boundary conditions
C           with A1=(1,0,0), A2=(0,1,0) in target frame
C SHPAR(1) = DIAMX=max extent in target frame x direction/d
C SHPAR(2) = NPY = (periodicity in target y direction)/DX(2)
C SHPAR(3) = NPZ = (periodicity in target z direction)/DX(3)

      ELSEIF(CSHAPE.EQ.'NSPPBC')THEN
         CALL TARNSP(A1,A2,SHPAR(1),0.,DX,CFLSHP,CDESCR,
     &               IDVSHP,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         NPY=NINT(SHPAR(2))
         NPZ=NINT(SHPAR(3))

C-----------------------------------------------------------------------
C add any other specific shape routines here

C-----------------------------------------------------------------------
C FRMFIL -> read list of occupied sites and compositions from file

      ELSEIF(CSHAPE.EQ.'FRMFIL')THEN
         CALL REASHP(CFLSHP,IDVOUT,IDVSHP,A1,A2,DX,CDESCR,MXNAT,NAT,
     &                IXYZ,ICOMP,MXN3,NAT3)

C-----------------------------------------------------------------------
C Reach here only in event of error:

      ELSE
         CALL ERRMSG('FATAL','TARGET',
     &               ' Uknown shape requested: check ddscat.par')
      ENDIF

C Check to see that arrays are large enough

      IF(NAT.GT.MXNAT)CALL ERRMSG('FATAL','TARGET',
     &                ' MXNAT < NAT; must increase MXNAT in DDSCAT')

C Write out target description

      WRITE(IDVOUT,FMT=9010)CDESCR,NAT

C Before returning, compute:

      NAT3=3*NAT
      RETURN
 9010 FORMAT(' >TARGET:',A,/,
     &       7X,I7,' = NAT0 = number of dipoles in target')
      END

      SUBROUTINE SIZER(MXNAT,NAT,IXYZ,LXYZ)
      IMPLICIT NONE
C Arguments:
      INTEGER MXNAT,NAT
      INTEGER LXYZ(3)
      INTEGER*2 IXYZ(MXNAT,3)
C Local variables:
      CHARACTER CMSGNM*70
      INTEGER JA,JD,JX
      INTEGER LXMIN(3),LXMAX(3)
C***********************************************************************
C
C Purpose: to determine full extent of target in x,y,z directions
C in order to determine what "computational" volume will be.
C B.T.Draine, Princeton University Observatory, 96.01.26
C History:
C 96.11.21 (BTD) modified to replace WRITE(0,... with CALL WRIMSG
C Copyright (C) 1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DO JD=1,3
         LXMIN(JD)=IXYZ(1,JD)
         LXMAX(JD)=LXMIN(JD)
      ENDDO
      DO JD=1,3
         DO JA=2,NAT
            JX=IXYZ(JA,JD)
            IF(JX.LT.LXMIN(JD))LXMIN(JD)=JX
            IF(JX.GT.LXMAX(JD))LXMAX(JD)=JX
         ENDDO
      ENDDO
      DO JD=1,3
         LXYZ(JD)=LXMAX(JD)-LXMIN(JD)+1
      ENDDO
      JA=LXYZ(1)*LXYZ(2)*LXYZ(3)
      WRITE(CMSGNM,6000)LXYZ,JA
      CALL WRIMSG('SIZER ',CMSGNM)
 6000 FORMAT('Target size L_x*L_y*L_z=',I4,' *',I4,' *',I4,' =',I6)
      RETURN
      END

      SUBROUTINE EVALQ(CXADIA,CXAOFF,AK,NAT3,E02,CXE,CXP,
     &                 CABS,CEXT,CPHA,MXN3,IMETHD)
      IMPLICIT NONE
C*** Arguments:
      REAL CABS,CEXT,CPHA,E02
      INTEGER IMETHD,MXN3,NAT3
      COMPLEX CXE(MXN3),
     &        CXP(MXN3),
     &        CXADIA(MXN3),
     &        CXAOFF(MXN3)
      REAL AK(3)
C
C*** Local variables:
      COMPLEX CXA,CXI,DCXA,RABS
      REAL AK1,AK2,AK3,PI
      INTEGER J1,J2,J3,NAT
C
C*** Intrinsic functions:
      INTRINSIC AIMAG,CONJG,REAL,SQRT
C
C*** SAVE statements:
      SAVE CXI
C
C*** Data statements:
C
      DATA CXI/(0.,1.)/
C***********************************************************************
C
C Given: CXADIA(J,1-3)=(a_11,a_22,a_33) for dipoles J=1-NAT,
C                  where symmetric 3x3 matrix a_ij is inverse of complex
C                  polarizability tensor alpha_ij for dipole J
C        CXAOFF(J,1-3)=(a_23,a_31,a_12) for dipoles J=1-NAT
C        AK(1-3) = (k_x,k_y,k_z)*d 
C                  d = (d_x*d_y*d_z)**(1/3) = effective lattice spacing
C        NAT3 = 3*number of dipoles
C        E02 = |E_0|^2 , where E_0 = incident complex E field.
C        CXE(1-NAT3) = components of E field at each dipole, in order
C                      E_1x,E_2x,...,E_NATx,E_1y,E_2y,...,E_NATy,
C                      E_1z,E_2z,...,E_NATz
C        CXP(1-NAT3) = components of polarization vector at each dipole,
C                      in order
C                      P_1x,P_2x,...,P_NATx,P_1y,P_2y,...,P_NATy,
C                      P_1z,P_2z,...,P_NATz
C        IMETHD = 0 or 1
C Finds: 
C        CEXT = extinction cross section /d**2
C  and, if IMETHD=1, also computes
C        CPHA = phase-lag cross section /d**2
C        CABS = absorption cross section /d**2
C        
C Note: present definition of CPHA is 1/2 of Martin's definition
C
C B.T.Draine, Princeton Univ. Obs., 87/1/4
C
C History:
C 88.04.28 (BTD): modifications
C 90.11.02 (BTD): modified to allow use of vacuum sites (now pass E02
C                 from calling routine instead of evaluating it here)
C 90.12.13 (BTD): modified to use IMETHD flag, to allow "fast" calls
C                 in which only CEXT is computed.
C 97.12.26 (BTD): removed CXALPH from argument list; replaced with
C                 CXADIA and CXAOFF.
C                 CXADIA and CXAOFF are diagonal and off-diagonal
C                 elements of alpha^{-1} for each dipole.
C                 Modified to properly evaluate CABS
C 98.01.01 (BTD): Correct inconsistencies in assumed data ordering.
C 98.01.13 (BTD): Examine for possible error in evaluation of Qabs
C 98.04.27 (BTD): Minor polishing.
C End history
C
C Copyright (C) 1993,1997,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Initialization:
C Compute magnitude of kd
C
      CEXT=0.
      CABS=0.
      CPHA=0.
      PI=4.*ATAN(1.)
      AK2=0.
      DO 10 J1=1,3
         AK2=AK2+AK(J1)*AK(J1)
   10 CONTINUE
      AK1=SQRT(AK2)
      AK3=AK1*AK2
C
C Initialization complete.
C
      IF(IMETHD.EQ.0)THEN
C
C*** Compute CEXT:
C
         DO 20 J1=1,NAT3
            CEXT=CEXT+AIMAG(CXP(J1))*REAL(CXE(J1))
     &               -REAL(CXP(J1))*AIMAG(CXE(J1))
   20    CONTINUE
         CEXT=4.*PI*AK1*CEXT/E02
      ELSEIF(IMETHD.EQ.1)THEN
C
C Compute 
C C_abs=(4*pi*k/|E_0|^2)*
C       sum_J { Im[P_J*conjg(a_J*P_J)] - (2/3)*k^3*|P_J|^2 }     
C      =(4*pi*k/|E_0|^2)*
C       sum_J {-Im[conjg(P_J)*a_J*P_J] - Im[i*(2/3)*k^3*P_J*conjg(P_J)]}
C      =-(4*pi*k/|E_0|^2)*
C       Im{ sum_J [ conjg(P_J)*(a_J*P_J + i*(2/3)*k^3*P_J) ] }
C
         NAT=NAT3/3
         CXA=(0.,0.)
         RABS=CXI*AK3/1.5
         DO 40 J1=1,NAT
            J2=J1+NAT
            J3=J2+NAT
            DCXA=CONJG(CXP(J1))*((CXADIA(J1)+RABS)*CXP(J1)+
     &                           CXAOFF(J2)*CXP(J3)+CXAOFF(J3)*CXP(J2))+
     &           CONJG(CXP(J2))*((CXADIA(J2)+RABS)*CXP(J2)+
     &                           CXAOFF(J3)*CXP(J1)+CXAOFF(J1)*CXP(J3))+
     &           CONJG(CXP(J3))*((CXADIA(J3)+RABS)*CXP(J3)+
     &                           CXAOFF(J1)*CXP(J2)+CXAOFF(J2)*CXP(J1))
            CXA=CXA+DCXA
   40    CONTINUE
         CABS=-4.*PI*AK1*AIMAG(CXA)/E02
C Compute CEXT and CPHA
         CXA=(0.,0.)
         DO 50 J1=1,NAT3
            CXA=CXA+CXP(J1)*CONJG(CXE(J1))
   50    CONTINUE
         CEXT=4.*PI*AK1*AIMAG(CXA)/E02
         CPHA=2.*PI*AK1*REAL(CXA)/E02
      ENDIF
      RETURN
C
      END

      SUBROUTINE GETMUELLER(IBETA,IORTH,IPHI,ITHETA,MXBETA,
     &                      MXSCA,MXPHI,MXTHET,NSCAT,
     &                      CMDTRQ,PHIN,SM,SMORI,
     &                      S1111,S2121,
     &                      CX1121,CXE01,CXE02,
     &                      CXF11,CXF12,CXF21,CXF22,
     &                      CXS1,CXS2,CXS3,CXS4,
     &                      QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,
     &                      QEXT,QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,
     &                      QSCG2SUM,QSCGSUM,QSCSUM,QTRQAB,
     &                      QTRQABSUM,QTRQSC,QTRQSCSUM,WGTA,WGTB)
      IMPLICIT NONE

C Arguments:

      INTEGER 
     &   IBETA,IORTH,IPHI,ITHETA,
     &   MXBETA,MXSCA,MXPHI,MXTHET,
     &   NSCAT
      CHARACTER 
     &   CMDTRQ*6
      REAL WG
      REAL 
     &   PHIN(MXSCA),QABS(2),QABSUM(2),QBKSCA(2),QBKSUM(2),QEXSUM(2),
     &   QEXT(2),QPHA(2),QPHSUM(2),QSCAG(3,2),QSCAG2(2),QSCAT(2),
     &   QSCG2SUM(2),QSCGSUM(3,2),QSCSUM(2),QTRQAB(3,2),QTRQABSUM(3,2),
     &   QTRQSC(3,2),QTRQSCSUM(3,2),S1111(MXSCA),S2121(MXSCA),
     &   SM(MXSCA,4,4),SMORI(MXSCA,4,4),
     &   WGTA(MXTHET,MXPHI),WGTB(MXBETA)
      COMPLEX 
     &   CX1121(MXSCA),CXE01(3),CXE02(3),
     &   CXF11(MXSCA),CXF12(MXSCA),CXF21(MXSCA),CXF22(MXSCA),
     &   CXS1(MXSCA),CXS2(MXSCA),CXS3(MXSCA),CXS4(MXSCA)

C Local variables:

      INTEGER J,K,JO,ND
      REAL COSPHI,SINPHI
      COMPLEX CXA,CXB,CXC,CXD,CXI
      DATA CXI/(0.,1.)/
      SAVE CXI
C***********************************************************************
C Given:
C   IBETA =index specifying rotation of target around axis a1
C   IORTH =number of incident polarization states being calculated for
C   IPHI  =index specifying phi value for orientation of target axis a1
C   ITHETA=index specifying theta value for orientation of target axis
C          a1
C   MXBETA=dimensioning information
C   MXSCA =dimensioning information
C   MXPHI =dimensioning information
C   MXTHET=dimensioning information
C   NSCAT =number of scattering directions for evaluation of Mueller
C          matrix
C   CMDTRQ='DOTORQ' or 'NOTORQ' depending on whether or not torque
C          calculation is to be carried out
C   PHIN(1-NSCAT)=values of PHI for scattering directions 1-NSCAT
C   S1111(1-NSCAT)=weighted sum of |f_11|^2 over previous orientations
C   S2121(1-NSCAT)=weighted sum of |f_21|^2 over previous orientations
C   CXE01(1-3)    =incident pol state 1 in Lab Frame
C   CXE02(1-3)    =                   2
C   CXF11(1-NSCAT)=f_11 for current orientation
C   CXF12(1-NSCAT)=f_12 for current orientation
C   CXF21(1-NSCAT)=f_21 for current orientation
C   CXF22(1-NSCAT)=f_22 for current orientation
C   QABS(2)       =Q_abs for two incident polarizations
C   QABSUM(2)     =weighted sum of Qabs over previous orientations
C   QBKSCA(2)     =Q_bk for two incident polarizations
C   QBKSUM(2)     =weighted sum of Q_bk over previous orientations
C   QEXSUM(2)     =weighted sum of Q_ext over previous orientations
C   QEXT(2)       =Q_ext for two incident polarizations
C   QPHA(2)       =Q_pha for two incident polarizations
C   QPHSUM(2)     =weighted sum of Q_ph over previous orientations
C   QSCAG(3,2)    =Q_pr vector for two incident polarizations
C   QSCAT(2)      =Q_sca for two incident polarizations
C   QSCGSUM(3,2)  =weighted sum of Q_pr vector over prev. orients.
C   QSCSUM(2)     =weighted sum of Q_sca over previous orientations
C   QTRQAB(3,2)   =absorptive part of Q_gamma for two inc. pols.
C   QTRQABSUM(3,2)=weighted sum of Q_gamma over previous orientations
C   QTRQSC(3,2)   =scattering part of Q_gamma for two inc. pols.
C   QTRQSCSUM(3,2)=weighted sum of Q_gamma over previous orientations
C   WGTA(ITHETA,IPHI)=weight factor for theta,phi orientation
C   WGTB(IBETA)      =weight factor for beta orientation
C   SMORI(1-NSCAT,4,4)=weighted sum of Mueller matrix over previous
C                      orientations
C If IORTH=1, returns:
C   S1111(1-NSCAT)=updated weighted sum of |f_11|^2 over NSCAT 
C                  scattering directions
C   S2121(1-NSCAT)=updated weighted sum of |f_21|^2
C   CX1121(1-NSCAT)=updated weighted summ of f_11*conjg(f_21)
C
C If IORTH=2, returns:
C   SM(1-NSCAT,4,4)=Mueller matrix for current orientation, and NSCAT
C                   scattering directions
C   CXS1(1-NSCAT)=amplitude scattering matrix element S_1 for current
C                 orientation
C   CXS2(1-NSCAT)=amplitude scattering matrix element S_2 for current
C                 orientation
C   CXS3(1-NSCAT)=amplitude scattering matrix element S_3 for current
C                 orientation
C   CXS4(1-NSCAT)=amplitude scattering matrix element S_4 for current
C                 orientations
C   QABSUM(2)     =updated weighted sum of Q_abs
C   QBKSUM(2)     =updated weighted sum of Q_bk
C   QEXSUM(2)     =updated weighted sum of Q_ext
C   QSCGSUM(3,2)  =updated weighted sum of Q_pr vector
C   QSCSUM(2)     =updated weighted sum of Q_sca
C   QTRQABSUM(3,2)=updated weighted sum of absorptive contribution to
C                  Q_gamma
C   QTRQSCSUM(3,2)=updated weighted sum of scattering contribution to
C                  Q_gamma
C
C   SMORI(1-NSCAT,4,4)=updated weighted sum of Mueller matrix elements
C                 
C History:
C 96.11.11 (BTD) ready for use
C 97.07.24 (BTD) corrected error in computation of amplitude scattering
C                matrix elements (CXS1,CXS2,CXS3,CXS4) and Mueller matrix
C                elements SM.  Until now code mistakenly used PHI
C                defining target orientation rather than PHIN 
C                defining scattering direction.  Correction of error
C                required replacing PHI by PHIN in argument list,
C                thereby requiring corresponding change in DDSCAT.
C                All calculated Mueller matrix elements until now were
C                therefore incorrect except for special cases where
C                PHI and PHIN were coincidentally the same (e.g.
C                target orientation PHI=0 and scattering plane PHIN=0).
C                This error was pointed out by Henriette Lemke (Inst.
C                for Atmospheric Physics, GKSS - Research Center,
C                Geesthacht.
C 97.07.24 (BTD) also corrected sign mistake in evaluation of S_14
C                and typo in evaluation of S_31.  Note that since S_31
C                had been evaluated incorrectly, PPOL (evaluated by
C                subroutine WRITESCA) was then numerically incorrect.
C 98.11.01 (BTD) Timo Nousiainen (tpnousia@lumi.meteo.helsinki.fi)
C                reported a problem with S_12 computed by DDSCAT for
C                a pseudosphere target when the scattering plane has
C                e.g. phi=90.  Problem is real and must be tracked down
C                and corrected.
C 98.11.16 (BTD) Modified code calculating complex amplitude scattering
C                matrix elements S1,S2,S3,S4 from f_ij.
C 00.06.13 (BTD) make data conversions explicit
C 03.10.23 (BTD) add QSCAG2 and QSCAG2SUM to argument list
C                add code to update QSCAG2SUM
C end history
C
C Copyright (C) 1996,1997,1998,2000,2003
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C*********  Sum scattering properties over orientations ****************
C
C Correspondence to notation of Bohren & Huffman (1983):
C Our f_jk correspond to notation of Draine (1988).  
C For the special case where incident polarization modes 1 and 2 are
C parallel and perpendicular to the scattering plane, we have the
C relationship between the f_jk and the elements S_j of the amplitude 
C scattering matrix as defined by Bohren & Huffman (1983) is as follows:
C     S_1 = -i*f_22
C     S_2 = -i*f_11
C     S_3 =  i*f_12
C     S_4 =  i*f_21
C In this case (incident pol. states parallel,perpendicular to the
C scattering plane), the elements of the 4x4 Mueller matrix (see Bohren & 
C Huffman 1983) are related to our f_jk as follows:
C     S_11 = [|f_11|^2 + |f_22|^2 + |f_12|^2 + |f_21|^2]/2
C     S_12 = [|f_11|^2 + |f_21|^2 - |f_22|^2 - |f_12|^2]/2
C     S_13 = -Re[f_11*conjg(f_12) + f_22*conjg(f_21)]
C     S_14 =  Im[f_22*conjg(f_21) - f_11*conjg(f_12)]
C     S_21 = [|f_11|^2 + |f_12|^2 - |f_22|^2 - |f_21|^2]/2
C     S_22 = [|f_11|^2 + |f_22|^2 - |f_21|^2 - |f_12|^2]/2
C     S_23 =  Re[f_22*conjg(f_21) - f_11*conjg(f_12)]
C     S_24 = -Im[f_11*conjg(f_12) + f_22*conjg(f_21)]
C     S_31 = -Re[f_11*conjg(f_21) + f_22*conjg(f_22)]
C     S_32 =  Re[f_22*conjg(f_12) - f_22*conjg(f_21)]
C     S_33 =  Re[f_22*conjg(f_11) + f_12*conjg(f_21)]
C     S_34 =  Im[f_11*conjg(f_22) + f_21*conjg(f_22)]
C     S_41 = -Im[f_21*conjg(f_11) + f_22*conjg(f_12)]
C     S_42 =  Im[f_22*conjg(f_12) - f_22*conjg(f_11)]
C     S_43 =  Im[f_22*conjg(f_11) - f_12*conjg(f_21)]
C     S_44 =  Re[f_22*conjg(f_11) - f_12*conjg(f_21)]
C
C Notation internal to this program: 
C ij.ne.kl: CX_ijkl = \f_ij* \times f_kl  (summed over orientations)
C            S_ijij = \f_ij* \times f_ij  (summed over orientations)
C 4 pure real elements: S1111,S1212,S2121,S2222
C 8 complex elements:   CX1112,CX1121,CX1122,CX1221,CX1222,CX2122
C 4 redundant elts.:    CX1211 = Conjg(CX1112)
C                       CX2111 = Conjg(CX1121)
C                       CX2112 = Conjg(CX1221)
C                       CX2211 = Conjg(CX1122)
C
C In this routine we will carry out fully general calculation of the
C 4x4 Mueller matrix elements, valid for arbitrary incident polarization
C states j=1,2 for which we have the scattering matrix f_ij
C
C First, we compute the amplitude scattering matrix elements S_1,S_2,
C S_3,S_4 as defined by Bohren & Huffman:
C=======================================================================

C WG=weighting factor for this orientation

      WG=WGTA(ITHETA,IPHI)*WGTB(IBETA)
      IF(IORTH.EQ.2)THEN

C CXE01,CXE02 are unit incident polarization vectors in Lab Frame.
C We assume CXE01 and CXE02 are normalized (REAPAR makes sure of this).
C CXA,CXB,CXC,CXD are complex coefficients corresponding to dot product
C of complex polarization vectors CXE01,CXE02 with y and z unit vectors
C in Lab Frame.

         CXA=CONJG(CXE01(2))
         CXB=CONJG(CXE01(3))
         CXC=CONJG(CXE02(2))
         CXD=CONJG(CXE02(3))

C Compute complex scattering amplitudes S_1,S_2,S_3,S_4 for this
C particular target orientation and NSCAT scattering directions:

         DO ND=1,NSCAT
            SINPHI=SIN(PHIN(ND))
            COSPHI=COS(PHIN(ND))
            CXS1(ND)= CXI*(CXF21(ND)*(CXA*SINPHI-CXB*COSPHI)+
     &                     CXF22(ND)*(CXC*SINPHI-CXD*COSPHI))
            CXS2(ND)=-CXI*(CXF11(ND)*(CXB*SINPHI+CXA*COSPHI)+
     &                     CXF12(ND)*(CXD*SINPHI+CXC*COSPHI))
            CXS3(ND)=-CXI*(CXF11(ND)*(CXA*SINPHI-CXB*COSPHI)+
     &                     CXF12(ND)*(CXC*SINPHI-CXD*COSPHI))
            CXS4(ND)= CXI*(CXF21(ND)*(CXB*SINPHI+CXA*COSPHI)+
     &                     CXF22(ND)*(CXD*SINPHI+CXC*COSPHI))
         ENDDO

C Now compute Mueller matrix elements for this particular target
C orientation:

         DO ND=1,NSCAT
            SM(ND,1,1)=0.5*REAL(CXS1(ND)*CONJG(CXS1(ND))+
     &                          CXS2(ND)*CONJG(CXS2(ND))+
     &                          CXS3(ND)*CONJG(CXS3(ND))+
     &                          CXS4(ND)*CONJG(CXS4(ND)))
            SM(ND,1,2)=0.5*REAL(CXS2(ND)*CONJG(CXS2(ND))-
     &                          CXS1(ND)*CONJG(CXS1(ND))+
     &                          CXS4(ND)*CONJG(CXS4(ND))-
     &                          CXS3(ND)*CONJG(CXS3(ND)))
            SM(ND,1,3)=REAL(CXS2(ND)*CONJG(CXS3(ND))+
     &                      CXS1(ND)*CONJG(CXS4(ND)))
            SM(ND,1,4)=AIMAG(CXS2(ND)*CONJG(CXS3(ND))-
     &                       CXS1(ND)*CONJG(CXS4(ND)))
            SM(ND,2,1)=0.5*REAL(CXS2(ND)*CONJG(CXS2(ND))-
     &                          CXS1(ND)*CONJG(CXS1(ND))-
     &                          CXS4(ND)*CONJG(CXS4(ND))+
     &                          CXS3(ND)*CONJG(CXS3(ND)))
            SM(ND,2,2)=0.5*REAL(CXS2(ND)*CONJG(CXS2(ND))+
     &                          CXS1(ND)*CONJG(CXS1(ND))-
     &                          CXS4(ND)*CONJG(CXS4(ND))-
     &                          CXS3(ND)*CONJG(CXS3(ND)))
            SM(ND,2,3)=REAL(CXS2(ND)*CONJG(CXS3(ND))-
     &                      CXS1(ND)*CONJG(CXS4(ND)))
            SM(ND,2,4)=AIMAG(CXS2(ND)*CONJG(CXS3(ND))+
     &                       CXS1(ND)*CONJG(CXS4(ND)))
            SM(ND,3,1)=REAL(CXS2(ND)*CONJG(CXS4(ND))+
     &                      CXS1(ND)*CONJG(CXS3(ND)))
            SM(ND,3,2)=REAL(CXS2(ND)*CONJG(CXS4(ND))-
     &                      CXS1(ND)*CONJG(CXS3(ND)))
            SM(ND,3,3)=REAL(CXS1(ND)*CONJG(CXS2(ND))+
     &                      CXS3(ND)*CONJG(CXS4(ND)))
            SM(ND,3,4)=AIMAG(CXS2(ND)*CONJG(CXS1(ND))+
     &                       CXS4(ND)*CONJG(CXS3(ND)))
            SM(ND,4,1)=AIMAG(CXS4(ND)*CONJG(CXS2(ND))+
     &                       CXS1(ND)*CONJG(CXS3(ND)))
            SM(ND,4,2)=AIMAG(CXS4(ND)*CONJG(CXS2(ND))-
     &                       CXS1(ND)*CONJG(CXS3(ND)))
            SM(ND,4,3)=AIMAG(CXS1(ND)*CONJG(CXS2(ND))-
     &                       CXS3(ND)*CONJG(CXS4(ND)))
            SM(ND,4,4)=REAL(CXS1(ND)*CONJG(CXS2(ND))-
     &                      CXS3(ND)*CONJG(CXS4(ND)))
         ENDDO

C Augment Mueller matrix for orientational average

         DO J=1,4
            DO K=1,4
               DO ND=1,NSCAT
                  SMORI(ND,J,K)=SMORI(ND,J,K)+WG*SM(ND,J,K)
               ENDDO
            ENDDO
         ENDDO

C***********************************************************************

      ELSE

C When IORTH=1, cannot compute full Mueller matrix.
C Compute three scattering properties:

         DO ND=1,NSCAT
            S1111(ND)=S1111(ND)+WG*REAL(CONJG(CXF11(ND))*CXF11(ND))
            S2121(ND)=S2121(ND)+WG*REAL(CONJG(CXF21(ND))*CXF21(ND))
            CX1121(ND)=CX1121(ND)+WG*REAL(CONJG(CXF11(ND))*CXF21(ND))
         ENDDO
      ENDIF

C**** Now augment sums of QABS,QBKSCA,QEXT,QSCA,G*QSCA over incident
C     directions and polarizations.

      DO JO=1,IORTH
         QEXSUM(JO)=QEXSUM(JO)+QEXT(JO)*WG
         QABSUM(JO)=QABSUM(JO)+QABS(JO)*WG
         QBKSUM(JO)=QBKSUM(JO)+QBKSCA(JO)*WG
         QPHSUM(JO)=QPHSUM(JO)+QPHA(JO)*WG
         QSCSUM(JO)=QSCSUM(JO)+QSCAT(JO)*WG
         QSCG2SUM(JO)=QSCG2SUM(JO)+QSCAG2(JO)*WG
         DO J=1,3
            QSCGSUM(J,JO)=QSCGSUM(J,JO)+QSCAG(J,JO)*WG
         ENDDO
         IF(CMDTRQ.EQ.'DOTORQ')THEN
            DO J=1,3
               QTRQABSUM(J,JO)=QTRQABSUM(J,JO)+QTRQAB(J,JO)*WG
               QTRQSCSUM(J,JO)=QTRQSCSUM(J,JO)+QTRQSC(J,JO)*WG
            ENDDO
         ENDIF
      ENDDO
      RETURN
      END

      SUBROUTINE COPYIT(CXA,CXB,NPTS)
      IMPLICIT NONE
C*** Arguments:
      INTEGER NPTS
      COMPLEX CXA(*), CXB(*)
C
C*** Local variables:
      INTEGER IPTS
C***********************************************************************
C Purpose: To copy a complex vector from one memory location to another.
C***********************************************************************
      DO 10 IPTS=1,NPTS
         CXB(IPTS)=CXA(IPTS)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE REDUCE(CXV,IOCC,MXN3,MXNAT,NAT,NAT0)
      IMPLICIT NONE
C***********************************************************************
C Given:
C      CXV(1-3*NAT) defined for NAT lattice sites
C      IOCC(1-NAT) = 0 or 1 depending on whether lattice site
C                      is vacant or occupied
C      MXN3,MXNAT = dimensioning information
C      NAT = number of lattice sites
C      NAT0 = number of occupied lattice sites
C Returns
C      CXV(1-3*NAT0) defined for NAT0 occupied lattice sites
C
C Arguments:
      INTEGER MXN3,MXNAT,NAT,NAT0
      INTEGER*2 IOCC(MXNAT)
      COMPLEX CXV(MXN3)
C Local variables:
      INTEGER J,JOC,M
C
C B.T.Draine, Princeton Univ. Observatory, 90.11.29
C History:
C 90.12.03 (BTD): Modified for new ordering of vectors.
C 90.12.05 (BTD): Corrected errors
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DO 20 M=0,2
         JOC=0
         DO 10 J=1,NAT
            IF(IOCC(J).GE.1)THEN
               JOC=JOC+1
               CXV(JOC+M*NAT0)=CXV(J+M*NAT)
            ENDIF
  10     CONTINUE
  20  CONTINUE
      RETURN
      END

      SUBROUTINE SLAMC1( BETA, T, RND, IEEE1 )
      IMPLICIT NONE
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      LOGICAL            IEEE1, RND
      INTEGER            BETA, T

*     ..
*
*  Purpose
*  =======
*
*  SLAMC1 determines the machine parameters given by BETA, T, RND, and
*  IEEE1.
*
*  Arguments
*  =========
*
*  BETA    (output) INTEGER
*          The base of the machine.
*
*  T       (output) INTEGER
*          The number of ( BETA ) digits in the mantissa.
*
*  RND     (output) LOGICAL
*          Specifies whether proper rounding  ( RND = .TRUE. )  or
*          chopping  ( RND = .FALSE. )  occurs in addition. This may not
*          be a reliable guide to the way in which the machine performs
*          its arithmetic.
*
*  IEEE1   (output) LOGICAL
*          Specifies whether rounding appears to be done in the IEEE
*          'round to nearest' style.
*
*  Further Details
*  ===============
*
*  The routine is based on the routine  ENVRON  by Malcolm and
*  incorporates suggestions by Gentleman and Marovich. See
*
*     Malcolm M. A. (1972) Algorithms to reveal properties of
*        floating-point arithmetic. Comms. of the ACM, 15, 949-951.
*
*     Gentleman W. M. and Marovich S. B. (1974) More on algorithms
*        that reveal properties of floating point arithmetic units.
*        Comms. of the ACM, 17, 276-277.
*
* =====================================================================
*
*     .. Local Scalars ..

      CHARACTER CMSGNM*70
      LOGICAL            FIRST, LIEEE1, LRND
      INTEGER            LBETA, LT
      REAL               A, B, C, F, MINUSA,ONE, QTR, SAVEC, T1, T2
*     ..
*     .. External Functions ..
      REAL               SLAMC3
      EXTERNAL           SLAMC3
*     ..
*     .. Save statement ..
      SAVE               FIRST, LIEEE1, LBETA, LRND, LT
*     ..
*     .. Data statements ..
      DATA               FIRST / .TRUE. /
*     ..
*     .. Executable Statements ..
*
c*** diagnostic
c      write(0,*)'entered slamc1'
c***
      IF( FIRST ) THEN
         FIRST = .FALSE.
         ONE = 1
*
*        LBETA,  LIEEE1,  LT and  LRND  are the  local values  of  BETA,
*        IEEE1, T and RND.
*
*        Throughout this routine  we use the function  SLAMC3  to ensure
*        that relevant values are  stored and not held in registers,  or
*        are not affected by optimizers.
*
*        function SLAMC3 performs simple addition of its arguments:
*        SLAMC3(a,b)=a+b
*
*        Compute  a = 2.0**m  with the  smallest positive integer m such
*        that
*
*           fl( a + 1.0 ) = a.
*
         A = 1
         C = 1

   10    CONTINUE
         IF( C.EQ.ONE ) THEN
            A = 2*A
            C = SLAMC3( A, ONE )
            C = SLAMC3( C, -A )
            GO TO 10
         END IF

*        Now compute  b = 2.0**m  with the smallest positive integer m
*        such that

*           fl( a + b ) .gt. a.

c--------------------------------------------------
c btd 040331 change to avoid problems with pgf77 -O
c         B = 1
c         C = SLAMC3( A, B )
         B = 1./64.
         C=A
c--------------------------------------------------

   20    CONTINUE
         IF( C.EQ.A ) THEN
            B = 2*B
            C = SLAMC3( A, B )
            GO TO 20
         END IF


*        Now compute the base.  a and c  are neighbouring floating point
*        numbers  in the  interval  ( beta**t, beta**( t + 1 ) )  and so
*        their difference is beta. Adding 0.25 to c is to ensure that it
*        is truncated to beta and not ( beta - 1 ).

         QTR = ONE / 4
         SAVEC = C
         C = SLAMC3( C, -A )
         LBETA = C + QTR

c btd 040330 begin fix:

         IF(LBETA.EQ.0)THEN
            LBETA=2
            WRITE(CMSGNM,FMT='(A,I3)')
     &         'Problem in SLAMC1 due to optimization: fix LBETA=',LBETA
            CALL WRIMSG('SLAMC1',CMSGNM)
         ENDIF

c btd 040330 end fix

*        Now determine whether rounding or chopping occurs,  by adding a
*        bit  less  than  beta/2  and a  bit  more  than  beta/2  to  a.

         B = LBETA
         F = SLAMC3( B / 2, -B / 100 )
         C = SLAMC3( F, A )
         IF( C.EQ.A ) THEN
            LRND = .TRUE.
         ELSE
            LRND = .FALSE.
         END IF
         F = SLAMC3( B / 2, B / 100 )
         C = SLAMC3( F, A )
         IF( ( LRND ) .AND. ( C.EQ.A ) )
     $      LRND = .FALSE.

*        Try and decide whether rounding is done in the  IEEE  'round to
*        nearest' style. B/2 is half a unit in the last place of the two
*        numbers A and SAVEC. Furthermore, A is even, i.e. has last  bit
*        zero, and SAVEC is odd. Thus adding B/2 to A should not  change
*        A, but adding B/2 to SAVEC should change SAVEC.

         T1 = SLAMC3( B / 2, A )
         T2 = SLAMC3( B / 2, SAVEC )
         LIEEE1 = ( T1.EQ.A ) .AND. ( T2.GT.SAVEC ) .AND. LRND

*        Now find  the  mantissa, t.  It should  be the  integer part of
*        log to the base beta of a,  however it is safer to determine  t
*        by powering.  So we find t as the smallest positive integer for
*        which

*           fl( beta**t + 1.0 ) = 1.0.

         LT = 0
         A = 1
         C = 1

   30    CONTINUE
         IF( C.EQ.ONE ) THEN
            LT = LT + 1
            A = A*LBETA
            C = SLAMC3( A, ONE )
            C = SLAMC3( C, -A )
            GO TO 30
         END IF
      END IF

      BETA = LBETA
      T = LT
      RND = LRND
      IEEE1 = LIEEE1
      RETURN

*     End of SLAMC1

      END

************************************************************************

      SUBROUTINE ERRMSG(CSTATS,CSUBRT,CMSGNM)
      IMPLICIT NONE
C Arguments:
      CHARACTER CMSGNM*(*),CSTATS*(*),CSUBRT*(*)
C
C Local variables:
      INTEGER IOERR
C
C***********************************************************************
C Given:
C       CSTATS = 'WARNING' or 'FATAL'
C       CSUBRT = name of subroutine
C       CMESGN = message
C Prints a warning message in a standardized way,
C and STOPs if CSTATS='FATAL'
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C
C History:
C 96.11.14 (PJF) Remove "getset" and hardwire "ioerr"
c 04.05.23 (BTD) cleanup
c end history
C***********************************************************************
      DATA IOERR/6/
      IF(CSTATS.EQ.'FATAL')THEN
         WRITE(IOERR,FMT=9000)CSUBRT
         WRITE(IOERR,FMT=9010)CMSGNM
         WRITE(IOERR,FMT=9020)
         STOP
      ELSEIF(CSTATS.EQ.'WARNING')THEN
         WRITE(IOERR,FMT=9030)CSUBRT
         WRITE(IOERR,FMT=9010)CMSGNM
      ENDIF
      RETURN
 9000 FORMAT(/,' >>>>> FATAL ERROR IN PROCEDURE: ',A)
 9010 FORMAT(1X,A)
 9020 FORMAT(' >>>>> EXECUTION ABORTED ')
 9030 FORMAT(/,' >>>>> WARNING IN PROCEDURE: ',A)
      END

      SUBROUTINE ESELF(CMETHD,CXZP,NX,NY,NZ,NPY,NPZ,AKD,DX,
     &                 CXZC,CXZW,CXZE)
      IMPLICIT NONE

C Arguments:

      CHARACTER*6 CMETHD
      INTEGER NPY,NPZ,NX,NY,NZ
      REAL AKD
      REAL DX(3)
      COMPLEX 
     &   CXZC(NX+1,NY+1,NZ+1,6),
     &   CXZE(NX,NY,NZ,3),
     &   CXZP(NX,NY,NZ,3),
     &   CXZW(2*NX,2*NY,2*NZ,*)

C Local scalars:

      COMPLEX 
     &   CXEX,CXEY,CXEZ,CXFAC,CXPHAS,CXUNIT,CXXX,CXXY,CXXZ,
     &   CXYY,CXYZ,CXZERO,CXZZ
      REAL BETA,FAC,R,R2,R3,WOLD,XX
      INTEGER 
     &   I,IER,II,IR,ISGN,ISUM,J,JJ,JPY,JPYM,JPZ,JPZM,JR,JSGN,
     &   K,KR,KSGN,M,NGRID

C Local arrays:

      REAL X(3)
      INTEGER 
     &   ISYM(3)
      COMPLEX CXSUM(6)

      EXTERNAL CXC3DFFT,CXFFTW,EXTND,PAD,TRIM
      INTRINSIC EXP,MIN,NINT,SIGN,SQRT
      SAVE BETA,CXUNIT,CXZERO,NGRID,WOLD
      DATA BETA/1.E-10/
c-----------------------------------------------------------------------
c subroutine ESELF
C
C       Given the dipole moments, CXZP, at all points on
C       a rectangular grid,oscillating at frequency AKD,
C       compute the electric field amplitude, CXZE,
C       at each point produced by all the other dipoles except the one
C       at that point.
C       The relationship between the dipoles and the field
C       values at the grid points can be expressed as a convolution,
C       and the convolution is efficiently evaluated using 3D FFTs.
C
C       3-dimensional FFT is performed using either
C
C       a) Native 3d FFT routine in Convex vector library.
C          This option is available only on Convex hardware, and
C          linking must be done with -lveclib option (see the Makefile).
C          This also requires that NX,NY,NZ be of form
C          (2**I)*(3**J)*(5**K); subroutine EXTEND takes care of choosing
C          suitable NX,NY,NZ.
C          Select CMETHD='CONVEX' (in the DDSCAT parameter file).
C       b) CXFFT3N interface to GPFA code of Temperton. 
C          Good points: 
C             -On CRAY the code is on average 30-40% faster in comparison
C              to TMPRTN (and 10-15 faster in comparison to BRENNR)
C             -On scalar machines the code is 2-8 faster in comparison
C              to BRENNR or TMPRTN
C             -Doesn't require additional storage
C          Limitations:
C              -Requires that NX,NY,NZ be of form (2**I)*(3**J)*(5**K); 
C               subroutine EXTEND takes care of choosing suitable NX,NY,NZ.
C              -The choice of "lvr" variable in gpfa2f, gpfa3f, gpfa5f
C               depends on machine. WARNING: on C90 use lvr=128, on
C               all other CRAY's use lvr=64; wrong lvr will produce WRONG
C               RESULTS. On scalar machines optimal lvr depends on cache
C               length; sub-optimal choice degrades performance but still 
C               produces correct results.
C       c) CXFFTW interface to FFTW (Fastest Fourier Transform in the
C               West) version 2.1.x from Frigo and Johnson.
C
C       INPUT:
C       CXZP(I,J,K,L)   Lth cartesian component of the dipole
C                       moment at the grid point (I,J,K);
C                       the DIMENSIONed length of CXZP in
C                       the calling routine is CXZP(NX,NY,NZ,3)
C                       [or CXZP(NX*NY*NZ,3) or CXZP(3*NX*NY*NZ)]
C
C       NX,NY,NZ        Size of grid in x,y,z directions (INTEGER).

c       NPY,NPZ         Period of lattice in y,z directions
c                       Note: must have NPY.GE.NX, NPZ.GE.NZ

C       DX(1-3)         Lattice spacing in x,y,z directions, in units of
C                       n**(-1./3.) .  Note that with this normalization
C                       we have DX(1)*DX(2)*DX(3)=1.

C       AKD             Frequency of oscillation of dipoles and electric
C                       field; also absolute value of wave vector of
C                       incident wave [c=1]  (REAL*4).

C       CXZC            (NX+1) by (NY+1) by (NZ+1) by 6 array of Green
C                       function coefficients used
C                       internally by ESELF and
C                       *************NOT TO BE OVERWRITTEN***********
C                       between calls, because these coefficients are
C                       recomputed only if W has changed since the last
C                       call to ESELF.

C       CXZW            Complex, scratch-space vector of length:
C                       2*NX*2*NY*2*NY*3
C                       See comment about FFT usage and CMETHD
C                       flag.
C                       Can be overwritten between calls to ESELF

C       OUTPUT:

C       CXZE(I,J,K,L)   Lth component of dipole-induced electric field
C                       at grid point (I,J,K);
C                       the DECLARED length of ZE in the calling
C                       program is CXZE(NX,NY,NZ,3)
C                       [or CXZE(NX*NY*NZ,3) or CXZE(3*NX*NY*NZ)]
C
C Originally written by Jeremy Goodman, Princeton Univ. Observatory, 90.09.22
C History:
C 90.11.29 (BTD): Modified to set untransformed ZC(1,1,1,1-6)=0.
C 90.11.29 (PJF): Modified to use FOURX and CXFFT99
C 90.12.05 (BTD): Modified for new ordering of elements of polarization
C                 and electric field vectors in calling program.  Modified
C                 ESELF and PAD to remove distinction between NX,NY,NZ
C                 and dimensions CXZE and CXZP, since our new ordering
C                 always assumes this.
C 90.12.13 (BTD): Modified to include CONVEX option.
C 92.04.20 (BTD): removed ISYM from argument list of TRIM (was not used)
C 94.06.20 (PJF): modified to call CXFFT3N when CMETHD='NEWTMP'
C 96.10.18 (BTD): changed NEWTMP to GPFAFT
C 97.10.16 (BTD): added DX(1-3) to argument list to support use for
C                 noncubic rectangular lattices.
C                 Added DX to 3 lines computing X(1-3)
C 99.04.26 (BTD): changed notation: CXY -> CXZE
C 00.06.22 (BTD): modified to support option FFTWFJ, with calls to CXFFTW
C 00.06.25 (BTD): modified to eliminate calls to FOURX (CMETHD=BRENNR)
C                 and CXFFT3 (CMETHD=TMPRTN), as these options are no
C                 longer supported
C 00.07.05 (BTD): further cleanup 
C 03.07.13 (BTD): changed FFTWFJ to FFTW21 to allow future distinction
C                 between FFTW 2.1.x and FFTW 3.0.x
C 04.03.05 (BTD): modified to handle a periodic lattice of scatterers
C                 with periodicity NPY*D(2) in y direction and
C                 NPZ*D(3) in z direction
c                 Added NPY and NPZ to argument list.
C                 Add parameter BETA to assist convergence
C end history
C Copyright (C) 1993,1994,1996,1997,1999,2000,2003,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DATA WOLD/-999.e-33/,CXUNIT/ (0.,1.)/,CXZERO/(0.,0.)/

      IF(AKD.EQ.WOLD)GOTO 70

C               AKD.NE.WOLD :

C               We have to recompute the
C               Green-function coefficients giving
C               components of field strength at a each grid point R
C               produced by unit-valued component of dipole moment at
C               point R', and then Fourier transform these components.

      WOLD=AKD
      NGRID=8*NX*NY*NZ

c        We assume screening function exp(-alpha*r^4) so
c        rmax^2 = sqrt(20/alpha) so that alpha*r^4 < 20
c     JPYM = maximum number of periods in Y direction
c            rmax = JPYM*NPY*DX(2)

c NPY=0 for nonperiodic case
c    >0 for periodic boundary conditions in y direction

      IF(NPY.EQ.0)THEN
         JPYM=0
      ELSE
         JPYM=INT((20./BETA)**0.25/(NPY*DX(2)))
      ENDIF

C
C               Compute the actual coefficients:
C
      DO K=1,NZ
         DO J=1,NY
            DO I=1,NX

c Compute 6 independent elements of 3x3 symmetric matrix A_jk, where
c A_jk*P_k = -electric field at location j due to dipole P_k at location k
c
c A_jk = (a_1  a_2  a_3)
c        (a_2  a_4  a_5)
c        (a_3  a_5  a_6)_jk

c NPY*d(2) = periodicity in Y direction
c NPZ*d(3) = periodicity in Z direction

c initialize CX(I,J,K,M) = a_M

               DO M=1,6
                  CXSUM(M)=CXZERO
               ENDDO
               DO JPY=-JPYM,JPYM

c NPZ=0 for nonperiodic case
c    >0 for periodic boundary conditions in z direction

                  IF(NPZ.EQ.0)THEN
                     JPZM=0
                  ELSE
                     JPZM=INT(SQRT(SQRT(20./BETA)-JPY*DX(2))/DX(3))
                  ENDIF

                  ISUM=I+J+K+JPY*JPY
                  DO JPZ=-JPZM,JPZM

C skip the self-interaction (R=0) case (I=J=K=1 and JPY=JPZ=0)

                     IF(ISUM+JPZ*JPZ.GT.3)THEN

C Note: here is where unequal lattice spacings are dealt with.
C For a cubic lattice we would have DX(1)=DX(2)=DX(3)=1.

                        X(1)=REAL(I-1)*DX(1)
                        X(2)=REAL(J-1+NPY*JPY)*DX(2)
                        X(3)=REAL(K-1+NPZ*JPZ)*DX(3)
                        R2=X(1)**2+X(2)**2+X(3)**2
                        R=SQRT(R2)
                        R3=R*R2

c include artificial factor exp(-beta*r^4) to assist convergence

                        CXPHAS=EXP(CXUNIT*AKD*R)*EXP(-BETA*R2*R2)
                        CXFAC=(1.-CXUNIT*AKD*R)/R2


                        M=0
                        DO II=1,3
                           M=M+1
                           CXSUM(M)=CXSUM(M)-
     &                              CXPHAS/R3*(AKD**2*(X(II)**2-R2)+
     &                              CXFAC*(R2-3*X(II)**2))
                           IF(II.LT.3)THEN
                              DO JJ=II+1,3
                                 M=M+1
                                 XX=X(II)*X(JJ)
                                 CXSUM(M)=CXSUM(M)-CXPHAS/R3*
     &                                    (AKD**2*XX-CXFAC*(3*XX))
                              ENDDO
                           ENDIF
                        ENDDO
                     ENDIF
                  ENDDO
               ENDDO
               DO M=1,6
                  CXZC(I,J,K,M)=CXSUM(M)
               ENDDO
            ENDDO
         ENDDO
      ENDDO

C          At this point, zc(i,j,k,*) contains the upper triangular
C          part of the symmetric 3 x 3 matrix giving the electric
C          field at grid point (i,j,k) caused by a dipole at (1,1,1)

C          Fill out zc to twice the size in each grid dimension
C          to accomodate negative lags [periodicity in each dimension is
C          assumed, so (e.g.)
C          nx < i <= 2*nx is equivalent to -nx < i <= 0],
C          exploiting symmetries, and Fourier transform.
C          Store only the first octant of the transform,
C          since the others can be obtained by symmetry.

      ISYM(1)=1
      ISYM(2)=1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,1),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'FFTW21')THEN
         CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL CXC3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF

      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,1))

      ISYM(1)=-1
      ISYM(2)=-1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,2),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'FFTW21')THEN
         CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL CXC3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF

      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,2))

      ISYM(1)=-1
      ISYM(2)=1
      ISYM(3)=-1
      CALL EXTND(CXZC(1,1,1,3),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'FFTW21')THEN
         CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL CXC3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF

      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,3))

      ISYM(1)=1
      ISYM(2)=1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,4),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'FFTW21')THEN
         CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL CXC3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF

      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,4))

      ISYM(1)=1
      ISYM(2)=-1
      ISYM(3)=-1
      CALL EXTND(CXZC(1,1,1,5),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'FFTW21')THEN
         CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL CXC3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF

      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,5))

      ISYM(1)=1
      ISYM(2)=1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,6),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'FFTW21')THEN
         CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL CXC3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF

      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,6))

C          End of recomputation of Green-function coefficients

   70 CONTINUE

C       Fourier transform the polarizations:

      DO M=1,3
         CALL PAD(CXZP(1,1,1,M),NX,NY,NZ,CXZW(1,1,1,M))
         IF(CMETHD.EQ.'GPFAFT')THEN
            CALL CXFFT3N(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,+1)
         ELSEIF(CMETHD.EQ.'FFTW21')THEN
            CALL CXFFTW(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,+1)
         ELSEIF(CMETHD.EQ.'CONVEX')THEN
            CALL CXC3DFFT(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
         ENDIF
      ENDDO

C***********************************************************************

C       Multiply by F.T. of Green function:

      DO K=1,2*NZ
         KSGN=NINT(SIGN(1.,NZ+1.5-K))
         KR=MIN(K,2*NZ+2-K)
         DO J=1,2*NY
            JSGN=NINT(SIGN(1.,NY+1.5-J))
            JR=MIN(J,2*NY+2-J)
            DO I=1,2*NX
               ISGN=NINT(SIGN(1.,NX+1.5-I))
               IR=MIN(I,2*NX+2-I)
               CXXX=CXZC(IR,JR,KR,1)
               CXXY=CXZC(IR,JR,KR,2)*(ISGN*JSGN)
               CXXZ=CXZC(IR,JR,KR,3)*(ISGN*KSGN)
               CXYY=CXZC(IR,JR,KR,4)
               CXYZ=CXZC(IR,JR,KR,5)*(JSGN*KSGN)
               CXZZ=CXZC(IR,JR,KR,6)
               CXEX=CXXX*CXZW(I,J,K,1)+CXXY*CXZW(I,J,K,2)+
     &              CXXZ*CXZW(I,J,K,3)
               CXEY=CXXY*CXZW(I,J,K,1)+CXYY*CXZW(I,J,K,2)+
     &              CXYZ*CXZW(I,J,K,3)
               CXEZ=CXXZ*CXZW(I,J,K,1)+CXYZ*CXZW(I,J,K,2)+
     &              CXZZ*CXZW(I,J,K,3)
               CXZW(I,J,K,1)=CXEX
               CXZW(I,J,K,2)=CXEY
               CXZW(I,J,K,3)=CXEZ
            ENDDO
         ENDDO
      ENDDO

C       Inverse Fourier transform to obtain electric field:

      DO M=1,3
         IF(CMETHD.EQ.'GPFAFT')THEN
            CALL CXFFT3N(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,-1)
         ELSEIF(CMETHD.EQ.'FFTW21')THEN
            CALL CXFFTW(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,-1)
         ELSEIF(CMETHD.EQ.'CONVEX')THEN
            CALL CXC3DFFT(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,2*NX,2*NY,-1,IER)
         ENDIF
C
C***********************************************************************

C Note: the Convex FFT routine already normalizes result.
C       For other FFT routines need to divide result by NGRID

         IF(CMETHD.EQ.'CONVEX')THEN
            DO K=1,NZ
               DO J=1,NY
                  DO I=1,NX
                     CXZE(I,J,K,M)=CXZW(I,J,K,M)
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            FAC=1./REAL(NGRID)
            DO K=1,NZ
               DO J=1,NY
                  DO I=1,NX
                     CXZE(I,J,K,M)=FAC*CXZW(I,J,K,M)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDDO

      RETURN
      END
C***********************************************************************

      SUBROUTINE EXTND(CXA,NX,NY,NZ,ISYM,CXB)
      IMPLICIT NONE

C       Using symmetries, extend first octant of coefficient matrix to
C       other octants.

C Originally written by Jeremy Goodman

C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      INTEGER NX,NY,NZ
      COMPLEX CXA(NX+1,NY+1,NZ+1),CXB(2*NX,2*NY,2*NZ)
      INTEGER ISYM(3)
C Local variables:
      INTEGER I,J,K
      COMPLEX CXZERO
C SAVE statement:
      SAVE CXZERO
C DATA statement:
      DATA CXZERO/(0.,0.)/
C***********************************************************************
      DO K=1,NZ
         DO J=1,NY
            DO I=1,NX
               CXB(I,J,K)=CXA(I,J,K)
            ENDDO
         ENDDO
      ENDDO
C
      DO K=1,NZ
         DO J=1,NY
            CXB(NX+1,J,K)=CXZERO
            DO I=NX+2,2*NX
               CXB(I,J,K)=CXA(2*NX+2-I,J,K)*ISYM(1)
            ENDDO
         ENDDO
      ENDDO
C
      DO K=1,NZ
         DO I=1,2*NX
            CXB(I,NY+1,K)=CXZERO
            DO J=NY+2,2*NY
               CXB(I,J,K)=CXB(I,2*NY+2-J,K)*ISYM(2)
            ENDDO
         ENDDO
      ENDDO
C
      DO J=1,2*NY
         DO I=1,2*NX
            CXB(I,J,NZ+1)=CXZERO
            DO K=NZ+2,2*NZ
               CXB(I,J,K)=CXB(I,J,2*NZ+2-K)*ISYM(3)
            ENDDO
         ENDDO
      ENDDO
C
      RETURN
      END
C***********************************************************************

      SUBROUTINE TRIM(CXB,NX,NY,NZ,CXA)
      IMPLICIT NONE
C
C Copy the first octant of CXB into CXA
C
C Originally written by Jeremy Goodman
C History:
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      INTEGER NX,NY,NZ
      COMPLEX CXA(NX+1,NY+1,NZ+1),CXB(2*NX,2*NY,2*NZ)
C Local variables:
      INTEGER I,J,K
C***********************************************************************
      DO 30 K=1,NZ+1
         DO 20 J=1,NY+1
            DO 10 I=1,NX+1
               CXA(I,J,K)=CXB(I,J,K)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      RETURN
      END
C***********************************************************************

      SUBROUTINE PAD(CXA,NX,NY,NZ,CXB)
      IMPLICIT NONE
C
C Pad the array CXA with zeros out to twice its length in each
C dimension, and put the result in CXB.
C
C Originally written by Jeremy Goodman
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      INTEGER NX,NY,NZ
      COMPLEX CXA(NX,NY,NZ),CXB(2*NX,2*NY,2*NZ)
C Local variables:
      COMPLEX CXZERO
      INTEGER I,J,K
      SAVE CXZERO
      DATA CXZERO/(0.,0.)/
C***********************************************************************
      DO 30 K=1,2*NZ
         DO 20 J=1,2*NY
            DO 10 I=1,2*NX
               CXB(I,J,K)=CXZERO
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE

      DO 60 K=1,NZ
         DO 50 J=1,NY
            DO 40 I=1,NX
               CXB(I,J,K)=CXA(I,J,K)
   40       CONTINUE
   50    CONTINUE
   60 CONTINUE

      RETURN
      END

C*********************************************************************
C                                                                    *
C     GPFAPACK - FORTRAN IMPLEMENTATION OF THE SELF-SORTING          *
C     IN-PLACE GENERALIZED PRIME FACTOR (COMPLEX) FFT [GPFA]         *
C                                                                    *
C     WRITTEN BY CLIVE TEMPERTON                                     *
C     RECHERCHE EN PREVISION NUMERIQUE / ECMWF                       *
C                                                                    *
C     THE PACKAGE CONSISTS OF THE SETUP ROUTINE SETGPFA, TOGETHER    *
C     WITH THE ROUTINES GPFA, GPFA2F, GPFA3F, GPFA5F                 *
C                                                                    *
C*********************************************************************
C
C        SUBROUTINE 'SETGPFA'
C        SETUP ROUTINE FOR SELF-SORTING IN-PLACE
C            GENERALIZED PRIME FACTOR (COMPLEX) FFT [GPFA]
C
C        CALL SETGPFA(TRIGS,N)
C
C        INPUT :
C        -----
C        N IS THE LENGTH OF THE TRANSFORMS. N MUST BE OF THE FORM:
C          -----------------------------------
C            N = (2**IP) * (3**IQ) * (5**IR)
C          -----------------------------------
C
C        OUTPUT:
C        ------
C        TRIGS IS A TABLE OF TWIDDLE FACTORS,
C          OF LENGTH 2*IPQR (REAL) WORDS, WHERE:
C          --------------------------------------
C            IPQR = (2**IP) + (3**IQ) + (5**IR)
C          --------------------------------------
C
C        WRITTEN BY CLIVE TEMPERTON 1990
C
C----------------------------------------------------------------------
C
      SUBROUTINE SETGPFA(TRIGS,N)
C
      DIMENSION TRIGS(*)
      DIMENSION NJ(3)
C
C     DECOMPOSE N INTO FACTORS 2,3,5
C     ------------------------------
      NN = N
      IFAC = 2
C
      DO 30 LL = 1 , 3
      KK = 0
   10 CONTINUE
      IF (MOD(NN,IFAC).NE.0) GO TO 20
      KK = KK + 1
      NN = NN / IFAC
      GO TO 10
   20 CONTINUE
      NJ(LL) = KK
      IFAC = IFAC + LL
   30 CONTINUE
C
      IF (NN.NE.1) THEN
         WRITE(6,40) N
   40    FORMAT(' *** WARNING!!!',I10,' IS NOT A LEGAL VALUE OF N ***')
         RETURN
      ENDIF
C
      IP = NJ(1)
      IQ = NJ(2)
      IR = NJ(3)
C
C     COMPUTE LIST OF ROTATED TWIDDLE FACTORS
C     ---------------------------------------
      NJ(1) = 2**IP
      NJ(2) = 3**IQ
      NJ(3) = 5**IR
C
      TWOPI = 4.0 * ASIN(1.0)
      I = 1
C
      DO 60 LL = 1 , 3
      NI = NJ(LL)
      IF (NI.EQ.1) GO TO 60
C
      DEL = TWOPI / FLOAT(NI)
      IROT = N / NI
      KINK = MOD(IROT,NI)
      KK = 0
C
      DO 50 K = 1 , NI
      ANGLE = FLOAT(KK) * DEL
      TRIGS(I) = COS(ANGLE)
      TRIGS(I+1) = SIN(ANGLE)
      I = I + 2
      KK = KK + KINK
      IF (KK.GT.NI) KK = KK - NI
   50 CONTINUE
   60 CONTINUE
C
      RETURN
      END
C        SUBROUTINE 'GPFA'
C        SELF-SORTING IN-PLACE GENERALIZED PRIME FACTOR (COMPLEX) FFT
C
C        *** THIS IS THE ALL-FORTRAN VERSION ***
C            -------------------------------
C
C        CALL GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)
C
C        A IS FIRST REAL INPUT/OUTPUT VECTOR
C        B IS FIRST IMAGINARY INPUT/OUTPUT VECTOR
C        TRIGS IS A TABLE OF TWIDDLE FACTORS, PRECALCULATED
C              BY CALLING SUBROUTINE 'SETGPFA'
C        INC IS THE INCREMENT WITHIN EACH DATA VECTOR
C        JUMP IS THE INCREMENT BETWEEN DATA VECTORS
C        N IS THE LENGTH OF THE TRANSFORMS:
C          -----------------------------------
C            N = (2**IP) * (3**IQ) * (5**IR)
C          -----------------------------------
C        LOT IS THE NUMBER OF TRANSFORMS
C        ISIGN = +1 FOR FORWARD TRANSFORM
C              = -1 FOR INVERSE TRANSFORM
C
C        WRITTEN BY CLIVE TEMPERTON
C        RECHERCHE EN PREVISION NUMERIQUE
C        ATMOSPHERIC ENVIRONMENT SERVICE, CANADA
C
C----------------------------------------------------------------------
C
C        DEFINITION OF TRANSFORM
C        -----------------------
C
C        X(J) = SUM(K=0,...,N-1)(C(K)*EXP(ISIGN*2*I*J*K*PI/N))
C
C---------------------------------------------------------------------
C
C        FOR A MATHEMATICAL DEVELOPMENT OF THE ALGORITHM USED,
C        SEE:
C
C        C TEMPERTON : "A GENERALIZED PRIME FACTOR FFT ALGORITHM
C          FOR ANY N = (2**P)(3**Q)(5**R)",
C          SIAM J. SCI. STAT. COMP., MAY 1992.
C
C----------------------------------------------------------------------
C
      SUBROUTINE GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)
C
      DIMENSION A(*), B(*), TRIGS(*)
      DIMENSION NJ(3)
C
C     DECOMPOSE N INTO FACTORS 2,3,5
C     ------------------------------
      NN = N
      IFAC = 2
C
      DO 30 LL = 1 , 3
      KK = 0
   10 CONTINUE
      IF (MOD(NN,IFAC).NE.0) GO TO 20
      KK = KK + 1
      NN = NN / IFAC
      GO TO 10
   20 CONTINUE
      NJ(LL) = KK
      IFAC = IFAC + LL
   30 CONTINUE
C
      IF (NN.NE.1) THEN
         WRITE(6,40) N
   40    FORMAT(' *** WARNING!!!',I10,' IS NOT A LEGAL VALUE OF N ***')
         RETURN
      ENDIF
C
      IP = NJ(1)
      IQ = NJ(2)
      IR = NJ(3)
C
C     COMPUTE THE TRANSFORM
C     ---------------------
      I = 1
      IF (IP.GT.0) THEN
         CALL GPFA2F(A,B,TRIGS,INC,JUMP,N,IP,LOT,ISIGN)
         I = I + 2 * ( 2**IP)
      ENDIF
      IF (IQ.GT.0) THEN
         CALL GPFA3F(A,B,TRIGS(I),INC,JUMP,N,IQ,LOT,ISIGN)
         I = I + 2 * (3**IQ)
      ENDIF
      IF (IR.GT.0) THEN
         CALL GPFA5F(A,B,TRIGS(I),INC,JUMP,N,IR,LOT,ISIGN)
      ENDIF
C
      RETURN
      END
C     fortran version of *gpfa2* -
C     radix-2 section of self-sorting, in-place, generalized pfa
C     central radix-2 and radix-8 passes included
C      so that transform length can be any power of 2
C
C-------------------------------------------------------------------
C
      subroutine gpfa2f(a,b,trigs,inc,jump,n,mm,lot,isign)
      dimension a(*), b(*), trigs(*)
      data lvr/64/
C
C     ***************************************************************
C     *                                                             *
C     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
C     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
C     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
C     *                                                             *
C     ***************************************************************
C
      n2 = 2**mm
      inq = n/n2
      jstepx = (n2-n) * inc
      ninc = n * inc
      ink = inc * inq
C
      m2 = 0
      m8 = 0
      if (mod(mm,2).eq.0) then
         m = mm/2
      else if (mod(mm,4).eq.1) then
         m = (mm-1)/2
         m2 = 1
      else if (mod(mm,4).eq.3) then
         m = (mm-3)/2
         m8 = 1
      endif
      mh = (m+1)/2
C
      nblox = 1 + (lot-1)/lvr
      left = lot
      s = float(isign)
      istart = 1
C
C  loop on blocks of lvr transforms
C  --------------------------------
      do 500 nb = 1 , nblox
C
      if (left.le.lvr) then
         nvex = left
      else if (left.lt.(2*lvr)) then
         nvex = left/2
         nvex = nvex + mod(nvex,2)
      else
         nvex = lvr
      endif
      left = left - nvex
C
      la = 1
C
C  loop on type I radix-4 passes
C  -----------------------------
      mu = mod(inq,4)
      if (isign.eq.-1) mu = 4 - mu
      ss = 1.0
      if (mu.eq.3) ss = -1.0
C
      if (mh.eq.0) go to 200
C
      do 160 ipass = 1 , mh
      jstep = (n*inc) / (4*la)
      jstepl = jstep - ninc
C
C  k = 0 loop (no twiddle factors)
C  -------------------------------
      do 120 jjj = 0 , (n-1)*inc , 4*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 115 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep, shortloop
      do 110 l = 1 , nvex
      t0 = a(ja+j) + a(jc+j)
      t2 = a(ja+j) - a(jc+j)
      t1 = a(jb+j) + a(jd+j)
      t3 = ss * ( a(jb+j) - a(jd+j) )
      u0 = b(ja+j) + b(jc+j)
      u2 = b(ja+j) - b(jc+j)
      u1 = b(jb+j) + b(jd+j)
      u3 = ss * ( b(jb+j) - b(jd+j) )
      a(ja+j) = t0 + t1
      a(jc+j) = t0 - t1
      b(ja+j) = u0 + u1
      b(jc+j) = u0 - u1
      a(jb+j) = t2 - u3
      a(jd+j) = t2 + u3
      b(jb+j) = u2 + t3
      b(jd+j) = u2 - t3
      j = j + jump
  110 continue
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  115 continue
  120 continue
C
C  finished if n2 = 4
C  ------------------
      if (n2.eq.4) go to 490
      kk = 2 * la
C
C  loop on nonzero k
C  -----------------
      do 150 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
      co3 = trigs(3*kk+1)
      si3 = s*trigs(3*kk+2)
C
C  loop along transform
C  --------------------
      do 140 jjj = k , (n-1)*inc , 4*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 135 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep,shortloop
      do 130 l = 1 , nvex
      t0 = a(ja+j) + a(jc+j)
      t2 = a(ja+j) - a(jc+j)
      t1 = a(jb+j) + a(jd+j)
      t3 = ss * ( a(jb+j) - a(jd+j ) )
      u0 = b(ja+j) + b(jc+j)
      u2 = b(ja+j) - b(jc+j)
      u1 = b(jb+j) + b(jd+j)
      u3 = ss * ( b(jb+j) - b(jd+j) )
      a(ja+j) = t0 + t1
      b(ja+j) = u0 + u1
      a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jc+j) = co2*(t0-t1) - si2*(u0-u1)
      b(jc+j) = si2*(t0-t1) + co2*(u0-u1)
      a(jd+j) = co3*(t2+u3) - si3*(u2-t3)
      b(jd+j) = si3*(t2+u3) + co3*(u2-t3)
      j = j + jump
  130 continue
C-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  135 continue
  140 continue
C-----( end of loop along transforms )
      kk = kk + 2*la
  150 continue
C-----( end of loop on nonzero k )
      la = 4*la
  160 continue
C-----( end of loop on type I radix-4 passes)
C
C  central radix-2 pass
C  --------------------
  200 continue
      if (m2.eq.0) go to 300
C
      jstep = (n*inc) / (2*la)
      jstepl = jstep - ninc
C
C  k=0 loop (no twiddle factors)
C  -----------------------------
      do 220 jjj = 0 , (n-1)*inc , 2*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 215 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep, shortloop
      do 210 l = 1 , nvex
      t0 = a(ja+j) - a(jb+j)
      a(ja+j) = a(ja+j) + a(jb+j)
      a(jb+j) = t0
      u0 = b(ja+j) - b(jb+j)
      b(ja+j) = b(ja+j) + b(jb+j)
      b(jb+j) = u0
      j = j + jump
  210 continue
C-----(end of loop across transforms)
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  215 continue
  220 continue
C
C  finished if n2=2
C  ----------------
      if (n2.eq.2) go to 490
C
      kk = 2 * la
C
C  loop on nonzero k
C  -----------------
      do 260 k = ink , jstep - ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
C
C  loop along transforms
C  ---------------------
      do 250 jjj = k , (n-1)*inc , 2*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 245 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
      if (kk.eq.n2/2) then
cdir$ ivdep, shortloop
      do 230 l = 1 , nvex
      t0 = ss * ( a(ja+j) - a(jb+j) )
      a(ja+j) = a(ja+j) + a(jb+j)
      a(jb+j) = ss * ( b(jb+j) - b(ja+j) )
      b(ja+j) = b(ja+j) + b(jb+j)
      b(jb+j) = t0
      j = j + jump
  230 continue
C
      else
C
cdir$ ivdep, shortloop
      do 240 l = 1 , nvex
      t0 = a(ja+j) - a(jb+j)
      a(ja+j) = a(ja+j) + a(jb+j)
      u0 = b(ja+j) - b(jb+j)
      b(ja+j) = b(ja+j) + b(jb+j)
      a(jb+j) = co1*t0 - si1*u0
      b(jb+j) = si1*t0 + co1*u0
      j = j + jump
  240 continue
C
      endif
C
C-----(end of loop across transforms)
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  245 continue
  250 continue
C-----(end of loop along transforms)
      kk = kk + 2 * la
  260 continue
C-----(end of loop on nonzero k)
C-----(end of radix-2 pass)
C
      la = 2 * la
      go to 400
C
C  central radix-8 pass
C  --------------------
  300 continue
      if (m8.eq.0) go to 400
      jstep = (n*inc) / (8*la)
      jstepl = jstep - ninc
      mu = mod(inq,8)
      if (isign.eq.-1) mu = 8 - mu
      c1 = 1.0
      if (mu.eq.3.or.mu.eq.7) c1 = -1.0
      c2 = sqrt(0.5)
      if (mu.eq.3.or.mu.eq.5) c2 = -c2
      c3 = c1 * c2
C
C  stage 1
C  -------
      do 320 k = 0 , jstep - ink , ink
      do 315 jjj = k , (n-1)*inc , 8*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 312 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jf + jstepl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      j = 0
cdir$ ivdep, shortloop
      do 310 l = 1 , nvex
      t0 = a(ja+j) - a(je+j)
      a(ja+j) = a(ja+j) + a(je+j)
      t1 = c1 * ( a(jc+j) - a(jg+j) )
      a(je+j) = a(jc+j) + a(jg+j)
      t2 = a(jb+j) - a(jf+j)
      a(jc+j) = a(jb+j) + a(jf+j)
      t3 = a(jd+j) - a(jh+j)
      a(jg+j) = a(jd+j) + a(jh+j)
      a(jb+j) = t0
      a(jf+j) = t1
      a(jd+j) = c2 * ( t2 - t3 )
      a(jh+j) = c3 * ( t2 + t3 )
      u0 = b(ja+j) - b(je+j)
      b(ja+j) = b(ja+j) + b(je+j)
      u1 = c1 * ( b(jc+j) - b(jg+j) )
      b(je+j) = b(jc+j) + b(jg+j)
      u2 = b(jb+j) - b(jf+j)
      b(jc+j) = b(jb+j) + b(jf+j)
      u3 = b(jd+j) - b(jh+j)
      b(jg+j) = b(jd+j) + b(jh+j)
      b(jb+j) = u0
      b(jf+j) = u1
      b(jd+j) = c2 * ( u2 - u3 )
      b(jh+j) = c3 * ( u2 + u3 )
      j = j + jump
  310 continue
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  312 continue
  315 continue
  320 continue
C
C  stage 2
C  -------
C
C  k=0 (no twiddle factors)
C  ------------------------
      do 330 jjj = 0 , (n-1)*inc , 8*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 328 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jf + jstepl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      j = 0
cdir$ ivdep, shortloop
      do 325 l = 1 , nvex
      t0 = a(ja+j) + a(je+j)
      t2 = a(ja+j) - a(je+j)
      t1 = a(jc+j) + a(jg+j)
      t3 = c1 * ( a(jc+j) - a(jg+j) )
      u0 = b(ja+j) + b(je+j)
      u2 = b(ja+j) - b(je+j)
      u1 = b(jc+j) + b(jg+j)
      u3 = c1 * ( b(jc+j) - b(jg+j ) )
      a(ja+j) = t0 + t1
      a(je+j) = t0 - t1
      b(ja+j) = u0 + u1
      b(je+j) = u0 - u1
      a(jc+j) = t2 - u3
      a(jg+j) = t2 + u3
      b(jc+j) = u2 + t3
      b(jg+j) = u2 - t3
      t0 = a(jb+j) + a(jd+j)
      t2 = a(jb+j) - a(jd+j)
      t1 = a(jf+j) - a(jh+j)
      t3 = a(jf+j) + a(jh+j)
      u0 = b(jb+j) + b(jd+j)
      u2 = b(jb+j) - b(jd+j)
      u1 = b(jf+j) - b(jh+j)
      u3 = b(jf+j) + b(jh+j)
      a(jb+j) = t0 - u3
      a(jh+j) = t0 + u3
      b(jb+j) = u0 + t3
      b(jh+j) = u0 - t3
      a(jd+j) = t2 + u1
      a(jf+j) = t2 - u1
      b(jd+j) = u2 - t1
      b(jf+j) = u2 + t1
      j = j + jump
  325 continue
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  328 continue
  330 continue
C
      if (n2.eq.8) go to 490
C
C  loop on nonzero k
C  -----------------
      kk = 2 * la
C
      do 350 k = ink , jstep - ink , ink
C
      co1 = trigs(kk+1)
      si1 = s * trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s * trigs(2*kk+2)
      co3 = trigs(3*kk+1)
      si3 = s * trigs(3*kk+2)
      co4 = trigs(4*kk+1)
      si4 = s * trigs(4*kk+2)
      co5 = trigs(5*kk+1)
      si5 = s * trigs(5*kk+2)
      co6 = trigs(6*kk+1)
      si6 = s * trigs(6*kk+2)
      co7 = trigs(7*kk+1)
      si7 = s * trigs(7*kk+2)
C
      do 345 jjj = k , (n-1)*inc , 8*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 342 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jf + jstepl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      j = 0
cdir$ ivdep, shortloop
      do 340 l = 1 , nvex
      t0 = a(ja+j) + a(je+j)
      t2 = a(ja+j) - a(je+j)
      t1 = a(jc+j) + a(jg+j)
      t3 = c1 * ( a(jc+j) - a(jg+j) )
      u0 = b(ja+j) + b(je+j)
      u2 = b(ja+j) - b(je+j)
      u1 = b(jc+j) + b(jg+j)
      u3 = c1 * ( b(jc+j) - b(jg+j ) )
      a(ja+j) = t0 + t1
      b(ja+j) = u0 + u1
      a(je+j) = co4*(t0-t1) - si4*(u0-u1)
      b(je+j) = si4*(t0-t1) + co4*(u0-u1)
      a(jc+j) = co2*(t2-u3) - si2*(u2+t3)
      b(jc+j) = si2*(t2-u3) + co2*(u2+t3)
      a(jg+j) = co6*(t2+u3) - si6*(u2-t3)
      b(jg+j) = si6*(t2+u3) + co6*(u2-t3)
      t0 = a(jb+j) + a(jd+j)
      t2 = a(jb+j) - a(jd+j)
      t1 = a(jf+j) - a(jh+j)
      t3 = a(jf+j) + a(jh+j)
      u0 = b(jb+j) + b(jd+j)
      u2 = b(jb+j) - b(jd+j)
      u1 = b(jf+j) - b(jh+j)
      u3 = b(jf+j) + b(jh+j)
      a(jb+j) = co1*(t0-u3) - si1*(u0+t3)
      b(jb+j) = si1*(t0-u3) + co1*(u0+t3)
      a(jh+j) = co7*(t0+u3) - si7*(u0-t3)
      b(jh+j) = si7*(t0+u3) + co7*(u0-t3)
      a(jd+j) = co3*(t2+u1) - si3*(u2-t1)
      b(jd+j) = si3*(t2+u1) + co3*(u2-t1)
      a(jf+j) = co5*(t2-u1) - si5*(u2+t1)
      b(jf+j) = si5*(t2-u1) + co5*(u2+t1)
      j = j + jump
  340 continue
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  342 continue
  345 continue
      kk = kk + 2 * la
  350 continue
C
      la = 8 * la
C
C  loop on type II radix-4 passes
C  ------------------------------
  400 continue
      mu = mod(inq,4)
      if (isign.eq.-1) mu = 4 - mu
      ss = 1.0
      if (mu.eq.3) ss = -1.0
C
      do 480 ipass = mh+1 , m
      jstep = (n*inc) / (4*la)
      jstepl = jstep - ninc
      laincl = la * ink - ninc
C
C  k=0 loop (no twiddle factors)
C  -----------------------------
      do 430 ll = 0 , (la-1)*ink , 4*jstep
C
      do 420 jjj = ll , (n-1)*inc , 4*la*ink
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 415 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      je = ja + laincl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jf + jstepl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = je + laincl
      if (ji.lt.istart) ji = ji + ninc
      jj = ji + jstepl
      if (jj.lt.istart) jj = jj + ninc
      jk = jj + jstepl
      if (jk.lt.istart) jk = jk + ninc
      jl = jk + jstepl
      if (jl.lt.istart) jl = jl + ninc
      jm = ji + laincl
      if (jm.lt.istart) jm = jm + ninc
      jn = jm + jstepl
      if (jn.lt.istart) jn = jn + ninc
      jo = jn + jstepl
      if (jo.lt.istart) jo = jo + ninc
      jp = jo + jstepl
      if (jp.lt.istart) jp = jp + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep, shortloop
      do 410 l = 1 , nvex
      t0 = a(ja+j) + a(jc+j)
      t2 = a(ja+j) - a(jc+j)
      t1 = a(jb+j) + a(jd+j)
      t3 = ss * ( a(jb+j) - a(jd+j) )
      a(jc+j) = a(ji+j)
      u0 = b(ja+j) + b(jc+j)
      u2 = b(ja+j) - b(jc+j)
      u1 = b(jb+j) + b(jd+j)
      u3 = ss * ( b(jb+j) - b(jd+j) )
      a(jb+j) = a(je+j)
      a(ja+j) = t0 + t1
      a(ji+j) = t0 - t1
      b(ja+j) = u0 + u1
      b(jc+j) = u0 - u1
      b(jd+j) = b(jm+j)
      a(je+j) = t2 - u3
      a(jd+j) = t2 + u3
      b(jb+j) = u2 + t3
      b(jm+j) = u2 - t3
C----------------------
      t0 = a(jb+j) + a(jg+j)
      t2 = a(jb+j) - a(jg+j)
      t1 = a(jf+j) + a(jh+j)
      t3 = ss * ( a(jf+j) - a(jh+j) )
      a(jg+j) = a(jj+j)
      u0 = b(je+j) + b(jg+j)
      u2 = b(je+j) - b(jg+j)
      u1 = b(jf+j) + b(jh+j)
      u3 = ss * ( b(jf+j) - b(jh+j) )
      b(je+j) = b(jb+j)
      a(jb+j) = t0 + t1
      a(jj+j) = t0 - t1
      b(jg+j) = b(jj+j)
      b(jb+j) = u0 + u1
      b(jj+j) = u0 - u1
      a(jf+j) = t2 - u3
      a(jh+j) = t2 + u3
      b(jf+j) = u2 + t3
      b(jh+j) = u2 - t3
C----------------------
      t0 = a(jc+j) + a(jk+j)
      t2 = a(jc+j) - a(jk+j)
      t1 = a(jg+j) + a(jl+j)
      t3 = ss * ( a(jg+j) - a(jl+j) )
      u0 = b(ji+j) + b(jk+j)
      u2 = b(ji+j) - b(jk+j)
      a(jl+j) = a(jo+j)
      u1 = b(jg+j) + b(jl+j)
      u3 = ss * ( b(jg+j) - b(jl+j) )
      b(ji+j) = b(jc+j)
      a(jc+j) = t0 + t1
      a(jk+j) = t0 - t1
      b(jl+j) = b(jo+j)
      b(jc+j) = u0 + u1
      b(jk+j) = u0 - u1
      a(jg+j) = t2 - u3
      a(jo+j) = t2 + u3
      b(jg+j) = u2 + t3
      b(jo+j) = u2 - t3
C----------------------
      t0 = a(jm+j) + a(jl+j)
      t2 = a(jm+j) - a(jl+j)
      t1 = a(jn+j) + a(jp+j)
      t3 = ss * ( a(jn+j) - a(jp+j) )
      a(jm+j) = a(jd+j)
      u0 = b(jd+j) + b(jl+j)
      u2 = b(jd+j) - b(jl+j)
      u1 = b(jn+j) + b(jp+j)
      u3 = ss * ( b(jn+j) - b(jp+j) )
      a(jn+j) = a(jh+j)
      a(jd+j) = t0 + t1
      a(jl+j) = t0 - t1
      b(jd+j) = u0 + u1
      b(jl+j) = u0 - u1
      b(jn+j) = b(jh+j)
      a(jh+j) = t2 - u3
      a(jp+j) = t2 + u3
      b(jh+j) = u2 + t3
      b(jp+j) = u2 - t3
      j = j + jump
  410 continue
C-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  415 continue
  420 continue
  430 continue
C-----( end of double loop for k=0 )
C
C  finished if last pass
C  ---------------------
      if (ipass.eq.m) go to 490
C
      kk = 2*la
C
C     loop on nonzero k
C     -----------------
      do 470 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
      co3 = trigs(3*kk+1)
      si3 = s*trigs(3*kk+2)
C
C  double loop along first transform in block
C  ------------------------------------------
      do 460 ll = k , (la-1)*ink , 4*jstep
C
      do 450 jjj = ll , (n-1)*inc , 4*la*ink
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 445 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      je = ja + laincl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jf + jstepl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = je + laincl
      if (ji.lt.istart) ji = ji + ninc
      jj = ji + jstepl
      if (jj.lt.istart) jj = jj + ninc
      jk = jj + jstepl
      if (jk.lt.istart) jk = jk + ninc
      jl = jk + jstepl
      if (jl.lt.istart) jl = jl + ninc
      jm = ji + laincl
      if (jm.lt.istart) jm = jm + ninc
      jn = jm + jstepl
      if (jn.lt.istart) jn = jn + ninc
      jo = jn + jstepl
      if (jo.lt.istart) jo = jo + ninc
      jp = jo + jstepl
      if (jp.lt.istart) jp = jp + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep, shortloop
      do 440 l = 1 , nvex
      t0 = a(ja+j) + a(jc+j)
      t2 = a(ja+j) - a(jc+j)
      t1 = a(jb+j) + a(jd+j)
      t3 = ss * ( a(jb+j) - a(jd+j) )
      a(jc+j) = a(ji+j)
      u0 = b(ja+j) + b(jc+j)
      u2 = b(ja+j) - b(jc+j)
      u1 = b(jb+j) + b(jd+j)
      u3 = ss * ( b(jb+j) - b(jd+j) )
      a(jb+j) = a(je+j)
      a(ja+j) = t0 + t1
      b(ja+j) = u0 + u1
      a(je+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
      b(jd+j) = b(jm+j)
      a(ji+j) = co2*(t0-t1) - si2*(u0-u1)
      b(jc+j) = si2*(t0-t1) + co2*(u0-u1)
      a(jd+j) = co3*(t2+u3) - si3*(u2-t3)
      b(jm+j) = si3*(t2+u3) + co3*(u2-t3)
C----------------------------------------
      t0 = a(jb+j) + a(jg+j)
      t2 = a(jb+j) - a(jg+j)
      t1 = a(jf+j) + a(jh+j)
      t3 = ss * ( a(jf+j) - a(jh+j) )
      a(jg+j) = a(jj+j)
      u0 = b(je+j) + b(jg+j)
      u2 = b(je+j) - b(jg+j)
      u1 = b(jf+j) + b(jh+j)
      u3 = ss * ( b(jf+j) - b(jh+j) )
      b(je+j) = b(jb+j)
      a(jb+j) = t0 + t1
      b(jb+j) = u0 + u1
      b(jg+j) = b(jj+j)
      a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jj+j) = co2*(t0-t1) - si2*(u0-u1)
      b(jj+j) = si2*(t0-t1) + co2*(u0-u1)
      a(jh+j) = co3*(t2+u3) - si3*(u2-t3)
      b(jh+j) = si3*(t2+u3) + co3*(u2-t3)
C----------------------------------------
      t0 = a(jc+j) + a(jk+j)
      t2 = a(jc+j) - a(jk+j)
      t1 = a(jg+j) + a(jl+j)
      t3 = ss * ( a(jg+j) - a(jl+j) )
      u0 = b(ji+j) + b(jk+j)
      u2 = b(ji+j) - b(jk+j)
      a(jl+j) = a(jo+j)
      u1 = b(jg+j) + b(jl+j)
      u3 = ss * ( b(jg+j) - b(jl+j) )
      b(ji+j) = b(jc+j)
      a(jc+j) = t0 + t1
      b(jc+j) = u0 + u1
      b(jl+j) = b(jo+j)
      a(jg+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jg+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jk+j) = co2*(t0-t1) - si2*(u0-u1)
      b(jk+j) = si2*(t0-t1) + co2*(u0-u1)
      a(jo+j) = co3*(t2+u3) - si3*(u2-t3)
      b(jo+j) = si3*(t2+u3) + co3*(u2-t3)
C----------------------------------------
      t0 = a(jm+j) + a(jl+j)
      t2 = a(jm+j) - a(jl+j)
      t1 = a(jn+j) + a(jp+j)
      t3 = ss * ( a(jn+j) - a(jp+j) )
      a(jm+j) = a(jd+j)
      u0 = b(jd+j) + b(jl+j)
      u2 = b(jd+j) - b(jl+j)
      a(jn+j) = a(jh+j)
      u1 = b(jn+j) + b(jp+j)
      u3 = ss * ( b(jn+j) - b(jp+j) )
      b(jn+j) = b(jh+j)
      a(jd+j) = t0 + t1
      b(jd+j) = u0 + u1
      a(jh+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jh+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jl+j) = co2*(t0-t1) - si2*(u0-u1)
      b(jl+j) = si2*(t0-t1) + co2*(u0-u1)
      a(jp+j) = co3*(t2+u3) - si3*(u2-t3)
      b(jp+j) = si3*(t2+u3) + co3*(u2-t3)
      j = j + jump
  440 continue
C-----(end of loop across transforms)
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  445 continue
  450 continue
  460 continue
C-----( end of double loop for this k )
      kk = kk + 2*la
  470 continue
C-----( end of loop over values of k )
      la = 4*la
  480 continue
C-----( end of loop on type II radix-4 passes )
C-----( nvex transforms completed)
  490 continue
      istart = istart + nvex * jump
  500 continue
C-----( end of loop on blocks of transforms )
C
      return
      end
C     fortran version of *gpfa3* -
C     radix-3 section of self-sorting, in-place
C        generalized PFA
C
C-------------------------------------------------------------------
C
      subroutine gpfa3f(a,b,trigs,inc,jump,n,mm,lot,isign)
      dimension a(*), b(*), trigs(*)
      data sin60/0.866025403784437/
      data lvr/64/
C
C     ***************************************************************
C     *                                                             *
C     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
C     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
C     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
C     *                                                             *
C     ***************************************************************
C
      n3 = 3**mm
      inq = n/n3
      jstepx = (n3-n) * inc
      ninc = n * inc
      ink = inc * inq
      mu = mod(inq,3)
      if (isign.eq.-1) mu = 3-mu
      m = mm
      mh = (m+1)/2
      s = float(isign)
      c1 = sin60
      if (mu.eq.2) c1 = -c1
C
      nblox = 1 + (lot-1)/lvr
      left = lot
      s = float(isign)
      istart = 1
C
C  loop on blocks of lvr transforms
C  --------------------------------
      do 500 nb = 1 , nblox
C
      if (left.le.lvr) then
         nvex = left
      else if (left.lt.(2*lvr)) then
         nvex = left/2
         nvex = nvex + mod(nvex,2)
      else
         nvex = lvr
      endif
      left = left - nvex
C
      la = 1
C
C  loop on type I radix-3 passes
C  -----------------------------
      do 160 ipass = 1 , mh
      jstep = (n*inc) / (3*la)
      jstepl = jstep - ninc
C
C  k = 0 loop (no twiddle factors)
C  -------------------------------
      do 120 jjj = 0 , (n-1)*inc , 3*jstep
      ja = istart + jjj
C
C  "transverse" loop
C  -----------------
      do 115 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep, shortloop
      do 110 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jb+j) = t2 - u3
      b(jb+j) = u2 + t3
      a(jc+j) = t2 + u3
      b(jc+j) = u2 - t3
      j = j + jump
  110 continue
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  115 continue
  120 continue
C
C  finished if n3 = 3
C  ------------------
      if (n3.eq.3) go to 490
      kk = 2 * la
C
C  loop on nonzero k
C  -----------------
      do 150 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
C
C  loop along transform
C  --------------------
      do 140 jjj = k , (n-1)*inc , 3*jstep
      ja = istart + jjj
C
C  "transverse" loop
C  -----------------
      do 135 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep,shortloop
      do 130 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
      j = j + jump
  130 continue
C-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  135 continue
  140 continue
C-----( end of loop along transforms )
      kk = kk + 2*la
  150 continue
C-----( end of loop on nonzero k )
      la = 3*la
  160 continue
C-----( end of loop on type I radix-3 passes)
C
C  loop on type II radix-3 passes
C  ------------------------------
  400 continue
C
      do 480 ipass = mh+1 , m
      jstep = (n*inc) / (3*la)
      jstepl = jstep - ninc
      laincl = la*ink - ninc
C
C  k=0 loop (no twiddle factors)
C  -----------------------------
      do 430 ll = 0 , (la-1)*ink , 3*jstep
C
      do 420 jjj = ll , (n-1)*inc , 3*la*ink
      ja = istart + jjj
C
C  "transverse" loop
C  -----------------
      do 415 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = ja + laincl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jd + laincl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = jh + jstepl
      if (ji.lt.istart) ji = ji + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep, shortloop
      do 410 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      a(jb+j) = a(jd+j)
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      b(jb+j) = b(jd+j)
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jd+j) = t2 - u3
      b(jd+j) = u2 + t3
      a(jc+j) = t2 + u3
      b(jc+j) = u2 - t3
C----------------------
      t1 = a(je+j) + a(jf+j)
      t2 = a(jb+j) - 0.5 * t1
      t3 = c1 * ( a(je+j) - a(jf+j) )
      a(jf+j) = a(jh+j)
      u1 = b(je+j) + b(jf+j)
      u2 = b(jb+j) - 0.5 * u1
      u3 = c1 * ( b(je+j) - b(jf+j) )
      b(jf+j) = b(jh+j)
      a(jb+j) = a(jb+j) + t1
      b(jb+j) = b(jb+j) + u1
      a(je+j) = t2 - u3
      b(je+j) = u2 + t3
      a(jh+j) = t2 + u3
      b(jh+j) = u2 - t3
C----------------------
      t1 = a(jf+j) + a(ji+j)
      t2 = a(jg+j) - 0.5 * t1
      t3 = c1 * ( a(jf+j) - a(ji+j) )
      t1 = a(jg+j) + t1
      a(jg+j) = a(jc+j)
      u1 = b(jf+j) + b(ji+j)
      u2 = b(jg+j) - 0.5 * u1
      u3 = c1 * ( b(jf+j) - b(ji+j) )
      u1 = b(jg+j) + u1
      b(jg+j) = b(jc+j)
      a(jc+j) = t1
      b(jc+j) = u1
      a(jf+j) = t2 - u3
      b(jf+j) = u2 + t3
      a(ji+j) = t2 + u3
      b(ji+j) = u2 - t3
      j = j + jump
  410 continue
C-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  415 continue
  420 continue
  430 continue
C-----( end of double loop for k=0 )
C
C  finished if last pass
C  ---------------------
      if (ipass.eq.m) go to 490
C
      kk = 2*la
C
C     loop on nonzero k
C     -----------------
      do 470 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
C
C  double loop along first transform in block
C  ------------------------------------------
      do 460 ll = k , (la-1)*ink , 3*jstep
C
      do 450 jjj = ll , (n-1)*inc , 3*la*ink
      ja = istart + jjj
C
C  "transverse" loop
C  -----------------
      do 445 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = ja + laincl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jd + laincl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = jh + jstepl
      if (ji.lt.istart) ji = ji + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
cdir$ ivdep, shortloop
      do 440 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      a(jb+j) = a(jd+j)
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      b(jb+j) = b(jd+j)
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jd+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jd+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
C----------------------
      t1 = a(je+j) + a(jf+j)
      t2 = a(jb+j) - 0.5 * t1
      t3 = c1 * ( a(je+j) - a(jf+j) )
      a(jf+j) = a(jh+j)
      u1 = b(je+j) + b(jf+j)
      u2 = b(jb+j) - 0.5 * u1
      u3 = c1 * ( b(je+j) - b(jf+j) )
      b(jf+j) = b(jh+j)
      a(jb+j) = a(jb+j) + t1
      b(jb+j) = b(jb+j) + u1
      a(je+j) = co1*(t2-u3) - si1*(u2+t3)
      b(je+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jh+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jh+j) = si2*(t2+u3) + co2*(u2-t3)
C----------------------
      t1 = a(jf+j) + a(ji+j)
      t2 = a(jg+j) - 0.5 * t1
      t3 = c1 * ( a(jf+j) - a(ji+j) )
      t1 = a(jg+j) + t1
      a(jg+j) = a(jc+j)
      u1 = b(jf+j) + b(ji+j)
      u2 = b(jg+j) - 0.5 * u1
      u3 = c1 * ( b(jf+j) - b(ji+j) )
      u1 = b(jg+j) + u1
      b(jg+j) = b(jc+j)
      a(jc+j) = t1
      b(jc+j) = u1
      a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
      a(ji+j) = co2*(t2+u3) - si2*(u2-t3)
      b(ji+j) = si2*(t2+u3) + co2*(u2-t3)
      j = j + jump
  440 continue
C-----(end of loop across transforms)
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  445 continue
  450 continue
  460 continue
C-----( end of double loop for this k )
      kk = kk + 2*la
  470 continue
C-----( end of loop over values of k )
      la = 3*la
  480 continue
C-----( end of loop on type II radix-3 passes )
C-----( nvex transforms completed)
  490 continue
      istart = istart + nvex * jump
  500 continue
C-----( end of loop on blocks of transforms )
C
      return
      end
C     fortran version of *gpfa5* -
C     radix-5 section of self-sorting, in-place,
C        generalized pfa
C
C-------------------------------------------------------------------
C
      subroutine gpfa5f(a,b,trigs,inc,jump,n,mm,lot,isign)
      dimension a(*), b(*), trigs(*)
      data sin36/0.587785252292473/, sin72/0.951056516295154/,
     *      qrt5/0.559016994374947/
      data lvr/64/
C
C     ***************************************************************
C     *                                                             *
C     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
C     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
C     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
C     *                                                             *
C     ***************************************************************
C
      n5 = 5 ** mm
      inq = n / n5
      jstepx = (n5-n) * inc
      ninc = n * inc
      ink = inc * inq
      mu = mod(inq,5)
      if (isign.eq.-1) mu = 5 - mu
C
      m = mm
      mh = (m+1)/2
      s = float(isign)
      c1 = qrt5
      c2 = sin72
      c3 = sin36
      if (mu.eq.2.or.mu.eq.3) then
         c1 = -c1
         c2 = sin36
         c3 = sin72
      endif
      if (mu.eq.3.or.mu.eq.4) c2 = -c2
      if (mu.eq.2.or.mu.eq.4) c3 = -c3
C
      nblox = 1 + (lot-1)/lvr
      left = lot
      s = float(isign)
      istart = 1
C
C  loop on blocks of lvr transforms
C  --------------------------------
      do 500 nb = 1 , nblox
C
      if (left.le.lvr) then
         nvex = left
      else if (left.lt.(2*lvr)) then
         nvex = left/2
         nvex = nvex + mod(nvex,2)
      else
         nvex = lvr
      endif
      left = left - nvex
C
      la = 1
C
C  loop on type I radix-5 passes
C  -----------------------------
      do 160 ipass = 1 , mh
      jstep = (n*inc) / (5*la)
      jstepl = jstep - ninc
      kk = 0
C
C  loop on k
C  ---------
      do 150 k = 0 , jstep-ink , ink
C
      if (k.gt.0) then
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
      co3 = trigs(3*kk+1)
      si3 = s*trigs(3*kk+2)
      co4 = trigs(4*kk+1)
      si4 = s*trigs(4*kk+2)
      endif
C
C  loop along transform
C  --------------------
      do 140 jjj = k , (n-1)*inc , 5*jstep
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 135 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
      if (k.eq.0) then
C
cdir$ ivdep, shortloop
      do 110 l = 1 , nvex
      t1 = a(jb+j) + a(je+j)
      t2 = a(jc+j) + a(jd+j)
      t3 = a(jb+j) - a(je+j)
      t4 = a(jc+j) - a(jd+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(ja+j) - 0.25 * t5
      a(ja+j) = a(ja+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jb+j) + b(je+j)
      u2 = b(jc+j) + b(jd+j)
      u3 = b(jb+j) - b(je+j)
      u4 = b(jc+j) - b(jd+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(ja+j) - 0.25 * u5
      b(ja+j) = b(ja+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jb+j) = t8 - u11
      b(jb+j) = u8 + t11
      a(je+j) = t8 + u11
      b(je+j) = u8 - t11
      a(jc+j) = t9 - u10
      b(jc+j) = u9 + t10
      a(jd+j) = t9 + u10
      b(jd+j) = u9 - t10
      j = j + jump
  110 continue
C
      else
C
cdir$ ivdep,shortloop
      do 130 l = 1 , nvex
      t1 = a(jb+j) + a(je+j)
      t2 = a(jc+j) + a(jd+j)
      t3 = a(jb+j) - a(je+j)
      t4 = a(jc+j) - a(jd+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(ja+j) - 0.25 * t5
      a(ja+j) = a(ja+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jb+j) + b(je+j)
      u2 = b(jc+j) + b(jd+j)
      u3 = b(jb+j) - b(je+j)
      u4 = b(jc+j) - b(jd+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(ja+j) - 0.25 * u5
      b(ja+j) = b(ja+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jb+j) = co1*(t8-u11) - si1*(u8+t11)
      b(jb+j) = si1*(t8-u11) + co1*(u8+t11)
      a(je+j) = co4*(t8+u11) - si4*(u8-t11)
      b(je+j) = si4*(t8+u11) + co4*(u8-t11)
      a(jc+j) = co2*(t9-u10) - si2*(u9+t10)
      b(jc+j) = si2*(t9-u10) + co2*(u9+t10)
      a(jd+j) = co3*(t9+u10) - si3*(u9-t10)
      b(jd+j) = si3*(t9+u10) + co3*(u9-t10)
      j = j + jump
  130 continue
C
      endif
C
C-----( end of loop across transforms )
C
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  135 continue
  140 continue
C-----( end of loop along transforms )
      kk = kk + 2*la
  150 continue
C-----( end of loop on nonzero k )
      la = 5*la
  160 continue
C-----( end of loop on type I radix-5 passes)
C
      if (n.eq.5) go to 490
C
C  loop on type II radix-5 passes
C  ------------------------------
  400 continue
C
      do 480 ipass = mh+1 , m
      jstep = (n*inc) / (5*la)
      jstepl = jstep - ninc
      laincl = la * ink - ninc
      kk = 0
C
C     loop on k
C     ---------
      do 470 k = 0 , jstep-ink , ink
C
      if (k.gt.0) then
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
      co3 = trigs(3*kk+1)
      si3 = s*trigs(3*kk+2)
      co4 = trigs(4*kk+1)
      si4 = s*trigs(4*kk+2)
      endif
C
C  double loop along first transform in block
C  ------------------------------------------
      do 460 ll = k , (la-1)*ink , 5*jstep
C
      do 450 jjj = ll , (n-1)*inc , 5*la*ink
      ja = istart + jjj
C
C     "transverse" loop
C     -----------------
      do 445 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = jc + jstepl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = ja + laincl
      if (jf.lt.istart) jf = jf + ninc
      jg = jf + jstepl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = jh + jstepl
      if (ji.lt.istart) ji = ji + ninc
      jj = ji + jstepl
      if (jj.lt.istart) jj = jj + ninc
      jk = jf + laincl
      if (jk.lt.istart) jk = jk + ninc
      jl = jk + jstepl
      if (jl.lt.istart) jl = jl + ninc
      jm = jl + jstepl
      if (jm.lt.istart) jm = jm + ninc
      jn = jm + jstepl
      if (jn.lt.istart) jn = jn + ninc
      jo = jn + jstepl
      if (jo.lt.istart) jo = jo + ninc
      jp = jk + laincl
      if (jp.lt.istart) jp = jp + ninc
      jq = jp + jstepl
      if (jq.lt.istart) jq = jq + ninc
      jr = jq + jstepl
      if (jr.lt.istart) jr = jr + ninc
      js = jr + jstepl
      if (js.lt.istart) js = js + ninc
      jt = js + jstepl
      if (jt.lt.istart) jt = jt + ninc
      ju = jp + laincl
      if (ju.lt.istart) ju = ju + ninc
      jv = ju + jstepl
      if (jv.lt.istart) jv = jv + ninc
      jw = jv + jstepl
      if (jw.lt.istart) jw = jw + ninc
      jx = jw + jstepl
      if (jx.lt.istart) jx = jx + ninc
      jy = jx + jstepl
      if (jy.lt.istart) jy = jy + ninc
      j = 0
C
C  loop across transforms
C  ----------------------
      if (k.eq.0) then
C
cdir$ ivdep, shortloop
      do 410 l = 1 , nvex
      t1 = a(jb+j) + a(je+j)
      t2 = a(jc+j) + a(jd+j)
      t3 = a(jb+j) - a(je+j)
      t4 = a(jc+j) - a(jd+j)
      a(jb+j) = a(jf+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(ja+j) - 0.25 * t5
      a(ja+j) = a(ja+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(jc+j) = a(jk+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jb+j) + b(je+j)
      u2 = b(jc+j) + b(jd+j)
      u3 = b(jb+j) - b(je+j)
      u4 = b(jc+j) - b(jd+j)
      b(jb+j) = b(jf+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(ja+j) - 0.25 * u5
      b(ja+j) = b(ja+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(jc+j) = b(jk+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jf+j) = t8 - u11
      b(jf+j) = u8 + t11
      a(je+j) = t8 + u11
      b(je+j) = u8 - t11
      a(jk+j) = t9 - u10
      b(jk+j) = u9 + t10
      a(jd+j) = t9 + u10
      b(jd+j) = u9 - t10
C----------------------
      t1 = a(jg+j) + a(jj+j)
      t2 = a(jh+j) + a(ji+j)
      t3 = a(jg+j) - a(jj+j)
      t4 = a(jh+j) - a(ji+j)
      a(jh+j) = a(jl+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(jb+j) - 0.25 * t5
      a(jb+j) = a(jb+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(ji+j) = a(jq+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jg+j) + b(jj+j)
      u2 = b(jh+j) + b(ji+j)
      u3 = b(jg+j) - b(jj+j)
      u4 = b(jh+j) - b(ji+j)
      b(jh+j) = b(jl+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(jb+j) - 0.25 * u5
      b(jb+j) = b(jb+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(ji+j) = b(jq+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jg+j) = t8 - u11
      b(jg+j) = u8 + t11
      a(jj+j) = t8 + u11
      b(jj+j) = u8 - t11
      a(jl+j) = t9 - u10
      b(jl+j) = u9 + t10
      a(jq+j) = t9 + u10
      b(jq+j) = u9 - t10
C----------------------
      t1 = a(jh+j) + a(jo+j)
      t2 = a(jm+j) + a(jn+j)
      t3 = a(jh+j) - a(jo+j)
      t4 = a(jm+j) - a(jn+j)
      a(jn+j) = a(jr+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(jc+j) - 0.25 * t5
      a(jc+j) = a(jc+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(jo+j) = a(jw+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jh+j) + b(jo+j)
      u2 = b(jm+j) + b(jn+j)
      u3 = b(jh+j) - b(jo+j)
      u4 = b(jm+j) - b(jn+j)
      b(jn+j) = b(jr+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(jc+j) - 0.25 * u5
      b(jc+j) = b(jc+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(jo+j) = b(jw+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jh+j) = t8 - u11
      b(jh+j) = u8 + t11
      a(jw+j) = t8 + u11
      b(jw+j) = u8 - t11
      a(jm+j) = t9 - u10
      b(jm+j) = u9 + t10
      a(jr+j) = t9 + u10
      b(jr+j) = u9 - t10
C----------------------
      t1 = a(ji+j) + a(jt+j)
      t2 = a(jn+j) + a(js+j)
      t3 = a(ji+j) - a(jt+j)
      t4 = a(jn+j) - a(js+j)
      a(jt+j) = a(jx+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(jp+j) - 0.25 * t5
      ax = a(jp+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(jp+j) = a(jd+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      a(jd+j) = ax
      u1 = b(ji+j) + b(jt+j)
      u2 = b(jn+j) + b(js+j)
      u3 = b(ji+j) - b(jt+j)
      u4 = b(jn+j) - b(js+j)
      b(jt+j) = b(jx+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(jp+j) - 0.25 * u5
      bx = b(jp+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(jp+j) = b(jd+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      b(jd+j) = bx
      a(ji+j) = t8 - u11
      b(ji+j) = u8 + t11
      a(jx+j) = t8 + u11
      b(jx+j) = u8 - t11
      a(jn+j) = t9 - u10
      b(jn+j) = u9 + t10
      a(js+j) = t9 + u10
      b(js+j) = u9 - t10
C----------------------
      t1 = a(jv+j) + a(jy+j)
      t2 = a(jo+j) + a(jt+j)
      t3 = a(jv+j) - a(jy+j)
      t4 = a(jo+j) - a(jt+j)
      a(jv+j) = a(jj+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(ju+j) - 0.25 * t5
      ax = a(ju+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(ju+j) = a(je+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      a(je+j) = ax
      u1 = b(jv+j) + b(jy+j)
      u2 = b(jo+j) + b(jt+j)
      u3 = b(jv+j) - b(jy+j)
      u4 = b(jo+j) - b(jt+j)
      b(jv+j) = b(jj+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(ju+j) - 0.25 * u5
      bx = b(ju+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(ju+j) = b(je+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      b(je+j) = bx
      a(jj+j) = t8 - u11
      b(jj+j) = u8 + t11
      a(jy+j) = t8 + u11
      b(jy+j) = u8 - t11
      a(jo+j) = t9 - u10
      b(jo+j) = u9 + t10
      a(jt+j) = t9 + u10
      b(jt+j) = u9 - t10
      j = j + jump
  410 continue
C
      else
C
cdir$ ivdep, shortloop
      do 440 l = 1 , nvex
      t1 = a(jb+j) + a(je+j)
      t2 = a(jc+j) + a(jd+j)
      t3 = a(jb+j) - a(je+j)
      t4 = a(jc+j) - a(jd+j)
      a(jb+j) = a(jf+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(ja+j) - 0.25 * t5
      a(ja+j) = a(ja+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(jc+j) = a(jk+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jb+j) + b(je+j)
      u2 = b(jc+j) + b(jd+j)
      u3 = b(jb+j) - b(je+j)
      u4 = b(jc+j) - b(jd+j)
      b(jb+j) = b(jf+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(ja+j) - 0.25 * u5
      b(ja+j) = b(ja+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(jc+j) = b(jk+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jf+j) = co1*(t8-u11) - si1*(u8+t11)
      b(jf+j) = si1*(t8-u11) + co1*(u8+t11)
      a(je+j) = co4*(t8+u11) - si4*(u8-t11)
      b(je+j) = si4*(t8+u11) + co4*(u8-t11)
      a(jk+j) = co2*(t9-u10) - si2*(u9+t10)
      b(jk+j) = si2*(t9-u10) + co2*(u9+t10)
      a(jd+j) = co3*(t9+u10) - si3*(u9-t10)
      b(jd+j) = si3*(t9+u10) + co3*(u9-t10)
C----------------------
      t1 = a(jg+j) + a(jj+j)
      t2 = a(jh+j) + a(ji+j)
      t3 = a(jg+j) - a(jj+j)
      t4 = a(jh+j) - a(ji+j)
      a(jh+j) = a(jl+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(jb+j) - 0.25 * t5
      a(jb+j) = a(jb+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(ji+j) = a(jq+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jg+j) + b(jj+j)
      u2 = b(jh+j) + b(ji+j)
      u3 = b(jg+j) - b(jj+j)
      u4 = b(jh+j) - b(ji+j)
      b(jh+j) = b(jl+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(jb+j) - 0.25 * u5
      b(jb+j) = b(jb+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(ji+j) = b(jq+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jg+j) = co1*(t8-u11) - si1*(u8+t11)
      b(jg+j) = si1*(t8-u11) + co1*(u8+t11)
      a(jj+j) = co4*(t8+u11) - si4*(u8-t11)
      b(jj+j) = si4*(t8+u11) + co4*(u8-t11)
      a(jl+j) = co2*(t9-u10) - si2*(u9+t10)
      b(jl+j) = si2*(t9-u10) + co2*(u9+t10)
      a(jq+j) = co3*(t9+u10) - si3*(u9-t10)
      b(jq+j) = si3*(t9+u10) + co3*(u9-t10)
C----------------------
      t1 = a(jh+j) + a(jo+j)
      t2 = a(jm+j) + a(jn+j)
      t3 = a(jh+j) - a(jo+j)
      t4 = a(jm+j) - a(jn+j)
      a(jn+j) = a(jr+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(jc+j) - 0.25 * t5
      a(jc+j) = a(jc+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(jo+j) = a(jw+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      u1 = b(jh+j) + b(jo+j)
      u2 = b(jm+j) + b(jn+j)
      u3 = b(jh+j) - b(jo+j)
      u4 = b(jm+j) - b(jn+j)
      b(jn+j) = b(jr+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(jc+j) - 0.25 * u5
      b(jc+j) = b(jc+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(jo+j) = b(jw+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      a(jh+j) = co1*(t8-u11) - si1*(u8+t11)
      b(jh+j) = si1*(t8-u11) + co1*(u8+t11)
      a(jw+j) = co4*(t8+u11) - si4*(u8-t11)
      b(jw+j) = si4*(t8+u11) + co4*(u8-t11)
      a(jm+j) = co2*(t9-u10) - si2*(u9+t10)
      b(jm+j) = si2*(t9-u10) + co2*(u9+t10)
      a(jr+j) = co3*(t9+u10) - si3*(u9-t10)
      b(jr+j) = si3*(t9+u10) + co3*(u9-t10)
C----------------------
      t1 = a(ji+j) + a(jt+j)
      t2 = a(jn+j) + a(js+j)
      t3 = a(ji+j) - a(jt+j)
      t4 = a(jn+j) - a(js+j)
      a(jt+j) = a(jx+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(jp+j) - 0.25 * t5
      ax = a(jp+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(jp+j) = a(jd+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      a(jd+j) = ax
      u1 = b(ji+j) + b(jt+j)
      u2 = b(jn+j) + b(js+j)
      u3 = b(ji+j) - b(jt+j)
      u4 = b(jn+j) - b(js+j)
      b(jt+j) = b(jx+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(jp+j) - 0.25 * u5
      bx = b(jp+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(jp+j) = b(jd+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      b(jd+j) = bx
      a(ji+j) = co1*(t8-u11) - si1*(u8+t11)
      b(ji+j) = si1*(t8-u11) + co1*(u8+t11)
      a(jx+j) = co4*(t8+u11) - si4*(u8-t11)
      b(jx+j) = si4*(t8+u11) + co4*(u8-t11)
      a(jn+j) = co2*(t9-u10) - si2*(u9+t10)
      b(jn+j) = si2*(t9-u10) + co2*(u9+t10)
      a(js+j) = co3*(t9+u10) - si3*(u9-t10)
      b(js+j) = si3*(t9+u10) + co3*(u9-t10)
C----------------------
      t1 = a(jv+j) + a(jy+j)
      t2 = a(jo+j) + a(jt+j)
      t3 = a(jv+j) - a(jy+j)
      t4 = a(jo+j) - a(jt+j)
      a(jv+j) = a(jj+j)
      t5 = t1 + t2
      t6 = c1 * ( t1 - t2 )
      t7 = a(ju+j) - 0.25 * t5
      ax = a(ju+j) + t5
      t8 = t7 + t6
      t9 = t7 - t6
      a(ju+j) = a(je+j)
      t10 = c3 * t3 - c2 * t4
      t11 = c2 * t3 + c3 * t4
      a(je+j) = ax
      u1 = b(jv+j) + b(jy+j)
      u2 = b(jo+j) + b(jt+j)
      u3 = b(jv+j) - b(jy+j)
      u4 = b(jo+j) - b(jt+j)
      b(jv+j) = b(jj+j)
      u5 = u1 + u2
      u6 = c1 * ( u1 - u2 )
      u7 = b(ju+j) - 0.25 * u5
      bx = b(ju+j) + u5
      u8 = u7 + u6
      u9 = u7 - u6
      b(ju+j) = b(je+j)
      u10 = c3 * u3 - c2 * u4
      u11 = c2 * u3 + c3 * u4
      b(je+j) = bx
      a(jj+j) = co1*(t8-u11) - si1*(u8+t11)
      b(jj+j) = si1*(t8-u11) + co1*(u8+t11)
      a(jy+j) = co4*(t8+u11) - si4*(u8-t11)
      b(jy+j) = si4*(t8+u11) + co4*(u8-t11)
      a(jo+j) = co2*(t9-u10) - si2*(u9+t10)
      b(jo+j) = si2*(t9-u10) + co2*(u9+t10)
      a(jt+j) = co3*(t9+u10) - si3*(u9-t10)
      b(jt+j) = si3*(t9+u10) + co3*(u9-t10)
      j = j + jump
  440 continue
C
      endif
C
C-----(end of loop across transforms)
C
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  445 continue
  450 continue
  460 continue
C-----( end of double loop for this k )
      kk = kk + 2*la
  470 continue
C-----( end of loop over values of k )
      la = 5*la
  480 continue
C-----( end of loop on type II radix-5 passes )
C-----( nvex transforms completed)
  490 continue
      istart = istart + nvex * jump
  500 continue
C-----( end of loop on blocks of transforms )
C
      return
      end

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
      IMPLICIT NONE
C
C     timeit_ibm6000
c history
C 94.06.20 (PJF) add dtime to the formal parameters
C 95.06.19 (PJF) modified to suppress printing if CMSGTM='noprint'
C 04.04.05 (BTD) changed IF(CMSGTM(1:7).NE.. to IF(CMSGTM.NE..
C end history
C This version of timeit uses the system call "mclock" available under
C RISC6000/320 IBM AIX3.1
C
C Copyright (C) 1993,1995,2004 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      CHARACTER CMSGTM* (*)
      REAL DTIME
C
C Local variables:
      REAL OLDTIM
      CHARACTER CSTA*3, CMSGNM*70
      INTEGER I1,I2,IALL
C
C External Subroutines ..
      EXTERNAL WRIMSG
C
C External Functions ..
      INTEGER MCLOCK
      EXTERNAL MCLOCK
C
      DATA CSTA/'ONE'/
C
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         I1=MCLOCK()
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         I2=MCLOCK()
         IALL=I2-I1
         DTIME=FLOAT(IALL)/100.
         IF(CMSGTM.NE.'NOPRINT'.AND.CMSGTM.NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            WRITE(CMSGNM,FMT='(G15.6, A)')DTIME,' CPU time (in secs) '
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE GETFML(AKR,AK3,AKSR,DX,
     &                  CALPHA,CMDSOL,CMDFFT,CMDTRQ,CSHAPE,
     &                  CXADIA,CXAOFF,CXALPH,CXALOF,CXALDS,CXALOS,
     &                  CXE,CXE01R,CXE02R,CXEPS,
     &                  CXF11,CXF12,CXF21,CXF22,CXRLOC,
     &                  CXPOL,CXSC,CXSCR1,CXZC,CXZW,
     &                  EM1R,EM2R,ETASCA,
     &                  IBETH,IBETH1,ICOMP,IDVOUT,INIT,IOCC,
     &                  IORTH,IPHI,IPHI1,ITASK,IXYZ0,
     &                  ITNUM,MXITER,
     &                  LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0,
     &                  MXCOMP,MXCXSC,MXN3,MXNAT,
     &                  MXNX,MXNY,MXNZ,MXPHI,MXSCA,MYID,
     &                  NAT,NAT0,NAT3,NAVG,NCOMP,NSCAT,NX,NY,NZ,
     &                  PHI,PHIN,PIA2,
     &                  QABS,QBKSCA,QEXT,QPHA,QSCA,QSCAG,QSCAG2,
     &                  QTRQAB,QTRQSC,
     &                  SCRRS1,SCRRS2,SHPAR,THETAN,TOL,TIMERS,
     &                  MXTIMERS,NTIMERS)
C
C***********************************************************************
C Function of GETFML is to return the scattering function fml in
C preselected scattering directions.
C
C Given:
C       AKR(1-3)=(k_x,k_y,k_z)*d for incident wave [in Target Frame]
C       AK3     =(kd)**3
C       AKSR(1-3,1-NSCAT)=(k_x,k_y,k_z)*d for NSCAT scattering directions
C       DX(1-3) =(d_x/d,d_y/d,d_z/d) where d_x,d_y,d_z=x,y,z lattice spacing
C                and d=(d_x*d_y*d_z)**(1/3)=effective lattice spacing
C       CALPHA  =descriptor of method used for assigning polarizabilities
C               =LATTDR or DRAI88 or GOBR88
C       CMDSOL  =descriptor of method used for iterative solution
C       CMDFFT  =descriptor of method used for FFTs
C       CMDTRQ  =descriptor of whether or not to compute torques
C       CSHAPE  =descriptor of target shape, needed by subroutine ALPHA
C       CXE01R(1-3)=incident polarization state 1 at origin [in TF]
C       CXE02R(1-3)=incident polarization state 2 at origin [in TF]
C       CXEPS(1-NCOMP)=dielectric constant for compositions 1-NCOMP
C       EM1R(1-3,1-NSCAT)=unit scat. polarization vectors 1 in TF
C       EM2R(1-3,1-NSCAT)=unit scat. polarization vectors 2 in TF
C       ETASCA  =parameter controlling number of scattering angles used
c                for calculation of radiation force, <cos>, <cos^2>, and
c                radiation torque
C       IBETH   =MYID+IBETH1 if first time through combined BETA/THETA 
C                orientation loop
C       IBETH1  =starting value of IBETH (see above)
C       ICOMP(1-NAT3)=x,y,z "composition" for sites 1-NAT
C       IDVOUT  =device for running output
C       INIT    =0,1,2 for choice of |x0> for CCG method
C       IOCC(1-NAT)=0,1 if site in extended target is vacant,occupied
C       IORTH   =1,2 to do 1,2 orthogonal pol states
C       IPHI    =which phi value for target orientation
C       IPHI1   =starting value of IPHI (see above)
C       ITASK    not used
C       IXYZ0(1-MXNAT,1-3)=lattice coordinates for sites 1-NAT (in TF)
C                with sites 1-NAT0 in list being the occupied sites.
C       LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0=integers used to assign locations
C                in scratch array
C       MXCOMP  =dimensioning info: maximum number of allowed compositions
C       MXCXSC  =dimensioning info for complex scratch space
C       MXN3    =dimensioning info (3*max number of sites)
C       MXNAT   =dimensioning info (max number of sites)
C       MXNX    =dimensioning info (max x extent of target)
C       MXNY    =dimensioning info (max y extent of target)
C       MXNZ    =dimensioning info (max z extent of target)
C       MXPHI   =dimensioning info (max number of phi vals for targ. orient)
C       MXSCA   =dimensioning info (max number of scat. dirs for f_ml)
C       MYID    =parallel process identifier (=0 if only 1 process)
C       NAT     =number of sites in extended target
C       NAT0    =number of sites in original target
C       NAT3    =3*NAT
C       NCOMP   =number of different dielectric tensor elements in target
C       NSCAT   =number of scat. dirs for f_ml
C       NX      =x extent of extended target
C       NY      =y extent of extended target
C       NZ      =z extent of extended target
C       PHI(1-NPHI)=phi values target orientation
C       PHIN(1-NSCAT)=phi values for scat. dirs for f_ml comp.
C       PIA2    =\pi*(3*NAT/4\pi)^{2/3} (NAT=number of sites in original target)
C       SHPAR(1-6)=target shape parameters, needed by subroutine ALPHA
C       THETAN(1-NSCAT)=theta values for scat. dirs for f_ml comp
C       TOL     =tolerance for terminating conjugate gradient iteration
C
C and scratch space:
C       CXRLOC(1-MXCOMP+1,3,3)
C       CXSC(1-MXCXSC)=scratch space
C       CXSCR1(1-MXN3)=scratch space
C       CXZC(1-MXNX+1,1-MXNY+1,1-MXNZ+1,1-6)=scratch space
C       CXZW(1-MXNAT,1-24)=scratch space
C       SCRRS1(1-MXN3)=scratch space
C       SCRRS2(1-MXNAT)=scratch space
C
C Returns:
C
C       CXADIA(1-3,1-NAT)=diagonal elements of "A matrix"
C       CXAOFF(1-3,1-NAT)=off-diagonal elements of 3x3 blocks on
C                         diagonal of "A matrix"
C       CXALPH(1-3,1-NAT)=diagonal elements of 3x3 polarizability
C                         tensor for dipoles 1-NAT (in TF)
C       CXALOF(1-3,1-NAT)=off-diagonal elements of 3x3 polarizability
C                         tensor for dipoles 1-NAT
C       CXALDS(J,1-3)=(alpha_11,alpha_22,alpha_33)/d^3 for dipole J=1-NAT
C                     where alpha_ij is computed using Rahmani et al. (2002) 
C                     prescription. Serves as storage space so that the 
C                     calculation need not be done at every ALPHA call. 
C                     Only used if CALPHA.EQ.'SCLDR'
C       CXALOS(J,1-3)=(alpha_23,alpha_31,alpha_12)/d^3 for dipole J=1-NAT
C                     Off-diagonal polarizability elements corresponding 
C                     to the diagonal elements in CXALDS.
C       CXE(1-NAT3)=incident x,y,z E field at dipoles 1-NAT (in TF)
C       CXF11(1-NSCAT)=scattering matrix element f_11 for NSCAT dirs
C       CXF12(1-NSCAT)=                          f_12
C       CXF21(1-NSCAT)=                          f_21
C       CXF22(1-NSCAT)=                          f_22
C       CXPOL(1-NAT3)=x,y,z polarization of dipoles 1-NAT in TF
C       QABS(1-2)=Q_abs=C_abs/(PIA2*d**2) for incident pols 1,2
C       QBKSCA(1-2)=diff.scatt.cross section/(PIA2*d^2) for backscat
C                   for inc.pols.1,2
C       QEXT(1-2)=Q_ext=C_ext/(PIA2*d**2) for incident pols 1,2
C       QPHA(1-2)=phase shift cross section for incident pols 1,2
C       QSCA(1-2)=Q_sca=C_sca/(PIA2*d**2) for incident pols 1,2
C       QSCAG(1-3,1-2)=<cos(theta)>*Q_sca for incident pols 1,2
C                      <sin(theta)*cos(phi)>*Q_sca for incident pols 1,2
C                      <sin(theta)*sin(phi)>*Q_sca for incident pols 1,2
C                      [QSCAG(1-3,1-2) is in Lab Frame]
C       QSCAG2(1-2)   =<cos^2(theta)>*Q_sca for inciden tpols 1,2
C       QTRQAB(1-3,1-2)=vector torque cross section/(PIA2*d^2) for
C                      torque due to absorption, along axes 1-3, for
C                      incident pols 1,2
C                      [QTRQAB(1-3,1-2) is in Lab Frame]
C       QTRQSC(1-3,1-2)=vector torque cross section/(PIA2*d^2) for
C                      torque due to scattering, along axes 1-3, for
C                      incident pols 1,2
C                      [QTRQSC(1-3,1-2) is in Lab Frame]
C       TIMERS(1-12)=timing information
C       ITNUM(1-2)= number of iterations taken for polarizations 1 and 2
C       MXITER    = maximum number of iterations allowed.
C
C Requires:
C	MATVEC = external routine to compute A*x
C	CMATVEC = external routine to compute conjg(A')*x
C	where A is matrix such that A*pol=E
C	and x is arbitrary vector
C
C B.T.Draine, Princeton Univ. Observatory, 1990.
C History:
C 90.11.06 (BTD): modified to change argument list and pass array
C                 dimensions.
C 90.11.29 (BTD): further modifications, including arguments
C                 changed calls to EVALE
C 90.11.29 (BTD): changes to use REDUCE so that computations in
C                 EVALQ and SCAT are restricted to occupied sites.
C 90.11.30 (BTD): multiple changes to reduce storage requirements
C 90.12.03 (BTD): change ordering of XYZ0
C 90.12.10 (BTD): remove XYZ0 and use IXYZ0 instead
C 90.12.13 (BTD): add new argument to calls to EVALQ
C 91.01.03 (BTD): modified so that when IORTH=1 no attempt is made
C                 to compute f_{ml} for "standard" definition of
C                 incident pol. states defined by scattering plane.
C 91.05.09 (BTD): after call to SCAT, adjust QSCA and QSCAG to make
C                 QSCA=QEXT-QABS
C 91.05.09 (BTD): eliminate redundant write statement
C 91.08.14 (BTD): add QBKSCA to argument list for GETFML
C                 add CBKSCA to argument list for SCAT
C                 compute QBKSCA from CBKSCA
C 91.09.17 (BTD): move call to subroutine ALPHA from DDSCAT to GETFML
C                 (since polarizability from Lattice Dipersion Relation
C                 depends on direction of propagation and polarization)
C                 add CALPHA, CXEPS, ICOMP, MXCOMP to argument list for
C                 GETFML
C 93.01.14 (BTD): change method for computing QSCA to use result from
C                 SCAT when albedo << .01 , to use (QEXT-QABS) when
C                 albedo >> .01, and to smoothly join these limits.
C 93.03.11 (BTD): deleted all code associated with unused variable
C                 CMACHN (originally included to identify machine/OS)
C 93.07.09 (BTD): modify method for computing QSCA to use .03 as
C                 the dividing point rather than .01 .
C 93.11.23 (BTD): added SAVE E02 to preserve value of E02 between calls
C                 [to eliminate problem encountered on Silicon Graphics
C                 machines when IPHI>1]
C 94.06.20 (PJF): Added DTIME to argument list for TIMEIT
C 95.06.14 (BTD): Changed CSCAG from scalar to CSCAG(3) vector
C                 where CSCAG(1)=C_sca*<cos(theta)>
C                 Changed QSCAG(1-2) to QSCAG(1-3,1-2)
C                 Added CTRQSC(1-3) to argument list of SCAT
C                 Added QTRQSC(1-3,1-2) to argument list of GETFML
C 95.06.15 (BTD): Added variable CXE to argument list of SCAT
C                 Added CTRQAB(1-3) to argument list of SCAT
C                 Added QTRQAB(1-3,1-2) to argument list of GETFML
C 95.06.16 (PJF+: Modified to eliminate call to DDACCG and replace
C           BTD): with code to call PETR (a modularized implementation
C                 of the Petravic-Kuo CCG algorithm).  With this change
C                 it becomes easier to substitute other implementations
C                 of CCG (or other iterative methods, such as QMR).
C 95.06.19 (BTD): Added CMDSOL to argument list to select CCG method
C               : Added CMDTRQ to argument list to allow torque
C                 calculation to be skipped
C 95.07.10 (BTD): Changed calls to TIMEIT (was not doing timing
C                 properly)
C 95.07.17 (BTD): Relocated call to EVALQ.
C                 Call REDUCE to "reduce" CXE as well as CXP, prior
C                 to calling EVALQ and SCAT.
C 95.07.20 (BTD): Added scratch space SCRRS2 for use by SCAT
C                 Added scratch array CXZW(1-MXNAT,10-12) to SCAT
C                 argument list
C 95.07.27 (BTD): Revised way in which CXALPH is "reduced" prior to
C                 calls to EVALQ and SCAT.
C                 Revised to compute CXALPH for each incident E field
C                 [Only reason this is needed is because of slight
C                 dependence of polarizabilities on incident pol state]
C                 Added scratch space CXSCR1 to argument list, to store
C                 first polarization solution while solving for second
C 95.08.11 (BTD): Relocated CALL CINIT to precede IF statements for
C                 selection of solution method.
C 95.08.14 (BTD): Added COMMON/NORMERR/ERRSCAL to support desired
C                 normalization of error printed out by subroutine
C                 PROGRESS (part of cgcommon.f)
C 96.11.14 (PJF): ADD TIMERS, MXTIMERS, NTIMERS  to formal parameters
C                 modify code to return timer results
C                 TIMERS contains information needed to time the
C                 code (for example CPU time or number of iterations)
C                 timers(1) --- CG CPU time for all iterations
C                 timers(2) --- number of iterations needed
C                 timers(3) --- not used
C                 timers(4) --- scat CPU time
C                 ... see code for timers(5-12)
C 96.11.21 (BTD): declared MXTIMERS,NTIMERS,
C 97.02.20 (BTD): removed SNORM2 from EXTERNAL statement
C 97.11.01 (BTD): added DX(1-3) to argument list of GETFML
C                 and to argument lists for EVALE, ALPHA, and SCAT
C                 [development of DDSCAT.6.0]
C 97.12.26 (BTD): added CXALOF to argument list of GETFML
C                 and to argument list of ALPHA, EVALA
C                 [development of DDSCAT.6.0]
C 98.01.01 (BTD): added 2 calls to new routine RESTORE to expand
C                 CXADIA and CXAOFF back to 3*NAT elements after they
C                 have been "reduced" to 3*NAT0 for efficient 
C                 execution of EVALQ
C 98.04.27 (BTD): added declarations for arguments CXAOFF and CXALOF
C                 [development of DDSCAT.6.0]
C                 only call CXALPH once for each orientation, since
C                 in new form of Lattice Dispersion Relation the
C                 polarizability does not depend on polarization,
C                 although it does depend on direction of propagation
C 98.11.18 (BTD): corrected misleading comments apropos EM1R,EM2R
C 98.12.04 (BTD): located error which resulted in subsequent incorrect
C                 evaluation of Mueller scattering matrix.
C                 Problem arose because at some point it was decided to
C                 convert to usual convention for incident polarization
C                 states 1 and 2 for computation of f_ml (CXF11,...)
C                 Unfortunately, this was forgotten, and subroutine
C                 GETMUELLER was written assuming that incident pol. 
C                 states l=1 and 2 referred to by f_ml were the ones 
C                 specified by the user in ddscat.par.  Because this in
C                 fact does seem preferable, we conform to this 
C                 prescription and have disabled the portion of GETFML
C                 which converted to the "usual" convention.  Note
C                 that since f_ml is now entirely for internal use,
C                 (except when IORTH=1, but then we do not compute
C                 Muller matrix) there is no motivation to adopt usual 
C                 convention.
C 98.12.07 (BTD): Experiment to verify claimed accuracy from PIM
C                 New module has been inserted into code below but
C                 commented out after verifying that reported errors
C                 appear to be close to "true" errors.
C                 However, module can be reactivated by uncommenting
C                 if such verification is desired in future.  Search
C                 below for string "98.12.07" to find the 2 modules. 
C 98.12.16 (BTD): Increase upper limit on number of iterations from 300
C                 to 10000
C 03.01.29 (BTD): returned CXE0R to argument list for ALPHA
C                 reactived calls to ALPHA for different polarizations
C                 since now using LATTDR again instead of GKDLDR
c 03.04.12 (BTD): added variables ITNUM(2) and MXITER to argument list
C                 and modified code to assign values to them
c                 added veriables ITERN and ITERMX
c 03.10.23 (BTD): modified argument list for SCAT:
c                    eliminated ICTHM and IPHIM
c                    added CSCAG2 and NAVG
c                 modified argument list of GETFML
c                    eliminated ICTHM and IPHIM
c 03.10.24 (BTD): added ETASCA to argument list
c                 and to argument list of SCAT
c 04.03.31 (BTD): changed WRITE(0 to WRITE(IDVOUT
c 04.05.22 (BTD): cleanup: comment out declarations of unused variables
c                 CXVAR1,CXVAR1,CXONE,CXZERO
c                 remove IF(IPHIM.GT.1) test, and always store
c                 first polarization (even if only doing one
c                 target orientation, overhead is not significant)
c 04.05.22 (BTD): fixed bug in computation of true error
c                 was summing from 3*I+1 to 3*I+3
c                 now sum from 3*I-2 to 3*I
C end history
C
C Copyright (C) 1993,1994,1995,1996,1997,1998,2003,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
      IMPLICIT NONE
C
C Arguments:
C
      CHARACTER CALPHA*6,CMDSOL*6,CMDFFT*6,CMDTRQ*6,CSHAPE*6
C
      INTEGER IBETH,IBETH1,ICTHM,IDVOUT,INIT,IORTH,IPHI,IPHI1,IPHIM,
     &        ITASK,LACE,LAXI,LCLM,LGI,LPI,LSC0,LQI,
     &        MXCOMP,MXCXSC,MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPHI,MXSCA,
     &        MXTIMERS,MYID,
     &        NAT,NAT0,NAT3,NAVG,NCOMP,NSCAT,NTIMERS,NX,NY,NZ

      INTEGER MXITER
      INTEGER ITNUM(2)
C
      INTEGER*2 ICOMP(MXN3),IOCC(MXNAT),IXYZ0(MXNAT,3)
C
      REAL AK3,ETASCA,PIA2,TOL
C
      REAL AKR(3),AKSR(3,MXSCA),DX(3),EM1R(3,MXSCA),EM2R(3,MXSCA),
     &     PHI(MXPHI),PHIN(MXSCA),
     &     QABS(2),QBKSCA(2),QEXT(2),QPHA(2),QSCA(2),QSCAG(3,2),
     &     QSCAG2(2),QTRQAB(3,2),QTRQSC(3,2),
     &     SCRRS1(MXN3),SCRRS2(MXNAT),SHPAR(6),
     &     THETAN(MXSCA),TIMERS(MXTIMERS)
C
      COMPLEX CXADIA(MXN3),CXALPH(MXN3),CXALOF(MXN3),CXAOFF(MXN3),
     &        CXALDS(NAT,3),CXALOS(NAT,3),
     &        CXE(MXN3),CXE01R(3),CXE02R(3),CXEPS(MXCOMP),
     &        CXF11(MXSCA),CXF12(MXSCA),CXF21(MXSCA),CXF22(MXSCA),
     &        CXRLOC(MXCOMP+1,3,3),
     &        CXPOL(MXN3),CXSC(MXCXSC),CXSCR1(MXN3),
     &        CXZC(MXNX+1,MXNY+1,MXNZ+1,6),
     &        CXZW(MXNAT,24)
C
C Common:
C
      INTEGER IDVOUT2,ITERMX,ITERN
      REAL ERRSCAL
C-----------------------------------------------------------------------
      COMMON/NORMERR/ERRSCAL,IDVOUT2,ITERMX,ITERN
C-----------------------------------------------------------------------
C
C Local variables
C
c      COMPLEX CXONE,CXZERO
c      COMPLEX CXVAR1,CXVAR2
      COMPLEX CXE0R(3)
C
      INTEGER I,J,JO,NAT03
C
      INTEGER IPAR(13)
C
      REAL
     &  CABS,CBKSCA,CEXT,CPHA,CSCA,CSCAG2,COSPHI,
     &  DTIME,DUMMY,E02,FALB,SINPHI
C
      REAL CSCAG(3),CTRQAB(3),CTRQSC(3),SPAR(6)
C
      SAVE E02
C      SAVE CXONE,CXZERO
C
      EXTERNAL CMATVEC,DIAGL,MATVEC,PCSUM,PROGRESS,PSCNRM2
C
C      DATA CXONE/(1.0,0.)/,CXZERO/(0.,0.)/
      IDVOUT2=IDVOUT
      NAT03=3*NAT0
C
C*** Compute fml directly only if IPHI=1
C    Otherwise use previously computed fml values to obtain new fml
C
      IF(IPHI.EQ.1)THEN
C
C Compute dipole polarizabilities for this direction of
C propagation.  Note that prescription now being used for
C dipole polarizabilities is independent of polarization of
C the incident electric field, therefore we need only call
C ALPHA once for each new direction of incidence.
C
C collinge: the above statement is incorrect, I think. I am 
C           moving the call to alpha inside the polarization state
C           loop.
C
C         CALL ALPHA(AKR,CALPHA,CXALDS,CXALPH,CXALOF,CXALOS,
C     &        CXE0R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH,IBETH1,
C     &        ICOMP,IOCC,IPHI,IPHI1,IXYZ0,JORTH,MYID,MXCOMP,MXNAT,
C     &        MXN3,NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,CXRLOC,CSHAPE,SHPAR)
C
C*** call EVALA to prepare A matrix elements
C
C         CALL EVALA(CXADIA,CXAOFF,CXALPH,CXALOF,MXN3,NAT)

         DO JO=1,IORTH
            IF(JO.EQ.1)THEN
               CXE0R(1)=CXE01R(1)
               CXE0R(2)=CXE01R(2)
               CXE0R(3)=CXE01R(3)
            ELSE
               CXE0R(1)=CXE02R(1)
               CXE0R(2)=CXE02R(2)
               CXE0R(3)=CXE02R(3)
C collinge: restore calls are not needed now.
C               CALL RESTORE(CXADIA,CXONE,IOCC,MXN3,MXNAT,NAT,NAT0)
C               CALL RESTORE(CXAOFF,CXZERO,IOCC,MXN3,MXNAT,NAT,NAT0)
            ENDIF
            E02=0.
            DO I=1,3
               E02=E02+REAL(CXE0R(I)*CONJG(CXE0R(I)))
            ENDDO
C
C Compute quantity used for "normalizing" error:
C
            ERRSCAL=SQRT(NAT0*E02)
C
C*** call EVALE for NAT sites

            CALL EVALE(CXE0R,AKR,DX,IXYZ0,MXNAT,MXN3,NAT,NAT0,
     &                 NX,NY,NZ,CXE)

C collinge: relocated ALPHA and EVALA calls here.

C***call ALPHA to determine polarizabilities at NAT sites
C    (note: this has to be within the loop over directions and
C     polarizations because Lattice Dispersion Relation polarizabilities
C     depend on direction of propagation and on polarization state)

            CALL ALPHA(AKR,CALPHA,CXALDS,CXALPH,CXALOF,CXALOS,
     &           CXE0R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH,IBETH1,
     &           ICOMP,IOCC,IPHI,IPHI1,IXYZ0,JO,MYID,MXCOMP,MXNAT,
     &           MXN3,NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,CXRLOC,CSHAPE,SHPAR)

C*** call EVALA to prepare A matrix elements

            CALL EVALA(CXADIA,CXAOFF,CXALPH,CXALOF,MXN3,NAT)

C*** first call to timeit:

            CALL TIMEIT(' SOLVER',DTIME)

C Version 4c called DDACCG at this point.  This call to DDACCG is
C replaced with code to
C (1) define parameters IPAR(1),IPAR(4),IPAR(10),SPAR(1)
C (2) call nuller to "clean" CXE (i.e., set to zero at unoccupied sites).
C (3) initialize first guess for cxpol=0
C
C Notation:
C ipar(1) LDA         LDA (Leading dimension of a)
C ipar(2) N           N   (Number of rows/columns of a)
C ipar(3) BLKSZ       N   (Size of block of data; used when data is
C                          partitioned using cyclic mode)
C ipar(4) LOCLEN      N   (Number of elements stored locally; for
C                          sequential=n)
C ipar(5) BASISDIM    C=basis=10 (Dimension of orthogonal basis, used in
C                                 GMRES)
C ipar(6) NPROCS      -1 (Number of processors)
C ipar(7) PROCID      -1 (Processor identification)
C ipar(8) PRECONTYPE PRET (=1 Type of preconditioning
C                     0-no preconditioning, 1-left, 2-right, 3-symmetric
C ipar(9) STOPTYPE   STOPT (Type of stopping criteria used)
C ipar(10) MAXIT     MAXIT (=int(n/2) Maximum number of iterations allowed)
C      IPAR(11) = -1 itno   (Number of iterations executed)
C      IPAR(12) = -1 status (On exit of iterative method; 0-converged)
C      IPAR(13) = -1 steperr 
C
            IPAR(1)=MXN3
            IPAR(2)=NAT3
            IPAR(3)=NAT3
            IPAR(4)=NAT3
            IPAR(6)=-1
            IPAR(7)=-1

c Increase upper limit from 300 to 10000 iterations
c            IPAR(10)=MIN(300,NAT03)

            IPAR(10)=MIN(10000,NAT03)
            MXITER=IPAR(10)

c pass information on max.no. of iterations allowed to COMMON/NORMERR/

            ITERMX=IPAR(10)
C
            SPAR(1)=TOL
C
C Clean CXE:
C
            IF(NAT0.LT.NAT)CALL NULLER(CXE,IOCC,MXNAT,MXN3,NAT)
C
C Initialize CXPOL (first guess)
C
            CALL CINIT(NAT3,CMPLX(0.,0.),CXPOL,1)
C
C Iterate to improve CXPOL
C
            IF(CMDSOL.EQ.'PETRKP')THEN
               IPAR(5)=-1
               IPAR(8)=1
C
C Note: PETR cannot be used with STOPTYPE=2 -- code crashes when
C calling STOPCRIT.  Stick with STOPTYPE=5
C
               IPAR(9)=5
               CALL PETR(CXPOL,CXE,CXSC,MXN3,IPAR,SPAR,MATVEC,CMATVEC)
C
C-----------------------------------------------------------------------
C 98.12.07 BTD Experiment to verify claimed accuracy from PETR.
C              This module is superfluous and could be excised without
C              affecting computed results, thereby eliminating
C              unnecessary computations.

               CALL MATVEC(CXPOL,CXSC,IPAR)
               DUMMY=0.
               DO I=1,NAT
                  IF(IOCC(I).GE.1)THEN
                     DO J=3*I-2,3*I
                        DUMMY=DUMMY+
     &                     REAL(CONJG(CXSC(J)-CXE(J))*(CXSC(J)-CXE(J)))
                     ENDDO
                  ENDIF
               ENDDO
               DUMMY=SQRT(DUMMY/(NAT0*E02))
               WRITE(IDVOUT,9200)DUMMY
C-----------------------------------------------------------------------
C
C second call to timeit:
C
               CALL TIMEIT('PETRKP',DTIME)
               TIMERS(1)=DTIME
               TIMERS(2)=FLOAT(IPAR(11))
            ELSEIF(CMDSOL.EQ.'PBCGST')THEN
               IPAR(5)=-1
               IPAR(8)=1

C PIMCBICGSTAB appears to be about 25% slower (per iteration) when
C called with STOPTYPE=2 rather than 5.  Therefore use STOPTYPE=2
C even though actual stopping criterion used is complicated by
C preconditioning.

               IPAR(9)=5

               CALL PIMCBICGSTAB(CXPOL,CXE,CXSC,IPAR,SPAR,MATVEC,
     &                           DIAGL,
     &                           DUMMY,PCSUM,PSCNRM2,PROGRESS)

C----------------------------------------------------------------------
C 98.12.07 BTD Experiment to verify claimed accuracy from PIM.
C              This module is superfluous and could be excised without
C              affecting computed results, thereby eliminating
C              unnecessary computations.

               CALL MATVEC(CXPOL,CXSC,IPAR)
               DUMMY=0.
               DO I=1,NAT
                  IF(IOCC(I).GE.1)THEN
                     DO J=3*I-2,3*I
                        DUMMY=DUMMY+
     &                     REAL(CONJG(CXSC(J)-CXE(J))*(CXSC(J)-CXE(J)))
                     ENDDO
                  ENDIF
               ENDDO
               DUMMY=SQRT(DUMMY/(NAT0*E02))
               WRITE(IDVOUT,9200)DUMMY
C----------------------------------------------------------------------

C second call to timeit:

               CALL TIMEIT('PBCGST',DTIME)

               TIMERS(1)=DTIME

               TIMERS(2)=FLOAT(IPAR(11))

            ELSE
               STOP'Error -- invalid CMDSOL in getfml'
            ENDIF

C*** Reduce the vectors CXADIA, CXAOFF, CXPOL and CXE to retain only 
C    occupied sites, to eliminate unnecessary calculations for 
C    unoccupied sites when calling EVALQ and SCAT

            CALL REDUCE(CXADIA,IOCC,MXN3,MXNAT,NAT,NAT0)
            CALL REDUCE(CXAOFF,IOCC,MXN3,MXNAT,NAT,NAT0)
            CALL REDUCE(CXE,IOCC,MXN3,MXNAT,NAT,NAT0)
            CALL REDUCE(CXPOL,IOCC,MXN3,MXNAT,NAT,NAT0)

            ITNUM(JO)=ITERN

C*** Store reduced polarization vector P
C    for use in subsequent computations for other phi values
C    CXSCR1     for JO=1
C    CXSC(LACE) for JO=2 (this scratch space no longer needed by solver)

cdelete            IF(IPHIM.GT.1)THEN
               IF(JO.EQ.1)THEN
                  CALL COPYIT(CXPOL,CXSCR1,NAT03)
               ELSEIF(JO.EQ.2)THEN
                  CALL COPYIT(CXPOL,CXSC(LACE),NAT03)
               ENDIF
cdelete            ENDIF

            CALL EVALQ(CXADIA,CXAOFF,AKR,NAT03,E02,CXE,CXPOL,
     &                 CABS,CEXT,CPHA,MXN3,1)

            QABS(JO)=CABS/PIA2
            QEXT(JO)=CEXT/PIA2
            QPHA(JO)=CPHA/PIA2
            WRITE(IDVOUT,9010)QABS(JO),QEXT(JO)

C*** first call to timeit:

            CALL TIMEIT(' SCAT ',DTIME)

            IF(JO.EQ.1)THEN

               CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,
     &                CBKSCA,CSCA,CSCAG,CSCAG2,CTRQAB,CTRQSC,
     &                CXE,CXE01R,CXF11,CXF21,CXPOL,
     &                CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),
     &                MXN3,MXNAT,MXSCA,NAT0,NAT03,NAVG,NSCAT,
     &                PHIN,SCRRS1,SCRRS2,THETAN,IXYZ0)

            ELSEIF(JO.EQ.2)THEN

               CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,
     &                CBKSCA,CSCA,CSCAG,CSCAG2,CTRQAB,CTRQSC,
     &                CXE,CXE01R,CXF12,CXF22,CXPOL,
     &                CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),
     &                MXN3,MXNAT,MXSCA,NAT0,NAT03,NAVG,NSCAT,
     &                PHIN,SCRRS1,SCRRS2,THETAN,IXYZ0)

            ENDIF

C*** second call to timeit

            CALL TIMEIT(' SCAT ',DTIME)

            TIMERS(4)=DTIME
            QBKSCA(JO)=CBKSCA/PIA2
            QSCA(JO)=CSCA/PIA2

C*** Since Q_ext and Q_abs are calculated "exactly", when particles
C    are "large" we obtain Q_sca from (Q_ext-Q_abs) rather than
C    scattering cross section computed by SCAT.  This is particularly
C    advantageous when the particles are large with complex scattering
C    patterns, so that angular integration of the differential scattering
C    cross section would be either very time-consuming or inaccurate.
C    However, when particles are "small" the scattering cross section
C    is small compared to Q_ext and Q_abs, so that the difference
C    (Q_ext-Q_abs) may be inaccurate.  Accordingly, when particles
C    are "small" we instead accept the scattering cross section
C    computed by SCAT (probably quite accurate when albedo is small because
C    the scattering pattern tends to be dipolar and therefore well-resolved
C    by a reasonable number of scattering directions ICTHM and IPHI).
C    We use an ad-hoc procedure to smoothly make the transitions
C    between these regimes, based on the albedo.
C    The "dividing" line of albedo=.03 is chosen on basis of
C    numerical experiments.  If Q_ext and Q_abs are each calculated to
C    accuracy of 1 times 10^{-4} (say), then the
C    difference between Q_ext and Q_abs would be accurate to
C    0.0001*Q_ext*sqrt(2) .  When albedo=.03 (Q_ext-Q_abs)/Q_sca would
C    then be accurate to .0001*sqrt(2)/.03=.005

            FALB=(QSCA(JO)/(.03*QEXT(JO)))**2
            QSCA(JO)=(QSCA(JO)+(QEXT(JO)-QABS(JO))*FALB)/(1.+FALB)

C    Compute QSCAG(1-3,JO), QTRQSC(1-3,JO), QSCAG2

            DO I=1,3
               QSCAG(I,JO)=QSCA(JO)*CSCAG(I)/CSCA
            ENDDO
            QSCAG2(JO)=QSCA(JO)*CSCAG2/CSCA
            IF(CMDTRQ.EQ.'DOTORQ')THEN
               DO I=1,3
                  QTRQAB(I,JO)=CTRQAB(I)/PIA2
                  QTRQSC(I,JO)=CTRQSC(I)/PIA2
               ENDDO
            ENDIF

         ENDDO

      ELSEIF(IPHI.GE.2)THEN

C*** Have previously computed dipole polarization vectors for
C    first phi value (and reduced them to NAT03 elements).
C    Use these two solutions to obtain Qabs, Qext, Qpha, Qsca, g*Qsca,
C    and fml for any additional values of target rotation phi.
C    CXSCR1     contains polarization vector for IPHI=1 and JO=1
C    CXSC(LACE) contains polarization vector for IPHI=1 and JO=2
C
C Incident polarization state 1 = CXE01R
C Call EVALE to obtain E at NAT0 occupied lattice sites
C first call to timing routine
C

         CALL TIMEIT(' EVALE',DTIME)

C*** Call EVALE for NAT0 occupied sites

         CALL EVALE(CXE01R,AKR,DX,IXYZ0,MXNAT,MXN3,NAT0,NAT0,
     &              NX,NY,NZ,CXE)

C second call to timing routine

         CALL TIMEIT(' EVALE',DTIME)
         TIMERS(5)=DTIME

C Compute polarizabilities at NAT sites, then reduce to NAT0 occupied
C sites:

         CALL TIMEIT(' ALPHA',DTIME)
         CALL ALPHA(AKR,CALPHA,CXALDS,CXALPH,CXALOF,CXALOS,
     &        CXE01R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH,IBETH1,
     &        ICOMP,IOCC,IPHI,IPHI1,IXYZ0,1,MYID,MXCOMP,MXNAT,MXN3,
     &        NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,CXRLOC,CSHAPE,SHPAR)
         CALL REDUCE(CXALPH,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL REDUCE(CXALOF,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL TIMEIT(' ALPHA',DTIME)
         TIMERS(6)=DTIME

C*** Construct polarization for incident pol. state 1

         COSPHI=COS(PHI(IPHI)-PHI(1))
         SINPHI=SIN(PHI(IPHI)-PHI(1))
         DO I=1,NAT03
            CXPOL(I)=COSPHI*CXSCR1(I)-SINPHI*CXSC(LACE+I-1)
         ENDDO

C*** first call to timing routine

         CALL TIMEIT(' EVALQ',DTIME)

         CALL EVALQ(CXADIA,CXAOFF,AKR,NAT03,E02,CXE,CXPOL,
     &              CABS,CEXT,CPHA,MXN3,1)

C*** second call to timing routine

         CALL TIMEIT(' EVALQ',DTIME)
         TIMERS(7)=DTIME

         QABS(1)=CABS/PIA2
         QEXT(1)=CEXT/PIA2
         QPHA(1)=CPHA/PIA2

C*** first call to timing routine

         CALL TIMEIT(' SCAT',DTIME)

C*** Now call SCAT
C    CXPOL has been reduced to NAT03 elements
C    first NAT03 elements of IXYZ0 correspond to physical sites

         CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,
     &             CBKSCA,CSCA,CSCAG,CSCAG2,CTRQAB,CTRQSC,
     &             CXE,CXE01R,CXF11,CXF21,CXPOL,
     &             CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),
     &             MXN3,MXNAT,MXSCA,NAT0,NAT03,NAVG,NSCAT,
     &             PHIN,SCRRS1,SCRRS2,THETAN,IXYZ0)

C*** second call to timing routine

         CALL TIMEIT(' SCAT',DTIME)
         TIMERS(8)=DTIME

         QBKSCA(1)=CBKSCA/PIA2
         QSCA(1)=CSCA/PIA2

C*** As above, compute Q_sca from either SCAT or (Q_ext-Q_abs)
C    depending on whether albedo << .03 or albedo >> .03

         FALB=(QSCA(1)/(.03*QEXT(1)))**2
         QSCA(1)=(QSCA(1)+(QEXT(1)-QABS(1))*FALB)/(1.+FALB)
         DO I=1,3
            QSCAG(I,1)=QSCA(1)*CSCAG(I)/CSCA
            QTRQAB(I,1)=CTRQAB(I)/PIA2
            QTRQSC(I,1)=CTRQSC(I)/PIA2
         ENDDO
         QSCAG2(1)=QSCA(1)*CSCAG2/CSCA

C*** Polarization state 2:

C*** first call to timing routine

         CALL TIMEIT(' EVALE',DTIME)

C*** Call EVALE for NAT0 occupied sites
C    to obtain appropriate E vector for pol. state 2

         CALL EVALE(CXE02R,AKR,DX,IXYZ0,MXNAT,MXN3,NAT0,NAT0,
     &              NX,NY,NZ,CXE)

C*** second call to timing routine

         CALL TIMEIT(' EVALE',DTIME)
         TIMERS(9)=DTIME

C Compute polarizabilities at NAT sites, then reduce to NAT0 occupied
C sites:

         CALL TIMEIT(' ALPHA',DTIME)
         CALL ALPHA(AKR,CALPHA,CXALDS,CXALPH,CXALOF,CXALOS,
     &        CXE02R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH,IBETH1,
     &        ICOMP,IOCC,IPHI,IPHI1,IXYZ0,2,MYID,MXCOMP,MXNAT,MXN3,
     &        NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,CXRLOC,CSHAPE,SHPAR)
         CALL REDUCE(CXALPH,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL REDUCE(CXALOF,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL TIMEIT(' ALPHA',DTIME)
         TIMERS(10)=DTIME

C*** Construct incident polarization vector for pol. state 2

         DO I=1,NAT03
            CXPOL(I)=COSPHI*CXSC(LACE+I-1)+SINPHI*CXSCR1(I)
         ENDDO

C*** first call to timing routine

         CALL TIMEIT(' EVALQ ',DTIME)
C
         CALL EVALQ(CXADIA,CXAOFF,AKR,NAT03,E02,CXE,CXPOL,
     &              CABS,CEXT,CPHA,MXN3,1)

C*** second call to timing routine

         CALL TIMEIT(' EVALQ ',DTIME)
         TIMERS(11)=DTIME
C
         QABS(2)=CABS/PIA2
         QEXT(2)=CEXT/PIA2
         QPHA(2)=CPHA/PIA2

C*** Call SCAT
C    CXPOL has NAT03 elements
C    IXYZ0 was initially given NAT03 elements

C*** first call to timing routine:

         CALL TIMEIT(' SCAT',DTIME)
         CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,
     &             CBKSCA,CSCA,CSCAG,CSCAG2,CTRQAB,CTRQSC,
     &             CXE,CXE01R,CXF12,CXF22,CXPOL,
     &             CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),
     &             MXN3,MXNAT,MXSCA,NAT0,NAT03,NAVG,NSCAT,
     &             PHIN,SCRRS1,SCRRS2,THETAN,IXYZ0)

C*** second call to timing routine

         CALL TIMEIT(' SCAT',DTIME)
         TIMERS(12)=DTIME

         QBKSCA(2)=CBKSCA/PIA2
         QSCA(2)=CSCA/PIA2

C*** As above, compute Q_sca from either SCAT or (Q_ext-Q_abs)
C    depending on whether albedo << .03 or albedo >> .03

         FALB=(QSCA(2)/(.03*QEXT(2)))**2
         QSCA(2)=(QSCA(2)+(QEXT(2)-QABS(2))*FALB)/(1.+FALB)
         DO I=1,3
            QSCAG(I,2)=QSCA(2)*CSCAG(I)/CSCA
            QTRQAB(I,2)=CTRQAB(I)/PIA2
            QTRQSC(I,2)=CTRQSC(I)/PIA2
         ENDDO
         QSCAG2(2)=QSCA(2)*CSCAG2/CSCA

      ENDIF

C*** If IORTH=2, then we have results for two incident polarization
C    states CXE01R and CXE02R, and it is possible to compute f_{ml} for
C    standard definition of f_{ml} in terms of incident polarization
C    states 1 and 2 defined by the scattering plane.
C    If, however, computations were done for IORTH=1, then results
C    exist only for single incident polarization state CXE01R, and
C    it is not possible to construct results for incident polarization
C    states defined by the scattering plane.  In this case we therefore
C    use results for f_{m1}, where polarization state 1 = CXE01R.
C
c BTD 98.12.04 disable and keep "primitive" f_ml----------------------
c     IF(IORTH.EQ.2)THEN
C*** Values of CXF11, CXF12, CXF21, CXF22 are for incident polarization
C    states CXE01R and CXE02R.  Now convert to standard definition of
C    f_{ml}: incident pol states 1 and 2 defined by scattering plane
c         DO I=1,NSCAT
c            CXVAR1=CXF11(I)
c            CXVAR2=CXF21(I)
c            COSPHI=COS(PHIN(I))
c            SINPHI=SIN(PHIN(I))
c            CXF11(I)=COSPHI*CXVAR1+SINPHI*CXF12(I)
c            CXF21(I)=COSPHI*CXVAR2+SINPHI*CXF22(I)
c            CXF12(I)=COSPHI*CXF12(I)-SINPHI*CXVAR1
c            CXF22(I)=COSPHI*CXF22(I)-SINPHI*CXVAR2
c         ENDDO
c      ENDIF
c----------------------------------------------------------------------

      RETURN
 9010 FORMAT(1X,'Q_abs =',1PE10.3,' Q_ext= ',E10.3)
 9200 FORMAT(' final true frac.err=',F12.7)
      END

      SUBROUTINE EVALA(CXADIA,CXAOFF,CXALPH,CXALOF,MXN3,NAT)
      IMPLICIT NONE
C*** Arguments:
      INTEGER MXN3,NAT
      COMPLEX CXADIA(MXN3),CXALOF(MXN3),CXALPH(MXN3),CXAOFF(MXN3)

C*** Local variables:
      INTEGER J1,J2,J3
      COMPLEX CX1,CX2,CX3,DENOM

C*********************************************************************
C Subroutine EVALA
C Purpose: to evaluate 3x3 diagonal blocks of matrix A for use in
C discrete-dipole scattering calculation.
C
C Given:   CXALPH(J,1-3)=(alpha_11,alpha_22,alpha_33) where alpha=
C                         complex polarizability tensor 
C                         of dipole J (J=1-NAT, first 3*NAT elements
C                         of CXALPH used)
C          CXALOF(J,1-3)=(alpha_23,alpha_31,alpha_12) for dipole J
C                        (J=1-NAT, first 3*NAT elements of CXALOF used)
C          NAT=number of dipoles
C          MXN3,MXNAT=dimensioning information

C Returns: CXADIAG(1-3*NAT)=diagonal elements of matrix A
C          CXAOFF(J,1-3)=(a_23,a_31,a_12) where a_ij=3x3 matrix
C                        equal to inverse of 3x3 matrix alpha_ij
C                        for dipole J (first 3*NAT elements of CXAOFF
C                        are used)

C Note that it is assumed that vectors E and P will have data
C in order E_1x,E_2x,...,E_Nx,E_1y,E_2y,...,E_Ny,E_1z,E_2z,...,E_Nz
C
C B. T. Draine, Princeton Univ. Obs., 87.01.07
C History:
C 88.05.05 (BTD): Modifications...
C 90.11.06 (BTD): Modified to pass array dimensions
C 97.12.25 (BTD): Added CXAOFF,CXALOF to argument list
C                 Modified to allow nondiagonal polarizabilities
C                 alpha_ij
C 98.01.01 (BTD): Correct inconsistency in assumed data ordering.
C
C End history
C Copyright (C) 1993,1997,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C***********************************************************************
C Given symmetric matrix m with six independent elements a1, a2, a3, b1,
C b2, b3 (see below), we seek inverse matrix M with six independent
C elements A1, A2, A3, B1, B2, B3 such that
C
C      (a1 b3 b2)   (A1 B3 B2)   (1 0 0)
C      (b3 a2 b1) x (B3 A2 B1) = (0 1 0)
C      (b2 b1 a3)   (B2 B1 A3)   (0 0 1)
C
C solution:
C                     a2*a3 - b1*b1
C A1 = ----------------------------------------------
C      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2
C
C                     a3*a1 - b2*b2
C A2 = ----------------------------------------------
C      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2
C
C                     a1*a2 - b3*b3
C A3 = ----------------------------------------------
C      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2
C
C                     b2*b3 - a1*b1
C B1 = ----------------------------------------------
C      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2
C
C                     b3*b1 - a2*b2
C B2 = ----------------------------------------------
C      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2
C
C                     b1*b2 - a3*b3
C B3 = ----------------------------------------------
C      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2
C
C***********************************************************************
C
      DO 100 J1=1,NAT
         J2=J1+NAT
         J3=J2+NAT
         CX1=CXALOF(J1)**2
         CX2=CXALOF(J2)**2
         CX3=CXALOF(J3)**2
         DENOM=CXALPH(J1)*CXALPH(J2)*CXALPH(J3)+
     &         2.*CXALOF(J1)*CXALOF(J2)*CXALOF(J3)-
     &         CXALPH(J1)*CX1-CXALPH(J2)*CX2-CXALPH(J3)*CX3
         CXADIA(J1)=(CXALPH(J2)*CXALPH(J3)-CX1)/DENOM
         CXADIA(J2)=(CXALPH(J3)*CXALPH(J1)-CX2)/DENOM
         CXADIA(J3)=(CXALPH(J1)*CXALPH(J2)-CX3)/DENOM
         CXAOFF(J1)=(CXALOF(J2)*CXALOF(J3)-CXALPH(J1)*CXALOF(J1))/DENOM
         CXAOFF(J2)=(CXALOF(J3)*CXALOF(J1)-CXALPH(J2)*CXALOF(J2))/DENOM
         CXAOFF(J3)=(CXALOF(J1)*CXALOF(J2)-CXALPH(J3)*CXALOF(J3))/DENOM
  100 CONTINUE
      RETURN
C
      END

      SUBROUTINE RESTORE(CXV,CXUNOC,IOCC,MXN3,MXNAT,NAT,NAT0)
      IMPLICIT NONE
C***********************************************************************
C Given:
C      CXV(1-3*NAT0) defined for NAT0 occupied lattice sites
C      IOCC(1-NAT) = 0 or 1 depending on whether lattice site
C                      is vacant or occupied
C      CXUNOC      = value to use for unoccupied sites 
C      MXN3,MXNAT  = dimensioning information
C      NAT         = number of lattice sites
C      NAT0        = number of occupied lattice sites
C Returns
C      CXV(1-3*NAT) defined for NAT lattice sites, occupied and 
C                   unoccupied, with CXV(J)=CXFILL for unoccupied sites
C Arguments:
      INTEGER MXN3,MXNAT,NAT,NAT0
      INTEGER*2 IOCC(MXNAT)
      COMPLEX CXUNOC
      COMPLEX CXV(MXN3)
C Local variables:
      INTEGER J,JUN,M
C
C B.T.Draine, Princeton Univ. Observatory
C History:
C 98.01.01 (BTD): Created for use in DDSCAT.6
C end history
C
C Copyright (C) 1998, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DO 20 M=2,0,-1
         JUN=NAT-NAT0
         DO 10 J=NAT,1,-1
            IF(IOCC(J).EQ.0)THEN
               JUN=JUN-1
               CXV(J+M*NAT)=CXUNOC
            ELSE
               CXV(J+M*NAT)=CXV(M*NAT0+J-JUN)
            ENDIF
  10     CONTINUE
  20  CONTINUE
      RETURN
      END

      subroutine caxpy(n,ca,cx,incx,cy,incy)
c
c     constant times a vector plus a vector.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      complex cx(*),cy(*),ca
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
      if (abs(real(ca)) + abs(aimag(ca)) .eq. 0.0 ) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        cy(iy) = cy(iy) + ca*cx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
   20 do 30 i = 1,n
        cy(i) = cy(i) + ca*cx(i)
   30 continue
      return
      end
      subroutine  cscal(n,ca,cx,incx)
c
c     scales a vector by a constant.
c     jack dongarra, 3/11/78.
c     modified to correct problem with negative increment, 8/21/90.
c
      complex ca,cx(1)
      integer i,incx,ix,n
c
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      do 10 i = 1,n
        cx(ix) = ca*cx(ix)
        ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 do 30 i = 1,n
        cx(i) = ca*cx(i)
   30 continue
      return
      end
      subroutine  cswap (n,cx,incx,cy,incy)
c
c     interchanges two vectors.
c     jack dongarra, 3/11/78.
c
      complex cx(1),cy(1),ctemp
      integer i,ix,iy,n,incx,incy
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        ctemp = cx(ix)
        cx(ix) = cy(iy)
        cy(iy) = ctemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c       code for both increments equal to 1
   20 do 30 i = 1,n
        ctemp = cx(i)
        cx(i) = cy(i)
        cy(i) = ctemp
   30 continue
      return
      end

      integer function icamax(n,cx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      complex cx(*)
      real smax
      integer i,incx,ix,n
      complex zdum
      real cabs1
      cabs1(zdum) = abs(real(zdum)) + abs(aimag(zdum))
c
      icamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      icamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = cabs1(cx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(cabs1(cx(ix)).le.smax) go to 5
         icamax = i
         smax = cabs1(cx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = cabs1(cx(1))
      do 30 i = 2,n
         if(cabs1(cx(i)).le.smax) go to 30
         icamax = i
         smax = cabs1(cx(i))
   30 continue
      return
      end
      integer function isamax(n,sx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),smax
      integer i,incx,ix,n
c
      isamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      isamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = abs(sx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(abs(sx(ix)).le.smax) go to 5
         isamax = i
         smax = abs(sx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = abs(sx(1))
      do 30 i = 2,n
         if(abs(sx(i)).le.smax) go to 30
         isamax = i
         smax = abs(sx(i))
   30 continue
      return
      end
      LOGICAL          FUNCTION LSAME( CA, CB )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          CA, CB
*     ..
*
*  Purpose
*  =======
*
*  LSAME returns .TRUE. if CA is the same letter as CB regardless of
*  case.
*
*  Arguments
*  =========
*
*  CA      (input) CHARACTER*1
*  CB      (input) CHARACTER*1
*          CA and CB specify the single characters to be compared.
*
* =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC          ICHAR
*     ..
*     .. Local Scalars ..
      INTEGER            INTA, INTB, ZCODE
*     ..
*     .. Executable Statements ..
*
*     Test if the characters are equal
*
      LSAME = CA.EQ.CB
      IF( LSAME )
     $   RETURN
*
*     Now test for equivalence if both characters are alphabetic.
*
      ZCODE = ICHAR( 'Z' )
*
*     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
*     machines, on which ICHAR returns a value with bit 8 set.
*     ICHAR('A') on Prime machines returns 193 which is the same as
*     ICHAR('A') on an EBCDIC machine.
*
      INTA = ICHAR( CA )
      INTB = ICHAR( CB )
*
      IF( ZCODE.EQ.90 .OR. ZCODE.EQ.122 ) THEN
*
*        ASCII is assumed - ZCODE is the ASCII code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.97 .AND. INTA.LE.122 ) INTA = INTA - 32
         IF( INTB.GE.97 .AND. INTB.LE.122 ) INTB = INTB - 32
*
      ELSE IF( ZCODE.EQ.233 .OR. ZCODE.EQ.169 ) THEN
*
*        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.129 .AND. INTA.LE.137 .OR.
     $       INTA.GE.145 .AND. INTA.LE.153 .OR.
     $       INTA.GE.162 .AND. INTA.LE.169 ) INTA = INTA + 64
         IF( INTB.GE.129 .AND. INTB.LE.137 .OR.
     $       INTB.GE.145 .AND. INTB.LE.153 .OR.
     $       INTB.GE.162 .AND. INTB.LE.169 ) INTB = INTB + 64
*
      ELSE IF( ZCODE.EQ.218 .OR. ZCODE.EQ.250 ) THEN
*
*        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
*        plus 128 of either lower or upper case 'Z'.
*
         IF( INTA.GE.225 .AND. INTA.LE.250 ) INTA = INTA - 32
         IF( INTB.GE.225 .AND. INTB.LE.250 ) INTB = INTB - 32
      END IF
      LSAME = INTA.EQ.INTB
*
*     RETURN
*
*     End of LSAME
*
      END
      subroutine saxpy(n,sa,sx,incx,sy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loop for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*),sa
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (sa .eq. 0.0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        sy(iy) = sy(iy) + sa*sx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sy(i) = sy(i) + sa*sx(i)
   30 continue
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,4
        sy(i) = sy(i) + sa*sx(i)
        sy(i + 1) = sy(i + 1) + sa*sx(i + 1)
        sy(i + 2) = sy(i + 2) + sa*sx(i + 2)
        sy(i + 3) = sy(i + 3) + sa*sx(i + 3)
   50 continue
      return
      end
      subroutine scopy(n,sx,incx,sy,incy)
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to 1.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        sy(iy) = sx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sy(i) = sx(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        sy(i) = sx(i)
        sy(i + 1) = sx(i + 1)
        sy(i + 2) = sx(i + 2)
        sy(i + 3) = sx(i + 3)
        sy(i + 4) = sx(i + 4)
        sy(i + 5) = sx(i + 5)
        sy(i + 6) = sx(i + 6)
   50 continue
      return
      end
      real function sdot(n,sx,incx,sy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*),stemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      stemp = 0.0e0
      sdot = 0.0e0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        stemp = stemp + sx(ix)*sy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      sdot = stemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        stemp = stemp + sx(i)*sy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        stemp = stemp + sx(i)*sy(i) + sx(i + 1)*sy(i + 1) +
     *   sx(i + 2)*sy(i + 2) + sx(i + 3)*sy(i + 3) + sx(i + 4)*sy(i + 4)
   50 continue
   60 sdot = stemp
      return
      end
      SUBROUTINE SGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,
     $                   BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER*1        TRANSA, TRANSB
      INTEGER            M, N, K, LDA, LDB, LDC
      REAL               ALPHA, BETA
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  SGEMM  performs one of the matrix-matrix operations
*
*     C := alpha*op( A )*op( B ) + beta*C,
*
*  where  op( X ) is one of
*
*     op( X ) = X   or   op( X ) = X',
*
*  alpha and beta are scalars, and A, B and C are matrices, with op( A )
*  an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
*
*  Parameters
*  ==========
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n',  op( A ) = A.
*
*              TRANSA = 'T' or 't',  op( A ) = A'.
*
*              TRANSA = 'C' or 'c',  op( A ) = A'.
*
*           Unchanged on exit.
*
*  TRANSB - CHARACTER*1.
*           On entry, TRANSB specifies the form of op( B ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSB = 'N' or 'n',  op( B ) = B.
*
*              TRANSB = 'T' or 't',  op( B ) = B'.
*
*              TRANSB = 'C' or 'c',  op( B ) = B'.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry,  M  specifies  the number  of rows  of the  matrix
*           op( A )  and of the  matrix  C.  M  must  be at least  zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N  specifies the number  of columns of the matrix
*           op( B ) and the number of columns of the matrix C. N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry,  K  specifies  the number of columns of the matrix
*           op( A ) and the number of rows of the matrix op( B ). K must
*           be at least  zero.
*           Unchanged on exit.
*
*  ALPHA  - REAL            .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - REAL             array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
*           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by m  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
*           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*           least  max( 1, k ).
*           Unchanged on exit.
*
*  B      - REAL             array of DIMENSION ( LDB, kb ), where kb is
*           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
*           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
*           part of the array  B  must contain the matrix  B,  otherwise
*           the leading  n by k  part of the array  B  must contain  the
*           matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
*           LDB must be at least  max( 1, k ), otherwise  LDB must be at
*           least  max( 1, n ).
*           Unchanged on exit.
*
*  BETA   - REAL            .
*           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*           supplied as zero then C need not be set on input.
*           Unchanged on exit.
*
*  C      - REAL             array of DIMENSION ( LDC, n ).
*           Before entry, the leading  m by n  part of the array  C must
*           contain the matrix  C,  except when  beta  is zero, in which
*           case C need not be set on entry.
*           On exit, the array  C  is overwritten by the  m by n  matrix
*           ( alpha*op( A )*op( B ) + beta*C ).
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            NOTA, NOTB
      INTEGER            I, INFO, J, L, NCOLA, NROWA, NROWB
      REAL               TEMP
*     .. Parameters ..
      REAL               ONE         , ZERO
      PARAMETER        ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Executable Statements ..
*
*     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
*     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
*     and  columns of  A  and the  number of  rows  of  B  respectively.
*
      NOTA  = LSAME( TRANSA, 'N' )
      NOTB  = LSAME( TRANSB, 'N' )
      IF( NOTA )THEN
         NROWA = M
         NCOLA = K
      ELSE
         NROWA = K
         NCOLA = M
      END IF
      IF( NOTB )THEN
         NROWB = K
      ELSE
         NROWB = N
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF(      ( .NOT.NOTA                 ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.NOTB                 ).AND.
     $         ( .NOT.LSAME( TRANSB, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSB, 'T' ) )      )THEN
         INFO = 2
      ELSE IF( M  .LT.0               )THEN
         INFO = 3
      ELSE IF( N  .LT.0               )THEN
         INFO = 4
      ELSE IF( K  .LT.0               )THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 8
      ELSE IF( LDB.LT.MAX( 1, NROWB ) )THEN
         INFO = 10
      ELSE IF( LDC.LT.MAX( 1, M     ) )THEN
         INFO = 13
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'SGEMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And if  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( BETA.EQ.ZERO )THEN
            DO 20, J = 1, N
               DO 10, I = 1, M
                  C( I, J ) = ZERO
   10          CONTINUE
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               DO 30, I = 1, M
                  C( I, J ) = BETA*C( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( NOTB )THEN
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B + beta*C.
*
            DO 90, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 50, I = 1, M
                     C( I, J ) = ZERO
   50             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 60, I = 1, M
                     C( I, J ) = BETA*C( I, J )
   60             CONTINUE
               END IF
               DO 80, L = 1, K
                  IF( B( L, J ).NE.ZERO )THEN
                     TEMP = ALPHA*B( L, J )
                     DO 70, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
   70                CONTINUE
                  END IF
   80          CONTINUE
   90       CONTINUE
         ELSE
*
*           Form  C := alpha*A'*B + beta*C
*
            DO 120, J = 1, N
               DO 110, I = 1, M
                  TEMP = ZERO
                  DO 100, L = 1, K
                     TEMP = TEMP + A( L, I )*B( L, J )
  100             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  110          CONTINUE
  120       CONTINUE
         END IF
      ELSE
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B' + beta*C
*
            DO 170, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 130, I = 1, M
                     C( I, J ) = ZERO
  130             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 140, I = 1, M
                     C( I, J ) = BETA*C( I, J )
  140             CONTINUE
               END IF
               DO 160, L = 1, K
                  IF( B( J, L ).NE.ZERO )THEN
                     TEMP = ALPHA*B( J, L )
                     DO 150, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  150                CONTINUE
                  END IF
  160          CONTINUE
  170       CONTINUE
         ELSE
*
*           Form  C := alpha*A'*B' + beta*C
*
            DO 200, J = 1, N
               DO 190, I = 1, M
                  TEMP = ZERO
                  DO 180, L = 1, K
                     TEMP = TEMP + A( L, I )*B( J, L )
  180             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  190          CONTINUE
  200       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of SGEMM .
*
      END
      SUBROUTINE SGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
*     .. Scalar Arguments ..
      REAL               ALPHA, BETA
      INTEGER            INCX, INCY, LDA, M, N
      CHARACTER*1        TRANS
*     .. Array Arguments ..
      REAL               A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  SGEMV  performs one of the matrix-vector operations
*
*     y := alpha*A*x + beta*y,   or   y := alpha*A'*x + beta*y,
*
*  where alpha and beta are scalars, x and y are vectors and A is an
*  m by n matrix.
*
*  Parameters
*  ==========
*
*  TRANS  - CHARACTER*1.
*           On entry, TRANS specifies the operation to be performed as
*           follows:
*
*              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
*
*              TRANS = 'T' or 't'   y := alpha*A'*x + beta*y.
*
*              TRANS = 'C' or 'c'   y := alpha*A'*x + beta*y.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           M must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - REAL            .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - REAL             array of DIMENSION ( LDA, n ).
*           Before entry, the leading m by n part of the array A must
*           contain the matrix of coefficients.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, m ).
*           Unchanged on exit.
*
*  X      - REAL             array of DIMENSION at least
*           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
*           and at least
*           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
*           Before entry, the incremented array X must contain the
*           vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  BETA   - REAL            .
*           On entry, BETA specifies the scalar beta. When BETA is
*           supplied as zero then Y need not be set on input.
*           Unchanged on exit.
*
*  Y      - REAL             array of DIMENSION at least
*           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
*           and at least
*           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
*           Before entry with BETA non-zero, the incremented array Y
*           must contain the vector y. On exit, Y is overwritten by the
*           updated vector y.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      REAL               ONE         , ZERO
      PARAMETER        ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     .. Local Scalars ..
      REAL               TEMP
      INTEGER            I, INFO, IX, IY, J, JX, JY, KX, KY, LENX, LENY
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( .NOT.LSAME( TRANS, 'N' ).AND.
     $         .NOT.LSAME( TRANS, 'T' ).AND.
     $         .NOT.LSAME( TRANS, 'C' )      )THEN
         INFO = 1
      ELSE IF( M.LT.0 )THEN
         INFO = 2
      ELSE IF( N.LT.0 )THEN
         INFO = 3
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'SGEMV ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ALPHA.EQ.ZERO ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
*     up the start points in  X  and  Y.
*
      IF( LSAME( TRANS, 'N' ) )THEN
         LENX = N
         LENY = M
      ELSE
         LENX = M
         LENY = N
      END IF
      IF( INCX.GT.0 )THEN
         KX = 1
      ELSE
         KX = 1 - ( LENX - 1 )*INCX
      END IF
      IF( INCY.GT.0 )THEN
         KY = 1
      ELSE
         KY = 1 - ( LENY - 1 )*INCY
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
*     First form  y := beta*y.
*
      IF( BETA.NE.ONE )THEN
         IF( INCY.EQ.1 )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 10, I = 1, LENY
                  Y( I ) = ZERO
   10          CONTINUE
            ELSE
               DO 20, I = 1, LENY
                  Y( I ) = BETA*Y( I )
   20          CONTINUE
            END IF
         ELSE
            IY = KY
            IF( BETA.EQ.ZERO )THEN
               DO 30, I = 1, LENY
                  Y( IY ) = ZERO
                  IY      = IY   + INCY
   30          CONTINUE
            ELSE
               DO 40, I = 1, LENY
                  Y( IY ) = BETA*Y( IY )
                  IY      = IY           + INCY
   40          CONTINUE
            END IF
         END IF
      END IF
      IF( ALPHA.EQ.ZERO )
     $   RETURN
      IF( LSAME( TRANS, 'N' ) )THEN
*
*        Form  y := alpha*A*x + y.
*
         JX = KX
         IF( INCY.EQ.1 )THEN
            DO 60, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  DO 50, I = 1, M
                     Y( I ) = Y( I ) + TEMP*A( I, J )
   50             CONTINUE
               END IF
               JX = JX + INCX
   60       CONTINUE
         ELSE
            DO 80, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IY   = KY
                  DO 70, I = 1, M
                     Y( IY ) = Y( IY ) + TEMP*A( I, J )
                     IY      = IY      + INCY
   70             CONTINUE
               END IF
               JX = JX + INCX
   80       CONTINUE
         END IF
      ELSE
*
*        Form  y := alpha*A'*x + y.
*
         JY = KY
         IF( INCX.EQ.1 )THEN
            DO 100, J = 1, N
               TEMP = ZERO
               DO 90, I = 1, M
                  TEMP = TEMP + A( I, J )*X( I )
   90          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
  100       CONTINUE
         ELSE
            DO 120, J = 1, N
               TEMP = ZERO
               IX   = KX
               DO 110, I = 1, M
                  TEMP = TEMP + A( I, J )*X( IX )
                  IX   = IX   + INCX
  110          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
  120       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of SGEMV .
*
      END
      SUBROUTINE SGER  ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
*     .. Scalar Arguments ..
      REAL               ALPHA
      INTEGER            INCX, INCY, LDA, M, N
*     .. Array Arguments ..
      REAL               A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  SGER   performs the rank 1 operation
*
*     A := alpha*x*y' + A,
*
*  where alpha is a scalar, x is an m element vector, y is an n element
*  vector and A is an m by n matrix.
*
*  Parameters
*  ==========
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           M must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - REAL            .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - REAL             array of dimension at least
*           ( 1 + ( m - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the m
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  Y      - REAL             array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCY ) ).
*           Before entry, the incremented array Y must contain the n
*           element vector y.
*           Unchanged on exit.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*  A      - REAL             array of DIMENSION ( LDA, n ).
*           Before entry, the leading m by n part of the array A must
*           contain the matrix of coefficients. On exit, A is
*           overwritten by the updated matrix.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER        ( ZERO = 0.0E+0 )
*     .. Local Scalars ..
      REAL               TEMP
      INTEGER            I, INFO, IX, J, JY, KX
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( M.LT.0 )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'SGER  ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF( INCY.GT.0 )THEN
         JY = 1
      ELSE
         JY = 1 - ( N - 1 )*INCY
      END IF
      IF( INCX.EQ.1 )THEN
         DO 20, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               DO 10, I = 1, M
                  A( I, J ) = A( I, J ) + X( I )*TEMP
   10          CONTINUE
            END IF
            JY = JY + INCY
   20    CONTINUE
      ELSE
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( M - 1 )*INCX
         END IF
         DO 40, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               IX   = KX
               DO 30, I = 1, M
                  A( I, J ) = A( I, J ) + X( IX )*TEMP
                  IX        = IX        + INCX
   30          CONTINUE
            END IF
            JY = JY + INCY
   40    CONTINUE
      END IF
*
      RETURN
*
*     End of SGER  .
*
      END
      REAL             FUNCTION SNRM2 ( N, X, INCX )
*     .. Scalar Arguments ..
      INTEGER                           INCX, N
*     .. Array Arguments ..
      REAL                              X( * )
*     ..
*
*  SNRM2 returns the euclidean norm of a vector via the function
*  name, so that
*
*     SNRM2 := sqrt( x'*x )
*
*
*
*  -- This version written on 25-October-1982.
*     Modified on 14-October-1993 to inline the call to SLASSQ.
*     Sven Hammarling, Nag Ltd.
*
*
*     .. Parameters ..
      REAL                  ONE         , ZERO
      PARAMETER           ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     .. Local Scalars ..
      INTEGER               IX
      REAL                  ABSXI, NORM, SCALE, SSQ
*     .. Intrinsic Functions ..
      INTRINSIC             ABS, SQRT
*     ..
*     .. Executable Statements ..
      IF( N.LT.1 .OR. INCX.LT.1 )THEN
         NORM  = ZERO
      ELSE IF( N.EQ.1 )THEN
         NORM  = ABS( X( 1 ) )
      ELSE
         SCALE = ZERO
         SSQ   = ONE
*        The following loop is equivalent to this call to the LAPACK
*        auxiliary routine:
*        CALL SLASSQ( N, X, INCX, SCALE, SSQ )
*
         DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
            IF( X( IX ).NE.ZERO )THEN
               ABSXI = ABS( X( IX ) )
               IF( SCALE.LT.ABSXI )THEN
                  SSQ   = ONE   + SSQ*( SCALE/ABSXI )**2
                  SCALE = ABSXI
               ELSE
                  SSQ   = SSQ   +     ( ABSXI/SCALE )**2
               END IF
            END IF
   10    CONTINUE
         NORM  = SCALE * SQRT( SSQ )
      END IF
*
      SNRM2 = NORM
      RETURN
*
*     End of SNRM2.
*
      END
      subroutine srot (n,sx,incx,sy,incy,c,s)
c
c     applies a plane rotation.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*),stemp,c,s
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        stemp = c*sx(ix) + s*sy(iy)
        sy(iy) = c*sy(iy) - s*sx(ix)
        sx(ix) = stemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c       code for both increments equal to 1
c
   20 do 30 i = 1,n
        stemp = c*sx(i) + s*sy(i)
        sy(i) = c*sy(i) - s*sx(i)
        sx(i) = stemp
   30 continue
      return
      end
      subroutine sscal(n,sa,sx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to 1.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sa,sx(*)
      integer i,incx,m,mp1,n,nincx
c
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        sx(i) = sa*sx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sx(i) = sa*sx(i)
   30 continue
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        sx(i) = sa*sx(i)
        sx(i + 1) = sa*sx(i + 1)
        sx(i + 2) = sa*sx(i + 2)
        sx(i + 3) = sa*sx(i + 3)
        sx(i + 4) = sa*sx(i + 4)
   50 continue
      return
      end
      subroutine sswap (n,sx,incx,sy,incy)
c
c     interchanges two vectors.
c     uses unrolled loops for increments equal to 1.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*),stemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        stemp = sx(ix)
        sx(ix) = sy(iy)
        sy(iy) = stemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c       code for both increments equal to 1
c
c
c       clean-up loop
c
   20 m = mod(n,3)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        stemp = sx(i)
        sx(i) = sy(i)
        sy(i) = stemp
   30 continue
      if( n .lt. 3 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,3
        stemp = sx(i)
        sx(i) = sy(i)
        sy(i) = stemp
        stemp = sx(i + 1)
        sx(i + 1) = sy(i + 1)
        sy(i + 1) = stemp
        stemp = sx(i + 2)
        sx(i + 2) = sy(i + 2)
        sy(i + 2) = stemp
   50 continue
      return
      end
      SUBROUTINE STRMM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,
     $                   B, LDB )
*     .. Scalar Arguments ..
      CHARACTER*1        SIDE, UPLO, TRANSA, DIAG
      INTEGER            M, N, LDA, LDB
      REAL               ALPHA
*     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  STRMM  performs one of the matrix-matrix operations
*
*     B := alpha*op( A )*B,   or   B := alpha*B*op( A ),
*
*  where  alpha  is a scalar,  B  is an m by n matrix,  A  is a unit, or
*  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
*
*     op( A ) = A   or   op( A ) = A'.
*
*  Parameters
*  ==========
*
*  SIDE   - CHARACTER*1.
*           On entry,  SIDE specifies whether  op( A ) multiplies B from
*           the left or right as follows:
*
*              SIDE = 'L' or 'l'   B := alpha*op( A )*B.
*
*              SIDE = 'R' or 'r'   B := alpha*B*op( A ).
*
*           Unchanged on exit.
*
*  UPLO   - CHARACTER*1.
*           On entry, UPLO specifies whether the matrix A is an upper or
*           lower triangular matrix as follows:
*
*              UPLO = 'U' or 'u'   A is an upper triangular matrix.
*
*              UPLO = 'L' or 'l'   A is a lower triangular matrix.
*
*           Unchanged on exit.
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n'   op( A ) = A.
*
*              TRANSA = 'T' or 't'   op( A ) = A'.
*
*              TRANSA = 'C' or 'c'   op( A ) = A'.
*
*           Unchanged on exit.
*
*  DIAG   - CHARACTER*1.
*           On entry, DIAG specifies whether or not A is unit triangular
*           as follows:
*
*              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*
*              DIAG = 'N' or 'n'   A is not assumed to be unit
*                                  triangular.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of B. M must be at
*           least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of B.  N must be
*           at least zero.
*           Unchanged on exit.
*
*  ALPHA  - REAL            .
*           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
*           zero then  A is not referenced and  B need not be set before
*           entry.
*           Unchanged on exit.
*
*  A      - REAL             array of DIMENSION ( LDA, k ), where k is m
*           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
*           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
*           upper triangular part of the array  A must contain the upper
*           triangular matrix  and the strictly lower triangular part of
*           A is not referenced.
*           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
*           lower triangular part of the array  A must contain the lower
*           triangular matrix  and the strictly upper triangular part of
*           A is not referenced.
*           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
*           A  are not referenced either,  but are assumed to be  unity.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
*           then LDA must be at least max( 1, n ).
*           Unchanged on exit.
*
*  B      - REAL             array of DIMENSION ( LDB, n ).
*           Before entry,  the leading  m by n part of the array  B must
*           contain the matrix  B,  and  on exit  is overwritten  by the
*           transformed matrix.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in  the  calling  (sub)  program.   LDB  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            LSIDE, NOUNIT, UPPER
      INTEGER            I, INFO, J, K, NROWA
      REAL               TEMP
*     .. Parameters ..
      REAL               ONE         , ZERO
      PARAMETER        ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      LSIDE  = LSAME( SIDE  , 'L' )
      IF( LSIDE )THEN
         NROWA = M
      ELSE
         NROWA = N
      END IF
      NOUNIT = LSAME( DIAG  , 'N' )
      UPPER  = LSAME( UPLO  , 'U' )
*
      INFO   = 0
      IF(      ( .NOT.LSIDE                ).AND.
     $         ( .NOT.LSAME( SIDE  , 'R' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.UPPER                ).AND.
     $         ( .NOT.LSAME( UPLO  , 'L' ) )      )THEN
         INFO = 2
      ELSE IF( ( .NOT.LSAME( TRANSA, 'N' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) )      )THEN
         INFO = 3
      ELSE IF( ( .NOT.LSAME( DIAG  , 'U' ) ).AND.
     $         ( .NOT.LSAME( DIAG  , 'N' ) )      )THEN
         INFO = 4
      ELSE IF( M  .LT.0               )THEN
         INFO = 5
      ELSE IF( N  .LT.0               )THEN
         INFO = 6
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 9
      ELSE IF( LDB.LT.MAX( 1, M     ) )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'STRMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         DO 20, J = 1, N
            DO 10, I = 1, M
               B( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
         RETURN
      END IF
*
*     Start the operations.
*
      IF( LSIDE )THEN
         IF( LSAME( TRANSA, 'N' ) )THEN
*
*           Form  B := alpha*A*B.
*
            IF( UPPER )THEN
               DO 50, J = 1, N
                  DO 40, K = 1, M
                     IF( B( K, J ).NE.ZERO )THEN
                        TEMP = ALPHA*B( K, J )
                        DO 30, I = 1, K - 1
                           B( I, J ) = B( I, J ) + TEMP*A( I, K )
   30                   CONTINUE
                        IF( NOUNIT )
     $                     TEMP = TEMP*A( K, K )
                        B( K, J ) = TEMP
                     END IF
   40             CONTINUE
   50          CONTINUE
            ELSE
               DO 80, J = 1, N
                  DO 70 K = M, 1, -1
                     IF( B( K, J ).NE.ZERO )THEN
                        TEMP      = ALPHA*B( K, J )
                        B( K, J ) = TEMP
                        IF( NOUNIT )
     $                     B( K, J ) = B( K, J )*A( K, K )
                        DO 60, I = K + 1, M
                           B( I, J ) = B( I, J ) + TEMP*A( I, K )
   60                   CONTINUE
                     END IF
   70             CONTINUE
   80          CONTINUE
            END IF
         ELSE
*
*           Form  B := alpha*A'*B.
*
            IF( UPPER )THEN
               DO 110, J = 1, N
                  DO 100, I = M, 1, -1
                     TEMP = B( I, J )
                     IF( NOUNIT )
     $                  TEMP = TEMP*A( I, I )
                     DO 90, K = 1, I - 1
                        TEMP = TEMP + A( K, I )*B( K, J )
   90                CONTINUE
                     B( I, J ) = ALPHA*TEMP
  100             CONTINUE
  110          CONTINUE
            ELSE
               DO 140, J = 1, N
                  DO 130, I = 1, M
                     TEMP = B( I, J )
                     IF( NOUNIT )
     $                  TEMP = TEMP*A( I, I )
                     DO 120, K = I + 1, M
                        TEMP = TEMP + A( K, I )*B( K, J )
  120                CONTINUE
                     B( I, J ) = ALPHA*TEMP
  130             CONTINUE
  140          CONTINUE
            END IF
         END IF
      ELSE
         IF( LSAME( TRANSA, 'N' ) )THEN
*
*           Form  B := alpha*B*A.
*
            IF( UPPER )THEN
               DO 180, J = N, 1, -1
                  TEMP = ALPHA
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 150, I = 1, M
                     B( I, J ) = TEMP*B( I, J )
  150             CONTINUE
                  DO 170, K = 1, J - 1
                     IF( A( K, J ).NE.ZERO )THEN
                        TEMP = ALPHA*A( K, J )
                        DO 160, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  160                   CONTINUE
                     END IF
  170             CONTINUE
  180          CONTINUE
            ELSE
               DO 220, J = 1, N
                  TEMP = ALPHA
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 190, I = 1, M
                     B( I, J ) = TEMP*B( I, J )
  190             CONTINUE
                  DO 210, K = J + 1, N
                     IF( A( K, J ).NE.ZERO )THEN
                        TEMP = ALPHA*A( K, J )
                        DO 200, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  200                   CONTINUE
                     END IF
  210             CONTINUE
  220          CONTINUE
            END IF
         ELSE
*
*           Form  B := alpha*B*A'.
*
            IF( UPPER )THEN
               DO 260, K = 1, N
                  DO 240, J = 1, K - 1
                     IF( A( J, K ).NE.ZERO )THEN
                        TEMP = ALPHA*A( J, K )
                        DO 230, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  230                   CONTINUE
                     END IF
  240             CONTINUE
                  TEMP = ALPHA
                  IF( NOUNIT )
     $               TEMP = TEMP*A( K, K )
                  IF( TEMP.NE.ONE )THEN
                     DO 250, I = 1, M
                        B( I, K ) = TEMP*B( I, K )
  250                CONTINUE
                  END IF
  260          CONTINUE
            ELSE
               DO 300, K = N, 1, -1
                  DO 280, J = K + 1, N
                     IF( A( J, K ).NE.ZERO )THEN
                        TEMP = ALPHA*A( J, K )
                        DO 270, I = 1, M
                           B( I, J ) = B( I, J ) + TEMP*B( I, K )
  270                   CONTINUE
                     END IF
  280             CONTINUE
                  TEMP = ALPHA
                  IF( NOUNIT )
     $               TEMP = TEMP*A( K, K )
                  IF( TEMP.NE.ONE )THEN
                     DO 290, I = 1, M
                        B( I, K ) = TEMP*B( I, K )
  290                CONTINUE
                  END IF
  300          CONTINUE
            END IF
         END IF
      END IF
*
      RETURN
*
*     End of STRMM .
*
      END
      SUBROUTINE STRMV ( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
*     .. Scalar Arguments ..
      INTEGER            INCX, LDA, N
      CHARACTER*1        DIAG, TRANS, UPLO
*     .. Array Arguments ..
      REAL               A( LDA, * ), X( * )
*     ..
*
*  Purpose
*  =======
*
*  STRMV  performs one of the matrix-vector operations
*
*     x := A*x,   or   x := A'*x,
*
*  where x is an n element vector and  A is an n by n unit, or non-unit,
*  upper or lower triangular matrix.
*
*  Parameters
*  ==========
*
*  UPLO   - CHARACTER*1.
*           On entry, UPLO specifies whether the matrix is an upper or
*           lower triangular matrix as follows:
*
*              UPLO = 'U' or 'u'   A is an upper triangular matrix.
*
*              UPLO = 'L' or 'l'   A is a lower triangular matrix.
*
*           Unchanged on exit.
*
*  TRANS  - CHARACTER*1.
*           On entry, TRANS specifies the operation to be performed as
*           follows:
*
*              TRANS = 'N' or 'n'   x := A*x.
*
*              TRANS = 'T' or 't'   x := A'*x.
*
*              TRANS = 'C' or 'c'   x := A'*x.
*
*           Unchanged on exit.
*
*  DIAG   - CHARACTER*1.
*           On entry, DIAG specifies whether or not A is unit
*           triangular as follows:
*
*              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*
*              DIAG = 'N' or 'n'   A is not assumed to be unit
*                                  triangular.
*
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the order of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  A      - REAL             array of DIMENSION ( LDA, n ).
*           Before entry with  UPLO = 'U' or 'u', the leading n by n
*           upper triangular part of the array A must contain the upper
*           triangular matrix and the strictly lower triangular part of
*           A is not referenced.
*           Before entry with UPLO = 'L' or 'l', the leading n by n
*           lower triangular part of the array A must contain the lower
*           triangular matrix and the strictly upper triangular part of
*           A is not referenced.
*           Note that when  DIAG = 'U' or 'u', the diagonal elements of
*           A are not referenced either, but are assumed to be unity.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, n ).
*           Unchanged on exit.
*
*  X      - REAL             array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the n
*           element vector x. On exit, X is overwritten with the
*           tranformed vector x.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER        ( ZERO = 0.0E+0 )
*     .. Local Scalars ..
      REAL               TEMP
      INTEGER            I, INFO, IX, J, JX, KX
      LOGICAL            NOUNIT
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( .NOT.LSAME( UPLO , 'U' ).AND.
     $         .NOT.LSAME( UPLO , 'L' )      )THEN
         INFO = 1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ).AND.
     $         .NOT.LSAME( TRANS, 'T' ).AND.
     $         .NOT.LSAME( TRANS, 'C' )      )THEN
         INFO = 2
      ELSE IF( .NOT.LSAME( DIAG , 'U' ).AND.
     $         .NOT.LSAME( DIAG , 'N' )      )THEN
         INFO = 3
      ELSE IF( N.LT.0 )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'STRMV ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
      NOUNIT = LSAME( DIAG, 'N' )
*
*     Set up the start point in X if the increment is not unity. This
*     will be  ( N - 1 )*INCX  too small for descending loops.
*
      IF( INCX.LE.0 )THEN
         KX = 1 - ( N - 1 )*INCX
      ELSE IF( INCX.NE.1 )THEN
         KX = 1
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF( LSAME( TRANS, 'N' ) )THEN
*
*        Form  x := A*x.
*
         IF( LSAME( UPLO, 'U' ) )THEN
            IF( INCX.EQ.1 )THEN
               DO 20, J = 1, N
                  IF( X( J ).NE.ZERO )THEN
                     TEMP = X( J )
                     DO 10, I = 1, J - 1
                        X( I ) = X( I ) + TEMP*A( I, J )
   10                CONTINUE
                     IF( NOUNIT )
     $                  X( J ) = X( J )*A( J, J )
                  END IF
   20          CONTINUE
            ELSE
               JX = KX
               DO 40, J = 1, N
                  IF( X( JX ).NE.ZERO )THEN
                     TEMP = X( JX )
                     IX   = KX
                     DO 30, I = 1, J - 1
                        X( IX ) = X( IX ) + TEMP*A( I, J )
                        IX      = IX      + INCX
   30                CONTINUE
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )*A( J, J )
                  END IF
                  JX = JX + INCX
   40          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 60, J = N, 1, -1
                  IF( X( J ).NE.ZERO )THEN
                     TEMP = X( J )
                     DO 50, I = N, J + 1, -1
                        X( I ) = X( I ) + TEMP*A( I, J )
   50                CONTINUE
                     IF( NOUNIT )
     $                  X( J ) = X( J )*A( J, J )
                  END IF
   60          CONTINUE
            ELSE
               KX = KX + ( N - 1 )*INCX
               JX = KX
               DO 80, J = N, 1, -1
                  IF( X( JX ).NE.ZERO )THEN
                     TEMP = X( JX )
                     IX   = KX
                     DO 70, I = N, J + 1, -1
                        X( IX ) = X( IX ) + TEMP*A( I, J )
                        IX      = IX      - INCX
   70                CONTINUE
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )*A( J, J )
                  END IF
                  JX = JX - INCX
   80          CONTINUE
            END IF
         END IF
      ELSE
*
*        Form  x := A'*x.
*
         IF( LSAME( UPLO, 'U' ) )THEN
            IF( INCX.EQ.1 )THEN
               DO 100, J = N, 1, -1
                  TEMP = X( J )
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 90, I = J - 1, 1, -1
                     TEMP = TEMP + A( I, J )*X( I )
   90             CONTINUE
                  X( J ) = TEMP
  100          CONTINUE
            ELSE
               JX = KX + ( N - 1 )*INCX
               DO 120, J = N, 1, -1
                  TEMP = X( JX )
                  IX   = JX
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 110, I = J - 1, 1, -1
                     IX   = IX   - INCX
                     TEMP = TEMP + A( I, J )*X( IX )
  110             CONTINUE
                  X( JX ) = TEMP
                  JX      = JX   - INCX
  120          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 140, J = 1, N
                  TEMP = X( J )
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 130, I = J + 1, N
                     TEMP = TEMP + A( I, J )*X( I )
  130             CONTINUE
                  X( J ) = TEMP
  140          CONTINUE
            ELSE
               JX = KX
               DO 160, J = 1, N
                  TEMP = X( JX )
                  IX   = JX
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 150, I = J + 1, N
                     IX   = IX   + INCX
                     TEMP = TEMP + A( I, J )*X( IX )
  150             CONTINUE
                  X( JX ) = TEMP
                  JX      = JX   + INCX
  160          CONTINUE
            END IF
         END IF
      END IF
*
      RETURN
*
*     End of STRMV .
*
      END
      SUBROUTINE XERBLA( SRNAME, INFO )
*
*  -- LAPACK auxiliary routine (preliminary version) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER*6        SRNAME
      INTEGER            INFO
*     ..
*
*  Purpose
*  =======
*
*  XERBLA  is an error handler for the LAPACK routines.
*  It is called by an LAPACK routine if an input parameter has an
*  invalid value.  A message is printed and execution stops.
*
*  Installers may consider modifying the STOP statement in order to
*  call system-specific exception-handling facilities.
*
*  Arguments
*  =========
*
*  SRNAME  (input) CHARACTER*6
*          The name of the routine which called XERBLA.
*
*  INFO    (input) INTEGER
*          The position of the invalid parameter in the parameter list
*          of the calling routine.
*
*
      WRITE( *, FMT = 9999 )SRNAME, INFO
*
      STOP
*
 9999 FORMAT( ' ** On entry to ', A6, ' parameter number ', I2, ' had ',
     $      'an illegal value' )
*
*     End of XERBLA
*
      END

      SUBROUTINE PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,EIGVAL)
      IMPLICIT NONE

C Arguments:

      INTEGER MXNAT,NAT
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      REAL A1(3),A2(3),DX(3),EIGVAL(3)

C Local variables:

      INTEGER LWORK
      PARAMETER(LWORK=12)
      INTEGER 
     &   INFO,
     &   J,J1,J2,J3,JA,JD,
     &   K,LDA,LDVL,LDVR,N
      REAL DENOM,PI,ZNORM,ZNORM2
      REAL 
     &   A(3,3),A3(3),VL(3,3),WI(3),WORK(LWORK),WR(3),
     &   ZR(3,3)
      DOUBLE PRECISION DSUM
      DOUBLE PRECISION CM(3)
      CHARACTER CMSGNM*70
C***********************************************************************
C Subroutine to determine principal axes of moment of inertia tensor
C of target.
C Target is assumed to be homogeneous.
C Given:
C
C MXNAT       =limit on largest allowed value of NAT=number of dipoles
C NAT         =number of dipoles in target
C IXYZ(J,1-3) =x,y,z location of dipole Jon lattice
C DX(1-3)     =(dx/d,dy/d,dz/d) where (dx,dy,dz)=lattice spacing in
C              x,y,z directions, 
C              and d = (dx*dy*dz)**(1/3) = effective lattice spacing
C ICOMP(J,1-3)=composition for dipole J; x,y,z directions
C
C Returns:
C
C A1(1-3)     =principal axis A1 in target frame (normalized)
C A2(1-3)     =principal axis A2 in target frame (normalized)
C EIGV(1-3)   =(eigenvalues of moment of inertia tensor)/(0.4*M*aeff^2)
C              definition of aeff = (3*V/4*pi)^{1/3} , V = solid volume
C              EIGV are in decreasing order:
C              EIGV(1) is largest, EIGV(3) is smallest
C
C              A1 = principal axis with largest moment of inertia 
C              A2 = principal axis with second-largest moment of inertia
C
C B.T. Draine, Princeton Univ. Observatory, 96.01.26
C History:
C 96.01.26 (BTD) extracted from routine TARBLOCKS
C                IX,IY,IZ replaced by IXYZ
C 96.02.23 (BTD) corrected typo in 2 format statements
C                add code computing axis a3 and printing out
C                eigenvalue.
C 96.11.01 (PJF) modified to use LAPACK code rather than EIGV
C                and associated routines from NSWC package.
C 96.11.21 (BTD) modified to remove WRITE(0 and replace with
C                calls to WRIMSG
C 97.12.26 (BTD) added DX(3) to argument list, and modified to
C                compute principal axes with unequal lattice
C                spacing.
C 98.04.27 (BTD) deleted unused variables I,ZI
C 98.12.15 (BTD) Appears to be a problem with LAPACK routine SGEEV
C                when compiled using g77 under Linux.
C                Add trap to catch this problem if it occurs,
C                print out warning, and terminate execution.
C 00.06.13 (BTD) corrected error in computation of diagonal elements
C                of moment of inertia tensor (NAT/6 -> NAT/18)
c 04.05.23 (BTD) added normalized eigenvalues EIGV to argument list
C End history.
C
C Copyright (C) 1993,1994,1995,1996,1997,1998,2000,2004
C               B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      PI=4.*ATAN(1.)

C Compute moment of inertia tensor.

      DO JD=1,3
         CM(JD)=0.
      ENDDO
      DO JA=1,NAT
         DO JD=1,3
            CM(JD)=CM(JD)+IXYZ(JA,JD)*DX(JD)
         ENDDO
      ENDDO
      DO JD=1,3
         CM(JD)=CM(JD)/NAT
      ENDDO

C Compute moment of inertia tensor

      DO J=1,3
         DO K=1,3
            A(J,K)=0.
         ENDDO
      ENDDO
      DSUM=0.
      DO K=1,3
         DO JA=1,NAT
            DSUM=DSUM+((IXYZ(JA,K)-CM(K))*DX(K))**2
         ENDDO
      ENDDO
      DO J=1,3
         A(J,J)=REAL(DSUM+(NAT/18.)*(DX(1)**2+DX(2)**2+DX(3)**2))
      ENDDO
      DO J=1,3
         DO K=1,3
            DSUM=0.
            DO JA=1,NAT
               DSUM=DSUM+(IXYZ(JA,J)-CM(J))*(IXYZ(JA,K)-CM(K))*
     &              DX(J)*DX(K)
            ENDDO
            A(J,K)=A(J,K)-REAL(DSUM)
         ENDDO
      ENDDO

C Normalize moment of inertia tensor to units of 0.4*mass*a_eff**2

      DENOM=0.4*NAT*(.75*NAT/PI)**(2./3.)
      DO 3500 K=1,3
         DO 3400 J=1,3
            A(J,K)=A(J,K)/DENOM
 3400    CONTINUE
 3500 CONTINUE

C Compute eigenvalues and eigenvectors of A(J,K)

      N=3
      LDA=3
      LDVR=3
      LDVL=3

C Call LAPACK routine SGEEV to obtain eigenvectors of moment of
C inertia tensor.  Only right eigenvectors are needed.

      CALL SGEEV('V','V',N,A,LDA,WR,WI,VL,LDVL,ZR,
     &           LDVR,WORK,LWORK,INFO)

c  ZR      (output) REAL array, dimension (LDVR,N)
c          If JOBVR = 'V', the right eigenvectors v(j) are stored one
c          after another in the columns of ZR, in the same order
c          as their eigenvalues.
c          If JOBVR = 'N', ZR is not referenced.
c          If the j-th eigenvalue is real, then v(j) = ZR(:,j),
c          the j-th column of ZR.
c          If the j-th and (j+1)-st eigenvalues form a complex
c          conjugate pair, then v(j) = ZR(:,j) + i*ZR(:,j+1) and
c          v(j+1) = ZR(:,j) = i*ZR(:,j+1).

C 98.12.06 BTD It appears that SGEEV or subsidiary LAPACK routines
C              are not executing properly under Linux g77.  This 
C              problem has not been noticed previously, and certainly
C              did not appear with the Solaris f77 compiler.  Perhaps
C              one of the LAPACK routines wass failing to SAVE some
C              variable between calls.  This problem has not recurred,
C              but in case of future problems we havee
C              introduced this trap to terminate execution in case
C              of failure of SGEEV.
C
      IF(INFO.NE.0)THEN
         WRITE(CMSGNM,FMT='(A,I4)')
     &      'Error in PRINAXIS: returned from SGEEV with INFO=',INFO
         WRITE(CMSGNM,FMT='(A)')
     &      'SGEEV is part of lapack.f'
         WRITE(CMSGNM,FMT='(A)')
     &      'possibly a problem with LAPACK routines'
         WRITE(CMSGNM,FMT='(A)')
     &      'workaround by specifying target axis by hand'
         CALL ERRMSG('FATAL','PRINAXIS',' failure in SGEEV')
      ENDIF


C Normalize the eigenvectors:

      DO J=1,3
         ZNORM2=0.
         DO K=1,3
            ZNORM2=ZNORM2+ZR(K,J)**2
         ENDDO

C Make first component of each eigenvector positive

         ZNORM=SQRT(ZNORM2)
         IF(ZR(1,J).LT.0.)THEN
            ZNORM=-ZNORM
         ELSEIF(ZR(1,J).EQ.0.)THEN
            IF(ZR(2,J).LT.0.)ZNORM=-ZNORM
         ENDIF
         DO K=1,3
            ZR(K,J)=ZR(K,J)/ZNORM
         ENDDO
      ENDDO

C Order the eigenvectors by eigenvalue, largest first:

      J1=1
      IF(WR(2).GT.WR(1))J1=2
      IF(WR(3).GT.WR(J1))J1=3
      IF(J1.EQ.1)THEN
         J2=2
         IF(WR(3).GT.WR(2))J2=3
      ELSEIF(J1.EQ.2)THEN
         J2=1
         IF(WR(3).GT.WR(1))J2=3
      ELSEIF(J1.EQ.3)THEN
         J2=1
         IF(WR(2).GT.WR(1))J2=2
      ENDIF
      DO K=1,3
         A1(K)=ZR(K,J1)
         A2(K)=ZR(K,J2)
      ENDDO

C Set J3=3 if J1+J2=1+2=3
C        2         =1+3=4
C        1         =2+3=5

      J3=6-J1-J2

C Having fixed eigenvectors a_1 and a_2, compute a_3 = a_1 x a_2

      A3(1)=A1(2)*A2(3)-A1(3)*A2(2)
      A3(2)=A1(3)*A2(1)-A1(1)*A2(3)
      A3(3)=A1(1)*A2(2)-A1(2)*A2(1)      

      EIGVAL(1)=WR(J1)
      EIGVAL(2)=WR(J2)
      EIGVAL(3)=WR(J3)

C*** enable following lines to print out eigenvalues
      WRITE(CMSGNM,FMT='(A,0PF8.5)')'I_1/.4Ma_eff^2 =',WR(J1)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0PF8.5)')'I_2/.4Ma_eff^2 =',WR(J2)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0PF8.5)')'I_3/.4Ma_eff^2 =',WR(J3)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0P3F9.5,A)')'axis a_1 = (',A1,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0P3F9.5,A)')'     a_2 = (',A2,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0P3F9.5,A)')'     a_3 = (',A3,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
C***
      RETURN
      END
